/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
const generate = require('./generate-b43c3d3b.js');
require('./package-033055fc.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');

const accordionCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}:host{display:block}";

const BcmAccordion = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this._id = generate.Generate.UID();
    this.multi = false;
  }
  componentDidRender() {
    if (!this.multi)
      this.checkExpandedCount();
  }
  checkExpandedCount() {
    var _a, _b;
    const accordion = this.el.querySelectorAll('.bcm-expansion-panel');
    if (accordion) {
      const checkExpandedCount = Array.from(accordion)
        .map((accordion) => accordion.expanded)
        .filter(Boolean).length;
      if (checkExpandedCount > 1) {
        const getLastExpandedId = (_b = (_a = Array.from(accordion).filter((accordion) => accordion.expanded)) === null || _a === void 0 ? void 0 : _a.pop()) === null || _b === void 0 ? void 0 : _b.id;
        Array.from(accordion).forEach((accordion) => {
          if (accordion.id !== getLastExpandedId) {
            accordion.expanded = false;
          }
        });
      }
    }
  }
  open(event) {
    if (this.multi)
      return;
    const id = event.detail;
    const accordion = this.el.querySelectorAll('.bcm-expansion-panel');
    if (accordion) {
      accordion.forEach((accordion) => {
        if (accordion.id !== id) {
          accordion.expanded = false;
        }
      });
    }
  }
  isLoad(event) {
    var _a, _b, _c;
    if (!this.multi) {
      var parentId = ((_b = (_a = event === null || event === void 0 ? void 0 : event.target) === null || _a === void 0 ? void 0 : _a.parentElement) === null || _b === void 0 ? void 0 : _b.id) || null;
      var nodeName = ((_c = event === null || event === void 0 ? void 0 : event.target) === null || _c === void 0 ? void 0 : _c.nodeName) || null;
      if (nodeName == 'BCM-EXPANSION-PANEL' && this._id == parentId) {
        this.checkExpandedCount();
      }
    }
  }
  render() {
    return (index.h(index.Host, { id: this._id }, index.h("slot", null)));
  }
  get el() { return index.getElement(this); }
};
BcmAccordion.style = accordionCss;

exports.bcm_accordion = BcmAccordion;
