/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index$1 = require('./index-c591ecec.js');
require('./color-helper-dc98a2ca.js');
require('./datetime-helper-eaf4fadb.js');
const generate = require('./generate-b43c3d3b.js');
require('./number-helper-a708fa79.js');
require('./string-helper-9cdfb273.js');
require('./validators-84d8ae28.js');
require('./element-dragger-a8562f82.js');
const utils = require('./utils-fc077139.js');
const floatingUi = require('./floating-ui-5b396838.js');
const bcm = require('./bcm-1d1fcf21.js');
const index = require('./index-5279dea2.js');
require('./colors-56282b00.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./package-033055fc.js');

const attendanceActionCommentStyle = index.ce({
  slots: {
    host: [
      // "tw-flex tw-h-fit tw-w-full tw-min-w-[288px] tw-flex-col tw-items-start tw-rounded tw-p-4 tw-shadow-2",
      "tw-w-fit",
      "tw-absolute tw-left-0 tw-right-0 tw-z-tooltip tw-opacity-100 tw-transition-opacity tw-duration-300",
      "tw-rounded tw-bg-white tw-shadow",
      "bcm-ui-element bcm-attendance-actions tw-flex tw-flex-col tw-items-start tw-justify-start tw-p-4 tw-font-medium tw-text-slate-700",
    ],
    footer: ["tw-flex tw-w-full tw-flex-row tw-items-center tw-justify-end tw-gap-2 "],
  },
  variants: {
    size: {
      small: {},
      medium: {},
      large: {},
    },
  },
  defaultVariants: {
    size: "medium",
  },
});

const BcmAttendanceActionsComment = class {
  constructor(hostRef) {
    index$1.registerInstance(this, hostRef);
    this.change = index$1.createEvent(this, "bcm-attendance-actions-comment-change", 3);
    this.lateMinutes = null;
    this.comment = null;
    this._id = generate.Generate.UID();
    this.size = bcm.Bcm.Size.medium;
    this.disabled = false;
    this.selectedKey = null;
    this.targetId = null;
    this.isShow = false;
    this.isLate = false;
    this.selectedItem = null;
  }
  handleSave(lateMinutes, comment) {
    this.change.emit({ lateMinutes, comment });
    this.hide();
  }
  async show() {
    const targetElement = document.getElementById(this.targetId);
    floatingUi.FloatingUI({
      ref: targetElement,
      floating: this.el,
      placement: "bottom-end",
      offset: 8,
      arrow: true,
      arrowColor: "tw-bg-white",
    });
    this.isShow = true;
    await utils.delay(100);
    if (this.isLate) {
      this.focusInput();
    }
    else {
      this.focusTextarea();
    }
  }
  focusInput() {
    const input = this.el.querySelector("bcm-input");
    input === null || input === void 0 ? void 0 : input.onBcmSelect();
  }
  focusTextarea() {
    const textarea = this.el.querySelector("bcm-textarea");
    textarea === null || textarea === void 0 ? void 0 : textarea.onBcmSelect();
  }
  async hide() {
    if (this.isShow) {
      this.el.remove();
    }
  }
  handleClickOutside(event) {
    if (!generate.Generate.findEventPath(event, this.el)) {
      this.hide();
    }
  }
  async formSubmit() {
    var _a, _b, _c;
    const { lateMinutes, comment, isLate } = this;
    if (isLate) {
      if (lateMinutes) {
        if (!(lateMinutes >= 0 && lateMinutes <= 200)) {
          return;
        }
      }
    }
    const { isValid } = await ((_a = this.el.querySelector("bcm-form")) === null || _a === void 0 ? void 0 : _a.submit());
    if (!isValid)
      return;
    this.handleSave(lateMinutes || ((_b = this.selectedItem) === null || _b === void 0 ? void 0 : _b.lateMin), comment || ((_c = this.selectedItem) === null || _c === void 0 ? void 0 : _c.comment));
  }
  render() {
    var _a, _b;
    const { size } = this;
    const { host, footer } = attendanceActionCommentStyle({
      size,
    });
    return (index$1.h(index$1.Host, { class: host(), onKeyDown: e => {
        if (e.key === "Escape")
          this.hide();
      } }, index$1.h("bcm-form", { validation: true, style: { width: "256px" } }, this.isLate ? (index$1.h("bcm-input", { label: "Minus Late", required: true, name: "lateMin", id: this._id + "-input-dropdown-late-content-input", type: "number", size: this.size, autocomplete: false, "no-margin": true, min: 0, max: 200, value: (_a = this.selectedItem) === null || _a === void 0 ? void 0 : _a.lateMin, placeholder: "Enter Minus Late", "onBcm-change": ({ detail }) => (this.lateMinutes = detail), onKeyDown: e => {
        if (e.key === "Enter")
          this.formSubmit();
      } }, index$1.h("i", { slot: "prefix", class: "far fa-clock" }))) : null, index$1.h("bcm-textarea", { name: "comment", value: (_b = this.selectedItem) === null || _b === void 0 ? void 0 : _b.comment, size: this.size, "onBcm-change": ({ detail }) => (this.comment = detail), label: "Description", "no-caption": true, rows: 4, onKeyDown: e => {
        if (e.key === "Enter")
          this.formSubmit();
      } }), index$1.h("footer", { class: footer() }, index$1.h("bcm-button", { class: "tw-order-2", icon: "fas fa-save", "icon-position": "prefix", size: this.size, onClick: () => this.formSubmit() }, "Save"), index$1.h("bcm-button", { class: "tw-order-1", icon: "fas fa-times", kind: "ghost", size: this.size, "icon-position": "prefix", onClick: () => this.hide() }, "Close")))));
  }
  get el() { return index$1.getElement(this); }
};

exports.bcm_attendance_actions_comment = BcmAttendanceActionsComment;
