/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index$1 = require('./index-c591ecec.js');
require('./color-helper-dc98a2ca.js');
require('./datetime-helper-eaf4fadb.js');
const generate = require('./generate-b43c3d3b.js');
require('./number-helper-a708fa79.js');
require('./string-helper-9cdfb273.js');
require('./validators-84d8ae28.js');
require('./element-dragger-a8562f82.js');
const floatingUi = require('./floating-ui-5b396838.js');
const bcm = require('./bcm-1d1fcf21.js');
const index$2 = require('./index-95ae50d0.js');
const index = require('./index-5279dea2.js');
require('./colors-56282b00.js');
require('./utils-fc077139.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./package-033055fc.js');

const attendanceActionDropdownStyle = index.ce({
  slots: {
    host: [
      "tw-w-fit",
      "tw-absolute tw-left-0 tw-right-0 tw-z-tooltip tw-opacity-100 tw-transition-opacity tw-duration-300",
      "tw-overscroll-contain  tw-scroll-smooth tw-rounded tw-bg-white tw-shadow tw-max-h-64 tw-overflow-y-auto",
      "bcm-ui-element bcm-attendance-actions tw-flex tw-flex-col tw-items-start tw-justify-start tw-p-2 tw-font-medium tw-text-slate-700"
    ],
    dataItem: ["tw-flex tw-w-full tw-cursor-pointer tw-flex-row tw-items-start tw-justify-start tw-gap-2 tw-rounded  hover:tw-bg-blue-100"],
    key: ["tw-font-mono tw-text-slate-600"],
    selectedItem: ["tw-bg-blue-100"],
  },
  variants: {
    size: {
      small: {
        dataItem: ["tw-text-2.5 tw-px-2.5 tw-py-2"],
      },
      medium: {
        dataItem: ["tw-text-3 tw-px-3 tw-py-2"],
      },
      large: {
        dataItem: ["tw-text-4 tw-px-4 tw-py-2"],
      },
    }
  },
  defaultVariants: {
    size: "medium"
  },
});

const BcmAttendanceActionsDropdown = class {
  constructor(hostRef) {
    index$1.registerInstance(this, hostRef);
    this.change = index$1.createEvent(this, "bcm-attendance-actions-dropdown-change", 3);
    this._id = generate.Generate.UID();
    this.size = bcm.Bcm.Size.medium;
    this.disabled = false;
    this.selectedKey = null;
    this.targetId = null;
    this.isShow = false;
    this.data = [];
  }
  handleSelectItem(item) {
    this.selectedKey = item.key;
    this.change.emit(item);
  }
  async show() {
    const targetElement = document.getElementById(this.targetId);
    floatingUi.FloatingUI({
      ref: targetElement,
      floating: this.el,
      placement: "bottom-end",
      offset: 4,
    });
    this.isShow = true;
  }
  async hide() {
    if (this.isShow) {
      this.el.remove();
    }
  }
  handleClickOutside() {
    this.hide();
  }
  render() {
    const { size } = this;
    const { host, dataItem, selectedItem, key } = attendanceActionDropdownStyle({
      size,
    });
    return (index$1.h(index$1.Host, { class: host() }, this.data.map((item) => (index$1.h("div", { class: index$2.classnames(dataItem(), this.selectedKey === item.key && selectedItem()), onClick: () => this.handleSelectItem(item) }, index$1.h("span", { class: key() }, item.key, " - "), index$1.h("span", null, item.value))))));
  }
  get el() { return index$1.getElement(this); }
};

exports.bcm_attendance_actions_dropdown = BcmAttendanceActionsDropdown;
