/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
const generate = require('./generate-b43c3d3b.js');
const bcm = require('./bcm-1d1fcf21.js');
const index$2 = require('./index-95ae50d0.js');
const index$1 = require('./index-d321de96.js');
const slotTemplate = require('./slot-template-df7b5b59.js');
const colorHelper = require('./color-helper-dc98a2ca.js');
require('./package-033055fc.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./string-helper-9cdfb273.js');
require('./colors-56282b00.js');
require('./utils-fc077139.js');

const ButtonTemplate = ({ value, type, componentClass, disabled, href, target, loading, isIconOnly, icon, iconPosition, id }) => {
  const ButtonTagType = (href) ? bcm.Bcm$1.HtmlElementType.a : bcm.Bcm$1.HtmlElementType.button;
  return (index.h(ButtonTagType, Object.assign({ id: id }, (type == bcm.Bcm$1.HtmlElementType.button && { type }), { class: componentClass, disabled: disabled, href: href, target: target, tabindex: "0", "aria-label": "button" }),
    index.h("span", { hidden: true },
      index.h("slot", null)),
    loading && index.h("span", { class: "bcm-button__container-loading" },
      " ",
      index.h("span", { class: "bcm-button__container-icon" },
        index.h("i", { class: "far fa-spinner-third fa-spin" }),
        " ")),
    icon && index.h("span", { class: `${iconPosition} bcm-button__container-icon` },
      index.h("i", { class: `${icon}` })),
    !isIconOnly && (index.h(slotTemplate.SlotTemplate, { className: "bcm-button__container-text", value: value })),
    index.h("slot", { name: "suffix" })));
};

const variantOptions = {
  save: {
    text: 'Save',
    color: 'emerald',
    icon: 'far fa-save',
    iconPosition: 'prefix',
  },
  ok: {
    text: 'Ok',
    color: 'emerald',
    icon: 'far fa-check',
    iconPosition: 'prefix',
  },
  new: {
    text: 'New',
    color: 'emerald',
    icon: 'far fa-plus',
    iconPosition: 'prefix',
  },
  add: {
    text: 'Add',
    color: 'emerald',
    icon: 'far fa-plus',
    iconPosition: 'prefix',
  },
  create: {
    text: 'Create',
    color: 'emerald',
    icon: 'far fa-plus',
    iconPosition: 'prefix',
  },
  prev: {
    text: 'Prev',
    color: '',
    icon: 'far fa-arrow-left',
    iconPosition: 'prefix',
  },
  next: {
    text: 'Next',
    color: '',
    icon: 'far fa-arrow-right',
    iconPosition: 'suffix',
  },
  apply: {
    text: 'Apply',
    color: '',
    icon: 'far fa-check-circle',
    iconPosition: 'prefix',
  },
  submit: {
    text: 'Submit',
    color: '',
    icon: 'far fa-save',
    iconPosition: 'prefix',
  },
  send: {
    text: 'Send',
    color: 'emerald',
    icon: 'far fa-paper-plane',
    iconPosition: 'prefix',
  },
  delete: {
    text: 'Delete',
    color: 'red',
    icon: 'far fa-trash',
    iconPosition: 'prefix',
  },
  cancel: {
    text: 'Cancel',
    color: 'red',
    icon: 'far fa-times',
    iconPosition: 'prefix',
  },
  decline: {
    text: 'Decline',
    color: 'red',
    icon: 'far fa-ban',
    iconPosition: 'prefix',
  },
  close: {
    text: 'Close',
    color: 'red',
    icon: 'far fa-times-circle',
    iconPosition: 'prefix',
  },
  archive: {
    text: 'Archive',
    color: 'red',
    icon: 'far fa-folder-open',
    iconPosition: 'prefix',
  },
  remove: {
    text: 'Remove',
    color: 'red',
    icon: 'far fa-minus-circle',
    iconPosition: 'prefix',
  },
  edit: {
    text: 'Edit',
    color: '',
    icon: 'far fa-edit',
    iconPosition: 'prefix',
  },
  export: {
    text: 'Export',
    color: '',
    icon: 'far fa-sign-out',
    iconPosition: 'prefix',
  },
  import: {
    text: 'Import',
    color: '',
    icon: 'far fa-sign-in',
    iconPosition: 'prefix',
  },
  filter: {
    text: 'Filter',
    color: '',
    icon: 'far fa-filter',
    iconPosition: 'prefix',
  },
  update: {
    text: 'Update',
    color: '',
    icon: 'far fa-sync',
    iconPosition: 'prefix',
  },
  reset: {
    text: "Reset",
    color: "",
    icon: 'far fa-sync',
    iconPosition: "prefix",
  },
  download: {
    text: 'Download',
    color: '',
    icon: 'far fa-download',
    iconPosition: 'prefix',
  },
};
var VariantProps;
(function (VariantProps) {
  VariantProps["save"] = "save";
  VariantProps["submit"] = "submit";
  VariantProps["ok"] = "ok";
  VariantProps["new"] = "new";
  VariantProps["add"] = "add";
  VariantProps["create"] = "create";
  VariantProps["apply"] = "apply";
  VariantProps["prev"] = "prev";
  VariantProps["next"] = "next";
  VariantProps["send"] = "send";
  VariantProps["delete"] = "delete";
  VariantProps["cancel"] = "cancel";
  VariantProps["decline"] = "decline";
  VariantProps["close"] = "close";
  VariantProps["archive"] = "archive";
  VariantProps["remove"] = "remove";
  VariantProps["edit"] = "edit";
  VariantProps["export"] = "export";
  VariantProps["import"] = "import";
  VariantProps["filter"] = "filter";
  VariantProps["update"] = "update";
  VariantProps["reset"] = "Reset";
  VariantProps["download"] = "download";
})(VariantProps || (VariantProps = {}));

const { state } = index$1.createStore({
  value: new Map(),
  setData: {},
  removeData: {}
});
const setValue = (val) => {
  const data = Object.assign(Object.assign({}, val), (variantOptions[val.variant] && {
    icon: variantOptions[val.variant].icon,
    value: variantOptions[val.variant].text,
    iconPosition: bcm.Bcm$1.IconPosition[variantOptions[val.variant].iconPosition],
    variantColor: variantOptions[val.variant].color
  }));
  state.value.set(data.id, data);
};
const removeValue = (_id) => {
  state.value.delete(_id);
};
const getValue = (id) => generate.snq(() => state.value.get(id), {});
const buttonState = {
  setValue,
  removeValue,
  getValue
};

const buttonCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");@import url(\"https://fonts.googleapis.com/css2?family=Inter:wght@200;400;500;600&display=swap\"); .size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}*{box-sizing:border-box}.bcm-button{display:inline-flex;width:fit-content;height:fit-content;--bcm-button-solid-color-default:var(--bcm-new-ds-color-white);--bcm-button-solid-background-color-default:var(--bcm-new-ds-color-blue-700);--bcm-button-solid-border-default:var(--bcm-new-ds-color-blue-700);--bcm-button-solid-color-hover:var(--bcm-new-ds-color-white);--bcm-button-solid-background-color-hover:var(--bcm-new-ds-color-blue-800);--bcm-button-solid-border-hover:var(--bcm-new-ds-color-blue-800);--bcm-button-solid-color-focus-visible:var(--bcm-new-ds-color-white);--bcm-button-solid-background-color-focus-visible:var(--bcm-new-ds-color-blue-900);--bcm-button-solid-border-focus-visible:var(--bcm-new-ds-color-blue-900);--bcm-button-solid-color-active:var(--bcm-new-ds-color-white);--bcm-button-solid-background-color-active:var(--bcm-new-ds-color-blue-900);--bcm-button-solid-border-active:var(--bcm-new-ds-color-blue-900);--bcm-button-solid-color-disabled:var(--bcm-new-ds-color-white);--bcm-button-solid-background-color-disabled:var(--bcm-new-ds-color-slate-400);--bcm-button-solid-border-disabled:var(--bcm-new-ds-color-slate-400);--bcm-button-ghost-color-default:var(--bcm-new-ds-color-slate-700);--bcm-button-ghost-background-color-default:var(--bcm-new-ds-color-slate-100);--bcm-button-ghost-border-default:var(--bcm-new-ds-color-slate-300);--bcm-button-ghost-color-hover:var(--bcm-new-ds-color-slate-700);--bcm-button-ghost-background-color-hover:var(--bcm-new-ds-color-slate-200);--bcm-button-ghost-border-hover:var(--bcm-new-ds-color-slate-400);--bcm-button-ghost-color-focus-visible:var(--bcm-new-ds-color-slate-700);--bcm-button-ghost-background-color-focus-visible:var(--bcm-new-ds-color-slate-400);--bcm-button-ghost-border-focus-visible:var(--bcm-new-ds-color-slate-600);--bcm-button-ghost-color-active:var(--bcm-new-ds-color-slate-700);--bcm-button-ghost-background-color-active:var(--bcm-new-ds-color-slate-300);--bcm-button-ghost-border-active:var(--bcm-new-ds-color-slate-500);--bcm-button-ghost-color-disabled:var(--bcm-new-ds-color-slate-300);--bcm-button-ghost-background-color-disabled:var(--bcm-new-ds-color-slate-50);--bcm-button-ghost-border-disabled:var(--bcm-new-ds-color-slate-200);--bcm-button-link-color-default:var(--bcm-new-ds-color-blue-700);--bcm-button-link-background-color-default:var(--bcm-new-ds-color-transparent);--bcm-button-link-border-default:var(--bcm-new-ds-color-transparent);--bcm-button-link-color-hover:var(--bcm-new-ds-color-blue-600);--bcm-button-link-background-color-hover:var(--bcm-new-ds-color-transparent);--bcm-button-link-border-hover:var(--bcm-new-ds-color-transparent);--bcm-button-link-color-focus-visible:var(--bcm-new-ds-color-blue-800);--bcm-button-link-background-color-focus-visible:var(--bcm-new-ds-color-slate-50);--bcm-button-link-border-focus-visible:var(--bcm-new-ds-color-slate-50);--bcm-button-link-color-active:var(--bcm-new-ds-color-blue-700);--bcm-button-link-background-color-active:var(--bcm-new-ds-color-slate-50);--bcm-button-link-border-active:var(--bcm-new-ds-color-slate-50);--bcm-button-link-color-disabled:var(--bcm-new-ds-color-slate-400);--bcm-button-link-background-color-disabled:var(--bcm-new-ds-color-transparent);--bcm-button-link-border-disabled:var(--bcm-new-ds-color-transparent);--bcm-button-ghost-link-color-default:var(--bcm-new-ds-color-slate-700);--bcm-button-ghost-link-background-color-default:var(--bcm-new-ds-color-transparent);--bcm-button-ghost-link-border-default:var(--bcm-new-ds-color-transparent);--bcm-button-ghost-link-color-hover:var(--bcm-new-ds-color-slate-700);--bcm-button-ghost-link-background-color-hover:var(--bcm-new-ds-color-slate-200);--bcm-button-ghost-link-border-hover:var(--bcm-new-ds-color-transparent);--bcm-button-ghost-link-color-focus-visible:var(--bcm-new-ds-color-slate-700);--bcm-button-ghost-link-background-color-focus-visible:var(--bcm-new-ds-color-slate-300);--bcm-button-ghost-link-border-focus-visible:var(--bcm-new-ds-color-transparent);--bcm-button-ghost-link-color-active:var(--bcm-new-ds-color-slate-700);--bcm-button-ghost-link-background-color-active:var(--bcm-new-ds-color-slate-300);--bcm-button-ghost-link-border-active:var(--bcm-new-ds-color-transparent);--bcm-button-ghost-link-color-disabled:var(--bcm-new-ds-color-slate-500);--bcm-button-ghost-link-background-color-disabled:var(--bcm-new-ds-color-transparent);--bcm-button-ghost-link-border-disabled:var(--bcm-new-ds-color-transparent)}.bcm-button.full-width{width:100%}.bcm-button.full-width .bcm-button__container{width:100%}.bcm-button:after,.bcm-button:before{content:\"\";clear:both}.bcm-button__container{border:none;color:inherit;background-color:inherit;padding:0;margin:0;font:inherit;cursor:pointer;outline:none;text-decoration:none;font-family:\"Inter\", sans-serif;font-size:14px;line-height:calc(14px + 8px);font-weight:400;font-weight:500;display:inline-flex;align-items:center;justify-content:center;gap:8px;padding:4px 12px;outline:none;border-radius:4px;transition:background-color 0.1s ease-in-out;position:relative;min-width:40px;border-width:1px;border-style:solid;border-color:initial}.bcm-button__container:hover,.bcm-button__container:focus,.bcm-button__container:active{outline:none;text-decoration:none}.bcm-button__container-loading{position:absolute;top:0;left:0;width:100%;height:100%;border-radius:4px;display:flex;align-items:center;justify-content:center}.bcm-button__container-kind-solid{color:var(--bcm-button-solid-color-default);background-color:var(--bcm-button-solid-background-color-default);border-color:var(--bcm-button-solid-border-default)}.bcm-button__container-kind-solid:hover{color:var(--bcm-button-solid-color-hover);background-color:var(--bcm-button-solid-background-color-hover);border-color:var(--bcm-button-solid-border-hover)}.bcm-button__container-kind-solid:focus-visible{color:var(--bcm-button-solid-color-focus-visible);background-color:var(--bcm-button-solid-background-color-focus-visible);border-color:var(--bcm-button-solid-border-focus-visible)}.bcm-button__container-kind-solid:active{color:var(--bcm-button-solid-color-active);background-color:var(--bcm-button-solid-background-color-active);border-color:var(--bcm-button-solid-border-active)}.bcm-button__container-kind-solid:disabled{color:var(--bcm-button-solid-color-disabled);background-color:var(--bcm-button-solid-background-color-disabled);border-color:var(--bcm-button-solid-border-disabled)}.bcm-button__container-kind-solid.checked{color:var(--bcm-button-solid-color-active);background-color:var(--bcm-button-solid-background-color-active);border-color:var(--bcm-button-solid-border-active)}.bcm-button__container-kind-solid.disabled{color:var(--bcm-button-solid-color-disabled);background-color:var(--bcm-button-solid-background-color-disabled);border-color:var(--bcm-button-solid-border-disabled)}.bcm-button__container-kind-solid .bcm-button__container-loading{color:var(--bcm-button-solid-color-default);background-color:var(--bcm-button-solid-background-color-default);border-color:var(--bcm-button-solid-border-default)}.bcm-button__container-kind-ghost{color:var(--bcm-button-ghost-color-default);background-color:var(--bcm-button-ghost-background-color-default);border-color:var(--bcm-button-ghost-border-default)}.bcm-button__container-kind-ghost:not([disabled]) .bcm-icon{color:var(--bcm-new-ds-color-slate-500)}.bcm-button__container-kind-ghost:hover{color:var(--bcm-button-ghost-color-hover);background-color:var(--bcm-button-ghost-background-color-hover);border-color:var(--bcm-button-ghost-border-hover)}.bcm-button__container-kind-ghost:focus-visible{color:var(--bcm-button-ghost-color-focus-visible);background-color:var(--bcm-button-ghost-background-color-focus-visible);border-color:var(--bcm-button-ghost-border-focus-visible)}.bcm-button__container-kind-ghost:active{color:var(--bcm-button-ghost-color-active);background-color:var(--bcm-button-ghost-background-color-active);border-color:var(--bcm-button-ghost-border-active)}.bcm-button__container-kind-ghost:disabled{color:var(--bcm-button-ghost-color-disabled);background-color:var(--bcm-button-ghost-background-color-disabled);border-color:var(--bcm-button-ghost-border-disabled)}.bcm-button__container-kind-ghost.checked{color:var(--bcm-button-ghost-color-active);background-color:var(--bcm-button-ghost-background-color-active);border-color:var(--bcm-button-ghost-border-active)}.bcm-button__container-kind-ghost.disabled{color:var(--bcm-button-ghost-color-disabled);background-color:var(--bcm-button-ghost-background-color-disabled);border-color:var(--bcm-button-ghost-border-disabled)}.bcm-button__container-kind-ghost .bcm-button__container-loading{color:var(--bcm-button-ghost-color-default);background-color:var(--bcm-button-ghost-background-color-default);border-color:var(--bcm-button-ghost-border-default)}.bcm-button__container-kind-link{color:var(--bcm-button-link-color-default);background-color:var(--bcm-button-link-background-color-default);border-color:var(--bcm-button-link-border-default)}.bcm-button__container-kind-link:hover{color:var(--bcm-button-link-color-hover);background-color:var(--bcm-button-link-background-color-hover);border-color:var(--bcm-button-link-border-hover)}.bcm-button__container-kind-link:focus-visible{color:var(--bcm-button-link-color-focus-visible);background-color:var(--bcm-button-link-background-color-focus-visible);border-color:var(--bcm-button-link-border-focus-visible)}.bcm-button__container-kind-link:active{color:var(--bcm-button-link-color-active);background-color:var(--bcm-button-link-background-color-active);border-color:var(--bcm-button-link-border-active)}.bcm-button__container-kind-link:disabled{color:var(--bcm-button-link-color-disabled);background-color:var(--bcm-button-link-background-color-disabled);border-color:var(--bcm-button-link-border-disabled)}.bcm-button__container-kind-link.checked{color:var(--bcm-button-link-color-active);background-color:var(--bcm-button-link-background-color-active);border-color:var(--bcm-button-link-border-active)}.bcm-button__container-kind-link.disabled{color:var(--bcm-button-link-color-disabled);background-color:var(--bcm-button-link-background-color-disabled);border-color:var(--bcm-button-link-border-disabled)}.bcm-button__container-kind-link .bcm-button__container-loading{color:var(--bcm-button-link-color-default);background-color:var(--bcm-button-link-background-color-default);border-color:var(--bcm-button-link-border-default)}.bcm-button__container-kind-ghost-link{color:var(--bcm-button-ghost-link-color-default);background-color:var(--bcm-button-ghost-link-background-color-default);border-color:var(--bcm-button-ghost-link-border-default)}.bcm-button__container-kind-ghost-link:hover{color:var(--bcm-button-ghost-link-color-hover);background-color:var(--bcm-button-ghost-link-background-color-hover);border-color:var(--bcm-button-ghost-link-border-hover)}.bcm-button__container-kind-ghost-link:focus-visible{color:var(--bcm-button-ghost-link-color-focus-visible);background-color:var(--bcm-button-ghost-link-background-color-focus-visible);border-color:var(--bcm-button-ghost-link-border-focus-visible)}.bcm-button__container-kind-ghost-link:active{color:var(--bcm-button-ghost-link-color-active);background-color:var(--bcm-button-ghost-link-background-color-active);border-color:var(--bcm-button-ghost-link-border-active)}.bcm-button__container-kind-ghost-link:disabled{color:var(--bcm-button-ghost-link-color-disabled);background-color:var(--bcm-button-ghost-link-background-color-disabled);border-color:var(--bcm-button-ghost-link-border-disabled)}.bcm-button__container-kind-ghost-link.checked{color:var(--bcm-button-ghost-link-color-active);background-color:var(--bcm-button-ghost-link-background-color-active);border-color:var(--bcm-button-ghost-link-border-active)}.bcm-button__container-kind-ghost-link.disabled{color:var(--bcm-button-ghost-link-color-disabled);background-color:var(--bcm-button-ghost-link-background-color-disabled);border-color:var(--bcm-button-ghost-link-border-disabled)}.bcm-button__container-kind-ghost-link .bcm-button__container-loading{color:var(--bcm-button-ghost-link-color-default);background-color:var(--bcm-button-ghost-link-background-color-default);border-color:var(--bcm-button-ghost-link-border-default)}.bcm-button__container[disabled]{cursor:not-allowed}.bcm-button__container-text{order:3;display:flex;align-items:center;gap:8px;white-space:nowrap}.bcm-button__container-icon{min-height:calc(12px + 8px)}.bcm-button__container-icon.prefix{order:2}.bcm-button__container-icon.suffix{order:4}.bcm-button__container-size-small{font-size:12px;line-height:calc(12px + 8px);padding:calc(4px - 3px) 12px;min-height:calc(calc(12px + 8px) + calc(calc(4px - 2px)) * 2)}.bcm-button__container-size-small .bcm-button__container-icon{min-height:calc(12px + 8px)}.bcm-button__container-size-medium{font-size:calc(12px + 1px);line-height:calc(12px + 8px);padding:calc(4px + 1px) 12px;min-height:calc(calc(12px + 8px) + calc(calc(4px + 2px)) * 2)}.bcm-button__container-size-medium .bcm-button__container-icon{min-height:calc(12px + 8px)}.bcm-button__container-size-large{font-size:16px;line-height:calc(16px + 8px);padding:calc(8px - 1px) 12px;min-height:calc(calc(16px + 8px) + (calc(8px) * 2))}.bcm-button__container-size-large .bcm-button__container-icon{min-height:calc(16px + 8px)}";

const BcmButton = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.bcmClick = index.createEvent(this, "bcm-click", 7);
    this._id = generate.Generate.UID();
    this.hidden = false;
    this.type = bcm.Bcm$1.ButtonType.button;
    this.size = bcm.Bcm$1.Size.medium;
    this.disabled = false;
    this.kind = bcm.Bcm$1.Kind.solid;
    this.outline = false;
    this.icon = undefined;
    this.href = undefined;
    this.target = undefined;
    this.value = undefined;
    this.loading = false;
    this.variant = undefined;
    this.dataDismiss = false;
    this.fullWidth = false;
    this.iconPosition = bcm.Bcm$1.IconPosition.prefix;
    this.color = undefined;
    this.checked = false;
  }
  handleOnClick(e) {
    if (this.disabled) {
      e.preventDefault();
      e.stopPropagation();
      return false;
    }
  }
  componentWillRender() {
    const { size, kind, icon, iconPosition, disabled, outline, href, type, target, loading, variant, fullWidth, hidden, value } = this;
    buttonState.setValue({
      id: this._id,
      size,
      type,
      kind,
      icon,
      iconPosition,
      disabled,
      outline,
      href,
      target,
      loading,
      variant,
      fullWidth,
      hidden,
      value,
      isIconOnly: !!(this.isHaveChildNodes() && this.icon),
    });
  }
  getStateData() {
    return buttonState.getValue(this._id);
  }
  isHaveChildNodes() {
    const childNodes = Array.from(this.el.childNodes);
    return childNodes.find(node => node.nodeType === Node.TEXT_NODE) === undefined;
  }
  setColor(color = this.color) {
    if (!color)
      return;
    const { kind } = this;
    const prefix = `--bcm-button-${kind}`;
    if (kind === 'solid') {
      return {
        [`${prefix}-color-default`]: colorHelper.ColorHelper.dsColor('white'),
        [`${prefix}-color-hover`]: colorHelper.ColorHelper.dsColor('white'),
        [`${prefix}-color-focus-visible`]: colorHelper.ColorHelper.dsColor('white'),
        [`${prefix}-color-active`]: colorHelper.ColorHelper.dsColor('white'),
        [`${prefix}-color-disabled`]: colorHelper.ColorHelper.dsColor('white'),
        [`${prefix}-background-color-default`]: colorHelper.ColorHelper.dsColor(color + '-700'),
        [`${prefix}-background-color-hover`]: colorHelper.ColorHelper.dsColor(color + '-800'),
        [`${prefix}-background-color-focus-visible`]: colorHelper.ColorHelper.dsColor(color + '-900'),
        [`${prefix}-background-color-active`]: colorHelper.ColorHelper.dsColor(color + '-900'),
        [`${prefix}-background-color-disabled`]: colorHelper.ColorHelper.dsColor('slate-400'),
        [`${prefix}-border-default`]: colorHelper.ColorHelper.dsColor(color + '-700'),
        [`${prefix}-border-hover`]: colorHelper.ColorHelper.dsColor(color + '-800'),
        [`${prefix}-border-focus-visible`]: colorHelper.ColorHelper.dsColor(color + '-900'),
        [`${prefix}-border-active`]: colorHelper.ColorHelper.dsColor(color + '-900'),
        [`${prefix}-border-disabled`]: colorHelper.ColorHelper.dsColor('slate-400')
      };
    }
    else if (kind == 'link') {
      return {
        [`${prefix}-color-default`]: colorHelper.ColorHelper.dsColor(color + '-700'),
        [`${prefix}-color-hover`]: colorHelper.ColorHelper.dsColor(color + '-800'),
        [`${prefix}-color-focus-visible`]: colorHelper.ColorHelper.dsColor(color + '-900'),
        [`${prefix}-color-active`]: colorHelper.ColorHelper.dsColor(color + '-900'),
        [`${prefix}-color-disabled`]: colorHelper.ColorHelper.dsColor('slate-400'),
        [`${prefix}-background-color-default`]: colorHelper.ColorHelper.dsColor('transparent'),
        [`${prefix}-background-color-hover`]: colorHelper.ColorHelper.dsColor('transparent'),
        [`${prefix}-background-color-focus-visible`]: colorHelper.ColorHelper.dsColor('slate-50'),
        [`${prefix}-background-color-active`]: colorHelper.ColorHelper.dsColor('slate-50'),
        [`${prefix}-background-color-disabled`]: colorHelper.ColorHelper.dsColor('transparent'),
        [`${prefix}-border-default`]: colorHelper.ColorHelper.dsColor('transparent'),
        [`${prefix}-border-hover`]: colorHelper.ColorHelper.dsColor('transparent'),
        [`${prefix}-border-focus-visible`]: colorHelper.ColorHelper.dsColor('slate-50'),
        [`${prefix}-border-active`]: colorHelper.ColorHelper.dsColor('slate-50'),
        [`${prefix}-border-disabled`]: colorHelper.ColorHelper.dsColor('transparent')
      };
    }
    else if (kind == 'ghost') {
      return {
        [`${prefix}-color-default`]: colorHelper.ColorHelper.dsColor(color + '-700'),
        [`${prefix}-color-hover`]: colorHelper.ColorHelper.dsColor(color + '-800'),
        [`${prefix}-color-focus-visible`]: colorHelper.ColorHelper.dsColor(color + '-600'),
        [`${prefix}-color-active`]: colorHelper.ColorHelper.dsColor(color + '-600'),
        [`${prefix}-color-disabled`]: colorHelper.ColorHelper.dsColor(color + '-300'),
        [`${prefix}-background-color-default`]: colorHelper.ColorHelper.dsColor(color + '-100'),
        [`${prefix}-background-color-hover`]: colorHelper.ColorHelper.dsColor(color + '-200'),
        [`${prefix}-background-color-focus-visible`]: colorHelper.ColorHelper.dsColor(color + '-400'),
        [`${prefix}-background-color-active`]: colorHelper.ColorHelper.dsColor(color + '-300'),
        [`${prefix}-background-color-disabled`]: colorHelper.ColorHelper.dsColor(color + '-50'),
        [`${prefix}-border-default`]: colorHelper.ColorHelper.dsColor(color + '-300'),
        [`${prefix}-border-hover`]: colorHelper.ColorHelper.dsColor(color + '-400'),
        [`${prefix}-border-focus-visible`]: colorHelper.ColorHelper.dsColor(color + '-600'),
        [`${prefix}-border-active`]: colorHelper.ColorHelper.dsColor(color + '-500'),
        [`${prefix}-border-disabled`]: colorHelper.ColorHelper.dsColor(color + '-200'),
      };
    }
    return;
  }
  render() {
    const { size, kind, disabled, outline, type, href, target, loading, variantColor, fullWidth, hidden, icon, iconPosition, value, isIconOnly, iconSize } = this.getStateData();
    const classPrefix = 'bcm-button';
    let componentClass = index$2.classnames('bcm-button__container', `bcm-button__container-size-${size}`, `bcm-button__container-kind-${outline ? 'ghost' : kind}`, {
      'full-width': fullWidth,
      'checked': this.checked,
      'disabled': disabled,
    });
    const hostClasses = index$2.classnames(`${classPrefix}`, {
      hidden,
      'full-width': fullWidth,
    });
    return (index.h(index.Host, { class: hostClasses, style: this.setColor(variantColor), onClick: () => !disabled && this.bcmClick.emit(this.el) }, index.h(ButtonTemplate, { type: type, value: value, componentClass: componentClass, disabled: disabled, href: href, target: target, icon: icon, loading: loading, iconSize: iconSize, isIconOnly: isIconOnly, iconPosition: iconPosition })));
  }
  get el() { return index.getElement(this); }
};
BcmButton.style = buttonCss;

exports.bcm_button = BcmButton;
