/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
const index$2 = require('./index-95ae50d0.js');
const generate = require('./generate-b43c3d3b.js');
const bcm = require('./bcm-1d1fcf21.js');
const utils = require('./utils-fc077139.js');
const index$1 = require('./index-d321de96.js');
const labelTemplate = require('./label-template-e83447b5.js');
const isLoadDecorator = require('./is-load-decorator-15036f37.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./package-033055fc.js');
require('./colors-250d0982.js');

const CheckboxGroupTemplate = ({ customStyle, groupContainerClasses, onBcmSelect, items }) => {
  return (index.h("div", { class: groupContainerClasses, style: customStyle }, items.childs && items.childs.map((checkbox) => {
    return (index.h("bcm-checkbox", { id: checkbox.id, name: checkbox.name, color: checkbox.color, checked: checkbox.checked, disabled: checkbox.disabled, readonly: checkbox.readonly, required: checkbox.required, noCaption: checkbox.noCaption, "no-margin": true, size: checkbox.size, "full-width": checkbox.fullWidth, onClick: (e) => { !checkbox.disabled && !checkbox.readonly && (onBcmSelect(checkbox.id), e.preventDefault()); } }, checkbox.slot || checkbox.label));
  })));
};

const { state } = index$1.createStore({
  group: new Map(),
  allChecked: true,
  allUnchecked: true,
  changeInderminate: {},
});
const setValue = async ({ fullWidth, optionType, buttonStyle, size, defaultCheckedItems, el, id, label, required, captionType, hidden, direction, childs, indeterminate, gap, noCaption, }) => {
  if (el) {
    state.group.set(id, {
      fullWidth,
      optionType,
      buttonStyle,
      size,
      defaultCheckedItems,
      label,
      required,
      captionType,
      hidden,
      direction,
      indeterminate,
      gap,
      noCaption,
      childs: childs === null || childs === void 0 ? void 0 : childs.map(child => {
        child.checked && (state.allUnchecked = false);
        !child.checked && (state.allChecked = false);
        // fullWidth && (fullWidth == 'flex' ? (child.style.flex = 'auto') : (child.style.width = '100%'));
        optionType && (child.optionType = optionType);
        buttonStyle && (child.buttonStyle = buttonStyle);
        size && (child.size = size);
        defaultCheckedItems && defaultCheckedItems.find(e => e === child.name) && (child.checked = true);
        child.noCaption = noCaption;
        return {
          id: child.id || generate.Generate.UID(),
          checked: child.checked || false,
          name: child.name,
          size: child.size,
          buttonStyle: child.buttonStyle,
          optionType: child.optionType,
          style: child.style,
          noCaption: child.noCaption,
          color: child.color,
          disabled: child.disabled,
          readonly: child.readonly,
          label: child.label || child.name,
          slot: child.slot || generate.snq(() => child.querySelector('.slot').textContent, child.textContent),
          required: child.required || required,
          el: child,
          captionType,
          hidden,
        };
      }),
      indeterminateState: !state.allChecked && !state.allUnchecked ? 'indeterminate' : state.allChecked ? 'determinate' : 'uncheck',
    });
  }
};
const getProperty = id => {
  return generate.snq(() => state.group.get(id), {});
};
const getValue = (id, name) => {
  var _a;
  const group = getProperty(id);
  let value = {};
  (_a = group.childs) === null || _a === void 0 ? void 0 : _a.map(child => {
    if (name) {
      if (child.name === name) {
        value[child.name] = {
          value: !!child.checked,
          name: child.name,
        };
      }
    }
    else {
      value[child.name] = {
        value: !!child.checked,
        name: child.name,
      };
    }
  });
  return value;
};
const getCheckedList = id => {
  var _a;
  const group = getProperty(id);
  let value = {};
  (_a = group.childs) === null || _a === void 0 ? void 0 : _a.map(child => {
    if (child.checked === true) {
      value[child.name] = {
        value: !!child.checked,
        name: child.name,
      };
    }
  });
  return value;
};
const setClear = id => {
  var _a;
  (_a = getProperty(id).childs) === null || _a === void 0 ? void 0 : _a.forEach(child => {
    child.checked = false;
  });
  checkInderminate(id);
};
const setCheckedItems = (id, items, checked, reset) => {
  var _a;
  const checkedItems = items && (typeof items == 'string' ? JSON.parse(items) : items);
  (_a = getProperty(id).childs) === null || _a === void 0 ? void 0 : _a.forEach(child => {
    if (checkedItems) {
      const checkedItem = checkedItems.find(e => e === child.name || e.name === child.name);
      if (checkedItem) {
        if (typeof checkedItem == 'object') {
          Object.keys(checkedItem).map(key => {
            if (key === 'checked') {
              child.checked = checkedItem[key];
            }
            else {
              child.checked = checked;
            }
          });
        }
        else {
          child.checked = checked;
        }
      }
      else {
        reset && (child.checked = false);
      }
    }
    else {
      child.checked = false;
    }
  });
  checkInderminate(id);
};
const resetCaption = id => {
  var _a;
  // const noCaption = getProperty(id).noCaption;
  (_a = getProperty(id).childs) === null || _a === void 0 ? void 0 : _a.forEach(child => {
    child.resetCaption();
    // child.noCaption = noCaption;
  });
};
const changeIndeterminate = id => {
  var _a;
  const group = getProperty(id);
  if (!group.disabled) {
    let checkAll = true;
    if (group.indeterminateState === 'determinate') {
      checkAll = false;
    }
    (_a = getProperty(id).childs) === null || _a === void 0 ? void 0 : _a.map(child => {
      child.checked = checkAll;
    });
    checkInderminate(id);
  }
};
const checkInderminate = id => {
  var _a;
  const group = getProperty(id);
  let allChecked = true;
  let allUnchecked = true;
  (_a = group.childs) === null || _a === void 0 ? void 0 : _a.map(child => {
    child.checked && (allUnchecked = false);
    !child.checked && (allChecked = false);
  });
  group.indeterminateState = !allChecked && !allUnchecked ? 'indeterminate' : allChecked ? 'determinate' : 'uncheck';
};
const onChange = (obj) => {
  var _a;
  (_a = getProperty(obj.id).childs) === null || _a === void 0 ? void 0 : _a.map(child => {
    child.checked = child.id === obj.childId ? !child.checked : child.checked;
  });
  checkInderminate(obj.id);
};
const removeState = id => {
  return Promise.resolve(state.group.delete(id));
};
const getStatesKeys = id => {
  return Object.keys(state.group.get(id));
};
const checkBoxGroupState = {
  setValue,
  getValue,
  setCheckedItems,
  getCheckedList,
  getProperty,
  setClear,
  resetCaption,
  onChange,
  getStatesKeys,
  state,
  removeState,
  changeIndeterminate,
};

const groupCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}.bcm-checkbox-group{display:flex;flex-direction:column;align-items:flex-start;width:100%;margin-bottom:8px}.bcm-checkbox-group.hidden{display:none}.bcm-checkbox-group__container{display:flex;flex-wrap:wrap;justify-content:flex-start;align-items:flex-start;width:100%}.bcm-checkbox-group__container.full-width{max-width:100%}.bcm-checkbox-group__container.vertical{gap:8px;flex-direction:column}.bcm-checkbox-group__container.button{gap:unset}.bcm-checkbox-group__container.indeterminate{padding-top:8px;margin-top:8px;border-top:1px solid #efefef}";

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
    r = Reflect.decorate(decorators, target, key, desc);
  else
    for (var i = decorators.length - 1; i >= 0; i--)
      if (d = decorators[i])
        r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const BcmCheckboxGroup = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.change = index.createEvent(this, "bcm-change", 7);
    this.groupCheckedList = index.createEvent(this, "bcm-group-checked-list", 7);
    this._id = generate.Generate.UID();
    this.direction = bcm.Bcm$1.Direction.horizontal;
    this.items = [];
    this.indeterminate = false;
    this.name = undefined;
    this.value = undefined;
    this.disabled = false;
    this.readonly = false;
    this.hidden = false;
    this.required = false;
    this.label = undefined;
    this.gap = undefined;
    this.defaultValue = undefined;
    this.fullWidth = false;
    this.optionType = 'default';
    this.buttonStyle = 'solid';
    this.size = bcm.Bcm$1.Size.medium;
    this.caption = undefined;
    this.noCaption = false;
    this.captionType = bcm.Bcm$1.Status.default;
    this.tick = {};
  }
  componentDidLoad() {
    this.initState();
  }
  disconnectedCallback() {
    checkBoxGroupState.removeState(this._id);
  }
  componentShouldUpdate(newVal, oldVal, propName) {
    if (propName == 'tick' && newVal !== oldVal) {
      const isHaveChild = generate.snq(() => checkBoxGroupState.getProperty(this._id).childs.length > 0, false);
      if (isHaveChild) {
        this.getValue().then(values => this.value = values);
      }
    }
    if (this.getOptions().indexOf(propName) > -1 && newVal !== oldVal) {
      this.initState();
    }
  }
  getOptions() {
    return generate.snq(() => checkBoxGroupState.getStatesKeys(this._id), []);
  }
  async initState() {
    const { fullWidth, optionType, buttonStyle, size, noCaption, defaultValue, label, required, captionType, hidden, direction, indeterminate, gap, items } = this;
    const defaultCheckedItems = defaultValue && (typeof defaultValue == 'string' ? JSON.parse(defaultValue) : defaultValue);
    const childElements = items.length > 0 ? items : await this.getCheckboxes();
    await checkBoxGroupState.setValue({
      id: this._id,
      el: this.el,
      indeterminate,
      fullWidth,
      optionType,
      buttonStyle,
      size,
      defaultCheckedItems,
      label,
      noCaption,
      required,
      captionType,
      hidden,
      gap,
      direction,
      childs: childElements
    });
    const slotArea = this.el.querySelector(`#bcm-checkbox-group__items-${this._id}`);
    if (slotArea) {
      slotArea.innerHTML && (slotArea.innerHTML = '');
    }
    this.value = await this.getValue();
  }
  async markForCheck() {
    await utils.delay(10);
    this.tick = generate.Generate.UID();
  }
  async onBcmFocus() {
    //focus first item
    const childs = this.getCheckboxes();
    if (childs.length > 0) {
      childs[0].onBcmFocus();
    }
  }
  async onBcmBlur() {
    this.el.blur();
  }
  async setClear() {
    checkBoxGroupState.setClear(this._id);
    await utils.delay(10);
    this.getCheckboxes().forEach(item => {
      item.setClear();
    });
    this.markForCheck();
    await utils.delay(10);
    return Promise.resolve();
  }
  async resetCaption() {
    await utils.delay(10);
    this.getCheckboxes().forEach(item => {
      item.resetCaption();
    });
    await utils.delay(10);
    return Promise.resolve();
  }
  async set(data) {
    if (Array.isArray(data)) {
      await this.check(data, true, true);
    }
  }
  async get() {
    const checklist = await this.getCheckedList() && Object.keys(await this.getCheckedList());
    return checklist.length > 0 ? checklist : [];
  }
  async check(items, checked = true, reset = false) {
    checkBoxGroupState.setCheckedItems(this._id, items, checked, reset);
    this.markForCheck();
  }
  async getValue(name) {
    return Promise.resolve(checkBoxGroupState.getValue(this._id, name));
  }
  async getCheckedList() {
    return checkBoxGroupState.getCheckedList(this._id);
  }
  handleItemsChange() {
    this.initState();
  }
  getCheckboxes() {
    return utils.getChildElements(this.el, 'bcm-checkbox:not(#bcm-indeterminate-element)');
  }
  async getCheckbox(id) {
    const element = this.el.querySelector(`bcm-checkbox[id="${id}"]`);
    if (element) {
      const name = element["name"];
      const value = await this.getValue(name);
      return { element, event: generate.snq(() => value[name], null) };
    }
    return {};
  }
  async indeterminateClick() {
    checkBoxGroupState.changeIndeterminate(this._id);
    this.markForCheck();
  }
  async changeCheckBox(id) {
    checkBoxGroupState.onChange({ id: this._id, childId: id });
    this.markForCheck();
    await utils.delay(10);
    this.value = await this.getValue();
    this.change.emit({ value: this.value, changed: Object.assign({}, await this.getCheckbox(id)) });
    this.groupCheckedList.emit(await this.getCheckedList());
  }
  getItems() {
    return checkBoxGroupState.getProperty(this._id);
  }
  render() {
    const items = this.getItems();
    const { disabled, captionType, label, indeterminate, indeterminateState, required, direction, optionType, hidden, fullWidth, gap } = items;
    const bcmChechboxGroup = index$2.classnames('bcm-checkbox-group', direction, optionType, {
      hidden,
      'full-width': fullWidth
    });
    const bcmChechboxGroupContainer = index$2.classnames('bcm-checkbox-group__container', optionType, {
      [direction]: optionType === 'default',
      indeterminate,
      hidden,
      'full-width': fullWidth
    });
    return (index.h(index.Host, { class: bcmChechboxGroup }, index.h("span", { hidden: true, id: `bcm-checkbox-group__items-${this._id}` }, index.h("slot", null)), index.h("div", { class: "bcm-checkbox-group__label" }, label &&
      index.h("div", null, index.h(labelTemplate.LabelTemplate, { size: this.size, type: captionType, value: label, required: required }))), indeterminate &&
      index.h("bcm-checkbox", { onClick: (e) => { this.indeterminateClick(), e.preventDefault(); }, "no-caption": true, "no-margin": true, id: "bcm-indeterminate-element", indeterminate: indeterminateState, disabled: disabled }, "Check All"), index.h(CheckboxGroupTemplate, { items: items, groupContainerClasses: bcmChechboxGroupContainer, customStyle: gap && ({ 'gap': gap }), onBcmSelect: (id) => this.changeCheckBox(id) })));
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "items": ["handleItemsChange"]
  }; }
};
__decorate([
  isLoadDecorator.IsLoad()
], BcmCheckboxGroup.prototype, "el", void 0);
BcmCheckboxGroup.style = groupCss;

exports.bcm_checkbox_group = BcmCheckboxGroup;
