/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
require('./color-helper-dc98a2ca.js');
require('./datetime-helper-eaf4fadb.js');
const generate = require('./generate-b43c3d3b.js');
require('./number-helper-a708fa79.js');
require('./string-helper-9cdfb273.js');
require('./validators-84d8ae28.js');
require('./element-dragger-a8562f82.js');
const bcm = require('./bcm-1d1fcf21.js');
const captionTemplate = require('./caption-template-85a18b6d.js');
const index$1 = require('./index-95ae50d0.js');
require('./types-cc4adee7.js');
const labelTemplate = require('./label-template-e83447b5.js');
require('./types-7523fd99.js');
require('./colors-56282b00.js');
require('./utils-fc077139.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./package-033055fc.js');

const chipGroupCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}.bcm-chip-group .bcm-chip{cursor:pointer}";

const BcmChipGroup = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.change = index.createEvent(this, "bcm-change", 7);
    this._id = generate.Generate.UID();
    this.name = undefined;
    this.value = undefined;
    this.required = false;
    this.size = "medium";
    this.label = undefined;
    this.caption = undefined;
    this.noCaption = false;
    this.captionType = bcm.Bcm.Status.default;
    this.captionError = undefined;
  }
  handleSelectItem(e) {
    const target = e === null || e === void 0 ? void 0 : e.target;
    if (target instanceof HTMLElement) {
      const data = e.detail;
      const chipItem = document.createElement("bcm-chip");
      // chipItem.setAttribute("type", "dismissable");
      chipItem.setAttribute("value", data.id);
      chipItem.innerHTML = data.text;
      target.parentNode.insertBefore(chipItem, target);
      this.setSelect(data.id);
    }
  }
  handleDismiss(e) {
    const target = e === null || e === void 0 ? void 0 : e.target;
    if (target instanceof HTMLElement) {
      target.remove();
      this.setSelect();
    }
  }
  handleSelect(e) {
    const target = e === null || e === void 0 ? void 0 : e.target;
    if (target instanceof HTMLElement) {
      if (target.type === "addable") {
        this.showListComponent(target.id);
      }
      else {
        this.setSelect(target.value);
      }
    }
  }
  showListComponent(id) {
    const listComponent = document.getElementById(id + "-list");
    if (listComponent) {
      listComponent.show();
    }
  }
  getSlots() {
    return this.el.querySelectorAll("bcm-chip");
  }
  setSelect(val = this.value, noEvent = false) {
    const slots = this.getSlots();
    if ((slots === null || slots === void 0 ? void 0 : slots.length) === 0)
      return;
    const slotArray = Array.from(slots);
    const selectedSlot = slotArray.find(slot => slot.value === val);
    if (!selectedSlot) {
      this.value = slotArray[0].value;
    }
    else {
      this.value = val;
    }
    slotArray.forEach(slot => {
      slot.selected = slot.value === this.value;
    });
    if (!noEvent) {
      this.change.emit(this.value);
    }
  }
  setAttr() {
    const slots = this.getSlots();
    if ((slots === null || slots === void 0 ? void 0 : slots.length) === 0)
      return;
    const slotArray = Array.from(slots);
    slotArray.forEach(slot => {
      slot.setAttribute("size", this.size);
    });
  }
  componentWillLoad() {
    this.setSelect();
  }
  componentDidRender() {
    this.setAttr();
  }
  render() {
    const { label, required, noCaption, captionType, captionError, caption } = this;
    const hostClasses = index$1.classnames("bcm-chip-group");
    return (index.h(index.Host, { class: hostClasses }, label && (index.h("div", null, index.h(labelTemplate.LabelTemplate, { type: captionType, value: label, required: required }))), index.h("div", { class: "tw-flex tw-flex-wrap tw-gap-1" }, index.h("slot", null)), index.h(captionTemplate.CaptionTemplate, { noCaption: noCaption, captionType: captionType, captionError: captionError, caption: caption })));
  }
  get el() { return index.getElement(this); }
};
BcmChipGroup.style = chipGroupCss;

exports.bcm_chip_group = BcmChipGroup;
