/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
require('./color-helper-dc98a2ca.js');
require('./datetime-helper-eaf4fadb.js');
const generate = require('./generate-b43c3d3b.js');
require('./number-helper-a708fa79.js');
require('./string-helper-9cdfb273.js');
require('./validators-84d8ae28.js');
require('./element-dragger-a8562f82.js');
require('./bcm-1d1fcf21.js');
require('./colors-56282b00.js');
require('./utils-fc077139.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./package-033055fc.js');

const BcmColorInput = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this._id = generate.Generate.UID();
    this.label = "";
    this.placeholder = "";
    this.value = "";
    this.required = false;
    this.disabled = false;
    this.readonly = false;
    this.fullWidth = false;
  }
  handleChange(color) {
    this.value = color;
    this.getInputElement().setValue(color);
    index.forceUpdate(this.el);
  }
  getInputElement() {
    return this.el.querySelector(`bcm-input`);
  }
  getPickerElement() {
    return document.querySelector("#" + this._id + "-picker");
  }
  handleInputChanged(e) {
    this.getPickerElement().color = e.detail;
  }
  eyeDropper() {
    const eyeDropper = new window.EyeDropper();
    eyeDropper
      .open()
      .then((color) => {
      this.handleChange(color.sRGBHex);
    })
      .catch((error) => {
      if (error.name === "NotAllowedError") {
        console.log("Permission to access sensor was denied.");
      }
      else if (error.name === "NotSupportedError") {
        console.log("Sensor not supported.");
      }
    });
  }
  isEyeDropperSupported() {
    return typeof window !== "undefined" && "EyeDropper" in window;
  }
  render() {
    return (index.h(index.Host, { class: "tw-block" }, index.h("bcm-input", { id: this._id + "-color", fullWidth: this.fullWidth, label: this.label, placeholder: this.placeholder, type: "text", "onBcm-change": e => this.handleInputChanged(e), value: this.value }, index.h("i", { slot: "prefix", class: "tw-flex tw-h-4 tw-w-4 tw-items-center tw-justify-center tw-rounded-full tw-border tw-border-gray-100", style: {
        backgroundColor: this.value,
      } }), this.isEyeDropperSupported() && index.h("i", { slot: "suffix", class: "far fa-eye-dropper", onClick: () => this.eyeDropper() })), index.h("bcm-linked", { targetId: this._id + "-color-container" }, index.h("bcm-colorful", { id: this._id + "-picker", color: this.value, onBcmChange: e => this.handleChange(e.detail) }))));
  }
  get el() { return index.getElement(this); }
};

exports.bcm_color_input = BcmColorInput;
