/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
const generate = require('./generate-b43c3d3b.js');
const index$1 = require('./index-95ae50d0.js');
require('./package-033055fc.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');

const BcmInputCustom = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.handleFocus = () => {
      this.hasFocus = true;
    };
    this.handleBlur = () => {
      this.hasFocus = false;
    };
    this.handleChange = (e) => {
      this.value = e.target.value;
      console.log(e);
    };
    this.handleInput = (e) => {
      // this.value = (e.target as HTMLInputElement).value;
      console.log(e);
    };
    this._id = generate.Generate.UID();
    this.name = undefined;
    this.value = undefined;
    this.type = "text";
    this.label = undefined;
    this.required = false;
    this.disabled = false;
    this.readonly = false;
    this.placeholder = undefined;
    this.fullwidth = false;
    this.hasFocus = false;
  }
  render() {
    const { _id, type, name, value, label, required, fullwidth, placeholder, disabled, readonly } = this;
    return (index.h(index.Host, { class: index$1.classnames("tw-inline-flex tw-w-full tw-max-w-[256px] tw-flex-col", {
        "tw-max-w-full": fullwidth,
      }) }, label && index.h("bcm-label", { value: label, required: required, htmlFor: _id }), index.h("div", { class: index$1.classnames("tw-relative tw-flex tw-w-full tw-flex-row tw-items-stretch tw-rounded tw-border tw-p-0 hover:tw-border-primary-600", {
        "tw-cursor-not-allowed tw-bg-secondary-50": this.disabled,
        "tw-cursor-text": !this.disabled,
        "tw-cursor-default tw-bg-secondary-50": this.readonly,
        "tw-border-primary-500 tw-bg-secondary-50": this.hasFocus,
        "tw-border-secondary-300 tw-bg-white": !this.hasFocus,
      }) }, index.h("input", { id: _id, name: name, type: type, value: value, "data-value": value, placeholder: placeholder, required: required, disabled: disabled, readonly: readonly, class: index$1.classnames("tw-text-overflow-ellipsis", "tw-rounded-none", "tw-flex-1", "tw-cursor-inherit", "tw-w-full", "tw-appearance-none", "tw-overflow-hidden", "tw-whitespace-nowrap", "tw-border-none", "tw-bg-transparent", "tw-p-2", "tw-text-secondary-600", "tw-placeholder-secondary-300", "tw-outline-none"), onFocus: this.handleFocus, onBlur: this.handleBlur, onChange: e => this.handleChange(e), onInput: this.handleInput }))));
  }
  get el() { return index.getElement(this); }
};

exports.bcm_input_custom = BcmInputCustom;
