/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
const generate = require('./generate-b43c3d3b.js');
const stringHelper = require('./string-helper-9cdfb273.js');
require('./package-033055fc.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./bcm-1d1fcf21.js');

const BcmItems = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.bcmItems = index.createEvent(this, "bcm-items", 7);
    this._id = generate.Generate.UID();
  }
  connectedCallback() {
    if (this.el.children && this.el.children.length > 0) {
      let slots = this.nestedItems(this.el);
      this.bcmItems.emit(slots);
      this.el.remove();
    }
  }
  mapItems(element) {
    var _a;
    const item = element;
    const textContent = (_a = item === null || item === void 0 ? void 0 : item.innerHTML) === null || _a === void 0 ? void 0 : _a.replace(/<bcm-item>.*<\/bcm-item>/g, '').replace(/<bcm-item .*>.*<\/bcm-item>/g, '').replace(/<!--(.|\s)*?-->/g, '').trim();
    const checkAttr = (attr) => stringHelper.StringHelper.elementBooleanCheck(element.getAttribute(attr));
    return Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({ id: element.getAttribute('id') || generate.Generate.UID(), text: element.getAttribute('text') || textContent }, (element.innerHTML.trim() && { isHtmlContent: element.textContent.length > 0 ? (element.innerHTML.trim()) : null })), (checkAttr('disabled') && { disabled: checkAttr('disabled') })), (checkAttr('selected') && { selected: checkAttr('selected') })), (checkAttr('hidden') && { hidden: checkAttr('hidden') })), (checkAttr('checked') && { checked: checkAttr('checked') })), (checkAttr('readonly') && { readonly: checkAttr('readonly') })), (checkAttr('active') && { active: checkAttr('active') })), (checkAttr('icon') && { icon: element.getAttribute('icon') })), (checkAttr('link') && { link: element.getAttribute('link') }));
  }
  nestedItems(element) {
    return generate.snq(() => Array.from(element === null || element === void 0 ? void 0 : element.children).map((child) => {
      var _a;
      return (Object.assign(Object.assign({}, (((_a = child === null || child === void 0 ? void 0 : child.tagName) === null || _a === void 0 ? void 0 : _a.toLowerCase()) === 'bcm-item' && this.mapItems(child))), { items: this.nestedItems(child) }));
    }), []);
  }
  render() {
    return index.h("slot", null);
  }
  get el() { return index.getElement(this); }
};

exports.bcm_items = BcmItems;
