/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
const index$1 = require('./index-95ae50d0.js');
const bcm = require('./bcm-1d1fcf21.js');
require('./_commonjsHelpers-ed84c3ca.js');

const linkCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");@import url(\"https://fonts.googleapis.com/css2?family=Inter:wght@200;400;500;600&display=swap\"); .size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}*{box-sizing:border-box}.bcm-link{font-family:\"Inter\", sans-serif;font-size:14px;line-height:calc(14px + 8px);font-weight:400;display:inline;color:#1D4ED8}.bcm-link.hidden{display:none}.bcm-link.disabled{pointer-events:none;cursor:not-allowed}.bcm-link.disabled .bcm-link__anchor{color:#6B7280}.bcm-link__anchor{display:inline-flex;align-items:baseline;font-size:inherit;color:inherit;text-decoration:none}.bcm-link__anchor.prefix .prefix-icon{margin-right:4px}.bcm-link__anchor.suffix .suffix-icon{margin-left:4px}.bcm-link__anchor:hover,.bcm-link__anchor:focus,.bcm-link__anchor:active,.bcm-link__anchor:focus-visible{outline:none}.bcm-link__anchor:hover{text-decoration:underline}.bcm-link__anchor:active{color:var(--bcm-new-ds-color-blue-700)}.bcm-link__anchor:focus-visible{color:var(--bcm-new-ds-color-blue-800)}.bcm-link__anchor:visited{color:#7E22CE}";

const BcmLink = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.hidden = false;
    this.href = undefined;
    this.target = undefined;
    this.icon = undefined;
    this.disabled = false;
    this.iconPosition = bcm.Bcm$1.IconPosition.prefix;
  }
  handleOnClick(e) {
    if (this.disabled) {
      e.preventDefault();
      e.stopPropagation();
    }
  }
  linkIsExternal(url) {
    return url && !!(url.startsWith('http') || url.startsWith('//'));
  }
  render() {
    const { href, icon, hidden, target, iconPosition, disabled } = this;
    const hostClasses = index$1.classnames('bcm-link', {
      disabled,
      hidden
    });
    const classes = index$1.classnames('bcm-link__anchor', iconPosition, {
      'suffix': this.linkIsExternal(href)
    });
    const ElementTagType = href ? 'a' : 'span';
    return (index.h(index.Host, { disabled: disabled, class: hostClasses }, index.h(ElementTagType, { class: classes, href: href, target: this.linkIsExternal(href) ? '_blank' : target }, icon && iconPosition === bcm.Bcm$1.IconPosition.prefix && index.h("bcm-icon", { class: "prefix-icon", icon: icon }), index.h("slot", null), this.linkIsExternal(href) && index.h("bcm-icon", { class: "suffix-icon", icon: "far fa-external-link-alt" }))));
  }
  get el() { return index.getElement(this); }
};
BcmLink.style = linkCss;

exports.bcm_link = BcmLink;
