/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
require('./color-helper-dc98a2ca.js');
require('./datetime-helper-eaf4fadb.js');
const generate = require('./generate-b43c3d3b.js');
require('./number-helper-a708fa79.js');
require('./string-helper-9cdfb273.js');
require('./validators-84d8ae28.js');
require('./element-dragger-a8562f82.js');
const utils = require('./utils-fc077139.js');
const bcm = require('./bcm-1d1fcf21.js');
const index$1 = require('./index-95ae50d0.js');
require('./colors-56282b00.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./package-033055fc.js');

const BcmModal2 = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.modalClose = index.createEvent(this, "bcm-modal-close", 7);
    this.modalOpen = index.createEvent(this, "bcm-modal-open", 7);
    this.modalBeforeClose = index.createEvent(this, "bcm-modal-before-close", 7);
    this.modalBeforeOpen = index.createEvent(this, "bcm-modal-before-open", 7);
    this._id = generate.Generate.UID();
    this.isShow = false;
    this.center = false;
    this.zIndex = "10400";
    this.size = bcm.Bcm.Size.medium;
    this.backdrop = true;
    this.fullWidth = false;
    this.fullScreen = false;
    this.overflow = true;
    this.isShowModal = false;
    this.shake = false;
  }
  // Listen to the click event on the component and its children
  handleClick(e) {
    // Check if the click event is triggered on a child element with "data-dismiss" attribute
    const dismiss = generate.Generate.findEventPathHasAttribute(e, "data-dismiss");
    // Check if the click event is triggered on the overlay element and backdrop is "static"
    const target = e.target;
    const isClickOverlay = target.attributes.getNamedItem("is-click-overlay");
    if (isClickOverlay && this.backdrop === "static") {
      // Shake the modal if the overlay is clicked and backdrop is "static"
      this.shakeModal();
    }
    else if (dismiss || isClickOverlay) {
      // Hide the modal if the "data-dismiss" element is clicked
      this.hide();
      e.preventDefault();
      e.stopPropagation();
    }
  }
  // Listen to the keydown event on the document element
  handleKeyDown(ev) {
    // Get the top modal in the DOM with "is-show" attribute
    const topModal = Array.from(document.querySelectorAll("bcm-modal-2[is-show]")).pop();
    if (topModal !== this.el) {
      return;
    }
    if (ev.key === "Escape") {
      if (this.backdrop === "static") {
        // Shake the modal if the backdrop is "static" and Escape key is pressed
        this.shakeModal();
      }
      else {
        // Hide the modal if Escape key is pressed
        this.hide();
      }
      ev.preventDefault();
      ev.stopPropagation();
      ev.stopImmediatePropagation();
    }
  }
  // Shake the modal by toggling "shake" state
  shakeModal() {
    this.shake = true;
    setTimeout(() => (this.shake = false), 300);
  }
  // Hide the modal by emitting "bcm-modal-before-close" event
  async hide() {
    this.modalBeforeClose.emit();
  }
  // Listen to "bcm-modal-before-close" event and hide the modal if defaultPrevented is not set
  async hideModal(e) {
    if (e.defaultPrevented) {
      return;
    }
    if (e.target === this.el) {
      this.isShowModal = false;
      await utils.delay(150);
      this.isShow = false;
      this.modalClose.emit();
    }
  }
  // Show the modal by emitting "bcm-modal-before-open" event
  async show() {
    this.modalBeforeOpen.emit();
  }
  // Listen to "bcm-modal-before-open" event and show the modal if defaultPrevented is not set
  async showModal(e) {
    if (e.defaultPrevented) {
      return;
    }
    if (e.target === this.el) {
      this.isShow = true;
      await utils.delay(50);
      this.isShowModal = true;
      document.body.appendChild(this.el);
      this.modalOpen.emit();
    }
  }
  // Get the width of the modal based on the size
  getWidth(size) {
    const sizes = {
      small: "576px",
      medium: "768px",
      large: "992px",
      xlarge: "1024px",
      xxlarge: "1200px",
      xxxlarge: "1700px",
    };
    return sizes[size] || size;
  }
  // Get the modal size
  setSize() {
    const { fullScreen, fullWidth, size, overflow } = this;
    let minHeight = "auto";
    let height = "auto";
    let width = fullWidth ? "100%" : this.getWidth(size);
    if (fullScreen) {
      height = overflow ? "100vh" : "auto";
      width = "100vw";
      minHeight = "100vh";
    }
    return { width, minHeight, height };
  }
  render() {
    return (index.h(index.Host, { class: { "tw-hidden": !this.isShow } }, index.h("bcm-overlay", { "z-index": +this.zIndex - 1, opacity: this.isShowModal ? "0.5" : "0" }), index.h("div", { class: index$1.classnames("tw-fixed tw-inset-0", "tw-flex tw-h-full tw-w-full tw-items-start tw-justify-center", "tw-overflow-y-scroll tw-overscroll-contain tw-font-sans", this.center ? "tw-items-center" : ""), style: {
        zIndex: this.zIndex,
      }, "is-click-overlay": true }, index.h("div", { class: index$1.classnames("tw-flex tw-w-full tw-flex-col", "tw-relative tw-z-modal tw-bg-white", "tw--translate-y-[20px] tw-transform tw-opacity-0 tw-transition tw-duration-300 tw-ease-in-out", this.fullScreen ? "" : `tw-m-4 tw-rounded-lg ${this.overflow ? "tw-max-h-[90vh]" : ""} `, this.shake ? "tw-animate-shake" : ""), style: Object.assign(Object.assign({}, this.setSize()), (this.isShowModal
        ? {
          transform: "translateY(0)",
          opacity: "1",
        }
        : {})) }, index.h("slot", { name: "header" }), index.h("bcm-scroll-area", { "is-disabled": !this.overflow }, index.h("slot", null)), index.h("slot", { name: "footer" })))));
  }
  get el() { return index.getElement(this); }
};

exports.bcm_modal_2 = BcmModal2;
