/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
const index$1 = require('./index-95ae50d0.js');
const colorHelper = require('./color-helper-dc98a2ca.js');
const generate = require('./generate-b43c3d3b.js');
const stringHelper = require('./string-helper-9cdfb273.js');
const popoverPlacement = require('./popover-placement-02e6101b.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./colors-56282b00.js');
require('./utils-fc077139.js');
require('./colors-250d0982.js');
require('./package-033055fc.js');
require('./bcm-1d1fcf21.js');

const popconfirmBoxCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");@import url(\"https://fonts.googleapis.com/css2?family=Inter:wght@200;400;500;600&display=swap\"); .size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}*{box-sizing:border-box}.bcm-popconfirm-box{position:absolute;transition:transform 0.2s ease-in-out;}.bcm-popconfirm-box .bcm-pop-box{font-family:\"Inter\", sans-serif;font-size:14px;line-height:calc(14px + 8px);font-weight:400;font-size:10px;line-height:calc(10px + 8px);box-shadow:0 4px 12px 2px rgba(17, 24, 38, 0.1);border-radius:4px;position:absolute;box-sizing:border-box;background-color:#FFFFFF;border:1px solid #FFFFFF;z-index:-99999;overflow:hidden;visibility:hidden;width:230px;filter:drop-shadow(0px 1px 6px rgba(0, 0, 0, 0.25));padding:8px 16px}.bcm-popconfirm-box .bcm-pop-box .bcm-pop-content{display:flex;flex-direction:row;align-items:flex-start}.bcm-popconfirm-box .bcm-pop-box .bcm-pop-content-icon{margin-right:8px;min-width:16px}.bcm-popconfirm-box .bcm-pop-box .bcm-pop-content-text{display:flex;flex-direction:row;align-items:center;text-align:left;padding-top:1px}.bcm-popconfirm-box .bcm-pop-box .bcm-pop-buttons{display:flex;justify-content:flex-end;margin-top:8px}.bcm-popconfirm-box .bcm-pop-box .bcm-pop-buttons bcm-button:first-child{margin-right:8px}.bcm-popconfirm-box::after{content:\"\";position:absolute;display:none;border:6px solid;z-index:10900;pointer-events:none}.bcm-popconfirm-box.bcm-pop-open{display:block;z-index:10900}.bcm-popconfirm-box.bcm-pop-open .bcm-pop-box{z-index:10900;overflow:unset;visibility:unset}.bcm-popconfirm-box.bcm-pop-open::after{display:block}.bcm-popconfirm-box.top .bcm-pop-box{bottom:100%;margin-bottom:16px}.bcm-popconfirm-box.top::after{bottom:100%;margin-bottom:4px;border-color:#FFFFFF transparent transparent transparent}.bcm-popconfirm-box.bottom .bcm-pop-box{top:100%;margin-top:16px}.bcm-popconfirm-box.bottom::after{top:100%;margin-top:4px;border-color:transparent transparent #FFFFFF transparent}.bcm-popconfirm-box.left .bcm-pop-box{right:100%;margin-right:16px}.bcm-popconfirm-box.left::after{right:100%;margin-right:4px;border-color:transparent transparent transparent #FFFFFF}.bcm-popconfirm-box.right .bcm-pop-box{left:100%;margin-left:16px}.bcm-popconfirm-box.right::after{left:100%;margin-left:4px;border-color:transparent #FFFFFF transparent transparent}.bcm-popconfirm-box.top.center .bcm-pop-box,.bcm-popconfirm-box.bottom.center .bcm-pop-box{left:50%;transform:translateX(-50%)}.bcm-popconfirm-box.top.center::after,.bcm-popconfirm-box.bottom.center::after{left:50%;transform:translateX(-50%)}.bcm-popconfirm-box.top.start .bcm-pop-box,.bcm-popconfirm-box.bottom.start .bcm-pop-box{left:0}.bcm-popconfirm-box.top.start::after,.bcm-popconfirm-box.bottom.start::after{left:16px}.bcm-popconfirm-box.top.end .bcm-pop-box,.bcm-popconfirm-box.bottom.end .bcm-pop-box{right:0}.bcm-popconfirm-box.top.end::after,.bcm-popconfirm-box.bottom.end::after{right:16px}.bcm-popconfirm-box.left.center .bcm-pop-box,.bcm-popconfirm-box.right.center .bcm-pop-box{top:50%;transform:translateY(-50%)}.bcm-popconfirm-box.left.center::after,.bcm-popconfirm-box.right.center::after{top:50%;transform:translateY(-50%)}.bcm-popconfirm-box.left.start .bcm-pop-box,.bcm-popconfirm-box.right.start .bcm-pop-box{top:0}.bcm-popconfirm-box.left.start::after,.bcm-popconfirm-box.right.start::after{top:12px}.bcm-popconfirm-box.left.end .bcm-pop-box,.bcm-popconfirm-box.right.end .bcm-pop-box{bottom:0}.bcm-popconfirm-box.left.end::after,.bcm-popconfirm-box.right.end::after{bottom:12px}.bcm-popconfirm-box.top{transform:translateY(1px)}.bcm-popconfirm-box.bottom{transform:translateY(-1px)}.bcm-popconfirm-box.left{transform:translateX(1px)}.bcm-popconfirm-box.right{transform:translateX(-1px)}.bcm-popconfirm-box.top.bcm-pop-open,.bcm-popconfirm-box.bottom.bcm-pop-open{transform:translateY(0)}.bcm-popconfirm-box.left.bcm-pop-open,.bcm-popconfirm-box.right.bcm-pop-open{transform:translateX(0)}";

const statuses = {
  error: ['fal fa-times-circle', 'red-6'],
  warning: ['fal fa-exclamation-circle', 'warmyellow-6'],
};
const BcmPopconfirmBox = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.onConfirm = index.createEvent(this, "bcm-popconfirm-confirm", 7);
    this.onCancel = index.createEvent(this, "bcm-popconfirm-cancel", 7);
    this.onShow = index.createEvent(this, "bcm-popconfirm-show", 7);
    this._id = generate.Generate.UID();
    this._target_id = undefined;
    this.message = undefined;
    this.status = 'warning';
    this.cancelText = "No";
    this.okeyText = "Yes";
    this.placement = undefined;
    this.open = false;
    this.hidden = false;
    this._internal_id = undefined;
    this.placement_string = undefined;
  }
  getPopconfirm() {
    return document.querySelector(`bcm-popconfirm[id="${this._target_id}"]`);
  }
  handleClickOutside(e) {
    if (this.el.contains(e.target) || this.getPopconfirm().contains(e.target)) {
      return;
    }
    this.getPopconfirm().hide();
    this.hide();
  }
  showHandler(e) {
    if (e.detail != this._target_id) {
      this.getPopconfirm().hide();
      this.hide();
    }
  }
  async show() {
    this.open = true;
    this.onShow.emit(this._target_id);
  }
  async hide() {
    this.open = false;
  }
  componentWillRender() {
    this.calculateLocation();
  }
  calculateLocation() {
    if (this.open) {
      var placement = this.placement;
      const box = this.el.querySelector('.bcm-pop-box');
      const targetElement = document.getElementById(this._target_id).children[0];
      if (box && targetElement) {
        let pos = popoverPlacement.setPosition(placement, targetElement, { top: targetElement.offsetTop, left: targetElement.offsetLeft });
        this.setPlacementString(placement);
        this.el.style.top = pos[0] + 'px';
        this.el.style.left = pos[1] + 'px';
      }
    }
  }
  setPlacementString(placement) {
    const placements = stringHelper.StringHelper.textContains(placement, '-') ? placement.split('-') : placement.split(' ');
    if (placements.length === 1) {
      placements.push('center');
    }
    this.placement_string = placements.join(' ');
  }
  handleConfirm() {
    this.getPopconfirm().hide();
    this.hide();
    this.onConfirm.emit(this._target_id);
  }
  handleCancel() {
    this.getPopconfirm().hide();
    this.hide();
    this.onCancel.emit(this._target_id);
  }
  render() {
    const { message, cancelText, okeyText, open, placement_string, status } = this;
    const statusies = statuses[status];
    const boxClasses = index$1.classnames('bcm-pop-box');
    const hostClasses = index$1.classnames('bcm-popconfirm-box', placement_string, {
      'bcm-pop-open': open,
    });
    return (index.h(index.Host, { class: hostClasses }, index.h("div", { class: boxClasses }, index.h("div", { class: "bcm-pop-content" }, index.h("div", { class: "bcm-pop-content-icon size-3", style: { color: colorHelper.ColorHelper.convertColorToHex(statusies[1]) } }, index.h("bcm-icon", { icon: statusies[0] })), index.h("div", { class: "bcm-pop-content-text" }, index.h("bcm-text", { scale: "size-2", innerHTML: message }))), index.h("div", { class: "bcm-pop-buttons" }, index.h("bcm-button", { size: "small", onClick: () => this.handleCancel(), outline: true }, cancelText), index.h("bcm-button", { size: "small", onClick: () => this.handleConfirm() }, okeyText)))));
  }
  get el() { return index.getElement(this); }
};
BcmPopconfirmBox.style = popconfirmBoxCss;

exports.bcm_popconfirm_box = BcmPopconfirmBox;
