/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
require('./color-helper-dc98a2ca.js');
require('./datetime-helper-eaf4fadb.js');
const generate = require('./generate-b43c3d3b.js');
require('./number-helper-a708fa79.js');
require('./string-helper-9cdfb273.js');
require('./validators-84d8ae28.js');
require('./element-dragger-a8562f82.js');
const utils = require('./utils-fc077139.js');
const bcm = require('./bcm-1d1fcf21.js');
const captionTemplate = require('./caption-template-85a18b6d.js');
const index$1 = require('./index-95ae50d0.js');
require('./types-cc4adee7.js');
require('./types-7523fd99.js');
const isLoadDecorator = require('./is-load-decorator-15036f37.js');
require('./colors-56282b00.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./package-033055fc.js');

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
    r = Reflect.decorate(decorators, target, key, desc);
  else
    for (var i = decorators.length - 1; i >= 0; i--)
      if (d = decorators[i])
        r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const BcmRadioGroup = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.change = index.createEvent(this, "bcm-change", 7);
    this._id = generate.Generate.UID();
    this.label = undefined;
    this.name = undefined;
    this.value = null;
    this.defaultValue = undefined;
    this.size = bcm.Bcm.Size.medium;
    this.disabled = undefined;
    this.hidden = false;
    this.required = false;
    this.gap = undefined;
    this.direction = bcm.Bcm.Direction.horizontal;
    this.fullWidth = false;
    this.items = [];
    this.caption = undefined;
    this.noCaption = false;
    this.captionError = undefined;
    this.captionType = bcm.Bcm.Status.default;
    this.captionCache = undefined;
    this.captionTypeCache = undefined;
  }
  get radios() {
    return Array.from(this.el.querySelectorAll("bcm-radio"));
  }
  get Items() {
    return this.items;
  }
  connectedCallback() {
    this.captionCache = this.caption;
    this.captionTypeCache = this.captionType;
  }
  updateValue() {
    var _a, _b, _c;
    this.value = (_c = (_b = (_a = this.radios) === null || _a === void 0 ? void 0 : _a.find(radio => radio.checked)) === null || _b === void 0 ? void 0 : _b.value) !== null && _c !== void 0 ? _c : null;
  }
  setRadioUpdate() {
    var _a;
    (_a = this.radios) === null || _a === void 0 ? void 0 : _a.forEach(radio => {
      radio.disabled = this.disabled || radio.disabled;
      radio.size = this.size;
      if (this.defaultValue) {
        radio.checked = radio.value == this.defaultValue;
      }
    });
  }
  watchDisabled(newVal, _oldVal) {
    var _a;
    (_a = this.radios) === null || _a === void 0 ? void 0 : _a.forEach(radio => radio.disabled = newVal);
  }
  watchDefaultValue(newVal, _oldVal) {
    var _a;
    (_a = this.radios) === null || _a === void 0 ? void 0 : _a.forEach(radio => radio.checked = radio.value == newVal);
    this.updateValue();
    this.change.emit(this.value);
  }
  componentWillLoad() {
    this.setRadioUpdate();
    this.updateValue();
  }
  handleChange(e) {
    var _a, _b;
    e.stopPropagation();
    e.preventDefault();
    const checked = (_a = e.target.checked) !== null && _a !== void 0 ? _a : false;
    (_b = this.radios) === null || _b === void 0 ? void 0 : _b.forEach(radio => {
      radio.checked = radio.id == e.target.id ? !checked : false;
    });
    this.updateValue();
    this.change.emit(this.value);
  }
  ;
  async setClear() {
    var _a;
    this.value = null;
    (_a = this.radios) === null || _a === void 0 ? void 0 : _a.forEach(radio => {
      radio.checked = false;
    });
  }
  async resetCaption() {
    await utils.delay(10);
    this.caption = this.captionCache;
    this.captionType = this.captionTypeCache;
    this.captionError = null;
    await utils.delay(10);
    return Promise.resolve();
  }
  async check(itemId, checked = true) {
    var _a;
    (_a = this.radios) === null || _a === void 0 ? void 0 : _a.forEach(radio => {
      radio.checked = radio.id == itemId || radio.value == itemId ? checked : false;
    });
    this.updateValue();
    this.change.emit(this.value);
  }
  async get() {
    return this.value;
  }
  async set(data) {
    await this.check(data);
  }
  async getValue() {
    return this.value;
  }
  render() {
    var _a, _b;
    const { direction, fullWidth, gap, label, size, required, disabled, caption, captionError, captionType, noCaption } = this;
    return (index.h(index.Host, { class: "tw-mb-2 tw-flex tw-flex-col", role: "radiogroup", "aria-labelledby": "radiogroup" }, label && index.h("bcm-label", { type: captionType, value: label, required: required }), index.h("div", { class: index$1.classnames("tw-flex tw-flex-wrap", direction == bcm.Bcm.Direction.horizontal ? "tw-flex-row" : "tw-flex-col", fullWidth && "tw-w-full"), style: { "gap": gap } }, index.h("slot", null), ((_a = this.Items) === null || _a === void 0 ? void 0 : _a.length) > 0 &&
      ((_b = this.Items) === null || _b === void 0 ? void 0 : _b.map(item => (index.h("bcm-radio", { id: item.id, value: item.value, disabled: disabled || item.disabled, checked: item.checked, color: item.color, size: size }, item.label))))), index.h(captionTemplate.CaptionTemplate, { noCaption: noCaption, captionType: captionType, captionError: captionError, caption: caption })));
  }
  get el() { return index.getElement(this); }
  static get watchers() { return {
    "disabled": ["watchDisabled"],
    "defaultValue": ["watchDefaultValue"]
  }; }
};
__decorate([
  isLoadDecorator.IsLoad()
], BcmRadioGroup.prototype, "el", void 0);

exports.bcm_radio_group = BcmRadioGroup;
