/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
const bcm = require('./bcm-1d1fcf21.js');
require('./color-helper-dc98a2ca.js');
require('./datetime-helper-eaf4fadb.js');
const generate = require('./generate-b43c3d3b.js');
require('./number-helper-a708fa79.js');
require('./string-helper-9cdfb273.js');
require('./validators-84d8ae28.js');
require('./element-dragger-a8562f82.js');
const index$1 = require('./index-95ae50d0.js');
require('./colors-56282b00.js');
require('./utils-fc077139.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./package-033055fc.js');

const BcmRadio = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.radioChange = index.createEvent(this, "bcm-radio-change", 7);
    this.focus = index.createEvent(this, "bcm-focus", 7);
    this.blur = index.createEvent(this, "bcm-blur", 7);
    this._id = generate.Generate.UID();
    this.checked = undefined;
    this.value = undefined;
    this.disabled = false;
    this.size = bcm.Bcm.Size.medium;
    this.color = undefined;
  }
  render() {
    const { value, size, disabled, checked, _id, color } = this;
    return (index.h(index.Host, { class: index$1.classnames("tw-cursor-pointer tw-font-sans tw-mb-1.5 tw-mt-1", {
        "tw-cursor-pointer tw-text-slate-600": !disabled,
        "tw-cursor-not-allowed tw-text-slate-400": disabled,
        "tw-text-1": size === bcm.Bcm.Size.small,
        "tw-text-2.5": size === bcm.Bcm.Size.medium,
        "tw-text-4": size === bcm.Bcm.Size.large,
      }), style: (generate.Generate.getTwColor(color)) }, index.h("label", { class: index$1.classnames("tw-inline-flex tw-flex-row tw-gap-2 tw-mr-2 tw-items-center", disabled ? "tw-cursor-not-allowed" : "tw-cursor-pointer"), htmlFor: _id + '-input' }, index.h("input", { role: "radio", "aria-label": "radio", id: _id + '-input', type: "radio", value: value, checked: checked, disabled: disabled, class: index$1.classnames("tw-flex tw-items-center tw-justify-center", "tw-relative tw-appearance-none tw-border tw-border-solid tw-rounded-full tw-cursor-pointer tw-transition tw-ease-in-out ", "tw-m-0", "before:tw-content-[''] before:tw-absolute before:tw-rounded-full", {
        "tw-w-4 tw-h-4 before:tw-w-2.5 before:tw-h-2.5": size === bcm.Bcm.Size.medium,
        "tw-w-3.5 tw-h-3.5 before:tw-w-2 before:tw-h-2": size === bcm.Bcm.Size.small,
        "tw-w-4.5 tw-h-4.5 before:tw-w-3 before:tw-h-3": size === bcm.Bcm.Size.large,
      }, "focus:tw-outline-none focus:tw-shadow-outline", 
      // default
      `tw-border-slate-400 tw-bg-slate-50`, `checked:tw-border-default-500`, `checked:before:tw-bg-default-500`, 
      // disabled
      `disabled:tw-border-slate-400 disabled:tw-bg-slate-200 disabled:tw-cursor-not-allowed`, `disabled:checked:tw-border-slate-400`, `disabled:checked:before:tw-bg-slate-400`, !disabled && index$1.classnames(
      // hover
      `hover:tw-border-default-600`, `hover:checked:tw-border-default-600`, `hover:checked:before:tw-bg-default-600`, 
      // focus-visible 
      `focus-visible:tw-border-default-800 focus-visible:tw-shadow-sm`, `focus-visible:checked:tw-border-default-800`, `focus-visible:checked:before:tw-bg-default-800`, 
      // active
      `active:tw-border-default-700`, `active:checked:tw-border-default-700`, `active:checked:before:tw-bg-default-700`)), onChange: () => this.radioChange.emit(), onFocus: () => this.focus.emit(), onBlur: () => this.blur.emit() }), index.h("slot", null))));
  }
  get el() { return index.getElement(this); }
};

exports.bcm_radio = BcmRadio;
