/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
require('./color-helper-dc98a2ca.js');
require('./datetime-helper-eaf4fadb.js');
const generate = require('./generate-b43c3d3b.js');
require('./number-helper-a708fa79.js');
require('./string-helper-9cdfb273.js');
require('./validators-84d8ae28.js');
require('./element-dragger-a8562f82.js');
const bcm = require('./bcm-1d1fcf21.js');
const index$1 = require('./index-95ae50d0.js');
require('./colors-56282b00.js');
require('./utils-fc077139.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./package-033055fc.js');

const osKeys = {
  ctrl: "⌘",
  alt: "⌥",
  shift: "⇧",
  del: "⌫",
  delete: "⌫",
  backspace: "⌦",
  enter: "⏎",
  return: "⏎",
};
const BcmShortcut = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.isMac = /Mac/.test(window.navigator.userAgent);
    this.hotkey = undefined;
    this.color = "slate";
    this.size = bcm.Bcm.Size.small;
  }
  getHotkey(key) {
    if (!key) {
      return "";
    }
    if (this.isMac && (key.includes(" ") || key.includes("+"))) {
      const keys = key.split(/[\s+]+/);
      return keys.map(k => osKeys[k] || k).join("");
    }
    else {
      return key;
    }
  }
  render() {
    const { size, color, hotkey } = this;
    return (index.h(index.Host, { class: index$1.classnames("bcm-ui-element bcm-ui-content-display", "tw-block tw-h-fit tw-w-fit tw-rounded tw-border tw-border-solid tw-px-1", "tw-border-default-300 tw-bg-default-100 tw-text-default-700", "tw-text-center tw-font-medium tw-capitalize", {
        "tw-text-2": size === bcm.Bcm.Size.small,
        "tw-text-3": size === bcm.Bcm.Size.medium,
        "tw-text-4": size === bcm.Bcm.Size.large,
      }), style: Object.assign({}, generate.Generate.getTwColor({ color })) }, this.getHotkey(hotkey)));
  }
};

exports.bcm_shortcut = BcmShortcut;
