/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index$1 = require('./index-c591ecec.js');
require('./color-helper-dc98a2ca.js');
require('./datetime-helper-eaf4fadb.js');
const generate = require('./generate-b43c3d3b.js');
require('./number-helper-a708fa79.js');
require('./string-helper-9cdfb273.js');
require('./validators-84d8ae28.js');
require('./element-dragger-a8562f82.js');
require('./bcm-1d1fcf21.js');
const index = require('./index-5279dea2.js');
require('./colors-56282b00.js');
require('./utils-fc077139.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./package-033055fc.js');

const skeletonStyle = index.ce({
  slots: {
    host: "tw-flex tw-flex-row tw-items-center tw-justify-center tw-flex-shrink-0 tw-relative tw-overflow-hidden tw-bg-gray-200",
  },
  variants: {
    variant: {
      rect: {
        host: "tw-rounded",
      },
      circle: {
        host: "tw-rounded-full",
      },
    },
    effect: {
      pulse: {
        host: "tw-animate-pulse",
      },
      ping: {
        host: "tw-animate-ping",
      },
      none: {
        host: "tw-animate-none",
      },
    },
    hidden: {
      true: {
        host: "tw-hidden",
      },
      false: {
        host: "tw-flex",
      },
    }
  },
  defaultVariants: {
    variant: "rect",
    effect: "pulse",
    hidden: false,
  },
});

const BcmSkeleton = class {
  constructor(hostRef) {
    index$1.registerInstance(this, hostRef);
    this._id = generate.Generate.UID();
    this.effect = "pulse";
    this.variant = "rect";
    this.hidden = false;
    this.width = "100%";
    this.height = "16px";
    this.marginBottom = null;
    this.customStyles = {};
  }
  render() {
    const { variant, effect, width, height, marginBottom, customStyles, hidden } = this;
    const style = Object.assign(Object.assign(Object.assign(Object.assign({}, (width ? { width } : {})), (height ? { height } : {})), (marginBottom ? { marginBottom } : {})), (typeof customStyles === "string" ? JSON.parse(customStyles) : customStyles));
    const { host } = skeletonStyle({ variant, effect, hidden });
    return (index$1.h(index$1.Host, { class: host(), style: style }));
  }
};

exports.bcm_skeleton = BcmSkeleton;
