/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index$1 = require('./index-c591ecec.js');
require('./color-helper-dc98a2ca.js');
require('./datetime-helper-eaf4fadb.js');
const generate = require('./generate-b43c3d3b.js');
require('./number-helper-a708fa79.js');
require('./string-helper-9cdfb273.js');
require('./validators-84d8ae28.js');
require('./element-dragger-a8562f82.js');
const utils = require('./utils-fc077139.js');
const bcm = require('./bcm-1d1fcf21.js');
const index = require('./index-95ae50d0.js');
require('./types-cc4adee7.js');
require('./types-7523fd99.js');
const stepperStates = require('./stepper-states-e293bcd3.js');
require('./colors-56282b00.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./package-033055fc.js');
require('./index-d321de96.js');

const StepperHeaderTemplate = ({ _title, description, status, valid, index: index$2, loading, active, stepChange, statusIcon, icon, disabled, headerHidden, }) => {
  const classes = index.classnames('bcm-stepper__header-item', `bcm-stepper__header-item--${status}`, {
    'bcm-stepper__header-item--active': active,
    'bcm-stepper__header-item--valid': valid,
    'bcm-stepper__header-item--invalid': !valid,
    'bcm-stepper__header-item--disabled': disabled,
    'hidden': headerHidden,
  });
  const defaultIcons = {
    success: 'fal fa-check',
    warning: 'fal fa-exclamation-triangle',
    error: 'fal fa-times',
  };
  const customIcon = (icon || (statusIcon && defaultIcons[status])) && index$1.h("bcm-icon", { icon: icon ? icon : defaultIcons[status] });
  return (index$1.h("div", { class: classes },
    index$1.h("div", { class: "bcm-stepper__header-item--container", onClick: () => !disabled && stepChange(index$2) },
      index$1.h("div", { class: "bcm-stepper__header-item-icon size-3" }, loading ? index$1.h("bcm-icon", { icon: "far fa-spinner-third fa-spin" }) : customIcon || index$2),
      index$1.h("div", { class: "bcm-stepper__header-item-title size-2" }, _title),
      index$1.h("div", { class: "bcm-stepper__header-item-description size-1 tw-text-center", innerHTML: description }))));
};

const stepperCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");@import url(\"https://fonts.googleapis.com/css2?family=Inter:wght@200;400;500;600&display=swap\"); .size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}*{box-sizing:border-box}.bcm-stepper{display:block;font-family:\"Inter\", sans-serif;font-size:14px;line-height:calc(14px + 8px);font-weight:400}.bcm-stepper__header{display:flex;flex-direction:row;justify-content:space-between;align-items:flex-start;padding:16px}.bcm-stepper__header *,.bcm-stepper__header ::after,.bcm-stepper__header ::before{box-sizing:content-box}.bcm-stepper__header-item{display:flex;flex-direction:column;align-items:center;justify-content:center;position:relative;min-width:150px}.bcm-stepper__header-item--container{display:flex;flex-direction:column;align-items:center;justify-content:center;position:relative}.bcm-stepper__header-item-icon{position:relative;width:32px;height:32px;min-width:32px;min-height:32px;display:flex;justify-content:center;align-items:center;border-radius:50%;background-color:var(--bcm-new-ds-color-blue-700);color:var(--bcm-new-ds-color-gray-800);line-height:1;margin-bottom:16px;user-select:none}.bcm-stepper__header-item-icon::before{width:40px;height:40px;border-radius:50%;border:2px solid var(--bcm-new-ds-color-blue-700);border-color:transparent;position:absolute;z-index:0;user-select:none;top:-6px;left:-6px}.bcm-stepper__header-item-title{color:var(--bcm-new-ds-color-gray-800)}.bcm-stepper__header-item-description{color:var(--bcm-new-ds-color-gray-700)}.bcm-stepper__header-item--disabled .bcm-stepper__header-item-title{color:var(--bcm-new-ds-color-gray-500)}.bcm-stepper__header-item--disabled .bcm-stepper__header-item-description{color:var(--bcm-new-ds-color-gray-500)}.bcm-stepper__header-item:not(.bcm-stepper__header-item--disabled):hover{cursor:pointer}.bcm-stepper__header-item:not(.bcm-stepper__header-item--disabled):hover .bcm-stepper__header-item-icon{background-color:var(--bcm-new-ds-color-blue-700)}.bcm-stepper__header-item::before,.bcm-stepper__header-item::after{content:\"\";position:absolute;width:calc(50% - 24px);height:2px;background-color:var(--bcm-new-ds-color-blue-700);top:16px;box-sizing:content-box}.bcm-stepper__header-item::after{right:0;border-radius:3px 0 0 3px}.bcm-stepper__header-item::before{left:0;border-radius:0 3px 3px 0}.bcm-stepper__header-item:first-of-type::before{display:none}.bcm-stepper__header-item:last-of-type::after{display:none}.bcm-stepper__header-item--active .bcm-stepper__header-item-icon::before{content:\"\";border:2px solid var(--bcm-new-ds-color-blue-700)}.bcm-stepper__header-item--active .bcm-stepper__header-item-title{font-weight:500}.bcm-stepper__header-line{width:100%;flex:1;height:2px;background-color:var(--bcm-new-ds-color-blue-700);margin-top:16px}.bcm-stepper__header-line--warning{background-color:var(--bcm-new-ds-color-amber-700)}.bcm-stepper__header-line--warning+.bcm-stepper__header-item::before{background-color:var(--bcm-new-ds-color-amber-700)}.bcm-stepper__header-item--warning::after{background-color:var(--bcm-new-ds-color-amber-700)}.bcm-stepper__header-item--warning .bcm-stepper__header-item-icon{background-color:var(--bcm-new-ds-color-amber-700)}.bcm-stepper__header-item--warning .bcm-stepper__header-item-icon::before{border-color:var(--bcm-new-ds-color-amber-700)}.bcm-stepper__header-item--warning:not(.bcm-stepper__header-item--disabled) .bcm-stepper__header-item-icon{color:white}.bcm-stepper__header-item--warning:not(.bcm-stepper__header-item--disabled):hover{cursor:pointer}.bcm-stepper__header-item--warning:not(.bcm-stepper__header-item--disabled):hover .bcm-stepper__header-item-icon{background-color:var(--bcm-new-ds-color-amber-800)}.bcm-stepper__header-line--success{background-color:var(--bcm-new-ds-color-emerald-700)}.bcm-stepper__header-line--success+.bcm-stepper__header-item::before{background-color:var(--bcm-new-ds-color-emerald-700)}.bcm-stepper__header-item--success::after{background-color:var(--bcm-new-ds-color-emerald-700)}.bcm-stepper__header-item--success .bcm-stepper__header-item-icon{background-color:var(--bcm-new-ds-color-emerald-700)}.bcm-stepper__header-item--success .bcm-stepper__header-item-icon::before{border-color:var(--bcm-new-ds-color-emerald-700)}.bcm-stepper__header-item--success:not(.bcm-stepper__header-item--disabled) .bcm-stepper__header-item-icon{color:white}.bcm-stepper__header-item--success:not(.bcm-stepper__header-item--disabled):hover{cursor:pointer}.bcm-stepper__header-item--success:not(.bcm-stepper__header-item--disabled):hover .bcm-stepper__header-item-icon{background-color:var(--bcm-new-ds-color-emerald-800)}.bcm-stepper__header-line--error{background-color:var(--bcm-new-ds-color-gray-300)}.bcm-stepper__header-line--error+.bcm-stepper__header-item::before{background-color:var(--bcm-new-ds-color-gray-300)}.bcm-stepper__header-item--error::after{background-color:var(--bcm-new-ds-color-gray-300)}.bcm-stepper__header-item--error .bcm-stepper__header-item-icon{background-color:var(--bcm-new-ds-color-red-700)}.bcm-stepper__header-item--error .bcm-stepper__header-item-icon::before{border-color:var(--bcm-new-ds-color-red-700)}.bcm-stepper__header-item--error:not(.bcm-stepper__header-item--disabled) .bcm-stepper__header-item-icon{color:white}.bcm-stepper__header-item--error:not(.bcm-stepper__header-item--disabled):hover{cursor:pointer}.bcm-stepper__header-item--error:not(.bcm-stepper__header-item--disabled):hover .bcm-stepper__header-item-icon{background-color:var(--bcm-new-ds-color-red-800)}.bcm-stepper__header-line--default{background-color:var(--bcm-new-ds-color-gray-300)}.bcm-stepper__header-line--default+.bcm-stepper__header-item::before{background-color:var(--bcm-new-ds-color-gray-300)}.bcm-stepper__header-item--default::after{background-color:var(--bcm-new-ds-color-gray-300)}.bcm-stepper__header-item--default .bcm-stepper__header-item-icon{background-color:var(--bcm-new-ds-color-blue-700)}.bcm-stepper__header-item--default .bcm-stepper__header-item-icon::before{border-color:var(--bcm-new-ds-color-blue-700)}.bcm-stepper__header-item--default:not(.bcm-stepper__header-item--disabled) .bcm-stepper__header-item-icon{color:white}.bcm-stepper__header-item--default:not(.bcm-stepper__header-item--disabled):hover{cursor:pointer}.bcm-stepper__header-item--default:not(.bcm-stepper__header-item--disabled):hover .bcm-stepper__header-item-icon{background-color:var(--bcm-new-ds-color-blue-800)}.bcm-stepper__header-line--loading{background-color:var(--bcm-new-ds-color-blue-700)}.bcm-stepper__header-line--loading+.bcm-stepper__header-item::before{background-color:var(--bcm-new-ds-color-blue-700)}.bcm-stepper__header-item--loading::after{background-color:var(--bcm-new-ds-color-blue-700)}.bcm-stepper__header-item--loading .bcm-stepper__header-item-icon{background-color:var(--bcm-new-ds-color-blue-700)}.bcm-stepper__header-item--loading .bcm-stepper__header-item-icon::before{border-color:var(--bcm-new-ds-color-blue-700)}.bcm-stepper__header-item--loading:not(.bcm-stepper__header-item--disabled) .bcm-stepper__header-item-icon{color:white}.bcm-stepper__header-item--loading:not(.bcm-stepper__header-item--disabled):hover{cursor:pointer}.bcm-stepper__header-item--loading:not(.bcm-stepper__header-item--disabled):hover .bcm-stepper__header-item-icon{background-color:var(--bcm-new-ds-color-blue-800)}.bcm-stepper__header-line--disabled{background-color:var(--bcm-new-ds-color-gray-300)}.bcm-stepper__header-line--disabled+.bcm-stepper__header-item::before{background-color:var(--bcm-new-ds-color-gray-300)}.bcm-stepper__header-item--disabled::after{background-color:var(--bcm-new-ds-color-gray-300)}.bcm-stepper__header-item--disabled .bcm-stepper__header-item-icon{background-color:var(--bcm-new-ds-color-gray-300)}.bcm-stepper__header-item--disabled .bcm-stepper__header-item-icon::before{border-color:var(--bcm-new-ds-color-gray-300)}.bcm-stepper__header-item--disabled:not(.bcm-stepper__header-item--disabled) .bcm-stepper__header-item-icon{color:white}.bcm-stepper__header-item--disabled:not(.bcm-stepper__header-item--disabled):hover{cursor:pointer}.bcm-stepper__header-item--disabled:not(.bcm-stepper__header-item--disabled):hover .bcm-stepper__header-item-icon{background-color:var(--bcm-new-ds-color-gray-400)}.bcm-stepper__header-item--disabled{cursor:not-allowed}.bcm-stepper__header-item--disabled.bcm-stepper__header-item--container{pointer-events:none}.bcm-stepper__step{display:none}.bcm-stepper__step-active{display:block}";

const BcmStepper = class {
  constructor(hostRef) {
    index$1.registerInstance(this, hostRef);
    this.bcmStepChange = index$1.createEvent(this, "bcm-step-change", 7);
    this.bcmStepperBeforeChange = index$1.createEvent(this, "bcm-step-before-change", 7);
    this.hidden = false;
    this._id = generate.Generate.UID();
    this.direction = bcm.Bcm.Direction.horizontal;
    this.linear = false;
    this.size = bcm.Bcm.Size.medium;
    this.icon = false;
    this.active = 1;
    this.stepperId = generate.Generate.UID();
    this.data = [];
    this.tick = {};
  }
  async dataChanged() {
    this.initState();
  }
  componentDidLoad() {
    this.initState();
  }
  disconnectedCallback() {
    // stepperStates.removeState(this.stepperId);
    this.reset();
  }
  async initState() {
    const { stepperId, data, direction, linear, size, icon, active, el } = this;
    const steps = data.length > 0 ? data : this.getSlotElements();
    await stepperStates.stepperStates.setValue({
      id: stepperId,
      el,
      direction,
      linear,
      size,
      icon,
      active,
      steps,
    });
    this.markForCheck();
  }
  componentDidRender() {
    this.setSteps(this.getItems());
  }
  setSteps(steps) {
    const slots = utils.getChildElements(this.el, "bcm-step");
    if (slots.length > 0) {
      slots.forEach((item, index) => {
        const step = steps.find(step => !item.headerHidden && step.id === item.id);
        if (step) {
          generate.Generate.setAttributes(item, Object.assign({ title: "", _title: step.title || step._title || "", status: step.status || "default", disabled: step.disabled || false, valid: step.valid || true, loading: step.loading || false, index: step.index || index, active: step.active || false, innerHtml: step.innerHtml || "" }, (item.hidden == true && { headerHidden: true })));
          if ((item.hidden = false)) {
            item.removeAttribute("hidden");
          }
        }
      });
    }
  }
  markForCheck() {
    this.tick = generate.Generate.UID();
  }
  handleChangeBcmHidden() {
    this.initState();
  }
  getActiveIndex() {
    return stepperStates.stepperStates.getActiveIndex(this.stepperId);
  }
  getSlotElements() {
    return generate.snq(() => utils.getChildElements(this.el, "bcm-step"), []);
  }
  async onStepChange(index) {
    if (index) {
      stepperStates.stepperStates.changeActiveStep(this.stepperId, index);
      this.bcmStepChange.emit(index);
    }
    index$1.forceUpdate(this.el);
    return Promise.resolve(index);
  }
  async prev() {
    const index = this.getActiveIndex() - 1;
    if (index >= 1) {
      if (!this.linear) {
        const previosStep = this.getItems()[index - 1];
        if (previosStep.disabled)
          return;
        await this.onStepChange(index);
      }
      else {
        await this.onStepChange(index);
      }
    }
    index$1.forceUpdate(this.el);
    return Promise.resolve(this.getActiveIndex());
  }
  async next(idx) {
    let index;
    idx == 0 ? (index = 0) : index == 1 ? (index = 1) : (index = idx || this.getActiveIndex());
    const step = await this.getCurrentStep();
    const lastStep = this.getItems()[this.getItems().length - 1];
    if (step.valid) {
      this.linear && lastStep.id != step.id && (step.status = "success");
      if (index < this.getItems().length) {
        await this.onStepChange(index + 1);
      }
    }
    else {
      step.status = "error";
    }
    index$1.forceUpdate(this.el);
    return Promise.resolve(this.getActiveIndex());
  }
  async setActive(index) {
    if (!index)
      return;
    if (typeof index != "number") {
      console.warn("index must be a number");
      return;
    }
    if (this.linear) {
      const prevSteps = this.getItems().filter(item => item.index < index);
      const prevStepIsValid = prevSteps === null || prevSteps === void 0 ? void 0 : prevSteps.map(item => ({
        id: item.id,
        status: item.status,
        disabled: item.disabled,
      })).every(item => item.status == "success" || item.status == "default");
      if (prevStepIsValid) {
        prevSteps === null || prevSteps === void 0 ? void 0 : prevSteps.forEach(item => {
          item.status = "success";
          item.disabled = false;
        });
        await this.next(index - 1);
      }
    }
    else {
      stepperStates.stepperStates.setActiveIndex(this.stepperId, index);
      await this.next(index - 1);
    }
  }
  async reset() {
    await this.onStepChange(1);
    stepperStates.stepperStates.stepperReset(this.stepperId);
    return Promise.resolve(this.getActiveIndex());
  }
  async getCurrentStep() {
    var _a;
    return generate.snq(() => this.getItems().filter(item => item.active == true)[0], (_a = this.getItems()[0]) !== null && _a !== void 0 ? _a : null);
  }
  async getSteps() {
    return Promise.resolve(this.getItems());
  }
  getItems() {
    return generate.snq(() => { var _a; return (_a = stepperStates.stepperStates.getValue(this.stepperId).steps) === null || _a === void 0 ? void 0 : _a.filter(item => !item.headerHidden); }, []);
  }
  headerClick(index) {
    this.bcmStepperBeforeChange.emit({
      current: this.getActiveIndex() - 1,
      next: index,
    });
  }
  async handleBcmStepBeforeChange(e) {
    if (e.defaultPrevented) {
      return;
    }
    if (e.target === this.el) {
      const { next } = e.detail;
      this.next(next);
    }
  }
  render() {
    const { hidden, direction, linear, size } = this;
    const hostClasses = index.classnames("bcm-ui-element tw-font-sans tw-antialiased", "bcm-stepper", "bcm-stepper__direction-" + direction, "bcm-stepper__size-" + size, {
      "bcm-stepper__linear": linear,
      hidden,
    });
    const lineClasses = item => index.classnames("bcm-stepper__header-line", `bcm-stepper__header-line--${(item === null || item === void 0 ? void 0 : item.disabled) ? "disabled" : (item === null || item === void 0 ? void 0 : item.status) === "error" ? "default" : item === null || item === void 0 ? void 0 : item.status}`);
    const items = this.getItems();
    return (index$1.h(index$1.Host, { class: hostClasses }, index$1.h("span", { hidden: true, id: `bcm-stepper__steps-${this._id}` }, index$1.h("slot", null)), index$1.h("main", null, index$1.h("header", { class: "bcm-stepper__header" }, items === null || items === void 0 ? void 0 : items.map((item, index) => [
      index$1.h(StepperHeaderTemplate, Object.assign({}, item, { stepChange: step => this.headerClick(step - 1) })),
      items.length > index + 1 && index$1.h("div", { class: lineClasses(item) }),
    ])), index$1.h("section", { class: "bcm-stepper__body" }, this.data && this.data.length > 0 ? items === null || items === void 0 ? void 0 : items.map(item => index$1.h("bcm-step", Object.assign({}, item))) : index$1.h("slot", null)))));
  }
  get el() { return index$1.getElement(this); }
  static get watchers() { return {
    "data": ["dataChanged"]
  }; }
};
BcmStepper.style = stepperCss;

exports.bcm_stepper = BcmStepper;
