/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
require('./color-helper-dc98a2ca.js');
require('./datetime-helper-eaf4fadb.js');
const generate = require('./generate-b43c3d3b.js');
require('./number-helper-a708fa79.js');
require('./string-helper-9cdfb273.js');
require('./validators-84d8ae28.js');
require('./element-dragger-a8562f82.js');
const bcm = require('./bcm-1d1fcf21.js');
const index$1 = require('./index-95ae50d0.js');
require('./colors-56282b00.js');
require('./utils-fc077139.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./package-033055fc.js');

const BcmTabItemHeader = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this._id = generate.Generate.UID();
    this.active = false;
    this.disabled = false;
    this.index = undefined;
    this.color = "blue";
    this.size = bcm.Bcm.Size.medium;
  }
  handleClick() {
    var _a;
    if (!this.disabled) {
      (_a = generate.Generate.findParentElement(this.el, "bcm-tab-group")) === null || _a === void 0 ? void 0 : _a.setActive(this.index);
    }
  }
  render() {
    const { color, size, active, disabled } = this;
    const tabId = this.el.getAttribute("tab-id");
    const disabledClass = "tw-cursor-not-allowed tw-text-gray-500 tw-opacity-50";
    const dc = generate.Generate.getTwColor({
      color: color,
      tones: [700, 800, 900]
    });
    return (index.h(index.Host, { role: "tab", id: `tab-${tabId}`, "aria-selected": active ? "true" : "false", "aria-controls": tabId, onClick: () => this.handleClick(), class: index$1.classnames(`tw-font-medium tw-flex tw-flex-1 tw-items-center tw-justify-center tw-border-0 tw-border-solid tw-border-b-[2px] tw-border-b-gray-300  tw-transition-font tw-focus:outline-none`, {
        "tw-text-2 tw-pt-1 tw-pb-1 tw-gap-2": size === bcm.Bcm.Size.small,
        "tw-text-3 tw-pt-2 tw-pb-2.5 tw-gap-2.5": size === bcm.Bcm.Size.medium,
        "tw-text-4 tw-pt-3 tw-pb-3 tw-gap-3": size === bcm.Bcm.Size.large,
      }, disabled ? disabledClass : "tw-cursor-pointer", active
        ? `tw-text-default-700 enabled:hover:tw-text-default-800 enabled:active:tw-text-default-900 enabled:focus-visible:tw-text-default-900`
        : "tw-text-gray-700"), style: dc }));
  }
  get el() { return index.getElement(this); }
};

exports.bcm_tab_item_header = BcmTabItemHeader;
