/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
require('./color-helper-dc98a2ca.js');
require('./datetime-helper-eaf4fadb.js');
const generate = require('./generate-b43c3d3b.js');
require('./number-helper-a708fa79.js');
require('./string-helper-9cdfb273.js');
require('./validators-84d8ae28.js');
require('./element-dragger-a8562f82.js');
require('./bcm-1d1fcf21.js');
require('./colors-56282b00.js');
require('./utils-fc077139.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./package-033055fc.js');

const BcmTabItem = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this._id = generate.Generate.UID();
    this.active = false;
    this.disabled = false;
    this.index = undefined;
  }
  componentWillLoad() {
    this.indexControl();
  }
  componentDidRender() {
    this.headerMove();
  }
  getHeaderItem() {
    const headerItem = this.el.querySelector("bcm-tab-item-header");
    if (headerItem) {
      headerItem.setAttribute("index", `${this.index}`);
      headerItem.setAttribute("active", `${this.active}`);
      headerItem.setAttribute("disabled", `${this.disabled}`);
      headerItem.setAttribute("tab-id", `${this._id}`);
      headerItem.style.order = `${this.index}`;
    }
    return headerItem;
  }
  getParentTabGroup() {
    return generate.Generate.findParentElement(this.el, "bcm-tab-group");
  }
  getFindHeaderItem() {
    var _a, _b;
    return (_b = (_a = this.getParentTabGroup()) === null || _a === void 0 ? void 0 : _a.querySelector("#tab-header")) === null || _b === void 0 ? void 0 : _b.querySelector(`bcm-tab-item-header[tab-id="${this._id}"]`);
  }
  headerMove() {
    var _a, _b, _c, _d;
    if (this.getHeaderItem()) {
      (_a = this.getFindHeaderItem()) === null || _a === void 0 ? void 0 : _a.remove();
      (_c = (_b = this.getParentTabGroup()) === null || _b === void 0 ? void 0 : _b.querySelector("#tab-header")) === null || _c === void 0 ? void 0 : _c.appendChild(this.getHeaderItem());
      (_d = this.el.parentElement) === null || _d === void 0 ? void 0 : _d.refresh();
    }
  }
  indexControl() {
    var _a;
    if (!this.index) {
      (_a = generate.Generate.findParentElement(this.el, "bcm-tab-group")) === null || _a === void 0 ? void 0 : _a.querySelectorAll("bcm-tab-item").forEach((item, index) => {
        if (item === this.el) {
          item.setAttribute("index", `${index + 1}`);
        }
      });
    }
  }
  componentDidLoad() {
    const observer = new MutationObserver(() => {
      this.headerMove();
    });
    observer.observe(this.el, { childList: true, subtree: true });
  }
  render() {
    return (index.h(index.Host, { id: this._id, role: "tabpanel", "aria-labelledby": `tab-${this._id}`, "aria-hidden": !this.active ? "true" : "false", class: {
        "tw-block": this.active,
        "tw-hidden": !this.active,
        "tw-opacity-50": this.disabled,
        "tw-w-full": true,
      } }, index.h("slot", null)));
  }
  get el() { return index.getElement(this); }
};

exports.bcm_tab_item = BcmTabItem;
