/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index$1 = require('./index-c591ecec.js');
const generate = require('./generate-b43c3d3b.js');
const bcm = require('./bcm-1d1fcf21.js');
const index = require('./index-95ae50d0.js');
const numberHelper = require('./number-helper-a708fa79.js');
const utils = require('./utils-fc077139.js');
const colors = require('./colors-56282b00.js');
const types = require('./types-7523fd99.js');
require('./package-033055fc.js');
require('./colors-250d0982.js');
require('./_commonjsHelpers-ed84c3ca.js');

const TagTemplate = ({ _id, color, customStyle, size, checked, hidden, value, type, onDismiss, onSelect }) => {
  !size && (size = bcm.Bcm$1.FontSize['size-1']);
  const getColor = (color) => {
    if ((type === bcm.Bcm$1.TagType.basic || type == bcm.Bcm$1.TagType.dismissable) && types.ColorProps[color])
      return {
        color: utils.extractColor(colors.ColorPalette, types.ColorProps[color] + '-6'),
        borderColor: utils.extractColor(colors.ColorPalette, types.ColorProps[color] + '-3'),
        backgroundColor: utils.extractColor(colors.ColorPalette, types.ColorProps[color] + '-1')
      };
  };
  const getSize = (size, returnNumber = false) => {
    if (numberHelper.NumberHelper.isNumber(size)) {
      size = bcm.Bcm$1.FontSize["size-" + size] || bcm.Bcm$1.FontSize["size-4"];
    }
    if (returnNumber) {
      return +(bcm.Bcm$1.FontSizeValue[size] || bcm.Bcm$1.FontSizeValue['size-4']) + 2;
    }
    return size;
  };
  const classes = index.classnames(getSize(size), 'bcm-tag__content', type);
  const hostClasses = index.classnames('bcm-tag', {
    hidden
  });
  return (index$1.h("div", { id: _id, class: index.classnames(hostClasses, { checked }) },
    index$1.h("span", { hidden: true },
      index$1.h("slot", null)),
    index$1.h("span", { class: classes, style: getColor(color), onClick: (e) => onSelect(e) },
      type === bcm.Bcm$1.TagType.add && (index$1.h("span", { class: "left" },
        index$1.h("bcm-icon", { icon: "far fa-plus" }))),
      type === bcm.Bcm$1.TagType.checkable && index$1.h("input", { type: "checkbox", checked: checked }),
      index$1.h("span", { class: "value", style: customStyle }, value),
      type === bcm.Bcm$1.TagType.dismissable && (index$1.h("span", { class: "right close-button", onClick: (e) => onDismiss(e) },
        index$1.h("bcm-icon", { icon: "fal fa-times" }))))));
};

const BcmTag = class {
  constructor(hostRef) {
    index$1.registerInstance(this, hostRef);
    this.change = index$1.createEvent(this, "bcm-change", 7);
    this.tagDismissable = index$1.createEvent(this, "bcm-tag-dismissable", 7);
    this.bcmTagSelect = index$1.createEvent(this, "bcm-tag-select", 7);
    this._id = generate.Generate.UID();
    this._internal_id = generate.Generate.UID();
    this.hidden = false;
    this.value = '';
    this.type = bcm.Bcm$1.TagType.basic;
    this.checked = false;
    this.color = undefined;
    this.customStyle = undefined;
    this.itemObject = undefined;
    this.size = bcm.Bcm$1.FontSize['size-1'];
    this.closeFunc = (e) => e;
    this.selectFunc = (e) => e;
  }
  handleClick() {
    this.type === bcm.Bcm$1.TagType.checkable && this.handleChecked();
  }
  handleClose() {
    this.tagDismissable.emit(this.el);
  }
  handleChecked() {
    this.checked = !this.checked;
    this.change.emit(this.checked);
  }
  render() {
    const { type, color, value, customStyle, size, hidden, checked } = this;
    return (index$1.h(TagTemplate, { size: size, hidden: hidden, color: color, customStyle: customStyle, checked: checked, value: value, type: bcm.Bcm$1.TagType[type], onSelect: (e) => { this.bcmTagSelect.emit(e); this.selectFunc({ event: e, id: this._id }); }, onDismiss: (e) => { this.handleClose(); this.closeFunc(e); } }));
  }
  get el() { return index$1.getElement(this); }
};

exports.bcm_tag = BcmTag;
