/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-c591ecec.js');
const index$1 = require('./index-95ae50d0.js');
const colorHelper = require('./color-helper-dc98a2ca.js');
const slotTemplate = require('./slot-template-df7b5b59.js');
require('./_commonjsHelpers-ed84c3ca.js');
require('./colors-56282b00.js');
require('./utils-fc077139.js');
require('./colors-250d0982.js');
require('./string-helper-9cdfb273.js');
require('./bcm-1d1fcf21.js');

const textCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");@import url(\"https://fonts.googleapis.com/css2?family=Inter:wght@200;400;500;600&display=swap\"); .size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}*{box-sizing:border-box}.bcm-text{display:inline;font-family:\"Inter\", sans-serif;font-size:14px;line-height:calc(14px + 8px);font-weight:400}.bcm-text.hidden{display:none}.bcm-text__paragraph{margin:0;padding:0}.bcm-text__font-size-1{font-size:10px;line-height:calc(10px + 8px)}.bcm-text__font-size-2{font-size:12px;line-height:calc(12px + 8px)}.bcm-text__font-size-3{font-size:14px;line-height:calc(14px + 8px)}.bcm-text__font-size-4{font-size:16px;line-height:calc(16px + 8px)}.bcm-text__font-size-5{font-size:18px;line-height:calc(18px + 8px)}.bcm-text__font-size-6{font-size:20px;line-height:calc(20px + 8px)}.bcm-text__font-size-7{font-size:24px;line-height:calc(24px + 8px)}.bcm-text__font-size-8{font-size:32px;line-height:calc(32px + 8px)}.bcm-text__font-size-9{font-size:40px;line-height:calc(40px + 8px)}";

const BcmText = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.hidden = false;
    this.scale = undefined;
    this.weight = "400";
    this.color = "slate";
    this.text = undefined;
    this.fontSize = 4;
  }
  render() {
    const { hidden, scale, weight, color, fontSize } = this;
    const hostClasses = index$1.classnames('bcm-text', {
      hidden
    });
    const classes = index$1.classnames('bcm-text__paragraph', `bcm-text__font-size-${fontSize}`, scale);
    const fontWeight = +weight || 400;
    const style = {
      color: colorHelper.ColorHelper.dsColor(color),
      fontWeight
    };
    return (index.h(index.Host, { class: hostClasses }, index.h("span", { hidden: true }, index.h("slot", null)), index.h("p", { class: classes, style: Object.assign({}, style) }, index.h(slotTemplate.SlotTemplate, { value: this.text }))));
  }
  get el() { return index.getElement(this); }
};
BcmText.style = textCss;

exports.bcm_text = BcmText;
