/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

const index$1 = require('./index-c591ecec.js');
const types = require('./types-cc4adee7.js');
const bcm = require('./bcm-1d1fcf21.js');
const index = require('./index-95ae50d0.js');
const generate = require('./generate-b43c3d3b.js');

const InputTemplate = ({ elementType, 
//textarea
rows, 
//props
id, internalId, type, placeholder, value, size, pattern, 
//,
unit, unitPrefix, maxLength, 
//boolean
disabled, clearable, focused, readonly, isPasswordVisible, passwordToggle, noDefaultIcon, inValid, captionType, resize, autocomplete, _suffix, _prefix, 
// custom functions
changePasswordVisibility, handleClear, steps, 
//event functions
ref, handleBlur, handleFocus, handleInput, handleChange, isEyeDropperSupported, eyeDropper, }) => {
  const ElementTagType = bcm.Bcm$1.HtmlElementType[elementType] || bcm.Bcm$1.HtmlElementType.input;
  type = type === "password" && isPasswordVisible ? "text" : type;
  value = generate.snq(() => value, "");
  type = (unit === null || unit === void 0 ? void 0 : unit.length) > 0 && !focused ? "text" : type;
  value = !focused ? value + (value && (unit === null || unit === void 0 ? void 0 : unit.length) > 0 ? " " + unit : "") : value;
  const typeColor = type === "color";
  type = type === "color" ? "text" : type;
  const templateHandleFocus = e => {
    e.target.parentElement.classList.add("focused");
    handleFocus(e);
  };
  const templateHandleBlur = e => {
    e.target.parentElement.classList.remove("focused");
    handleBlur(e);
  };
  var containerClass = index.classnames("bcm-input__container", ElementTagType === bcm.Bcm$1.HtmlElementType.textarea && index.classnames("bcm-input__textarea", "textarea-size-" + bcm.Bcm$1.Size[size], "resize-" + resize, "textarea-" + size), ElementTagType === bcm.Bcm$1.HtmlElementType.input && index.classnames("input-size-" + bcm.Bcm$1.Size[size]), {
    focused: focused,
    clearable: clearable,
    disabled,
    readonly,
    invalid: inValid,
    unit: (unit === null || unit === void 0 ? void 0 : unit.length) > 0,
    // 'empty': value?.length < 1,
    error: captionType === "error",
  });
  const caretContainer = index.classnames("caret-container", {
    unit: (unit === null || unit === void 0 ? void 0 : unit.length) > 0,
    disabled: disabled || readonly || inValid,
  });
  const inputClass = "bcm-input__container--" + size;
  const unitClass = index.classnames(inputClass, "unit-prefix");
  return (index$1.h("div", { class: containerClass, id: id + "-container" },
    index$1.h("span", { hidden: true },
      index$1.h("slot", null)),
    index$1.h("span", { class: "input-prefix" },
      index$1.h("slot", { name: "prefix" }),
      _prefix && _prefix.length > 0 && index$1.h("span", { innerHTML: _prefix }),
      unitPrefix && index$1.h("span", { class: unitClass }, unitPrefix),
      typeColor && (index$1.h("i", { class: "tw-flex tw-h-4 tw-w-4 tw-items-center tw-justify-center tw-rounded-full tw-border tw-border-slate-300", style: {
          backgroundColor: value,
        } }))),
    index$1.h(ElementTagType, Object.assign({ tabindex: "0", id: id + "-input", "bcm-internal-id": internalId, class: "bcm-input-element " + inputClass }, (ElementTagType === bcm.Bcm$1.HtmlElementType.input && {
      type,
      autocomplete: autocomplete ? "on" : "off",
      pattern,
    }), (ElementTagType === bcm.Bcm$1.HtmlElementType.textarea && { rows: rows, resize: resize }), { value: value, maxLength: maxLength, "aria-label": placeholder || "Enter text", "aria-labelledby": id + "-label", title: "", placeholder: placeholder, disabled: disabled, readOnly: readonly, ref: el => ref(el), onBlur: e => templateHandleBlur(e), onFocus: e => templateHandleFocus(e), onInput: e => handleInput(e), onChange: e => handleChange(e) })),
    index$1.h("span", { class: "input-suffix-content" }, clearable && !disabled && !readonly && (index$1.h("span", { class: "input-suffix input-suffix-button input-clear-button", onClick: e => handleClear(e) },
      index$1.h("bcm-icon", { icon: "far fa-times" })))),
    index$1.h("span", { class: "input-suffix-content" }, (type === "password" || type === "text") && passwordToggle && (index$1.h("span", { class: "input-suffix input-suffix-button", onClick: () => changePasswordVisibility() },
      index$1.h("bcm-icon", { icon: isPasswordVisible ? "far fa-eye-slash" : "far fa-eye" })))),
    index$1.h("span", { class: "input-suffix-content" }, Object.keys(types.defaultIcons).includes(type) && !noDefaultIcon && (index$1.h("span", { class: "input-suffix" },
      index$1.h("bcm-icon", { icon: types.defaultIcons[type] })))),
    index$1.h("span", { class: "input-suffix-content" }, type === "number" && (index$1.h("div", { class: caretContainer },
      index$1.h("span", { class: "bcm-input-caret", onClick: () => steps("up") },
        index$1.h("bcm-icon", { icon: "fas fa-caret-up" })),
      index$1.h("span", { class: "bcm-input-caret", onClick: () => steps("down") },
        index$1.h("bcm-icon", { icon: "fas fa-caret-down" }))))),
    index$1.h("span", { class: "input-suffix-content" },
      type !== "number" && (index$1.h("span", { class: "input-suffix" },
        index$1.h("slot", { name: "suffix" }),
        _suffix && _suffix.length > 0 && index$1.h("span", { innerHTML: _suffix }))),
      typeColor && isEyeDropperSupported() && (index$1.h("span", { class: "input-suffix" },
        index$1.h("span", null,
          index$1.h("i", { class: "far fa-eye-dropper", onClick: () => eyeDropper() })))))));
};

exports.InputTemplate = InputTemplate;
