/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
'use strict';

const index = require('./index-c591ecec.js');
const generate = require('./generate-b43c3d3b.js');

function JsonParse(attribute, isMethod = false) {
  return (proto, propName) => {
    const { connectedCallback, componentWillRender } = proto;
    proto.connectedCallback = function () {
      const host = index.getElement(this);
      if (host[propName]) {
        const value = generate.snq(() => host.hasAttribute(attribute) ? host.getAttribute(attribute).valueOf() : host[attribute].valueOf(), null);
        if (value) {
          this[propName] = generate.snq(() => typeof value === 'string' ? JSON.parse(value) : value, []);
          host.removeAttribute(attribute);
        }
      }
      return connectedCallback && connectedCallback.call(this);
    };
    proto.componentWillRender = async function () {
      if (isMethod) {
        const host = index.getElement(this);
        if (isMethod) {
          const value = generate.snq(() => host.hasAttribute(attribute) ? host.getAttribute(attribute).valueOf() : host[attribute].valueOf(), null);
          if (value && value.length > 0 && typeof value === 'string') {
            this[attribute] = generate.snq(() => JSON.parse(value), []);
          }
          host.removeAttribute(attribute);
        }
        return componentWillRender && componentWillRender.call(this);
      }
    };
  };
}

exports.JsonParse = JsonParse;
