/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { tv } from "tailwind-variants";
export const badgeStyle = tv({
  slots: {
    host: "bcm-badge bcm-ui-element bcm-ui-content-display tw-inline-flex tw-items-center tw-justify-center tw-font-normal ",
    base: [
      "bcm-badge__dot tw-z-10",
      "tw-flex tw-items-center tw-justify-center tw-flex-row",
      "tw-rounded-full tw-text-center",
      "tw-bg-[--bcm-badge-bg] tw-text-[--bcm-badge-text]",
      "tw-whitespace-nowrap",
    ],
    dotText: "empty:tw-hidden",
  },
  variants: {
    size: {
      small: {
        host: "tw-text-2 tw-gap-1",
        base: "bcm-badge__dot-size-small tw-text-1 tw-min-w-1.5 tw-min-h-1.5",
        dotText: "tw-px-1.5 tw-min-w-4",
      },
      medium: {
        host: "tw-text-3 tw-gap-1.5",
        base: "bcm-badge__dot-size-medium tw-text-2 tw-min-w-2 tw-min-h-2",
        dotText: "tw-px-1.5 tw-min-w-5",
      },
      large: {
        host: "tw-text-4 tw-gap-2",
        base: "bcm-badge__dot-size-large tw-text-3 tw-min-w-2.5 tw-min-h-2.5",
        dotText: "tw-px-2 tw-min-w-6",
      },
    },
    blink: {
      true: {
        base: [
          "bcm-badge__dot-blink tw-relative",
          "after:tw-content-[''] after:tw-absolute after:tw-top-0 after:tw-left-0 after:tw-z-[-1]",
          "after:tw-w-full after:tw-h-full after:tw-bg-[--bcm-badge-bg] after:tw-opacity-75 after:tw-rounded-full",
          "after:tw-animate-blink after:tw-pointer-events-none",
        ],
      },
    },
  },
  defaultVariants: {
    size: "medium",
    blink: false,
  },
});
