/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h, Host } from '@stencil/core';
import cs from 'classnames';
import Bcm from '../../../models/bcm';
export class BcmDivider {
  constructor() {
    this.hidden = false;
    this.direction = Bcm.Direction.horizontal;
  }
  render() {
    const { hidden, direction } = this;
    const hostClasses = cs('bcm-divider', 'bcm-divider__direction-' + direction, {
      'hidden': hidden
    });
    return (h(Host, { class: hostClasses }, h("span", { hidden: true }, h("slot", null))));
  }
  static get is() { return "bcm-divider"; }
  static get originalStyleUrls() {
    return {
      "$": ["divider.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["divider.css"]
    };
  }
  static get properties() {
    return {
      "hidden": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "hidden",
        "reflect": false,
        "defaultValue": "false"
      },
      "direction": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "DirectionTypes",
          "resolved": "\"horizontal\" | \"vertical\"",
          "references": {
            "DirectionTypes": {
              "location": "import",
              "path": "../../../models/bcm-types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "direction",
        "reflect": false,
        "defaultValue": "Bcm.Direction.horizontal"
      }
    };
  }
  static get elementRef() { return "el"; }
}
