/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { Host, getAssetPath, h } from "@stencil/core";
const customIconList = {
  "message-bot": "message-bot.svg",
};
export class BcmIcon {
  constructor() {
    this.hidden = false;
    this.icon = undefined;
  }
  getIcon() {
    const { icon } = this;
    if (icon in customIconList) {
      const _icon = getAssetPath("./static/" + customIconList[icon]);
      return (h("div", { class: "tw-flex tw-h-fit tw-w-fit tw-items-center tw-justify-center" }, h("img", { src: `${_icon}`, alt: icon, class: "tw-h-fit tw-w-fit" })));
    }
    return h("i", { class: `${icon}` });
  }
  render() {
    const { /*icon,*/ hidden } = this;
    return h(Host, { class: `bcm-icon fa ${hidden ? "hidden" : ""}` }, this.getIcon());
  }
  static get is() { return "bcm-icon"; }
  static get originalStyleUrls() {
    return {
      "$": ["icon.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["icon.css"]
    };
  }
  static get assetsDirs() { return ["static"]; }
  static get properties() {
    return {
      "hidden": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "hidden",
        "reflect": false,
        "defaultValue": "false"
      },
      "icon": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "icon",
        "reflect": false
      }
    };
  }
  static get elementRef() { return "el"; }
}
