/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import snq from "snq";
import { createStore } from "@stencil/store";
import { variantOptions } from "../button/types";
import Bcm from "../../../models/bcm";
const { state } = createStore({
  value: new Map(),
  setData: {},
  removeData: {}
});
const setValue = (val) => {
  const data = Object.assign(Object.assign({}, val), (variantOptions[val.variant] && {
    icon: variantOptions[val.variant].icon,
    value: variantOptions[val.variant].text,
    iconPosition: Bcm.IconPosition[variantOptions[val.variant].iconPosition],
    variantColor: variantOptions[val.variant].color
  }));
  state.value.set(data.id, data);
};
const removeValue = (_id) => {
  state.value.delete(_id);
};
const getValue = (id) => snq(() => state.value.get(id), {});
export default {
  setValue,
  removeValue,
  getValue
};
