/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h, Host } from '@stencil/core';
import { Generate } from '../../../helper/generate';
export class BcmAccordion {
  constructor() {
    this._id = Generate.UID();
    this.multi = false;
  }
  componentDidRender() {
    if (!this.multi)
      this.checkExpandedCount();
  }
  checkExpandedCount() {
    var _a, _b;
    const accordion = this.el.querySelectorAll('.bcm-expansion-panel');
    if (accordion) {
      const checkExpandedCount = Array.from(accordion)
        .map((accordion) => accordion.expanded)
        .filter(Boolean).length;
      if (checkExpandedCount > 1) {
        const getLastExpandedId = (_b = (_a = Array.from(accordion).filter((accordion) => accordion.expanded)) === null || _a === void 0 ? void 0 : _a.pop()) === null || _b === void 0 ? void 0 : _b.id;
        Array.from(accordion).forEach((accordion) => {
          if (accordion.id !== getLastExpandedId) {
            accordion.expanded = false;
          }
        });
      }
    }
  }
  open(event) {
    if (this.multi)
      return;
    const id = event.detail;
    const accordion = this.el.querySelectorAll('.bcm-expansion-panel');
    if (accordion) {
      accordion.forEach((accordion) => {
        if (accordion.id !== id) {
          accordion.expanded = false;
        }
      });
    }
  }
  isLoad(event) {
    var _a, _b, _c;
    if (!this.multi) {
      var parentId = ((_b = (_a = event === null || event === void 0 ? void 0 : event.target) === null || _a === void 0 ? void 0 : _a.parentElement) === null || _b === void 0 ? void 0 : _b.id) || null;
      var nodeName = ((_c = event === null || event === void 0 ? void 0 : event.target) === null || _c === void 0 ? void 0 : _c.nodeName) || null;
      if (nodeName == 'BCM-EXPANSION-PANEL' && this._id == parentId) {
        this.checkExpandedCount();
      }
    }
  }
  render() {
    return (h(Host, { id: this._id }, h("slot", null)));
  }
  static get is() { return "bcm-accordion"; }
  static get originalStyleUrls() {
    return {
      "$": ["accordion.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["accordion.css"]
    };
  }
  static get properties() {
    return {
      "_id": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "id",
        "reflect": true,
        "defaultValue": "Generate.UID()"
      },
      "multi": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "multi",
        "reflect": false,
        "defaultValue": "false"
      }
    };
  }
  static get elementRef() { return "el"; }
  static get listeners() {
    return [{
        "name": "bcm-open",
        "method": "open",
        "target": undefined,
        "capture": false,
        "passive": false
      }, {
        "name": "bcm-is-load",
        "method": "isLoad",
        "target": undefined,
        "capture": false,
        "passive": false
      }];
  }
}
