/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h, Host } from '@stencil/core';
import cs from 'classnames';
import { Generate } from '../../../helper/generate';
export class BcmBreadcrumb {
  constructor() {
    this.items = undefined;
    this.seperator = '/';
    this.hidden = false;
    this.isOpen = false;
  }
  handleClickOutside(e) {
    if (!this.el.contains(e.target)) {
      this.isOpen && (this.isOpen = false);
    }
  }
  handleOpen(id) {
    this.isOpen = this.isOpen == id ? false : id;
  }
  parseItem(item, index) {
    item.index = index;
    item.id = item.id || Generate.UID();
    return item;
  }
  render() {
    const { items, seperator, hidden } = this;
    const hostClasses = cs('bcm-breadcrumb', 'size-2', { hidden });
    const LinkTemplate = (item) => (h("bcm-link", Object.assign({ id: item.id || Generate.UID(), onClick: () => this.bcmBreadcrumb.emit(item), target: item.target && item.index < items.length - 1 ? item.target : '_self' }, ((item.child == true || item.index < items.length - 1) && item.href && {
      href: item.href
    }), { icon: item.icon ? item.icon : null, class: cs({
        'active': item.index === items.length - 1,
        'is-link': (item.child == true || item.index < items.length - 1) && item.href
      }) }), item.label ? item.label : null));
    const DropdownTemplate = (item) => (h("details", { class: cs('bcm-breadcrumb__dropdown-item', { 'active': item.index === items.length - 1, 'open': this.isOpen === item.id }), id: item.id, open: this.isOpen === item.id }, h("summary", { onClick: () => this.handleOpen(item.id), class: this.isOpen === item.id && 'open' }, h("span", { class: "is-link" }, h(LinkTemplate, Object.assign({}, { 'icon': item.icon, 'label': item.label, 'href': 'javascript:void(0)', 'index': item.index })), h("bcm-icon", { icon: "fas fa-caret-down" }))), h("div", { class: "bcm-breadcrumb__dropdown-submenu" }, item.dropdown.map(link => (h("span", { class: "size-2 dropdown-item" }, h(LinkTemplate, Object.assign({}, link, { child: true }))))))));
    return (h(Host, { class: hostClasses }, h("span", { hidden: true }, h("slot", null)), items.map((item, index) => (h("span", { class: "bcm-breadcrumb__item" }, item.dropdown && item.dropdown.length > 0 ? DropdownTemplate(this.parseItem(item, index)) : LinkTemplate(this.parseItem(item, index)), index < items.length - 1 ? h("span", { class: "seperator" }, seperator) : null)))));
  }
  static get is() { return "bcm-breadcrumb"; }
  static get originalStyleUrls() {
    return {
      "$": ["breadcrumb.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["breadcrumb.css"]
    };
  }
  static get properties() {
    return {
      "items": {
        "type": "unknown",
        "mutable": true,
        "complexType": {
          "original": "Array<ItemType>",
          "resolved": "ItemType[]",
          "references": {
            "Array": {
              "location": "global"
            },
            "ItemType": {
              "location": "import",
              "path": "./types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      },
      "seperator": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "seperator",
        "reflect": false,
        "defaultValue": "'/'"
      },
      "hidden": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "hidden",
        "reflect": false,
        "defaultValue": "false"
      }
    };
  }
  static get states() {
    return {
      "isOpen": {}
    };
  }
  static get events() {
    return [{
        "method": "bcmBreadcrumb",
        "name": "bcm-breadcrumb-click",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }];
  }
  static get elementRef() { return "el"; }
  static get listeners() {
    return [{
        "name": "click",
        "method": "handleClickOutside",
        "target": "window",
        "capture": false,
        "passive": false
      }];
  }
}
