/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h, Host } from '@stencil/core';
import cs from 'classnames';
import { Generate } from '../../../helper/generate';
import Bcm from '../../../models/bcm';
export class BcmCheckboxLite {
  constructor() {
    this._id = Generate.UID();
    this.checked = true;
    this.indeterminate = null;
    this.disabled = false;
    this.hidden = false;
    this.required = false;
    this.readOnly = false;
    this.captionType = Bcm.Status.default;
  }
  render() {
    const { disabled, checked, readOnly, required, indeterminate, hidden, captionType, _id } = this;
    // const hostClasses = cs(
    //     'bcm-checkbox',
    //     'bcm-checkbox__type-default',
    //     {
    //         'error': captionType == Bcm.Status.error,
    //         hidden,
    //         checked,
    //         disabled,
    //         required,
    //         readOnly,
    //     }
    // )
    // const bcmCheckboxIconClass = cs(
    //     'bcm-checkbox__icon',
    //     'bcm-checkbox__icon-lite',
    //     'bcm-checkbox__icon-' + indeterminate,
    //     {
    //         checked
    //     }
    // )
    // const bcmCheckboxLabelClass = cs(
    //     'bcm-checkbox__label'
    // )
    const bcmCheckboxClass = cs('bcm-checkbox', `bcm-checkbox-size-medium`, {
      'error': captionType == Bcm.Status.error,
      hidden,
      checked,
      disabled,
      required
    });
    const bcmCheckboxIconClass = cs('bcm-checkbox__label-icon', 'bcm-checkbox__label-icon-lite', 'bcm-checkbox__label-icon-' + indeterminate, {
      'bcm-checkbox__label-icon-checked': checked,
    });
    const bcmCheckboxLabelClass = cs('bcm-checkbox__label');
    const bcmCheckboxInputClass = cs('bcm-checkbox__input');
    return (h(Host, { class: bcmCheckboxClass, style: { 'margin': '0' } }, h("div", { class: bcmCheckboxInputClass, style: {
        'padding-top': '5px'
      } }, h("input", { id: _id, type: "checkbox", checked: checked, disabled: disabled, required: required, readOnly: readOnly }), h("label", { class: bcmCheckboxLabelClass, htmlFor: _id }, h("span", { class: bcmCheckboxIconClass }, h("div", { style: {
        'height': '12px',
        'min-height': '12px',
        'width': '12px',
        'min-width': '12px'
      } }, h("svg", { class: "bcm-icon-lite", width: "100%", height: "100%", viewBox: "0 0 11 9", fill: "none", xmlns: "http://www.w3.org/2000/svg" }, h("path", { d: "M1.91308 4.03516H1.91326C1.99256 4.03525 2.07081 4.05331 2.14213 4.08798C2.21341 4.12262 2.27591 4.17295 2.32497 4.2352L1.91308 4.03516ZM1.91308 4.03516H1.09394C0.890308 4.03516 0.776602 4.26975 0.902321 4.4292L0.902371 4.42927L4.11214 8.49567L4.11218 8.49573C4.32247 8.76188 4.72568 8.76114 4.93667 8.49617L4.93708 8.49566L10.6597 1.24398C10.6598 1.24378 10.66 1.24358 10.6602 1.24338C10.7884 1.08295 10.6699 0.85 10.4689 0.85H9.6498C9.48941 0.85 9.33668 0.9235 9.2376 1.05044C9.23751 1.05055 9.23742 1.05066 9.23734 1.05077L4.52403 7.02157M1.91308 4.03516L4.52403 7.02157M4.52403 7.02157L2.32506 4.23531L4.52403 7.02157Z", fill: "#ffffff" }))))))));
  }
  static get is() { return "bcm-checkbox-lite"; }
  static get originalStyleUrls() {
    return {
      "$": ["../../../global/components/_checkbox.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["../../../global/components/_checkbox.css"]
    };
  }
  static get properties() {
    return {
      "_id": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "id",
        "reflect": true,
        "defaultValue": "Generate.UID()"
      },
      "checked": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "checked",
        "reflect": false,
        "defaultValue": "true"
      },
      "indeterminate": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "IndeterminateTypes",
          "resolved": "\"determinate\" | \"indeterminate\" | \"uncheck\"",
          "references": {
            "IndeterminateTypes": {
              "location": "import",
              "path": "../../../models/bcm-types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "indeterminate",
        "reflect": false,
        "defaultValue": "null"
      },
      "disabled": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "disabled",
        "reflect": false,
        "defaultValue": "false"
      },
      "hidden": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "hidden",
        "reflect": false,
        "defaultValue": "false"
      },
      "required": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "required",
        "reflect": false,
        "defaultValue": "false"
      },
      "readOnly": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "read-only",
        "reflect": false,
        "defaultValue": "false"
      },
      "captionType": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "StatusTypes",
          "resolved": "\"default\" | \"error\" | \"info\" | \"success\" | \"warning\"",
          "references": {
            "StatusTypes": {
              "location": "import",
              "path": "../../../models/bcm-types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "caption-type",
        "reflect": false,
        "defaultValue": "Bcm.Status.default"
      }
    };
  }
  static get elementRef() { return "el"; }
}
