/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h, Host } from '@stencil/core';
import cs from 'classnames';
export class BcmErrorLayout {
  constructor() {
    this.size = 'medium';
    this.hidden = false;
    this.items = [];
    this.itemsProp = [];
  }
  connectedCallback() { }
  disconnectedCallback() { }
  componentWillLoad() {
    this.parseItems(this.items);
  }
  componentDidLoad() { }
  componentWillRender() { }
  componentDidRender() { }
  componentWillUpdate() { }
  componentDidUpdate() { }
  /**
   * @desc
   * @param newValue
   * @returns {void}
   */
  parseItems(newValue) {
    if (newValue) {
      typeof newValue == 'string'
        ? this.itemsProp = JSON.parse(newValue)
        : this.itemsProp = newValue;
    }
  }
  async set(val) {
    this.items = val;
  }
  async clear() {
    this.items = [];
  }
  render() {
    const { itemsProp } = this;
    const classes = cs('error-layout', this.size);
    const hostClasses = cs(this.hidden ? 'hidden' : null);
    return (h(Host, { class: hostClasses }, itemsProp.length > 0 && (h("div", { class: classes }, h("ul", null, this.itemsProp.map((item) => h("li", null, h("span", null, item))))))));
  }
  static get is() { return "bcm-error-layout"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["error-layout.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["error-layout.css"]
    };
  }
  static get properties() {
    return {
      "size": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "SizeProp",
          "resolved": "\"large\" | \"medium\" | \"small\"",
          "references": {
            "SizeProp": {
              "location": "import",
              "path": "./types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "size",
        "reflect": false,
        "defaultValue": "'medium'"
      },
      "hidden": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "hidden",
        "reflect": false,
        "defaultValue": "false"
      },
      "items": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "Array<object> | string",
          "resolved": "object[] | string",
          "references": {
            "Array": {
              "location": "global"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "items",
        "reflect": false,
        "defaultValue": "[]"
      }
    };
  }
  static get states() {
    return {
      "itemsProp": {}
    };
  }
  static get methods() {
    return {
      "set": {
        "complexType": {
          "signature": "(val: any) => Promise<void>",
          "parameters": [{
              "tags": [],
              "text": ""
            }],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      },
      "clear": {
        "complexType": {
          "signature": "() => Promise<void>",
          "parameters": [],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      }
    };
  }
  static get elementRef() { return "el"; }
  static get watchers() {
    return [{
        "propName": "items",
        "methodName": "parseItems"
      }];
  }
}
