/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { tv } from "tailwind-variants";
export const inputDropdownStyle = tv({
  slots: {
    base: "tw-font-sans tw-flex tw-flex-col tw-items-start tw-justify-start tw-gap-2",
    content: "tw-flex tw-flex-row tw-items-center tw-justify-start tw-gap-3",
    inputArea: "tw-flex tw-flex-row tw-items-center tw-justify-start tw-gap-1 tw-box-content tw-border tw-border-solid tw-max-w-[100px]  tw-uppercase tw-font-medium tw-text-center tw-border-gray-300 tw-rounded",
    input: "tw-flex-1 tw-text-inherit tw-uppercase tw-font-semibold tw-text-center tw-border-none tw-bg-transparent tw-outline-none tw-w-full",
    button: [
      "input-dropdown-button tw-flex tw-flex-row tw-items-center tw-justify-center tw-gap-1 tw-rounded tw-outline-none tw-bg-slate-100",
      "tw-border tw-border-solid tw-border-slate-300 tw-font-medium tw-text-slate-600",
      "hover:tw-border-slate-400 hover:tw-bg-slate-200",
      "tw-min-w-[32px]",
      "tw-cursor-pointer",
      "disabled:tw-cursor-not-allowed disabled:tw-text-slate-400 disabled:tw-pointer-events-none",
      "readonly:tw-text-slate-700 readonly:tw-cursor-text",
    ],
    menu: "tw-mt-1 tw-flex tw-flex-col tw-items-start tw-justify-center tw-gap-2 tw-overflow-auto tw-bg-white tw-p-3  tw-font-sans tw-text-3 tw-text-slate-700",
    menuItem: "tw-flex tw-w-full tw-cursor-pointer tw-flex-row tw-items-start tw-gap-1 tw-rounded tw-px-3 tw-py-1  tw-text-slate-700 hover:tw-bg-blue-100",
    selectedItem: "tw-flex tw-w-full tw-flex-row tw-items-start tw-gap-1 tw-rounded tw-px-3 tw-py-1  tw-text-slate-700 tw-bg-primary-200",
    disabledItem: "tw-flex tw-w-full tw-flex-row tw-items-start tw-gap-1 tw-rounded tw-px-3 tw-py-1  tw-cursor-not-allowed tw-text-slate-400 tw-bg-slate-100 hover:tw-bg-slate-100 tw-list-none",
    commentArea: "tw-flex tw-h-fit tw-w-full tw-min-w-[288px] tw-flex-col tw-items-start tw-rounded tw-p-4 tw-shadow-2",
  },
  variants: {
    size: {
      small: {
        button: "tw-h-[18px] tw-text-1 tw-leading-none",
      },
      medium: {
        button: "tw-h-[24px] tw-text-2",
        inputArea: "tw-p-0.5",
        input: "tw-text-4",
      },
      large: {
        button: "tw-h-[30px] tw-text-2",
        inputArea: "tw-p-1",
        input: "tw-text-6",
      },
    },
    invalid: {
      true: {
        inputArea: "tw-border-red-600 tw-bg-red-50",
        input: "tw-text-red-500",
      },
    },
    disabled: {
      true: {
        base: "tw-opacity-50 tw-cursor-not-allowed",
        input: "tw-cursor-not-allowed",
      },
    },
    hideComment: {
      true: {
        base: "tw-min-w-[98px]",
      },
      false: {
        base: "tw-min-w-[128px] ",
      },
    },
    label: {
      true: "",
    },
  },
  defaultVariants: {
    size: "medium",
    invalid: false,
    hideComment: false,
    disabled: false,
  },
});
