/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
var __rest = (this && this.__rest) || function (s, e) {
  var t = {};
  for (var p in s)
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
      t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function")
    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
      if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
        t[p[i]] = s[p[i]];
    }
  return t;
};
import React from "react";
import ReactDOM from "react-dom";
import { NumericFormat } from "react-number-format";
export class BcmReactNumber {
  constructor() {
    this.isRange = (value, min, max) => {
      if (value === undefined) {
        return true;
      }
      const minValid = min === undefined || value >= min;
      const maxValid = max === undefined || value <= max;
      return minValid && maxValid;
    };
    this.disabled = false;
    this.options = undefined;
  }
  componentWillRender() {
    this.init();
  }
  componentDidLoad() {
    this.init();
  }
  init() {
    const _a = this.options, { min, max, mode } = _a, rest = __rest(_a, ["min", "max", "mode"]);
    const render = React.createElement(NumericFormat, Object.assign(Object.assign({}, rest), { isAllowed: (values) => {
        if (mode === "strict") {
          return this.isRange(values.floatValue, +min, +max);
        }
        return true;
      }, onValueChange: e => {
        if (this.options.onValueChange) {
          this.options.onValueChange(e);
        }
      } }));
    ReactDOM.render(render, this.el);
  }
  static get is() { return "bcm-react-number"; }
  static get properties() {
    return {
      "disabled": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "disabled",
        "reflect": true,
        "defaultValue": "false"
      },
      "options": {
        "type": "unknown",
        "mutable": true,
        "complexType": {
          "original": "ExtendedNumericPropsType",
          "resolved": "InternalNumberFormatBase & { thousandSeparator?: string | boolean; decimalSeparator?: string; allowedDecimalSeparators?: string[]; thousandsGroupStyle?: \"none\" | \"thousand\" | \"lakh\" | \"wan\"; decimalScale?: number; fixedDecimalScale?: boolean; allowNegative?: boolean; allowLeadingZeros?: boolean; suffix?: string; prefix?: string; } & Omit<InputAttributes, \"prefix\" | \"form\" | \"slot\" | \"style\" | \"title\" | \"pattern\" | \"color\" | \"dir\" | \"width\" | \"height\" | \"name\" | \"id\" | \"hidden\" | \"size\" | \"className\" | \"type\" | \"disabled\" | \"autoFocus\" | \"formAction\" | \"formEncType\" | \"formMethod\" | \"formNoValidate\" | \"formTarget\" | \"aria-label\" | \"maxLength\" | \"onClick\" | \"checked\" | \"required\" | \"multiple\" | \"placeholder\" | \"accept\" | \"alt\" | \"aria-labelledby\" | \"aria-hidden\" | \"onSelect\" | \"accessKey\" | \"role\" | \"aria-live\" | \"readOnly\" | \"onFocus\" | \"onBlur\" | \"minLength\" | \"min\" | \"max\" | \"step\" | \"autoComplete\" | \"capture\" | \"crossOrigin\" | \"enterKeyHint\" | \"list\" | \"src\" | \"onChange\" | \"defaultChecked\" | \"suppressContentEditableWarning\" | \"suppressHydrationWarning\" | \"contentEditable\" | \"contextMenu\" | \"draggable\" | \"lang\" | \"nonce\" | \"spellCheck\" | \"tabIndex\" | \"translate\" | \"radioGroup\" | \"about\" | \"datatype\" | \"inlist\" | \"property\" | \"resource\" | \"typeof\" | \"vocab\" | \"autoCapitalize\" | \"autoCorrect\" | \"autoSave\" | \"itemProp\" | \"itemScope\" | \"itemType\" | \"itemID\" | \"itemRef\" | \"results\" | \"security\" | \"unselectable\" | \"inputMode\" | \"is\" | \"aria-activedescendant\" | \"aria-atomic\" | \"aria-autocomplete\" | \"aria-busy\" | \"aria-checked\" | \"aria-colcount\" | \"aria-colindex\" | \"aria-colspan\" | \"aria-controls\" | \"aria-current\" | \"aria-describedby\" | \"aria-details\" | \"aria-disabled\" | \"aria-dropeffect\" | \"aria-errormessage\" | \"aria-expanded\" | \"aria-flowto\" | \"aria-grabbed\" | \"aria-haspopup\" | \"aria-invalid\" | \"aria-keyshortcuts\" | \"aria-level\" | \"aria-modal\" | \"aria-multiline\" | \"aria-multiselectable\" | \"aria-orientation\" | \"aria-owns\" | \"aria-placeholder\" | \"aria-posinset\" | \"aria-pressed\" | \"aria-readonly\" | \"aria-relevant\" | \"aria-required\" | \"aria-roledescription\" | \"aria-rowcount\" | \"aria-rowindex\" | \"aria-rowspan\" | \"aria-selected\" | \"aria-setsize\" | \"aria-sort\" | \"aria-valuemax\" | \"aria-valuemin\" | \"aria-valuenow\" | \"aria-valuetext\" | \"dangerouslySetInnerHTML\" | \"onCopy\" | \"onCopyCapture\" | \"onCut\" | \"onCutCapture\" | \"onPaste\" | \"onPasteCapture\" | \"onCompositionEnd\" | \"onCompositionEndCapture\" | \"onCompositionStart\" | \"onCompositionStartCapture\" | \"onCompositionUpdate\" | \"onCompositionUpdateCapture\" | \"onFocusCapture\" | \"onBlurCapture\" | \"onChangeCapture\" | \"onBeforeInput\" | \"onBeforeInputCapture\" | \"onInput\" | \"onInputCapture\" | \"onReset\" | \"onResetCapture\" | \"onSubmit\" | \"onSubmitCapture\" | \"onInvalid\" | \"onInvalidCapture\" | \"onLoad\" | \"onLoadCapture\" | \"onError\" | \"onErrorCapture\" | \"onKeyDown\" | \"onKeyDownCapture\" | \"onKeyPress\" | \"onKeyPressCapture\" | \"onKeyUp\" | \"onKeyUpCapture\" | \"onAbort\" | \"onAbortCapture\" | \"onCanPlay\" | \"onCanPlayCapture\" | \"onCanPlayThrough\" | \"onCanPlayThroughCapture\" | \"onDurationChange\" | \"onDurationChangeCapture\" | \"onEmptied\" | \"onEmptiedCapture\" | \"onEncrypted\" | \"onEncryptedCapture\" | \"onEnded\" | \"onEndedCapture\" | \"onLoadedData\" | \"onLoadedDataCapture\" | \"onLoadedMetadata\" | \"onLoadedMetadataCapture\" | \"onLoadStart\" | \"onLoadStartCapture\" | \"onPause\" | \"onPauseCapture\" | \"onPlay\" | \"onPlayCapture\" | \"onPlaying\" | \"onPlayingCapture\" | \"onProgress\" | \"onProgressCapture\" | \"onRateChange\" | \"onRateChangeCapture\" | \"onResize\" | \"onResizeCapture\" | \"onSeeked\" | \"onSeekedCapture\" | \"onSeeking\" | \"onSeekingCapture\" | \"onStalled\" | \"onStalledCapture\" | \"onSuspend\" | \"onSuspendCapture\" | \"onTimeUpdate\" | \"onTimeUpdateCapture\" | \"onVolumeChange\" | \"onVolumeChangeCapture\" | \"onWaiting\" | \"onWaitingCapture\" | \"onAuxClick\" | \"onAuxClickCapture\" | \"onClickCapture\" | \"onContextMenu\" | \"onContextMenuCapture\" | \"onDoubleClick\" | \"onDoubleClickCapture\" | \"onDrag\" | \"onDragCapture\" | \"onDragEnd\" | \"onDragEndCapture\" | \"onDragEnter\" | \"onDragEnterCapture\" | \"onDragExit\" | \"onDragExitCapture\" | \"onDragLeave\" | \"onDragLeaveCapture\" | \"onDragOver\" | \"onDragOverCapture\" | \"onDragStart\" | \"onDragStartCapture\" | \"onDrop\" | \"onDropCapture\" | \"onMouseDown\" | \"onMouseDownCapture\" | \"onMouseEnter\" | \"onMouseLeave\" | \"onMouseMove\" | \"onMouseMoveCapture\" | \"onMouseOut\" | \"onMouseOutCapture\" | \"onMouseOver\" | \"onMouseOverCapture\" | \"onMouseUp\" | \"onMouseUpCapture\" | \"onSelectCapture\" | \"onTouchCancel\" | \"onTouchCancelCapture\" | \"onTouchEnd\" | \"onTouchEndCapture\" | \"onTouchMove\" | \"onTouchMoveCapture\" | \"onTouchStart\" | \"onTouchStartCapture\" | \"onPointerDown\" | \"onPointerDownCapture\" | \"onPointerMove\" | \"onPointerMoveCapture\" | \"onPointerUp\" | \"onPointerUpCapture\" | \"onPointerCancel\" | \"onPointerCancelCapture\" | \"onPointerEnter\" | \"onPointerEnterCapture\" | \"onPointerLeave\" | \"onPointerLeaveCapture\" | \"onPointerOver\" | \"onPointerOverCapture\" | \"onPointerOut\" | \"onPointerOutCapture\" | \"onGotPointerCapture\" | \"onGotPointerCaptureCapture\" | \"onLostPointerCapture\" | \"onLostPointerCaptureCapture\" | \"onScroll\" | \"onScrollCapture\" | \"onWheel\" | \"onWheelCapture\" | \"onAnimationStart\" | \"onAnimationStartCapture\" | \"onAnimationEnd\" | \"onAnimationEndCapture\" | \"onAnimationIteration\" | \"onAnimationIterationCapture\" | \"onTransitionEnd\" | \"onTransitionEndCapture\"> & Omit<InputAttributes, \"prefix\" | \"suffix\" | \"ref\" | \"value\" | \"type\" | \"defaultValue\" | \"onFocus\" | \"onBlur\" | \"thousandSeparator\" | \"decimalSeparator\" | \"decimalScale\" | \"fixedDecimalScale\" | \"allowNegative\" | \"allowLeadingZeros\" | \"onChange\" | \"inputMode\" | \"onKeyDown\" | \"onMouseUp\" | \"displayType\" | \"renderText\" | \"getInputRef\" | \"valueIsNumericString\" | \"onValueChange\" | \"isAllowed\" | \"isCharacterSame\" | \"allowedDecimalSeparators\" | \"thousandsGroupStyle\"> & { customInput?: ComponentType<InputAttributes>; } & { mode: \"strict\" | \"none\"; onValueChange?: (e: NumberFormatValues) => void; }",
          "references": {
            "ExtendedNumericPropsType": {
              "location": "global"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      }
    };
  }
  static get elementRef() { return "el"; }
}
