/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { Generate } from "@bcm/helpers";
import { h, Host } from "@stencil/core";
import { skeletonStyle } from "./skeleton.style";
export class BcmSkeleton {
  constructor() {
    this._id = Generate.UID();
    this.effect = "pulse";
    this.variant = "rect";
    this.hidden = false;
    this.width = "100%";
    this.height = "16px";
    this.marginBottom = null;
    this.customStyles = {};
  }
  render() {
    const { variant, effect, width, height, marginBottom, customStyles, hidden } = this;
    const style = Object.assign(Object.assign(Object.assign(Object.assign({}, (width ? { width } : {})), (height ? { height } : {})), (marginBottom ? { marginBottom } : {})), (typeof customStyles === "string" ? JSON.parse(customStyles) : customStyles));
    const { host } = skeletonStyle({ variant, effect, hidden });
    return (h(Host, { class: host(), style: style }));
  }
  static get is() { return "bcm-skeleton"; }
  static get properties() {
    return {
      "_id": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "id",
        "reflect": true,
        "defaultValue": "Generate.UID()"
      },
      "effect": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "\"pulse\" | \"ping\" | \"none\"",
          "resolved": "\"none\" | \"ping\" | \"pulse\"",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "effect",
        "reflect": true,
        "defaultValue": "\"pulse\""
      },
      "variant": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "\"circle\" | \"rect\"",
          "resolved": "\"circle\" | \"rect\"",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "variant",
        "reflect": true,
        "defaultValue": "\"rect\""
      },
      "hidden": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "hidden",
        "reflect": true,
        "defaultValue": "false"
      },
      "width": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "width",
        "reflect": false,
        "defaultValue": "\"100%\""
      },
      "height": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "height",
        "reflect": false,
        "defaultValue": "\"16px\""
      },
      "marginBottom": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "margin-bottom",
        "reflect": false,
        "defaultValue": "null"
      },
      "customStyles": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "{ [key: string]: string } | string",
          "resolved": "string | { [key: string]: string; }",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "custom-styles",
        "reflect": false,
        "defaultValue": "{}"
      }
    };
  }
}
