/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { Generate } from "@bcm/helpers";
import { Bcm } from "@bcm/model";
import { h, Host } from "@stencil/core";
import cs from "classnames";
export class BcmTabItemHeader {
  constructor() {
    this._id = Generate.UID();
    this.active = false;
    this.disabled = false;
    this.index = undefined;
    this.color = "blue";
    this.size = Bcm.Size.medium;
  }
  handleClick() {
    var _a;
    if (!this.disabled) {
      (_a = Generate.findParentElement(this.el, "bcm-tab-group")) === null || _a === void 0 ? void 0 : _a.setActive(this.index);
    }
  }
  render() {
    const { color, size, active, disabled } = this;
    const tabId = this.el.getAttribute("tab-id");
    const disabledClass = "tw-cursor-not-allowed tw-text-gray-500 tw-opacity-50";
    const dc = Generate.getTwColor({
      color: color,
      tones: [700, 800, 900]
    });
    return (h(Host, { role: "tab", id: `tab-${tabId}`, "aria-selected": active ? "true" : "false", "aria-controls": tabId, onClick: () => this.handleClick(), class: cs(`tw-font-medium tw-flex tw-flex-1 tw-items-center tw-justify-center tw-border-0 tw-border-solid tw-border-b-[2px] tw-border-b-gray-300  tw-transition-font tw-focus:outline-none`, {
        "tw-text-2 tw-pt-1 tw-pb-1 tw-gap-2": size === Bcm.Size.small,
        "tw-text-3 tw-pt-2 tw-pb-2.5 tw-gap-2.5": size === Bcm.Size.medium,
        "tw-text-4 tw-pt-3 tw-pb-3 tw-gap-3": size === Bcm.Size.large,
      }, disabled ? disabledClass : "tw-cursor-pointer", active
        ? `tw-text-default-700 enabled:hover:tw-text-default-800 enabled:active:tw-text-default-900 enabled:focus-visible:tw-text-default-900`
        : "tw-text-gray-700"), style: dc }));
  }
  static get is() { return "bcm-tab-item-header"; }
  static get properties() {
    return {
      "_id": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "id",
        "reflect": true,
        "defaultValue": "Generate.UID()"
      },
      "active": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "active",
        "reflect": true,
        "defaultValue": "false"
      },
      "disabled": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "disabled",
        "reflect": false,
        "defaultValue": "false"
      },
      "index": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "index",
        "reflect": false
      },
      "color": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "color",
        "reflect": false,
        "defaultValue": "\"blue\""
      },
      "size": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "SizeTypes",
          "resolved": "\"large\" | \"medium\" | \"small\"",
          "references": {
            "SizeTypes": {
              "location": "import",
              "path": "@bcm/model"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "size",
        "reflect": false,
        "defaultValue": "Bcm.Size.medium"
      }
    };
  }
  static get elementRef() { return "el"; }
}
