/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import Bcm from "../../../models/bcm";
import { KeyControl } from "../../../models/abstract-classes/abstract-key-control";
export class ListKeyControl extends KeyControl {
  constructor(keyCode, element, treeview, checkBoxes) {
    super(keyCode, element, '.bcm-list__item', '.bcm-list__item-childs');
    this.isTreeview = false;
    this.isCheckBoxes = false;
    this.isTreeview = treeview;
    this.isCheckBoxes = checkBoxes;
  }
  keyUpControl() {
    if (this.isTreeview) {
      this.keyUpTreeview();
    }
    else {
      if (this.isFirstElement()) {
        this.setFocus(this.getLastElement());
      }
      else {
        this.setFocus(this.getPreviousElement());
      }
    }
  }
  keyDownTreeView() {
    var _a;
    if (this.isTreeview) {
      if (this.isRootElement() && this.isRootElementIsOpen()) {
        const childs = this.getChildElement();
        if (childs) {
          this.setFocus(childs.firstChild);
        }
      }
      else {
        if (this.isLastElement() && this.getParentElement(this.getFocusedElement())) {
          this.setFocus((_a = this.getParentElement(this.getFocusedElement())) === null || _a === void 0 ? void 0 : _a.nextElementSibling);
        }
        else {
          this.setFocus(this.getNextElement());
        }
      }
    }
  }
  keyUpTreeview() {
    if (this.isFirstElement()) {
      const parent = this.getParentElement(this.getFocusedElement());
      this.setFocus(parent);
    }
    else {
      const previousElement = this.getPreviousElement();
      if (previousElement) {
        if (previousElement.classList.contains('bcm-list__item--open')) {
          const getChildElement = previousElement.querySelectorAll(this.getChildElementName())[0];
          console.log({ getChildElement });
          this.setFocus(getChildElement.lastChild);
        }
        else {
          this.setFocus(previousElement);
        }
      }
    }
  }
  keyDownControl() {
    if (this.isTreeview) {
      this.keyDownTreeView();
    }
    else {
      if (this.isLastElement()) {
        this.setFocus(this.getFirstElement());
      }
      else {
        this.setFocus(this.getNextElement());
      }
    }
  }
  keyRightControl() {
    if (this.isTreeview) {
      if (!this.isRootElementIsOpen() && this.isRootElement()) {
        const { id } = this.getFocusedElement();
        this.openGroup(id);
      }
    }
  }
  keyLeftControl() {
    if (this.isTreeview) {
      if (this.isRootElementIsOpen() && this.isRootElement()) {
        const { id } = this.getFocusedElement();
        this.openGroup(id);
      }
    }
  }
  keyEnterControl() { }
  keySpaceControl() {
    if (this.isCheckBoxes) {
      const { id } = this.getFocusedElement();
      this.checkedItem(id);
    }
  }
  keyDown() {
    switch (this.getKeyCode()) {
      case Bcm.KeyCode.up:
        this.keyUpControl();
        break;
      case Bcm.KeyCode.down:
        this.keyDownControl();
        break;
      case Bcm.KeyCode.left:
        this.keyLeftControl();
        break;
      case Bcm.KeyCode.right:
        this.keyRightControl();
        break;
      case Bcm.KeyCode.enter:
        this.keyEnterControl();
        break;
      case Bcm.KeyCode.space:
        this.keySpaceControl();
        break;
    }
  }
  keyUp() { }
}
