/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { Generate } from "@bcm/helpers";
import { Bcm } from "@bcm/model";
import { FloatingUI } from "@bcm/utils";
import { Host, h } from "@stencil/core";
import cs from "classnames";
import { attendanceActionDropdownStyle } from "./attendance-actions-dropdown.style";
export class BcmAttendanceActionsDropdown {
  constructor() {
    this._id = Generate.UID();
    this.size = Bcm.Size.medium;
    this.disabled = false;
    this.selectedKey = null;
    this.targetId = null;
    this.isShow = false;
    this.data = [];
  }
  handleSelectItem(item) {
    this.selectedKey = item.key;
    this.change.emit(item);
  }
  async show() {
    const targetElement = document.getElementById(this.targetId);
    FloatingUI({
      ref: targetElement,
      floating: this.el,
      placement: "bottom-end",
      offset: 4,
    });
    this.isShow = true;
  }
  async hide() {
    if (this.isShow) {
      this.el.remove();
    }
  }
  handleClickOutside() {
    this.hide();
  }
  render() {
    const { size } = this;
    const { host, dataItem, selectedItem, key } = attendanceActionDropdownStyle({
      size,
    });
    return (h(Host, { class: host() }, this.data.map((item) => (h("div", { class: cs(dataItem(), this.selectedKey === item.key && selectedItem()), onClick: () => this.handleSelectItem(item) }, h("span", { class: key() }, item.key, " - "), h("span", null, item.value))))));
  }
  static get is() { return "bcm-attendance-actions-dropdown"; }
  static get properties() {
    return {
      "_id": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "id",
        "reflect": true,
        "defaultValue": "Generate.UID()"
      },
      "size": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "SizeTypes",
          "resolved": "\"large\" | \"medium\" | \"small\"",
          "references": {
            "SizeTypes": {
              "location": "import",
              "path": "@bcm/model"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "size",
        "reflect": false,
        "defaultValue": "Bcm.Size.medium"
      },
      "disabled": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "disabled",
        "reflect": false,
        "defaultValue": "false"
      },
      "selectedKey": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "selected-key",
        "reflect": false,
        "defaultValue": "null"
      },
      "targetId": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "target-id",
        "reflect": false,
        "defaultValue": "null"
      },
      "isShow": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "is-show",
        "reflect": false,
        "defaultValue": "false"
      },
      "data": {
        "type": "unknown",
        "mutable": true,
        "complexType": {
          "original": "Bcm.InputDropdownData[]",
          "resolved": "InputDropdownData[]",
          "references": {
            "Bcm": {
              "location": "import",
              "path": "@bcm/model"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "defaultValue": "[]"
      }
    };
  }
  static get events() {
    return [{
        "method": "change",
        "name": "bcm-attendance-actions-dropdown-change",
        "bubbles": false,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }];
  }
  static get methods() {
    return {
      "show": {
        "complexType": {
          "signature": "() => Promise<void>",
          "parameters": [],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      },
      "hide": {
        "complexType": {
          "signature": "() => Promise<void>",
          "parameters": [],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      }
    };
  }
  static get elementRef() { return "el"; }
  static get listeners() {
    return [{
        "name": "click",
        "method": "handleClickOutside",
        "target": "window",
        "capture": false,
        "passive": false
      }];
  }
}
