/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { tv } from "tailwind-variants";
// --bcm-attendance-actions-button-bg: #F1F5F9; /* slate-100 */
// --bcm-attendance-actions-button-text: #334155; /* slate-700 */
// --bcm-attendance-actions-button-border: #CBD5E1; /* slate-300 */
// --bcm-attendance-actions-button-hover-bg: #E2E8F0; /* slate-200 */
// --bcm-attendance-actions-button-active-bg: #CBD5E1; /* slate-300 */
// --bcm-attendance-actions-button-disabled-bg: #CBD5E1; /* slate-300 */
// --bcm-attendance-actions-button-disabled-text: #64748B; /* slate-500 */
export const attendanceActionStyle = tv({
  slots: {
    host: ["tw-flex tw-flex-row tw-items-center tw-justify-center tw-w-full tw-max-w-48 tw-gap-2", "bcm-ui-element bcm-attendance-actions"],
    base: "",
    buttonContainer: "tw-flex tw-flex-row tw-items-center tw-justify-center tw-w-full tw-max-w-[168px]",
    button: [
      "",
      "tw-button-reset",
      "tw-flex-1 last:tw-flex-none",
      "tw-bg-[--bcm-attendance-actions-button-bg]",
      "tw-text-[--bcm-attendance-actions-button-text]",
      "tw-border tw-border-solid tw-border-[--bcm-attendance-actions-button-border]",
      "hover:tw-bg-[--bcm-attendance-actions-button-hover-bg]",
      "active:tw-bg-[--bcm-attendance-actions-button-active-bg]",
      "focus-visible:tw-ring-2 focus-visible:tw-ring-offset-2 focus-visible:tw-z-10",
      "tw-flex tw-flex-row tw-items-center tw-justify-center",
      "first:tw-rounded-l last:tw-rounded-r",
      "tw-font-medium",
      "-tw-ml-[1px] first:tw-ml-0",
    ],
    dropdownButton: "",
    mainButton: "",
    commentIcon: "",
  },
  variants: {
    selected: {
      true: {
        button: [
          "tw-text-white tw-border-transparent last:tw-ml-[1px]",
          "first:tw-justify-start",
        ],
        mainButton: [
          "tw-min-w-[calc(theme(spacing.12)-1px)]"
        ],
      },
      false: {
        button: [
          ""
        ],
      },
    },
    size: {
      small: {
        button: [
          "tw-text-2",
          "tw-min-h-6",
          "tw-gap-2",
        ],
        mainButton: [
          "tw-px-3",
        ],
        dropdownButton: [
          "tw-px-2.5"
        ],
      },
      medium: {
        button: [
          "tw-text-3",
          "tw-min-h-8",
          "tw-gap-2",
        ],
        mainButton: [
          "tw-px-3",
        ],
        dropdownButton: [
          "tw-px-2.5"
        ],
      },
      large: {
        button: [
          "tw-text-4",
          "tw-min-h-10",
          "tw-gap-2.5",
        ],
        mainButton: [
          "tw-px-3",
        ],
        dropdownButton: [
          "tw-px-3"
        ],
      },
    },
    disabled: {
      true: {},
      false: {}
    }
  },
  compoundVariants: [
    {
      disabled: true,
      class: {
        buttonContainer: [
          "tw-cursor-not-allowed tw-pointer-events-none",
        ],
        button: [
          "tw-cursor-not-allowed",
          "tw-bg-[--bcm-attendance-actions-button-disabled-bg]",
          "tw-text-[--bcm-attendance-actions-button-disabled-text]",
          "tw-border-transparent",
          "hover:tw-bg-[--bcm-attendance-actions-button-disabled-bg]",
        ],
        mainButton: [
          "tw-bg-[--bcm-attendance-actions-button-disabled-bg]",
          "tw-text-[--bcm-attendance-actions-button-disabled-text]",
          "tw-border-transparent",
          "hover:tw-bg-[--bcm-attendance-actions-button-disabled-bg]",
          "tw-cursor-not-allowed",
        ],
        host: [
          "tw-cursor-not-allowed",
        ],
        commentIcon: [
          "tw-cursor-not-allowed tw-pointer-events-none",
        ],
      }
    },
    {
      disabled: false,
      class: {
        button: [
          "tw-cursor-pointer",
        ],
      }
    }
  ],
  defaultVariants: {
    selected: false,
    size: "medium",
    disabled: false,
  },
});
