/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { Host, h } from '@stencil/core';
import { Generate } from '../../../helper/generate';
export class BcmAttendance {
  constructor() {
    this._id = Generate.UID();
    this.data = [];
  }
  render() {
    const { data } = this;
    const classPrefix = 'bcm-attendance';
    return (h(Host, { class: classPrefix }, h("span", { hidden: true }, h("slot", null)), data.map(item => {
      var _a, _b;
      return h("div", { class: `${classPrefix}__item` }, h("bcm-tooltip", { trigger: "hover", message: `${item.weekday || null} / AM`, "aria-label": `${item.weekday || null} / AM` }, h("span", { class: `${classPrefix}__item-am ${classPrefix}__item-status-${(_a = item.am) !== null && _a !== void 0 ? _a : 'default'}` })), h("bcm-tooltip", { trigger: "hover", message: `${item.weekday || null} / PM`, "aria-label": `${item.weekday || null} / PM` }, h("span", { class: `${classPrefix}__item-pm ${classPrefix}__item-status-${(_b = item.pm) !== null && _b !== void 0 ? _b : 'default'}` })));
    })));
  }
  static get is() { return "bcm-attendance"; }
  static get originalStyleUrls() {
    return {
      "$": ["attendance.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["attendance.css"]
    };
  }
  static get properties() {
    return {
      "_id": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "id",
        "reflect": true,
        "defaultValue": "Generate.UID()"
      },
      "data": {
        "type": "any",
        "mutable": true,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "data",
        "reflect": false,
        "defaultValue": "[]"
      }
    };
  }
  static get elementRef() { return "el"; }
}
