/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { Host, h } from "@stencil/core";
import cs from "classnames";
import colors from "tailwindcss/colors";
export class BcmOverlay {
  constructor() {
    this.center = false;
    this.color = colors.black;
    this.opacity = "0.5";
    this.zIndex = "10400";
  }
  render() {
    return (h(Host, { class: cs("tw-fixed tw-inset-0 tw-transition", {
        "tw-flex tw-items-center tw-justify-center": this.center,
      }), style: {
        backgroundColor: `${this.color}`,
        opacity: this.opacity,
        zIndex: this.zIndex,
      } }, h("slot", null)));
  }
  static get is() { return "bcm-overlay"; }
  static get properties() {
    return {
      "center": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "center",
        "reflect": false,
        "defaultValue": "false"
      },
      "color": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "\"#000\"",
          "resolved": "\"#000\"",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "color",
        "reflect": false,
        "defaultValue": "colors.black"
      },
      "opacity": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "opacity",
        "reflect": false,
        "defaultValue": "\"0.5\""
      },
      "zIndex": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "z-index",
        "reflect": false,
        "defaultValue": "\"10400\""
      }
    };
  }
}
