/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h, Host } from '@stencil/core';
import { getChildElements } from '../../../utils/utils';
export class BcmCollapseGroup {
  constructor() {
    this.borderless = false;
    this.open = false;
    this.multiple = false;
    this.hidden = false;
  }
  handleOpen({ target, detail }) {
    if (!this.multiple && this.el === target.parentElement) {
      this.qs().forEach(child => {
        child.open = child.id === detail;
      });
    }
  }
  componentDidLoad() {
    this.qs().forEach((child, index) => {
      !child.borderless && (child.borderless = this.borderless);
      this.qs().length == index + 1 && (child.noBorder = true);
    });
  }
  qs() {
    return getChildElements(this.el, 'bcm-collapse');
  }
  render() {
    const { hidden } = this;
    return (h(Host, { class: { hidden } }, h("slot", null)));
  }
  static get is() { return "bcm-collapse-group"; }
  static get properties() {
    return {
      "borderless": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "borderless",
        "reflect": false,
        "defaultValue": "false"
      },
      "open": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "open",
        "reflect": false,
        "defaultValue": "false"
      },
      "multiple": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "multiple",
        "reflect": false,
        "defaultValue": "false"
      },
      "hidden": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "hidden",
        "reflect": false,
        "defaultValue": "false"
      }
    };
  }
  static get elementRef() { return "el"; }
  static get listeners() {
    return [{
        "name": "bcm-collapse-open",
        "method": "handleOpen",
        "target": "document",
        "capture": false,
        "passive": false
      }];
  }
}
