/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h, Host } from '@stencil/core';
import cs from 'classnames';
const lowercase = (str) => str.toLowerCase();
export class BcmOldSearch {
  constructor() {
    this.data = [];
    this.searchFields = ['text', 'value' /*, ...*/];
    this.returnField = 'idx';
    this.searchSub = null;
    this.hidden = false;
    this.onlyChild = false;
    this.clearable = false;
    this.searchValue = '';
    this.searchPlaceholder = 'Search';
    this.disabled = false;
    this._internal_id = (Math.random() * 4).toString(16).replace('.', '');
    this.results = [];
  }
  getInput() {
    return this.el.shadowRoot.querySelector('bcm-old-input');
  }
  componentDidLoad() {
    this.getInput().clearable = this.clearable;
  }
  listenBcmChange(e) {
    e.stopPropagation();
  }
  async setValue(value) {
    await this.getInput().setValue(value);
    return value;
  }
  async select() {
    await this.getInput().select();
    this.bcmOnSearch.emit(true);
    return true;
  }
  async setClear() {
    await this.getInput().setClear();
    this.bcmOnSearch.emit(true);
    return true;
  }
  async searchArray(value, idFields = null) {
    // console.log(this.data)
    let cacheSearchFields = this.searchFields;
    let arrayResult = [];
    if (idFields) {
      this.searchFields = [idFields];
    }
    value.forEach(item => {
      // item = {[idFields]:item}
      this.results = [];
      // console.log(this.data)
      this.nestedSearch(this.data, item, true);
      arrayResult.push(...this.results);
    });
    this.searchFields = cacheSearchFields;
    return arrayResult;
    // await this.getInput().setValue( value )
    // return value
  }
  nestedSearch(items, value, equal = false) {
    var result;
    items && (items.map((item) => {
      this.searchFields.map(searchField => {
        if (searchField in item) {
          // debugger;
          item[searchField] = lowercase(String(item[searchField]));
          if (this.onlyChild) {
            if (item[this.searchSub]) {
              var temp = this.nestedSearch(item[this.searchSub], value, equal);
              if (temp) {
                this.results.push((result = String(item[this.returnField])));
                this.results.push(temp);
              }
            }
            else {
              if (equal) {
                // console.log(value)
                if (item[searchField] == lowercase(String(value))) {
                  // if (item == lowercase(value)) {
                  this.results.push((result = String(item[this.returnField])));
                  // this.results.push (result = String(item))
                }
              }
              else {
                if (item[searchField].indexOf(lowercase(value)) !== -1) {
                  this.results.push((result = String(item[this.returnField])));
                }
              }
            }
          }
          else {
            if (item[this.searchSub]) {
              var temp = this.nestedSearch(item[this.searchSub], value, equal);
              if (temp) {
                this.results.push((result = String(item[this.returnField])));
                this.results.push(temp);
              }
            }
            if (equal) {
              // console.log(value)
              if (item[searchField] == lowercase(String(value))) {
                // if (item == lowercase(value)) {
                this.results.push((result = String(item[this.returnField])));
                // this.results.push (result = String(item))
              }
            }
            else {
              if (item[searchField].indexOf(lowercase(value)) !== -1) {
                this.results.push((result = String(item[this.returnField])));
              }
            }
          }
        }
      });
    }));
    return result;
  }
  /**
   * @desc
   * @param value
   */
  inputChange(value) {
    this.results = [];
    // data prop'unda arama yapılacak (searchFields prop'u içerisindeki alanlar ile)
    // arama sonucunda eşleyen itemların 'idx', index
    // değerleri, array şeklinde root component'e
    // event ile gönderilecek
    // Örneğin value == 'to' olduğunda aşağıdaki
    // sonuçlar filtrelenmeli
    // -->
    //{ text: 'Mateusz Eaton', idx: 2 },
    //{ text: 'Tony Vickers', idx: 3 },
    // result array'i eşleşen itemların
    // index numaralarını tutacak
    // results = [2, 3]
    // Örnek arama
    // #
    this.nestedSearch(this.data, value);
    this.results = Array.from(new Set(this.results));
    (value && ((this.results.length > 0 && this.bcmOnSearch.emit(this.results)) || this.bcmOnSearch.emit([-1]))) || this.bcmOnSearch.emit(true);
    this.bcmOnSearchValue.emit(value);
  }
  render() {
    const hostClasses = cs(this.hidden ? 'hidden' : null);
    return (h(Host, { class: hostClasses }, h("bcm-old-input", { placeholder: this.searchPlaceholder, "no-caption": true, "no-margin": true, "full-width": true, disabled: this.disabled, type: "search", "on-bcm-change": e => this.inputChange(e.detail), value: this.searchValue })));
  }
  static get is() { return "bcm-old-search"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["old-search.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["old-search.css"]
    };
  }
  static get properties() {
    return {
      "data": {
        "type": "unknown",
        "mutable": true,
        "complexType": {
          "original": "Array<object>",
          "resolved": "object[]",
          "references": {
            "Array": {
              "location": "global"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "defaultValue": "[]"
      },
      "searchFields": {
        "type": "unknown",
        "mutable": true,
        "complexType": {
          "original": "Array<string>",
          "resolved": "string[]",
          "references": {
            "Array": {
              "location": "global"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "defaultValue": "['text', 'value' /*, ...*/]"
      },
      "returnField": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "return-field",
        "reflect": false,
        "defaultValue": "'idx'"
      },
      "searchSub": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "searchsub",
        "reflect": false,
        "defaultValue": "null"
      },
      "hidden": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "hidden",
        "reflect": false,
        "defaultValue": "false"
      },
      "onlyChild": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "only-child",
        "reflect": false,
        "defaultValue": "false"
      },
      "clearable": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "clearable",
        "reflect": false,
        "defaultValue": "false"
      },
      "searchValue": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "search-value",
        "reflect": false,
        "defaultValue": "''"
      },
      "searchPlaceholder": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "searchplaceholder",
        "reflect": false,
        "defaultValue": "'Search'"
      },
      "disabled": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "disabled",
        "reflect": false,
        "defaultValue": "false"
      },
      "_internal_id": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "_internal_id",
        "reflect": true,
        "defaultValue": "(Math.random() * 4).toString(16).replace('.', '')"
      }
    };
  }
  static get states() {
    return {
      "results": {}
    };
  }
  static get events() {
    return [{
        "method": "bcmOnSearch",
        "name": "bcm-on-search",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }, {
        "method": "bcmOnSearchValue",
        "name": "bcm-on-search-value",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }];
  }
  static get methods() {
    return {
      "setValue": {
        "complexType": {
          "signature": "(value: any) => Promise<any>",
          "parameters": [{
              "tags": [],
              "text": ""
            }],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<any>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      },
      "select": {
        "complexType": {
          "signature": "() => Promise<boolean>",
          "parameters": [],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<boolean>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      },
      "setClear": {
        "complexType": {
          "signature": "() => Promise<boolean>",
          "parameters": [],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<boolean>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      },
      "searchArray": {
        "complexType": {
          "signature": "(value: any, idFields?: string) => Promise<any[]>",
          "parameters": [{
              "tags": [],
              "text": ""
            }, {
              "tags": [],
              "text": ""
            }],
          "references": {
            "Promise": {
              "location": "global"
            }
          },
          "return": "Promise<any[]>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      }
    };
  }
  static get elementRef() { return "el"; }
  static get watchers() {
    return [{
        "propName": "searchValue",
        "methodName": "inputChange"
      }];
  }
  static get listeners() {
    return [{
        "name": "bcm-change",
        "method": "listenBcmChange",
        "target": undefined,
        "capture": false,
        "passive": false
      }];
  }
}
