/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h, Host } from '@stencil/core';
import cs from 'classnames';
/**
 * @desc
 * @param str
 */
const lowercase = (str) => str.toLowerCase();
export class BcmTabPane {
  constructor() {
    this.size = 'medium';
    this.hidden = false;
    this.fullWidth = false;
    this.tab = (Math.random() * 4).toString(16).replace('.', '');
    this.active = false;
  }
  connectedCallback() { }
  disconnectedCallback() { }
  componentWillLoad() { }
  componentDidLoad() { }
  componentWillRender() { }
  componentDidRender() { }
  componentWillUpdate() { }
  componentDidUpdate() { }
  handleActiveTabPane(e) {
    if (lowercase(e.target.nodeName) === 'bcm-tab') {
      if (e.target.tabId === this.tab) {
        this.active = true;
      }
      else {
        this.active = false;
      }
    }
  }
  render() {
    const classes = cs('tab-pane', this.size);
    const hostClasses = cs(this.hidden ? 'hidden' : null, this.active ? 'active' : null);
    return (h(Host, { class: hostClasses }, h("div", { class: classes }, h("slot", null))));
  }
  static get is() { return "bcm-tab-pane"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["tab-pane.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["tab-pane.css"]
    };
  }
  static get properties() {
    return {
      "size": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "SizeProp",
          "resolved": "\"large\" | \"medium\" | \"small\"",
          "references": {
            "SizeProp": {
              "location": "import",
              "path": "./types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "size",
        "reflect": false,
        "defaultValue": "'medium'"
      },
      "hidden": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "hidden",
        "reflect": false,
        "defaultValue": "false"
      },
      "fullWidth": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "full-width",
        "reflect": false,
        "defaultValue": "false"
      },
      "tab": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "tab",
        "reflect": false,
        "defaultValue": "(Math.random() * 4).toString(16).replace('.', '')"
      },
      "active": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "active",
        "reflect": false,
        "defaultValue": "false"
      }
    };
  }
  static get elementRef() { return "el"; }
  static get listeners() {
    return [{
        "name": "bcm-click",
        "method": "handleActiveTabPane",
        "target": "document",
        "capture": true,
        "passive": false
      }];
  }
}
