/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h, Host } from '@stencil/core';
import cs from 'classnames';
import { getChilds } from '../../../utils/utils';
import { TypeProps } from './types';
export class BcmTabsContent {
  constructor() {
    this.size = 'medium';
    this.hidden = false;
    this.fullWidth = false;
    this.type = TypeProps.normal;
  }
  connectedCallback() { }
  disconnectedCallback() { }
  componentWillLoad() { }
  componentDidLoad() { }
  componentWillRender() { }
  componentDidRender() { }
  componentWillUpdate() { }
  componentDidUpdate() { }
  handleActivePane(e) {
    getChilds(this.el, 'bcm-tab-pane').forEach(items => {
      items.tab == e.detail && (items.active = true);
      items.tab != e.detail && (items.active = false);
    });
  }
  render() {
    const classes = cs('tabs-content', this.size);
    const hostClasses = cs(this.hidden ? 'hidden' : null, this.type);
    return (h(Host, { class: hostClasses }, h("div", { class: classes }, h("slot", null))));
  }
  static get is() { return "bcm-tabs-content"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["tabs-content.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["tabs-content.css"]
    };
  }
  static get properties() {
    return {
      "size": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "SizeProp",
          "resolved": "\"large\" | \"medium\" | \"small\"",
          "references": {
            "SizeProp": {
              "location": "import",
              "path": "./types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "size",
        "reflect": false,
        "defaultValue": "'medium'"
      },
      "hidden": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "hidden",
        "reflect": false,
        "defaultValue": "false"
      },
      "fullWidth": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "full-width",
        "reflect": false,
        "defaultValue": "false"
      },
      "type": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "TypeProp",
          "resolved": "\"normal\" | \"pane\" | \"stepper\"",
          "references": {
            "TypeProp": {
              "location": "import",
              "path": "./types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "type",
        "reflect": false,
        "defaultValue": "TypeProps.normal"
      }
    };
  }
  static get elementRef() { return "el"; }
  static get listeners() {
    return [{
        "name": "bcm-tabs-active-item",
        "method": "handleActivePane",
        "target": "document",
        "capture": false,
        "passive": false
      }];
  }
}
