/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h, Host } from '@stencil/core';
import { getChilds } from '../../../utils/utils';
import cs from 'classnames';
export class BcmtreeviewItem {
  constructor() {
    this.firstRun = true;
    this.items = undefined;
    this.itemObject = undefined;
    this.text = undefined;
    this.tooltipText = undefined;
    this._id = (Math.random() * 4).toString(16).replace('.', '');
    this.parentId = undefined;
    this.hasChild = false;
    this.size = 'medium';
    this.icon = 'bug';
    this.open = false;
    this.selected = false;
    this.checkboxes = false;
    this.showIcon = false;
    this.favicon = false;
    this.favorite = false;
    this.checked = false;
    this.checkTrigger = false;
    this.focused = false;
    this.disabled = false;
    this.contextMenuShow = false;
    this._contextMenu = [];
    this.indeterminateState = 'uncheck';
    this._internal_id = "";
    this.menuPadding = 0;
    this.childLength = 0;
    this.indeterminate = false;
    this.hidden = false;
    this.contextMenu = [];
    this.contextOffsetLeft = 0;
    this.contextOffsetTop = 0;
  }
  /**
   * @ComponentMethod
   */
  componentWillLoad() {
    this.menuPadding = 24;
    this.childLength = this.el.children.length;
    this.parseItems(this._contextMenu);
  }
  /**
   * @ComponentMethod
   */
  componentDidLoad() {
    // if (!this.disabled){
    //     // if (this.selected) this.treeviewItemSelected.emit(this.itemObject)
    //     if (this.checked){ 
    //         // this.treeviewChecked.emit(this._id)
    //         this.handleCheckMouseUp()
    //     }
    // }
    if (!this.disabled && this.firstRun && this.checkTrigger) {
      this.firstRun = false;
      this.handleCheckMouseUp();
    }
  }
  /**
   * @desc
   * @returns {void}
   */
  /*  setIndeterminateState() {
       if(this.getAllChilds().length > 0) {
           
           let state: string = 'uncheck'
           let allChecked: boolean = true
           let allUnchecked: boolean = true

           this.getAllChilds().map((item) => {
               item.checked && (allUnchecked = false)
               !item.checked && (allChecked = false)
           });
           
           !allChecked && !allUnchecked
           ? state = 'indeterminate'
           : allChecked
           ? state = 'determinate'
           : state = 'uncheck'
           
           this.indeterminateState = state as any;
           
       }
   } */
  /* @Watch('indeterminateState')
  onCheckedChange() {
      if (this.indeterminateState == 'determinate') {
          this.treeviewChecked.emit(this._id)
      }else if (this.indeterminateState == 'uncheck') {
          this.treeviewIndeterminateUnchecked.emit(this._id)
          this.checked = false
      }else{
          this.treeviewIndeterminateUnchecked.emit(this._id)
          this.checked = false
      }
  } */
  /**
   * @descc
   * @param event
   */
  handletreeviewClearSelecteds(event) {
    if (!this.disabled) {
      if (event.detail && event.detail !== this.itemObject)
        this.selected = false;
    }
  }
  /**
   * @descc
   * @param event
   */
  ListentreeviewChange() {
    //this.setIndeterminateState();
  }
  /**
   * @descc
   * @param event
   */
  ListentreeviewShowContext(event) {
    this.contextOffsetTop = event.detail[1];
    this.contextOffsetLeft = event.detail[2];
    if (event.detail[0] && event.detail[0] === this._id) {
      this.contextMenuShow = true;
    }
    else {
      this.contextMenuShow = false;
    }
  }
  /**
   * @desc
   * @param event
   */
  handleWindowClick(event) {
    const target = event.target;
    if (target === this.el)
      return;
    this.contextMenuShow = false;
  }
  /**
   * @desc
   */
  handleClick() {
    if (!this.disabled) {
      this.selected = true;
      this.treeviewItemSelected.emit(this.itemObject);
    }
  }
  /**
   * @desc
   */
  handleFavClick(e) {
    if (!this.disabled) {
      this.favorite = !this.favorite;
      if (!this.itemObject["rightSlot"]) {
        this.itemObject["rightSlot"] = {};
      }
      this.itemObject["rightSlot"]["favorite"] = this.favorite;
      this.favoriteStatus.emit(this.itemObject);
      e.stopPropagation();
      e.preventDefault();
    }
  }
  /**
   * @desc
   */
  handleOpen() {
    this.open = !this.open;
  }
  getRootChilds(element = this.el) {
    return getChilds(element, 'bcm-treeview-item');
  }
  getAllChilds(element = this.el) {
    let returnAllItems = [];
    getChilds(element, 'bcm-treeview-item').forEach(items => {
      this.getAllChilds(items) && (returnAllItems = [...returnAllItems, ...this.getAllChilds(items)]);
      returnAllItems = [...returnAllItems,
        items
      ];
    });
    return returnAllItems;
  }
  /**
   * @desc
   * -
   */
  checkGroupState() {
    // debugger;
    const childsRoot = this.getRootChilds();
    let [state, allChecked, allUnchecked] = ['uncheck', true, true];
    if (childsRoot.length > 0) {
      childsRoot.forEach(checkbox => {
        (checkbox.checked || checkbox.indeterminateState === 'indeterminate') && (allUnchecked = false);
        !checkbox.checked && (allChecked = false);
      });
      !allChecked && !allUnchecked
        ? state = 'indeterminate'
        : allChecked
          ? state = 'determinate'
          : state = 'uncheck';
      this.indeterminateState = state;
      if (state === 'determinate') {
        this.checked = true;
        // if(this.checked) {
        this.treeviewChecked.emit(this._id);
        // }
      }
      else {
        this.checked = false;
        this.treeviewUnchecked.emit(this._id);
      }
    }
    else {
      if (this.checked) {
        this.checked = false;
        this.treeviewUnchecked.emit(this._id);
      }
      else {
        this.checked = true;
        this.treeviewChecked.emit(this._id);
      }
    }
  }
  /**
   * @Event
   * @desc
   * -
   */
  handleCheckMouseUp() {
    const checked = this.checked;
    const state = this.indeterminateState;
    if (!this.hasChild) {
      !checked
        ? this.checked = true
        : this.checked = false;
      if (this.checked) {
        this.treeviewChecked.emit(this._id);
      }
      else {
        this.treeviewUnchecked.emit(this._id);
      }
      this.groupCheck.emit(this.parentId);
      return;
    }
    const childs = this.getAllChilds();
    if (state === 'indeterminate' || state === 'uncheck') {
      childs.forEach(child => {
        child.checked = true;
        // if(this.checked) {
        this.treeviewChecked.emit(child._id);
        // }
        child.indeterminateState = 'determined';
      });
    }
    else {
      childs.forEach(child => {
        child.checked = false;
        this.treeviewUnchecked.emit(child._id);
        child.indeterminateState = 'uncheck';
      });
    }
    this.checkGroupState();
    this.groupCheck.emit(this.parentId);
  }
  checkGroup(e) {
    const { detail: groupId } = e;
    if (!groupId || this._id !== groupId)
      return;
    this.checkGroupState();
    this.groupCheck.emit(this.parentId);
  }
  /**
   * @desc
   * @param item
   */
  contextItemRenderer(item) {
    return (h("span", null, item.title));
  }
  /**
   * @desc
   * @param newValue
   * @returns {void}
   */
  parseItems(newValue) {
    if (newValue) {
      typeof newValue == 'string'
        ? this.contextMenu = JSON.parse(newValue)
        : this.contextMenu = newValue;
    }
  }
  render() {
    const { _id, text, tooltipText, size, icon, open, childLength, checkboxes, showIcon, checked, indeterminateState, focused, contextMenuShow } = this;
    const menuPadding = this.menuPadding + 'px';
    const textContent = cs('text-content', size, 'size-2'
    // {
    //     'size-2': size === 'small' || size === 'medium',
    //     'size-3': size === 'large',
    // }
    );
    const classes = cs('treeview-item', {
      'focus': focused,
      'open': open,
      'selected': this.selected
    });
    const treeviewContextMenu = cs('treeview-item-context-menu', {
      'show': contextMenuShow
    });
    const treeviewInner = cs('treeview-inner', {
      'open': open,
    });
    const indeterminate = cs('indeterminate', {
      'disabled': this.disabled,
    });
    const treeviewItemContainer = cs('treeview-item-container', {
      'selected': this.selected,
      'disabled': this.disabled
    });
    const collapseContent = cs('collapse-content', {
      'child': childLength > 0,
    });
    const hostClasses = cs(this.hidden ? 'hidden' : null);
    const faviconClass = cs("favicon", {
      "favorite": this.favorite
    });
    return (h(Host, { class: hostClasses }, h("div", { class: classes }, h("div", { class: collapseContent, id: "collapse-button", onClick: () => childLength > 0 && this.handleOpen() }, childLength > 0 && (h("bcm-icon", { class: "collapse-icon", icon: `far fa-${open ? 'caret-down' : 'caret-right'}` }))), h("div", { class: treeviewItemContainer }, h("section", { onMouseUp: () => this.handleCheckMouseUp() }, checkboxes && (h("div", { class: "check-content" }, indeterminateState == 'indeterminate' && (h("span", { class: indeterminate })) || (h("bcm-checkbox", { id: 'check-' + _id, name: 'check-' + _id, checked: checked, disabled: this.disabled, noCaption: true })))), h("div", { class: textContent, onClick: () => this.handleClick(), title: tooltipText }, showIcon && icon && (h("bcm-icon", { class: "icon", icon: icon })), h("span", { id: "text" }, text))), this.favicon && (h("section", { class: faviconClass, onClick: (e) => this.handleFavClick(e) }, h("bcm-icon", { title: this.favorite ? "Click to remove from favorite list" : "Click to add to your favourites list", icon: "far fa-star" })))), !checkboxes && (h("div", { class: treeviewContextMenu, style: { top: this.contextOffsetTop + 'px', left: this.contextOffsetLeft + 'px' } }, this.contextMenu.length !== 0 && this.contextMenu.map((item) => (this.contextItemRenderer(item)))))), h("div", { class: treeviewInner, style: { paddingLeft: menuPadding } }, h("slot", null))));
  }
  static get is() { return "bcm-treeview-item"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["treeview-item.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["treeview-item.css"]
    };
  }
  static get properties() {
    return {
      "items": {
        "type": "any",
        "mutable": true,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "items",
        "reflect": false
      },
      "itemObject": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "item-object",
        "reflect": false
      },
      "text": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "text",
        "reflect": false
      },
      "tooltipText": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "tooltip-text",
        "reflect": false
      },
      "_id": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "id",
        "reflect": true,
        "defaultValue": "(Math.random() * 4).toString(16).replace('.', '')"
      },
      "parentId": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "parent-id",
        "reflect": false
      },
      "hasChild": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "has-child",
        "reflect": false,
        "defaultValue": "false"
      },
      "size": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "SizeProp",
          "resolved": "\"large\" | \"medium\" | \"small\"",
          "references": {
            "SizeProp": {
              "location": "import",
              "path": "./types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "size",
        "reflect": false,
        "defaultValue": "'medium'"
      },
      "icon": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "icon",
        "reflect": false,
        "defaultValue": "'bug'"
      },
      "open": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "open",
        "reflect": true,
        "defaultValue": "false"
      },
      "selected": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "selected",
        "reflect": false,
        "defaultValue": "false"
      },
      "checkboxes": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "checkboxes",
        "reflect": false,
        "defaultValue": "false"
      },
      "showIcon": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "show-icon",
        "reflect": false,
        "defaultValue": "false"
      },
      "favicon": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "favicon",
        "reflect": false,
        "defaultValue": "false"
      },
      "favorite": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "favorite",
        "reflect": false,
        "defaultValue": "false"
      },
      "checked": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "checked",
        "reflect": true,
        "defaultValue": "false"
      },
      "checkTrigger": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "checktrigger",
        "reflect": true,
        "defaultValue": "false"
      },
      "focused": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "focused",
        "reflect": true,
        "defaultValue": "false"
      },
      "disabled": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "disabled",
        "reflect": true,
        "defaultValue": "false"
      },
      "contextMenuShow": {
        "type": "boolean",
        "mutable": true,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "context-menu-show",
        "reflect": false,
        "defaultValue": "false"
      },
      "_contextMenu": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "Array<object> | string",
          "resolved": "object[] | string",
          "references": {
            "Array": {
              "location": "global"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "context-menu",
        "reflect": false,
        "defaultValue": "[]"
      },
      "indeterminateState": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "'uncheck' | 'indeterminate' | 'determinate'",
          "resolved": "\"determinate\" | \"indeterminate\" | \"uncheck\"",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "indeterminate-state",
        "reflect": false,
        "defaultValue": "'uncheck'"
      },
      "_internal_id": {
        "type": "string",
        "mutable": true,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "_internal_id",
        "reflect": true,
        "defaultValue": "\"\""
      }
    };
  }
  static get states() {
    return {
      "menuPadding": {},
      "childLength": {},
      "indeterminate": {},
      "hidden": {},
      "contextMenu": {},
      "contextOffsetLeft": {},
      "contextOffsetTop": {}
    };
  }
  static get events() {
    return [{
        "method": "treeviewItemSelected",
        "name": "bcm-treeview-item-selected",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": "Component Events"
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }, {
        "method": "treeviewUnchecked",
        "name": "bcm-treeview-unchecked",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }, {
        "method": "treeviewChecked",
        "name": "bcm-treeview-checked",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }, {
        "method": "treeviewChange",
        "name": "bcm-treeview-change",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }, {
        "method": "treeviewIndeterminateUnchecked",
        "name": "bcm-treeview-indeterminate-unchecked",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }, {
        "method": "treeviewIndeterminateChecked",
        "name": "bcm-treeview-indeterminate-checked",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }, {
        "method": "itemChecked",
        "name": "bcm-treeview-check-item-checked",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }, {
        "method": "itemUnchecked",
        "name": "bcm-treeview-check-item-unchecked",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }, {
        "method": "groupCheck",
        "name": "bcm-treeview-check-group-check",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }, {
        "method": "favoriteStatus",
        "name": "bcm-favorite-status",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }];
  }
  static get elementRef() { return "el"; }
  static get watchers() {
    return [{
        "propName": "_contextMenu",
        "methodName": "parseItems"
      }];
  }
  static get listeners() {
    return [{
        "name": "bcm-treeview-clear-selecteds",
        "method": "handletreeviewClearSelecteds",
        "target": "document",
        "capture": false,
        "passive": false
      }, {
        "name": "bcm-treeview-change",
        "method": "ListentreeviewChange",
        "target": "document",
        "capture": false,
        "passive": false
      }, {
        "name": "bcm-treeview-send-check",
        "method": "ListentreeviewShowContext",
        "target": "document",
        "capture": false,
        "passive": false
      }, {
        "name": "bcm-treeview-send-uncheck",
        "method": "ListentreeviewShowContext",
        "target": "document",
        "capture": false,
        "passive": false
      }, {
        "name": "bcm-treeview-show-context",
        "method": "ListentreeviewShowContext",
        "target": "document",
        "capture": false,
        "passive": false
      }, {
        "name": "click",
        "method": "handleWindowClick",
        "target": "window",
        "capture": false,
        "passive": false
      }, {
        "name": "bcm-treeview-check-group-check",
        "method": "checkGroup",
        "target": undefined,
        "capture": false,
        "passive": false
      }];
  }
}
