import React from "react";
import ReactDOM from "react-dom";
import { HexColorPicker } from "react-colorful";
import { debounce } from "lodash";
// https://github.com/omgovich/react-colorful
export class BcmColorful {
  constructor() {
    this.color = "#3b82f6";
  }
  handleChange(e) {
    this.bcmChange.emit(e);
  }
  componentDidRender() {
    const { color } = this;
    ReactDOM.render(React.createElement(HexColorPicker, {
      color,
      onChange: debounce(this.handleChange.bind(this), 150),
    }), this.el);
  }
  static get is() { return "bcm-colorful"; }
  static get originalStyleUrls() {
    return {
      "$": ["colorful.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["colorful.css"]
    };
  }
  static get properties() {
    return {
      "color": {
        "type": "any",
        "mutable": true,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "color",
        "reflect": false,
        "defaultValue": "\"#3b82f6\""
      }
    };
  }
  static get events() {
    return [{
        "method": "bcmChange",
        "name": "bcmChange",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }];
  }
  static get elementRef() { return "el"; }
}
