/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { Generate, StringHelper } from "@bcm/helpers";
import Overflow from "rc-overflow";
import React from "react";
import ReactDOM from "react-dom";
export class BcmRcOverflow {
  constructor() {
    this.renderItem = item => {
      return React.createElement("bcm-tooltip", {
        placement: "bottom",
        message: item.text,
        trigger: "hover",
      }, React.createElement("div", {
        id: item.value + "-tag",
        className: "bcm-tag",
        onClick: ({ target }) => this.onClickControl(target, item, false),
      }, React.createElement("span", { className: "bcm-tag__content dismissable" }, 
      // .bcm-tag__content span {
      //     display: block;
      //     max-width: 38px;
      //     white-space: nowrap;
      //     overflow: hidden;
      //     text-overflow: ellipsis;
      React.createElement("div", { className: "value tw-block tw-max-w-[38px] tw-overflow-hidden tw-overflow-ellipsis tw-whitespace-nowrap" }, item.text), React.createElement("span", {
        className: "right close-button",
      }, React.createElement("bcm-icon", {
        icon: "fa fa-times",
      })))));
    };
    this.renderRest = items => {
      const titles = (items === null || items === void 0 ? void 0 : items.sort((a, b) => +a.ct - +b.ct).slice(0, 15).map(item => StringHelper.textLimitter(item.text, 40, true)).toString().split(",").join("\r\n")) + (items.length > 15 ? "\r\n..." : "");
      return React.createElement("bcm-tooltip", {
        placement: "bottom",
        message: titles,
        trigger: "hover",
      }, React.createElement("div", {
        className: "bcm-tag bcm-tag--other",
        onClick: ({ target }) => this.onClickControl(target, items, true),
      }, React.createElement("span", { className: `bcm-tag__content dismissable ${this.checked ? "checkable checked" : ""}` }, React.createElement("span", { className: "value" }, `+${items === null || items === void 0 ? void 0 : items.length}`), React.createElement("span", { className: "right close-button" }, React.createElement("bcm-icon", {
        icon: "fa fa-times",
      })))));
    };
    this._id = Generate.UID();
    this.maxCount = 1;
    this.data = [];
    this.checked = false;
  }
  isClickDismiss(e) {
    return e["s-hn"] === "BCM-ICON";
  }
  onClickControl(e, item, isOtherTag = false) {
    const isClickClose = this.isClickDismiss(e);
    isClickClose && this.deleteTag.emit({ id: Array.isArray(item) ? item.map(i => i.value) : item.value }) && this.checked && (this.checked = false);
    !isOtherTag && this.selectTag.emit({ id: item.value }) && this.checked && (this.checked = false);
    if (isOtherTag && !isClickClose) {
      this.checked = !this.checked;
      this.selectOtherTag.emit({ id: item === null || item === void 0 ? void 0 : item.map(i => i.value), checked: this.checked });
    }
  }
  componentWillRender() {
    const { data, renderItem, renderRest, maxCount } = this;
    this.overflowInstance = React.createElement(Overflow, {
      data,
      renderItem,
      renderRest,
      maxCount,
    });
    ReactDOM.render(this.overflowInstance, this.el);
  }
  static get is() { return "bcm-rc-overflow"; }
  static get originalStyleUrls() {
    return {
      "$": ["rc-overflow.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["rc-overflow.css"]
    };
  }
  static get properties() {
    return {
      "_id": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "id",
        "reflect": true,
        "defaultValue": "Generate.UID()"
      },
      "maxCount": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "number | \"responsive\" | \"invalidate\"",
          "resolved": "\"invalidate\" | \"responsive\" | number",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "max-count",
        "reflect": false,
        "defaultValue": "1"
      },
      "data": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "[]",
          "resolved": "[]",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "defaultValue": "[]"
      }
    };
  }
  static get states() {
    return {
      "checked": {}
    };
  }
  static get events() {
    return [{
        "method": "selectOtherTag",
        "name": "bcm-select-other-tag",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }, {
        "method": "selectTag",
        "name": "bcm-select-tag",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }, {
        "method": "deleteTag",
        "name": "bcm-delete-tag",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }];
  }
  static get elementRef() { return "el"; }
}
