/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { Bcm } from "@bcm/model";
import moment from "moment";
import Picker, { RangePicker } from "rc-picker";
import momentGenerateConfig from "rc-picker/lib/generate/moment";
import enUS from "rc-picker/lib/locale/en_US";
import cs from "classnames";
import React from "react";
import ReactDOM from "react-dom";
export class BcmRcPicker {
  constructor() {
    this.manageDisabledDates = (current) => {
      const { min, max, dates, custom } = this.disabledDates || {};
      if (min && current.isBefore(this.convertDateToMoment(min)))
        return true;
      if (max && current.isAfter(this.convertDateToMoment(max)))
        return true;
      if (dates && dates.length > 0) {
        return dates.some(date => current.isSame(this.convertDateToMoment(date), "day"));
      }
      if (custom) {
        return custom(current);
      }
      return false;
    };
    this.manageDisabledTime = () => {
      const { disabledHours, disabledMinutes, disabledSeconds } = this.disabledTime || {};
      return Object.assign(Object.assign(Object.assign({}, ((disabledHours && this.showHour) && { disabledHours: () => disabledHours })), ((disabledMinutes && this.showMinute) && { disabledMinutes: () => disabledMinutes })), ((disabledSeconds && this.showSecond) && { disabledSeconds: () => disabledSeconds }));
    };
    this.convertDateToMoment = (date) => {
      return date && date !== "invalid date" ? moment(date) : null;
    };
    this.placeholder = undefined;
    this.size = Bcm.Size.medium;
    this.error = false;
    this.disabled = false;
    this.clearable = false;
    this.ariaLabel = undefined;
    this.type = "date";
    this.format = undefined;
    this.range = false;
    this.showToday = true;
    this.disabledDates = undefined;
    this.showTime = false;
    this.showNow = true;
    this.showHour = true;
    this.showMinute = true;
    this.showSecond = false;
    this.use12Hours = false;
    this.hourStep = 1;
    this.minuteStep = 1;
    this.secondStep = 1;
    this.hideDisabledOptions = false;
    this.disabledTime = undefined;
    this.newValue = null;
  }
  async set(value) {
    if (!value) {
      this.newValue = null;
      this.bcmRCPickerChange.emit(null);
      return;
    }
    this.newValue = this.range ? [moment(value[0]), moment(value[1])] : moment(value);
    this.bcmRCPickerChange.emit(this.newValue);
  }
  componentDidRender() {
    const dateOptions = {
      showToday: this.showToday,
      disabledDate: current => this.manageDisabledDates(current),
    };
    const timeOptions = {
      showNow: this.showNow,
      showHour: this.showHour,
      showMinute: this.showMinute,
      showSecond: this.showSecond,
      use12Hours: this.use12Hours,
      hourStep: this.hourStep,
      minuteStep: this.minuteStep,
      secondStep: this.secondStep,
      hideDisabledOptions: this.hideDisabledOptions,
      disabledTime: () => this.manageDisabledTime(),
    };
    const options = {
      time: Object.assign({}, timeOptions),
      date: Object.assign({}, dateOptions),
      datetime: Object.assign(Object.assign(Object.assign({}, dateOptions), timeOptions), { showTime: Object.assign({ showSecond: this.showSecond }, timeOptions) }),
    };
    const sharedProps = Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({ generateConfig: momentGenerateConfig, value: this.newValue, onChange: newValue => this.set(newValue) }, (this.format && { format: this.format })), (this.clearable && { allowClear: this.clearable })), (this.placeholder && { placeholder: this.placeholder })), (this.error && { error: this.error })), (this.disabled && { disabled: this.disabled })), (this.ariaLabel && { 'aria-label': this.ariaLabel })), {
      // picker: this.type,
      picker: this.type === "datetime" ? "date" : this.type
    }), options[this.type]), { prefixCls: "bcm-date", suffixIcon: " ", autofocus: true, locale: enUS, separator: " - ", changeOnBlur: true, className: cs(`bcm-date--${this.type}`, {
        [`bcm-date--${this.size}`]: this.size,
        "bcm-date--error": this.error,
        "bcm-date--existed": this.newValue,
        "bcm-date--clearable": this.clearable,
      }) });
    if (this.range) {
      ReactDOM.render(React.createElement(RangePicker, Object.assign({}, sharedProps)), this.el);
    }
    else {
      ReactDOM.render(React.createElement(Picker, Object.assign({}, sharedProps)), this.el);
    }
  }
  static get is() { return "bcm-rc-picker"; }
  static get originalStyleUrls() {
    return {
      "$": ["rc-picker.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["rc-picker.css"]
    };
  }
  static get properties() {
    return {
      "placeholder": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "placeholder",
        "reflect": false
      },
      "size": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "SizeTypes",
          "resolved": "\"large\" | \"medium\" | \"small\"",
          "references": {
            "SizeTypes": {
              "location": "import",
              "path": "@bcm/model"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "size",
        "reflect": true,
        "defaultValue": "Bcm.Size.medium"
      },
      "error": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "error",
        "reflect": false,
        "defaultValue": "false"
      },
      "disabled": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "disabled",
        "reflect": false,
        "defaultValue": "false"
      },
      "clearable": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "clearable",
        "reflect": false,
        "defaultValue": "false"
      },
      "ariaLabel": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "aria-label",
        "reflect": false
      },
      "type": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "\"time\" | \"date\" | \"week\" | \"month\" | \"year\" | \"datetime\"",
          "resolved": "\"date\" | \"datetime\" | \"month\" | \"time\" | \"week\" | \"year\"",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "type",
        "reflect": false,
        "defaultValue": "\"date\""
      },
      "format": {
        "type": "any",
        "mutable": false,
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "format",
        "reflect": false
      },
      "range": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "range",
        "reflect": false,
        "defaultValue": "false"
      },
      "showToday": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "show-today",
        "reflect": false,
        "defaultValue": "true"
      },
      "disabledDates": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "{ min: any; max: any; dates: any; custom: any; }",
          "resolved": "{ min: any; max: any; dates: any; custom: any; }",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      },
      "showTime": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "show-time",
        "reflect": false,
        "defaultValue": "false"
      },
      "showNow": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "show-now",
        "reflect": false,
        "defaultValue": "true"
      },
      "showHour": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "show-hour",
        "reflect": false,
        "defaultValue": "true"
      },
      "showMinute": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "show-minute",
        "reflect": false,
        "defaultValue": "true"
      },
      "showSecond": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "show-second",
        "reflect": false,
        "defaultValue": "false"
      },
      "use12Hours": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "use-1-2-hours",
        "reflect": false,
        "defaultValue": "false"
      },
      "hourStep": {
        "type": "number",
        "mutable": false,
        "complexType": {
          "original": "number",
          "resolved": "number",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "hour-step",
        "reflect": false,
        "defaultValue": "1"
      },
      "minuteStep": {
        "type": "number",
        "mutable": false,
        "complexType": {
          "original": "number",
          "resolved": "number",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "minute-step",
        "reflect": false,
        "defaultValue": "1"
      },
      "secondStep": {
        "type": "number",
        "mutable": false,
        "complexType": {
          "original": "number",
          "resolved": "number",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "second-step",
        "reflect": false,
        "defaultValue": "1"
      },
      "hideDisabledOptions": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "hide-disabled-options",
        "reflect": false,
        "defaultValue": "false"
      },
      "disabledTime": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "{ disabledHours: any; disabledMinutes: any; disabledSeconds: any }",
          "resolved": "{ disabledHours: any; disabledMinutes: any; disabledSeconds: any; }",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      }
    };
  }
  static get states() {
    return {
      "newValue": {}
    };
  }
  static get events() {
    return [{
        "method": "bcmRCPickerChange",
        "name": "bcmRCPickerChange",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "any",
          "resolved": "any",
          "references": {}
        }
      }];
  }
  static get methods() {
    return {
      "set": {
        "complexType": {
          "signature": "(value: Moment | null) => Promise<void>",
          "parameters": [{
              "tags": [],
              "text": ""
            }],
          "references": {
            "Promise": {
              "location": "global"
            },
            "Moment": {
              "location": "import",
              "path": "moment"
            }
          },
          "return": "Promise<void>"
        },
        "docs": {
          "text": "",
          "tags": []
        }
      }
    };
  }
  static get elementRef() { return "el"; }
}
