/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { getElement } from "@stencil/core";
export function BcmComponent() {
  return (target, _propertyKey) => {
    const originalComponentDidLoad = target.componentWillRender;
    target.componentWillRender = function () {
      const hostElement = getElement(this); //
      const isStopChange = hostElement.hasAttribute("stop-change");
      if (isStopChange) {
        hostElement.addEventListener("bcm-change", (event) => {
          event.stopImmediatePropagation();
        }, {
          capture: true,
          once: true,
        });
      }
      else {
        hostElement.removeAttribute("stop-change");
      }
      if (originalComponentDidLoad) {
        originalComponentDidLoad.call(this);
      }
    };
  };
}
