/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { getElement } from "@stencil/core";
export function BcmEventControl() {
  return (target, _propertyKey) => {
    const originalComponentWillRender = target.componentWillRender;
    target.componentWillRender = function () {
      const hostElement = getElement(this);
      const stopEvents = hostElement["stopEvents"];
      if (stopEvents) {
        const events = hostElement["stopEvents"];
        const eventList = (events === null || events === void 0 ? void 0 : events.split(",")) || [];
        (eventList === null || eventList === void 0 ? void 0 : eventList.length) > 0
          ? eventList.forEach(event => {
            hostElement.addEventListener(event, (event) => {
              event.stopPropagation();
            }, {
              capture: true,
              once: true,
            });
          })
          : null;
      }
      if (originalComponentWillRender) {
        originalComponentWillRender.call(this);
      }
    };
  };
}
