/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { getElement } from '@stencil/core';
export function IsLoad() {
  return (proto) => {
    const { componentDidLoad } = proto;
    proto.componentDidLoad = function () {
      const host = getElement(this);
      const { openIntersecting } = host;
      initProps(host);
      openIntersecting && registerAttrReflect(host);
      return componentDidLoad && componentDidLoad.call(this);
    };
  };
}
export function registerAttrReflect(element) {
  if ('IntersectionObserver' in window) {
    let io = new IntersectionObserver((data) => {
      if (data[0].isIntersecting) {
        isIntersecting(element);
      }
    });
    io.observe(element);
  }
  else {
    setTimeout(() => {
      isIntersecting(element);
    }, 300);
  }
}
export function initProps(element) {
  element.dispatchEvent(new CustomEvent('bcm-is-load', {
    bubbles: true,
    composed: true,
    detail: {
      isLoad: true,
    },
  }));
}
export function isIntersecting(element) {
  element.dispatchEvent(new CustomEvent('bcm-is-intersecting', {
    bubbles: true,
    composed: true,
    detail: {
      isIntersecting: true,
    },
  }));
}
