/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { getElement } from '@stencil/core';
export function AttrReflect(attribute) {
  return (proto, propName) => {
    const { connectedCallback, componentWillRender } = proto;
    proto.connectedCallback = function () {
      const host = getElement(this);
      if (!(host[attribute] || this[propName]))
        return;
      this[propName] = host[attribute] || this[propName];
      host.setAttribute(propName, host[attribute] || this[propName]);
      host.removeAttribute(attribute);
      return connectedCallback && connectedCallback.call(this);
    };
    proto.componentWillRender = function () {
      const host = getElement(this);
      if (!(host[attribute] || this[propName]))
        return;
      this[propName] = host[attribute] || this[propName];
      host.setAttribute(propName, host[attribute] || this[propName]);
      host.removeAttribute(attribute);
      return componentWillRender && componentWillRender.call(this);
    };
  };
}
