/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
export class KeyControl {
  constructor(keyCode, element, elementName, childElementName) {
    this.elementName = '';
    this.childElementName = '';
    this.keyCode = keyCode;
    this.element = element;
    this.elementName = elementName;
    this.childElementName = childElementName;
  }
  getKeyCode() {
    return this.keyCode;
  }
  getElementName() {
    return this.elementName;
  }
  getChildElementName() {
    return this.childElementName;
  }
  getFocusedElementName() {
    return this.getElementName() + '.focused';
  }
  getFocusedElement() {
    return this.element.querySelectorAll(this.getFocusedElementName())[0] || null;
  }
  getFirstElement() {
    return this.element.querySelectorAll(this.getElementName())[0] || null;
  }
  getNextElement() {
    var _a;
    return ((_a = this.getFocusedElement()) === null || _a === void 0 ? void 0 : _a.nextElementSibling) || this.getFirstElement();
  }
  getPreviousElement() {
    var _a;
    return ((_a = this.getFocusedElement()) === null || _a === void 0 ? void 0 : _a.previousElementSibling) || this.getFirstElement();
  }
  getChildElement() {
    var _a;
    return ((_a = this.getFocusedElement()) === null || _a === void 0 ? void 0 : _a.querySelectorAll(this.getChildElementName())[0]) || null;
  }
  getParentElement(element) {
    if (element && element) {
      const isRootElement = element && element.attributes['data-isroot'];
      if (isRootElement) {
        return element;
      }
      return this.getParentElement(element.parentNode);
    }
  }
  focusElementIsOpen() {
    var _a;
    return ((_a = this.getFocusedElement()) === null || _a === void 0 ? void 0 : _a.classList.contains('bcm-list__item--open')) || false;
  }
  isRootElement() {
    var _a;
    return ((_a = this.getFocusedElement()) === null || _a === void 0 ? void 0 : _a.querySelectorAll(this.getChildElementName()).length) > 0;
  }
  isRootElementIsOpen() {
    return this.getFocusedElement().classList.contains('bcm-list__item--open');
  }
  getFocusedChildElement() {
    var _a;
    return ((_a = this.getChildElement()) === null || _a === void 0 ? void 0 : _a.querySelectorAll('.focused')[0]) || null;
  }
  isLastElement() {
    var _a;
    return ((_a = this.getFocusedElement()) === null || _a === void 0 ? void 0 : _a.nextElementSibling) === null;
  }
  focusParentElementFirstChild() {
    var _a, _b;
    return this.setFocus((_b = (_a = this.getFocusedElement()) === null || _a === void 0 ? void 0 : _a.parentElement) === null || _b === void 0 ? void 0 : _b.firstChild);
  }
  isFirstElement() {
    var _a;
    return ((_a = this.getFocusedElement()) === null || _a === void 0 ? void 0 : _a.previousElementSibling) === null;
  }
  focusRootElement() {
    var _a, _b, _c;
    return this.setFocus((_c = (_b = (_a = this.getFocusedElement()) === null || _a === void 0 ? void 0 : _a.parentElement) === null || _b === void 0 ? void 0 : _b.parentElement) === null || _c === void 0 ? void 0 : _c.firstChild);
  }
  nextRootElement() {
    var _a, _b, _c;
    return this.setFocus((_c = (_b = (_a = this.getFocusedElement()) === null || _a === void 0 ? void 0 : _a.parentElement) === null || _b === void 0 ? void 0 : _b.parentElement) === null || _c === void 0 ? void 0 : _c.nextElementSibling);
  }
  findFocusElementParent() {
    return this.getFocusedElement().parentNode.querySelectorAll('.bcm-list__item--open');
  }
  getLastElement() {
    return this.element.querySelectorAll(this.getElementName())[this.element.querySelectorAll(this.getElementName()).length - 1] || null;
  }
  setFocus(element) {
    element.focus();
  }
}
