/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { Generate } from "@bcm/helpers";
import { FloatingUI } from "@bcm/utils";
import { LinkedAbstract } from "./linked-abstract";
export class LinkedService extends LinkedAbstract {
  constructor() {
    super();
  }
  show() {
    const targetElement = document.getElementById(this.getTargetId());
    const element = Generate.createComponent("div", {
      id: this.getId(),
      innerHTML: this.getHtmlContent(),
      className: "tw-absolute tw-left-0 tw-right-0 tw-z-tooltip tw-opacity-100 tw-transition-opacity tw-duration-300 tw-w-fit"
    });
    FloatingUI({
      ref: targetElement,
      floating: element,
      placement: this.getPlacement(),
      offset: 4,
    });
  }
  hide() {
    const bcmOverlay = document.getElementById("bcm-overlay-container");
    if (bcmOverlay) {
      const element = bcmOverlay.querySelector(`#${this.getId()}`);
      if (element) {
        element.remove();
      }
    }
  }
  setId(id) {
    this.id = id;
  }
  setTargetId(targetId) {
    this.targetId = targetId;
  }
  setHtmlContent(htmlContent) {
    this.htmlContent = htmlContent;
  }
  getTargetId() {
    return this.targetId;
  }
  getHtmlContent() {
    return this.htmlContent;
  }
  setPlacement(placement) {
    this.placement = placement;
  }
  getPlacement() {
    return this.placement;
  }
  getId() {
    return this.id;
  }
}
