export const argTypesDate = {
    "range": {
        control: "boolean",
        description: "Specifies whether the date picker is in range mode.",
        table: {
            category: "Date Properties",
            defaultValue: { summary: "false" },
            type: { summary: "boolean" },
        },
    },
    "show-today": {
        control: { type: "select", options: ["true", "false"] },
        description: "Show the today button in the date picker.",
        table: {
            category: "Date Properties",
            defaultValue: { summary: "true" },
            type: { summary: "string" },
        },
    },
    "disabled-dates": {
        control: "object",
        description: "The dates that are disabled in the date picker. The value is stored as an object.",
        table: {
            category: "Date Properties",
            defaultValue: {
                summary: "Disabled Date Object",
                detail: `const bcmDate = document.querySelector("bcm-date");
bcmDate.disabledDates = {
    min: new Date(2023, 11, 1), // disable dates before 
    max: moment().endOf('month').toDate(), // disable dates after
    dates: [
        moment("2023-11-12").toDate(), 
        moment("2023-11-15").toDate(), 
        moment("2023-11-20").toDate(),
        new Date(2023, 11, 25)
    ],
    custom: (current) => {
        // return current <= moment().endOf('day') // disable dates before today
        // return current >= moment().startOf('day') // disable dates after today
        return current < moment().startOf("week") || current > moment().endOf("week"); // disable dates outside of the current week
    },
}`,
            },
            type: { summary: "object" },
        },
    },
};
