export const argTypesTime = {
    "range": {
        control: "boolean",
        description: "Specifies whether the time picker is in range mode.",
        table: {
            category: "Date Properties",
            defaultValue: { summary: "false" },
            type: { summary: "boolean" },
        },
    },
    "show-now": {
        control: { type: "select", options: ["true", "false"] },
        description: "Specifies whether the now button is shown.",
        table: {
            category: "Time Properties",
            defaultValue: { summary: "true" },
            type: { summary: "string" },
        },
    },
    "show-second": {
        control: "boolean",
        description: "Specifies whether the second is shown.",
        table: {
            category: "Time Properties",
            defaultValue: { summary: "false" },
            type: { summary: "boolean" },
        },
    },
    "use-12-hours": {
        control: "boolean",
        description: "Specifies whether the time picker is shown in 12-hour format.",
        table: {
            category: "Time Properties",
            defaultValue: { summary: "false" },
            type: { summary: "boolean" },
        },
    },
    "hour-step": {
        control: "number",
        description: "Specifies the hour step.",
        table: {
            category: "Time Properties",
            defaultValue: { summary: "1" },
            type: { summary: "number" },
        },
    },
    "minute-step": {
        control: "number",
        description: "Specifies the minute step.",
        table: {
            category: "Time Properties",
            defaultValue: { summary: "1" },
            type: { summary: "number" },
        },
    },
    "second-step": {
        control: "number",
        description: "Specifies the second step.",
        table: {
            category: "Time Properties",
            defaultValue: { summary: "1" },
            type: { summary: "number" },
        },
    },
    "hide-disabled-options": {
        control: "boolean",
        description: "Specifies whether the disabled options are hidden.",
        table: {
            category: "Time Properties",
            defaultValue: { summary: "false" },
            type: { summary: "boolean" },
        },
    },
    "disabled-time": {
        description: "The times that are disabled in the time picker. The value is stored as an object.",
        table: {
            category: "Time Properties",
            defaultValue: {
                summary: "Disabled Time Object",
                detail: `
const bcmDate = document.querySelector("bcm-date");
bcmDate.disabledTime = {
disabledHours: [1, 2, 3, 4, 5, 6, 7, 10, 11],
disabledMinutes: [1, 2, 3, 4, 5, 6, 7, 8, 9],
disabledSeconds: [1, 2, 3, 4, 5, 6, 7, 8, 9],
};`,
            },
            type: { summary: "object" },
        },
    },
};
