/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h } from '@stencil/core';
import cs from 'classnames';
import Bcm from '../models/bcm';
export const CheckboxTemplate = ({ disabled, checked, readonly, required, indeterminate, hidden, captionType, _id }) => {
  // if ( indeterminate ) {
  //   checked = indeterminate == 'determinate' ? true : false 
  // }
  const hostClasses = cs('bcm-checkbox', 'bcm-checkbox__type-default', `bcm-checkbox-size-medium`, {
    // 'size-2': size === Bcm.Size.small || size === Bcm.Size.medium,
    // 'size-3': optionType === 'button' && size === Bcm.Size.large,
    'error': captionType == Bcm.Status.error,
    hidden,
    checked,
    disabled,
    required,
    readonly,
  });
  const bcmCheckboxIconClass = cs('bcm-checkbox__label-icon', 'bcm-checkbox__label-icon-lite', 'bcm-checkbox__label-icon-' + indeterminate, {
    'bcm-checkbox__label-icon-checked': checked,
  });
  const bcmCheckboxLabelClass = cs('bcm-checkbox__label');
  return (h("div", { class: hostClasses }, h("input", { tabindex: "-1", id: _id, type: "checkbox", checked: checked, disabled: disabled, required: required, readonly: readonly }), h("label", { class: bcmCheckboxLabelClass, htmlFor: _id }, h("span", { class: bcmCheckboxIconClass }, h("bcm-icon", { icon: "far fa-check" })))));
};
