/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h } from '@stencil/core';
import cs from 'classnames';
import { CheckboxTemplate } from './checkbox-template';
import { StringHelper } from '@bcm/helpers';
export const ListItemTemplate = ({ item, treeview, highlight, checkboxes, size, selectedItem, openGroup, checkedItem, focusItem, searchIsOnlyChilds }) => {
  const isHaveChildren = item.items && item.items.length > 0;
  var text = StringHelper.htmlEntities(item.text);
  let intersection = [];
  if (highlight && StringHelper.slugify(text).includes(StringHelper.slugify(highlight))) {
    if (!searchIsOnlyChilds || (searchIsOnlyChilds && (!isHaveChildren || (!treeview && item.type != "group")))) {
      text = StringHelper.highlight(text, highlight);
    }
  }
  if (item.type != 'group' && item.template) {
    const match = item.template
      .replace(/\s/g, '')
      .match(/\{{[^}}]+\}/g)
      .map(x => x.replace(/[{}]/g, ''));
    const keys = Object.keys(item.itemObject);
    intersection = match.filter(x => keys.includes(x));
  }
  text = item.isHtmlContent ? item.isHtmlContent : item.template && intersection.length > 0 ? StringHelper.templateParser(item.template, Object.assign(Object.assign({}, item.itemObject), { text })) : text;
  const unClickable = !treeview && item.type == "group" && !item.clickable;
  const disabled = item.disabled;
  const readonly = item.readonly;
  const itemClick = (event) => {
    let path = event.path || event.composedPath();
    if (path.filter(x => x.attributes && x.attributes.getNamedItem("unlinked"))[0]) {
      return;
    }
    // if (readonly) {
    //     collapseClick();
    // }
    !unClickable && !disabled && !readonly && (checkboxes ? checkedItem(item.id) : selectedItem(item.id));
  };
  const collapseClick = () => {
    // if (disabled) {
    //     return;
    // }
    item.open = item.isSearching;
    openGroup(item.id);
  };
  return (h("div", { id: item.id, hidden: item.hidden, "on-focus": e => !unClickable && !disabled && focusItem(e), tabIndex: unClickable || disabled ? -1 : 0, class: cs('bcm-list__item', 
    // size === 'large' ? 'size-3' : 'size-2',
    'bcm-list__item-' + size, {
      'bcm-list__item--group': !treeview && item.type == 'group',
      'bcm-list__item--readonly': readonly,
    }) }, h("div", { class: cs('bcm-list__item-content', !checkboxes && item.selected && 'selected', { disabled, readonly }) }, treeview && (h("div", { class: "bcm-list__item-content-collapse-icon", onClick: () => collapseClick() }, isHaveChildren && h("bcm-icon", { icon: cs('fas fa-caret-' + (item.isSearching || item.open ? 'down' : 'right')) }))), h("div", { class: cs('bcm-list__item-content-text', { treeview }), onClick: (e) => itemClick(e) }, checkboxes && (treeview || (!treeview && item.type != 'group')) && (h("div", { class: "bcm-list__item-content-text-checkbox" }, h(CheckboxTemplate, { indeterminate: item.indeterminate, checked: item.checked, disabled: item.disabled }))), h("span", Object.assign({ class: "bcm-list__item-content-text-inner" }, (item.title && { "title": item.title }), { innerHTML: text })))), (treeview || !treeview && item.type == "group") && isHaveChildren && (h("div", { class: "bcm-list__item-childs" }, (item.isSearching || item.open || (!treeview && item.type == "group")) &&
    item.items.map((item) => (h(ListItemTemplate, { highlight: highlight, item: item, searchIsOnlyChilds: searchIsOnlyChilds, treeview: treeview, checkboxes: checkboxes, size: size, selectedItem: selectedItem, checkedItem: checkedItem, openGroup: parentId => openGroup(parentId), focusItem: itemId => focusItem(itemId) })))))));
};
