/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h } from '@stencil/core';
import cs from 'classnames';
export const StepperHeaderTemplate = ({ _title, description, status, valid, index, loading, active, stepChange, statusIcon, icon, disabled, headerHidden, }) => {
  const classes = cs('bcm-stepper__header-item', `bcm-stepper__header-item--${status}`, {
    'bcm-stepper__header-item--active': active,
    'bcm-stepper__header-item--valid': valid,
    'bcm-stepper__header-item--invalid': !valid,
    'bcm-stepper__header-item--disabled': disabled,
    'hidden': headerHidden,
  });
  const defaultIcons = {
    success: 'fal fa-check',
    warning: 'fal fa-exclamation-triangle',
    error: 'fal fa-times',
  };
  const customIcon = (icon || (statusIcon && defaultIcons[status])) && h("bcm-icon", { icon: icon ? icon : defaultIcons[status] });
  return (h("div", { class: classes }, h("div", { class: "bcm-stepper__header-item--container", onClick: () => !disabled && stepChange(index) }, h("div", { class: "bcm-stepper__header-item-icon size-3" }, loading ? h("bcm-icon", { icon: "far fa-spinner-third fa-spin" }) : customIcon || index), h("div", { class: "bcm-stepper__header-item-title size-2" }, _title), h("div", { class: "bcm-stepper__header-item-description size-1 tw-text-center", innerHTML: description }))));
};
