/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h } from '@stencil/core';
import Bcm from '../models/bcm';
import cs from 'classnames';
import { NumberHelper } from '../helper/number-helper';
import { extractColor } from '../utils/utils';
import { ColorPalette } from '../global/variables/colors';
import { ColorProps } from '../components/other_deprecated/tag/types';
export const TagTemplate = ({ _id, color, customStyle, size, checked, hidden, value, type, onDismiss, onSelect }) => {
  !size && (size = Bcm.FontSize['size-1']);
  const getColor = (color) => {
    if ((type === Bcm.TagType.basic || type == Bcm.TagType.dismissable) && ColorProps[color])
      return {
        color: extractColor(ColorPalette, ColorProps[color] + '-6'),
        borderColor: extractColor(ColorPalette, ColorProps[color] + '-3'),
        backgroundColor: extractColor(ColorPalette, ColorProps[color] + '-1')
      };
  };
  const getSize = (size, returnNumber = false) => {
    if (NumberHelper.isNumber(size)) {
      size = Bcm.FontSize["size-" + size] || Bcm.FontSize["size-4"];
    }
    if (returnNumber) {
      return +(Bcm.FontSizeValue[size] || Bcm.FontSizeValue['size-4']) + 2;
    }
    return size;
  };
  const classes = cs(getSize(size), 'bcm-tag__content', type);
  const hostClasses = cs('bcm-tag', {
    hidden
  });
  return (h("div", { id: _id, class: cs(hostClasses, { checked }) }, h("span", { hidden: true }, h("slot", null)), h("span", { class: classes, style: getColor(color), onClick: (e) => onSelect(e) }, type === Bcm.TagType.add && (h("span", { class: "left" }, h("bcm-icon", { icon: "far fa-plus" }))), type === Bcm.TagType.checkable && h("input", { type: "checkbox", checked: checked }), h("span", { class: "value", style: customStyle }, value), type === Bcm.TagType.dismissable && (h("span", { class: "right close-button", onClick: (e) => onDismiss(e) }, h("bcm-icon", { icon: "fal fa-times" }))))));
};
