/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { StringHelper } from "@bcm/helpers";
import { Fragment, h } from "@stencil/core";
import { ToolbarHamburgerTemplate } from "./toolbar-hamburger-template";
export const ToolbarTemplate = ({ columns, config, extensions, tableId, onHideColumn, onSearch, onSelectExportType }) => {
  const { showColumnButton, showExportButton, showNewButton, showFilterButton, showSearchInput } = config;
  return (h("div", { class: "tw-flex tw-w-full tw-flex-row tw-items-center tw-justify-between" }, h("div", { class: "tw-flex tw-flex-row tw-items-center tw-justify-start tw-gap-2" }, h("slot", { name: "left" }), showFilterButton && (h("bcm-dropdown", { kind: "ghost" }, h("bcm-icon", { icon: "far fa-filter" }), "Filter", h("bcm-badge", { color: "blue", size: "small", value: "1" }, "1"))), showSearchInput && h("bcm-input", { class: "!tw-mb-0", placeholder: "Search", type: "search", "no-caption": true, "onBcm-input": e => onSearch(e.detail) })), h("div", null), h("div", { class: "tw-flex tw-flex-row tw-flex-wrap tw-items-center tw-justify-start tw-gap-2", id: "test" }, h("slot", { name: "right" }), showNewButton && h("bcm-button", { icon: "fas fa-plus" }, "New"), showColumnButton && (h("section", { class: "tw-hidden lg:tw-block md:tw-block" }, h("bcm-dropdown", { kind: "ghost", placement: "bottom-end" }, h("bcm-icon", { icon: "far fa-plus" }), "Add Column", h(Fragment, null, h("bcm-content", { class: "tw-hidden lg:tw-block md:tw-block" }, h("div", { class: "tw-shadow-custom tw-w-full tw-min-w-[256px] tw-flex-col tw-gap-2 tw-p-4" }, columns === null || columns === void 0 ? void 0 : columns.map(col => {
    return (h("bcm-item", { color: "white" }, h("div", { class: "tw-flex tw-h-4 tw-w-full tw-flex-1 tw-items-center tw-justify-between tw-gap-1 tw-font-medium" }, h("span", null, StringHelper.capitalize(col.id)), h("bcm-switch", { class: "!tw-mt-2", disabled: col.disabled, "onBcm-change": e => onHideColumn({ checked: e.detail, id: col.id }), accessKey: col.id, id: col.id, "no-caption": true, checked: true }))));
  }))))))), showExportButton && (h("section", { class: "tw-hidden lg:tw-block md:tw-block" }, (extensions === null || extensions === void 0 ? void 0 : extensions.length) > 1 && (h("bcm-dropdown", { id: tableId + "extention-content", selectable: false, kind: "ghost", class: "!tw-font-medium" }, "Export As", h("bcm-content", { class: "tw-hidden lg:tw-block md:tw-block" }, h("div", { class: "tw-shadow-custom tw-flex tw-w-full tw-min-w-[200px] tw-flex-col tw-gap-2 tw-p-4" }, extensions === null || extensions === void 0 ? void 0 : extensions.map(ext => {
    return (h("div", { class: "tw-flex tw-w-full tw-flex-1 tw-cursor-pointer tw-flex-row tw-items-center tw-justify-start tw-gap-2 tw-rounded tw-bg-white tw-px-3 tw-py-[5px] tw-font-sans tw-text-size-4 tw-font-medium tw-antialiased hover:tw-bg-slate-100", onClick: () => onSelectExportType(ext) }, h("span", null, h("i", { class: "tw-text-size-5 " + ext.icon })), h("span", null, ext.text)));
  }))))), (extensions === null || extensions === void 0 ? void 0 : extensions.length) == 1 && (h("bcm-button", { outline: true, onClick: () => onSelectExportType(extensions[0]) }, h("img", { src: "assets/" + extensions[0].path }), " Export as ", extensions[0].text))))), h("bcm-button", { outline: true, id: tableId + "-hamburger-menu", class: "sm:tw-block lg:tw-hidden md:tw-hidden", icon: "fas fa-bars" }), h(ToolbarHamburgerTemplate, { hamburgerMenuId: tableId + "-hamburger-menu", config: config, column: columns, extensions: extensions, onHideColumn: onHideColumn, onSelectExportType: onSelectExportType })));
};
