/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { a as Bcm } from './bcm.js';
import './string-helper.js';
import { C as CaptionTemplate } from './caption-template.js';
import './index2.js';
import './types.js';
import './color-helper.js';
import './validators.js';
import './generate.js';
import './number-helper.js';
import './element-dragger.js';
import './types2.js';

const BcmCaption$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.noCaption = false;
    this.captionType = Bcm.Status.default;
    this.captionClasses = undefined;
    this.caption = undefined;
    this.captionError = undefined;
    this.customErrorMessage = undefined;
    this.size = Bcm.Size.medium;
    this.maxLength = undefined;
    this.value = undefined;
  }
  render() {
    const { noCaption, captionType, captionClasses, caption, captionError, customErrorMessage, size, maxLength, value } = this;
    return (h(Host, { class: "tw-block" }, h(CaptionTemplate, { noCaption: noCaption, captionType: captionType, captionClasses: captionClasses, caption: caption, captionError: captionError, customErrorMessage: customErrorMessage, size: size, maxLength: maxLength, value: value })));
  }
}, [0, "bcm-caption", {
    "noCaption": [4, "no-caption"],
    "captionType": [1, "caption-type"],
    "captionClasses": [8, "caption-classes"],
    "caption": [1],
    "captionError": [1, "caption-error"],
    "customErrorMessage": [1, "custom-error-message"],
    "size": [1],
    "maxLength": [8, "max-length"],
    "value": [8]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-caption"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-caption":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmCaption$1);
      }
      break;
  } });
}

const BcmCaption = BcmCaption$1;
const defineCustomElement = defineCustomElement$1;

export { BcmCaption, defineCustomElement };
