/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { g as getChildElements } from './utils.js';

const BcmCollapseGroup$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.borderless = false;
    this.open = false;
    this.multiple = false;
    this.hidden = false;
  }
  handleOpen({ target, detail }) {
    if (!this.multiple && this.el === target.parentElement) {
      this.qs().forEach(child => {
        child.open = child.id === detail;
      });
    }
  }
  componentDidLoad() {
    this.qs().forEach((child, index) => {
      !child.borderless && (child.borderless = this.borderless);
      this.qs().length == index + 1 && (child.noBorder = true);
    });
  }
  qs() {
    return getChildElements(this.el, 'bcm-collapse');
  }
  render() {
    const { hidden } = this;
    return (h(Host, { class: { hidden } }, h("slot", null)));
  }
  get el() { return this; }
}, [4, "bcm-collapse-group", {
    "borderless": [1028],
    "open": [1028],
    "multiple": [1028],
    "hidden": [1028]
  }, [[4, "bcm-collapse-open", "handleOpen"]]]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-collapse-group"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-collapse-group":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmCollapseGroup$1);
      }
      break;
  } });
}

const BcmCollapseGroup = BcmCollapseGroup$1;
const defineCustomElement = defineCustomElement$1;

export { BcmCollapseGroup, defineCustomElement };
