/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { c as classnames } from './index2.js';
import { I as IsLoad } from './is-load-decorator.js';
import { D as DateTimeHelper } from './validators.js';
import { G as Generate } from './generate.js';
import { a as Bcm } from './bcm.js';
import { d as delay } from './utils.js';
import { d as defineCustomElement$6 } from './datetime-picker.js';
import { d as defineCustomElement$5 } from './icon.js';
import { d as defineCustomElement$4 } from './label.js';
import { d as defineCustomElement$3 } from './old-input.js';
import { d as defineCustomElement$2 } from './tooltip.js';

const datePickerCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}:host{display:inline-flex;width:100%;max-width:256px}:host(.full-width){max-width:100%}:host(.hidden){display:none}:host(.linked-component){display:none}";

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
    r = Reflect.decorate(decorators, target, key, desc);
  else
    for (var i = decorators.length - 1; i >= 0; i--)
      if (d = decorators[i])
        r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const BcmDatePicker$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this._id = Generate.UID();
    this.date = new Date();
    this.value = undefined;
    this.endDate = null;
    this.range = false;
    this.hidden = false;
    this.name = undefined;
    this.fullWidth = false;
    this.required = false;
    this.label = undefined;
    this.placeholder = undefined;
    this.disabledDates = '';
    this.disabled = false;
    this.noMargin = false;
    this.noCaption = false;
    this.caption = '';
    this.captionError = undefined;
    this.captionType = 'default';
    this.alignment = undefined;
    this._internal_id = (Math.random() * 4).toString(16).replace('.', '');
    this.placement = Bcm.Placement['bottom-start'];
    this.linkedComponent = undefined;
    this.clearable = false;
    this.stateStartDate = null;
    this.stateEndDate = null;
  }
  handleStartDateChange() {
    this.handleDate();
  }
  handleEndDateChange() {
    this.handleDate();
  }
  /**
   * @desc
   */
  handlePickerLoad() {
    this.value = this.picker.value;
  }
  /**
   * @desc
   * @param event
   */
  handlePickerChange(event) {
    this.value = event.detail;
  }
  /**
   * @desc
   * @param value
   */
  async set(value) {
    return this.picker.set(value);
  }
  async get() {
    var _a;
    return ((_a = this.value) === null || _a === void 0 ? void 0 : _a.timestamp) || null;
  }
  /**
   * @desc
   * @param disabled
   */
  async setDisabled(disabled) {
    this.disabled = disabled;
  }
  async setClear() {
    await this.picker.setClear();
    await delay(10);
    return Promise.resolve();
  }
  async setStartDate(dateOrTime) {
    if (dateOrTime) {
      dateOrTime = DateTimeHelper.convertTimeStampToDate(new Date(dateOrTime).getTime());
      this.stateStartDate = dateOrTime;
    }
    else {
      this.setClear();
    }
  }
  async setEndDate(dateOrTime) {
    if (dateOrTime) {
      dateOrTime = DateTimeHelper.convertTimeStampToDate(new Date(dateOrTime).getTime());
      this.stateEndDate = dateOrTime;
    }
    else {
      this.setClear();
    }
  }
  /* mp --- */
  handleDate() {
    if (this.range) {
      if (this.stateStartDate && this.stateEndDate) {
        this.set(this.stateStartDate + '-' + this.stateEndDate);
      }
    }
    else {
      this.set(this.stateStartDate);
    }
  }
  /**
   * @desc
   */
  async getInput() {
    return await this.picker.getInput();
  }
  /**
   * @desc
   */
  async open() {
    return await this.picker.open();
  }
  /**
   * @desc
   */
  async getValue() {
    return this.value;
  }
  /**
   * @desc
   */
  async isValid() {
    return await this.picker.isValid();
  }
  async resetCaption() {
    await delay(10);
    await this.picker.resetCaption();
    this.captionType = 'default';
    this.captionError = null;
    await delay(10);
    return Promise.resolve();
  }
  render() {
    const hostClasses = classnames(this.hidden ? 'hidden' : null, {
      'full-width': this.fullWidth,
      'linked-component': this.linkedComponent,
    });
    return (h(Host, { class: hostClasses }, h("bcm-datetime-picker", { "linked-component": this.linkedComponent, id: this._id, name: this.name, type: this.range ? 'range' : 'date', date: this.date, placeholder: this.placeholder, fullWidth: this.fullWidth, ref: el => (this.picker = el), required: this.required, clearable: this.clearable, label: this.label, "end-date": this.endDate, disabled: this.disabled, disabledDates: this.disabledDates, "on-bcm-load": () => this.handlePickerLoad(), "on-bcm-change": (e) => this.handlePickerChange(e), noCaption: this.noCaption, caption: this.caption, captionError: this.captionError, captionType: this.captionType, alignment: this.alignment, placement: this.placement, noMargin: this.noMargin })));
  }
  get el() { return this; }
  static get watchers() { return {
    "stateStartDate": ["handleStartDateChange"],
    "stateEndDate": ["handleEndDateChange"]
  }; }
  static get style() { return datePickerCss; }
}, [1, "bcm-date-picker", {
    "_id": [1537, "id"],
    "date": [1025],
    "value": [1032],
    "endDate": [1025, "end-date"],
    "range": [1028],
    "hidden": [1028],
    "name": [1537],
    "fullWidth": [1028, "full-width"],
    "required": [1028],
    "label": [1025],
    "placeholder": [1025],
    "disabledDates": [1032, "disableddates"],
    "disabled": [1028],
    "noMargin": [1028, "no-margin"],
    "noCaption": [1028, "no-caption"],
    "caption": [1025],
    "captionError": [1025, "caption-error"],
    "captionType": [1025, "caption-type"],
    "alignment": [1032],
    "_internal_id": [1537, "internal-id"],
    "placement": [1025],
    "linkedComponent": [1025, "linked-component"],
    "clearable": [1028],
    "stateStartDate": [32],
    "stateEndDate": [32],
    "set": [64],
    "get": [64],
    "setDisabled": [64],
    "setClear": [64],
    "setStartDate": [64],
    "setEndDate": [64],
    "getInput": [64],
    "open": [64],
    "getValue": [64],
    "isValid": [64],
    "resetCaption": [64]
  }]);
__decorate([
  IsLoad()
], BcmDatePicker$1.prototype, "el", void 0);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-date-picker", "bcm-datetime-picker", "bcm-icon", "bcm-label", "bcm-old-input", "bcm-tooltip"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-date-picker":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmDatePicker$1);
      }
      break;
    case "bcm-datetime-picker":
      if (!customElements.get(tagName)) {
        defineCustomElement$6();
      }
      break;
    case "bcm-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$5();
      }
      break;
    case "bcm-label":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "bcm-old-input":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "bcm-tooltip":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const BcmDatePicker = BcmDatePicker$1;
const defineCustomElement = defineCustomElement$1;

export { BcmDatePicker, defineCustomElement };
