/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { c as classnames } from './index2.js';

const errorLayoutCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");@import url(\"https://fonts.googleapis.com/css2?family=Inter:wght@200;400;500;600&display=swap\"); .size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}*{box-sizing:border-box}.error-layout{font-family:\"Inter\", sans-serif;font-size:14px;line-height:calc(14px + 8px);font-weight:400;font-size:12px;line-height:calc(12px + 8px);padding:12px;background:var(--bcm-new-ds-color-red-100);border:2px solid var(--bcm-new-ds-color-red-200);box-sizing:border-box;border-radius:4px;color:var(--bcm-new-ds-color-red-400)}.error-layout li>span{margin-left:-4px}";

const BcmErrorLayout$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.size = 'medium';
    this.hidden = false;
    this.items = [];
    this.itemsProp = [];
  }
  connectedCallback() { }
  disconnectedCallback() { }
  componentWillLoad() {
    this.parseItems(this.items);
  }
  componentDidLoad() { }
  componentWillRender() { }
  componentDidRender() { }
  componentWillUpdate() { }
  componentDidUpdate() { }
  /**
   * @desc
   * @param newValue
   * @returns {void}
   */
  parseItems(newValue) {
    if (newValue) {
      typeof newValue == 'string'
        ? this.itemsProp = JSON.parse(newValue)
        : this.itemsProp = newValue;
    }
  }
  async set(val) {
    this.items = val;
  }
  async clear() {
    this.items = [];
  }
  render() {
    const { itemsProp } = this;
    const classes = classnames('error-layout', this.size);
    const hostClasses = classnames(this.hidden ? 'hidden' : null);
    return (h(Host, { class: hostClasses }, itemsProp.length > 0 && (h("div", { class: classes }, h("ul", null, this.itemsProp.map((item) => h("li", null, h("span", null, item))))))));
  }
  get el() { return this; }
  static get watchers() { return {
    "items": ["parseItems"]
  }; }
  static get style() { return errorLayoutCss; }
}, [1, "bcm-error-layout", {
    "size": [1025],
    "hidden": [1028],
    "items": [1025],
    "itemsProp": [32],
    "set": [64],
    "clear": [64]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-error-layout"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-error-layout":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmErrorLayout$1);
      }
      break;
  } });
}

const BcmErrorLayout = BcmErrorLayout$1;
const defineCustomElement = defineCustomElement$1;

export { BcmErrorLayout, defineCustomElement };
