/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const formGroupCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}:host{display:block}:host(.hidden){display:none}";

const BcmFormGroup$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this._id = (Math.random() * 4).toString(16).replace('.', '');
    this.hidden = false;
    this.validation = false;
    this.name = "";
    this.value = undefined;
  }
  inputChange() {
    //   console.log("diğişti")
  }
  render() {
    return (h(Host, { "on-bcm-change": () => this.inputChange() }, h("form", { class: "bcm-form" }, h("slot", null))));
  }
  get el() { return this; }
  static get style() { return formGroupCss; }
}, [1, "bcm-form-group", {
    "_id": [1537, "id"],
    "hidden": [1028],
    "validation": [1028],
    "name": [1025],
    "value": [1032]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-form-group"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-form-group":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmFormGroup$1);
      }
      break;
  } });
}

const BcmFormGroup = BcmFormGroup$1;
const defineCustomElement = defineCustomElement$1;

export { BcmFormGroup, defineCustomElement };
