/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { G as Generate } from './generate.js';
import { c as classnames } from './index2.js';
import { d as defineCustomElement$4 } from './icon.js';
import { d as defineCustomElement$3 } from './label.js';
import { d as defineCustomElement$2 } from './tooltip.js';

const BcmInputCustom$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.handleFocus = () => {
      this.hasFocus = true;
    };
    this.handleBlur = () => {
      this.hasFocus = false;
    };
    this.handleChange = (e) => {
      this.value = e.target.value;
      console.log(e);
    };
    this.handleInput = (e) => {
      // this.value = (e.target as HTMLInputElement).value;
      console.log(e);
    };
    this._id = Generate.UID();
    this.name = undefined;
    this.value = undefined;
    this.type = "text";
    this.label = undefined;
    this.required = false;
    this.disabled = false;
    this.readonly = false;
    this.placeholder = undefined;
    this.fullwidth = false;
    this.hasFocus = false;
  }
  render() {
    const { _id, type, name, value, label, required, fullwidth, placeholder, disabled, readonly } = this;
    return (h(Host, { class: classnames("tw-inline-flex tw-w-full tw-max-w-[256px] tw-flex-col", {
        "tw-max-w-full": fullwidth,
      }) }, label && h("bcm-label", { value: label, required: required, htmlFor: _id }), h("div", { class: classnames("tw-relative tw-flex tw-w-full tw-flex-row tw-items-stretch tw-rounded tw-border tw-p-0 hover:tw-border-primary-600", {
        "tw-cursor-not-allowed tw-bg-secondary-50": this.disabled,
        "tw-cursor-text": !this.disabled,
        "tw-cursor-default tw-bg-secondary-50": this.readonly,
        "tw-border-primary-500 tw-bg-secondary-50": this.hasFocus,
        "tw-border-secondary-300 tw-bg-white": !this.hasFocus,
      }) }, h("input", { id: _id, name: name, type: type, value: value, "data-value": value, placeholder: placeholder, required: required, disabled: disabled, readonly: readonly, class: classnames("tw-text-overflow-ellipsis", "tw-rounded-none", "tw-flex-1", "tw-cursor-inherit", "tw-w-full", "tw-appearance-none", "tw-overflow-hidden", "tw-whitespace-nowrap", "tw-border-none", "tw-bg-transparent", "tw-p-2", "tw-text-secondary-600", "tw-placeholder-secondary-300", "tw-outline-none"), onFocus: this.handleFocus, onBlur: this.handleBlur, onChange: e => this.handleChange(e), onInput: this.handleInput }))));
  }
  get el() { return this; }
}, [0, "bcm-input-custom", {
    "_id": [1537, "id"],
    "name": [1],
    "value": [1025],
    "type": [1],
    "label": [1],
    "required": [4],
    "disabled": [4],
    "readonly": [4],
    "placeholder": [1],
    "fullwidth": [4],
    "hasFocus": [32]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-input-custom", "bcm-icon", "bcm-label", "bcm-tooltip"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-input-custom":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmInputCustom$1);
      }
      break;
    case "bcm-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "bcm-label":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "bcm-tooltip":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const BcmInputCustom = BcmInputCustom$1;
const defineCustomElement = defineCustomElement$1;

export { BcmInputCustom, defineCustomElement };
