/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { c as classnames } from './index2.js';
import { d as defineCustomElement$2 } from './icon.js';

/**
 * 'status' prop predefined values
 */
var StatusProps;
(function (StatusProps) {
  StatusProps["info"] = "info";
  StatusProps["error"] = "error";
  StatusProps["warning"] = "warning";
  StatusProps["success"] = "success";
})(StatusProps || (StatusProps = {}));

const messageCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}:host{display:inline-block}:host(.hidden){display:none}.message{display:flex;width:100%;box-sizing:border-box;padding:8px 16px;box-shadow:0px 4px 12px rgba(0, 0, 0, 0.15);border-radius:4px;font-size:12px;line-height:20px}.message:not(.full-width){max-width:460px}.message.info{background-color:var(--bcm-color-blue-1);color:var(--bcm-color-blue-6)}.message.error{background-color:var(--bcm-color-red-1);color:var(--bcm-color-red-6)}.message.warning{background-color:var(--bcm-color-warmyellow-1);color:var(--bcm-color-warmyellow-6)}.message.success{background-color:var(--bcm-color-green-1);color:var(--bcm-color-green-6)}.message bcm-icon{margin-right:9px;margin-top:2px}";

const BcmMessage$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.status = StatusProps.info;
    this.fullWidth = false;
    this.loading = false;
    this.isShow = false;
    this.hidden = false;
  }
  /**
   * @desc
   */
  getIcon() {
    switch (this.status) {
      case StatusProps.info:
        return h("bcm-icon", { icon: "far fa-info-circle" });
      case StatusProps.error:
        return h("bcm-icon", { icon: "far fa-times-circle" });
      case StatusProps.warning:
        return h("bcm-icon", { icon: "far fa-exclamation-circle" });
      case StatusProps.success:
        return h("bcm-icon", { icon: "far fa-check-circle" });
    }
  }
  /**
   * @desc Removes component itself
   */
  dismiss() {
    this.isShow = false;
    // this.el.remove()
  }
  /**
   * @desc
   */
  async hide() {
    this.dismiss();
  }
  /**
   * @desc
   */
  async show() {
    this.isShow = true;
  }
  render() {
    const { fullWidth, status, isShow, loading } = this;
    const classes = classnames('message', loading ? 'info' : status, {
      'full-width': fullWidth,
      'show': isShow
    });
    const hostClasses = classnames(this.hidden ? 'hidden' : null);
    return (h(Host, { class: hostClasses }, h("div", { class: classes }, loading && (h("bcm-icon", { icon: "far fa-spinner-third fa-spin" })), !loading && (this.getIcon()), h("slot", null))));
  }
  get el() { return this; }
  static get style() { return messageCss; }
}, [1, "bcm-message", {
    "status": [1025],
    "fullWidth": [1028, "full-width"],
    "loading": [1028],
    "isShow": [1540, "open"],
    "hidden": [1028],
    "hide": [64],
    "show": [64]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-message", "bcm-icon"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-message":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmMessage$1);
      }
      break;
    case "bcm-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const BcmMessage = BcmMessage$1;
const defineCustomElement = defineCustomElement$1;

export { BcmMessage, defineCustomElement };
