/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { c as classnames } from './index2.js';
import { a as Bcm } from './bcm.js';
import { S as StringHelper } from './string-helper.js';
import { S as SlotTemplate } from './slot-template.js';
import { G as Generate } from './generate.js';
import { d as defineCustomElement$2 } from './icon.js';

const modalCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");@import url(\"https://fonts.googleapis.com/css2?family=Inter:wght@200;400;500;600&display=swap\"); .size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}*{box-sizing:border-box}.bcm-modal{font-family:\"Inter\", sans-serif;font-size:14px;line-height:calc(14px + 8px);font-weight:400;display:flex;flex-direction:column;align-items:center;justify-content:flex-start;flex-wrap:nowrap;width:100%;height:100%;position:fixed;z-index:-1;opacity:0;top:0;left:0;visibility:hidden;overflow:auto;padding:24px;transition:opacity 0.5s ease, visibility 0.4s ease-in-out, 0.3s z-index}.bcm-modal__show{opacity:1;z-index:10500;visibility:visible;transition:opacity 0.2s ease, visibility 0.4s ease-in-out, 0.3s z-index}.bcm-modal__show .bcm-modal__container{transition:opacity 0.2s ease-in-out, transform 0.2s ease-in-out;transform:translateY(0)}.bcm-modal .overlay{position:fixed;width:100vw;height:100vh;z-index:1;top:0;left:0;opacity:0.6;background-color:var(--bcm-new-ds-color-slate-900)}.bcm-modal__container{display:flex;flex-direction:column;width:100%;box-shadow:0 2px 6px 1px rgba(17, 24, 38, 0.1);border-radius:8px;background-color:var(--bcm-new-ds-color-white);z-index:2;transform:translateY(-50px);transition:opacity 0.2s ease-in-out, transform 0.2s ease-in-out}.bcm-modal__container.portrait{max-width:312px}.bcm-modal__container.landscape{max-width:475px}.bcm-modal__container.small{max-width:576px}.bcm-modal__container.medium{max-width:768px}.bcm-modal__container.large{max-width:992px}.bcm-modal__container.xlarge{max-width:1024px}.bcm-modal__container.xxlarge{max-width:1200px}.bcm-modal__container.xxxlarge{max-width:1700px}.bcm-modal__container.full-width{width:100%;max-width:100%}.bcm-modal__container.custom-size main{overflow:auto;height:100%;width:100%}.bcm-modal__container-main{color:var(--bcm-color-grey-8);padding:0}.bcm-modal__container-header{display:flex;flex-direction:row;align-items:center;justify-content:space-between;flex-wrap:nowrap;padding:12px 24px;font-size:16px;line-height:calc(16px + 8px);font-weight:500;color:var(--bcm-new-ds-color-slate-600);background-color:var(--bcm-new-ds-color-slate-100);position:relative}.bcm-modal__container-header span.full-width{width:100%}.bcm-modal__container-header-close{display:flex;flex-direction:row;align-items:center;justify-content:center;flex-wrap:nowrap;padding:8px;cursor:pointer;color:var(--bcm-new-ds-color-slate-500);transition:color 0.1s ease-in-out}.bcm-modal__container-header-close:hover{color:var(--bcm-new-ds-color-slate-600)}.bcm-modal__container-header-close:active{color:var(--bcm-new-ds-color-slate-700)}.bcm-modal__container-header-close:focus-visible{color:var(--bcm-new-ds-color-slate-800)}.bcm-modal__container-header:after{border-radius:8px 8px 0 0;content:\"\";display:block;width:100%;height:4px;background-color:var(--bcm-color-primary-500);position:absolute;top:-4px;left:0}.bcm-modal__container-footer-content{display:flex;flex-direction:row;align-items:flex-start;justify-content:flex-end;flex-wrap:nowrap;padding:12px 24px 24px;grid-gap:8px}";

const BcmModal$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.close = createEvent(this, "bcm-close", 3);
    this.modalClose = createEvent(this, "bcm-modal-close", 3);
    this.modalBeforeClose = createEvent(this, "bcm-modal-before-close", 3);
    this.modalBeforeOpen = createEvent(this, "bcm-modal-before-open", 3);
    this.modalSlots = {};
    this._id = Generate.UID();
    this.isShow = false;
    this.hidden = false;
    this.size = Bcm.Size.medium;
    this.backdrop = true;
    this.width = undefined;
    this.height = undefined;
    this.fullWidth = false;
  }
  connectedCallback() {
    const bcmSlots = this.el.querySelectorAll('bcm-modal-header, bcm-modal-footer');
    if (bcmSlots) {
      bcmSlots.forEach(el => {
        let slotName = StringHelper.lowercase(StringHelper.split(el.nodeName, '-').pop());
        el.slot = slotName;
        el.classList.add(`bcm-modal__container-${slotName}-content`);
        this.modalSlots[slotName] = el;
      });
    }
    const disableScrollClass = `bcm-modal--disable-scroll-${this._id}`;
    const styleId = `bcm-modal-style-${this._id}`;
    let style = document.getElementById(styleId);
    if (!style) {
      style = document.createElement('style');
      style.id = styleId;
      style.innerHTML = `.${disableScrollClass} { overflow: hidden; }`;
      document.head.appendChild(style);
    }
  }
  componentWillLoad() {
    // document.body.appendChild(this.el);
  }
  handleSubmit(e) {
    const button = Generate.findEventPathWithNodeName(e, StringHelper.uppercase('bcm-button'));
    if (button && button.dataDismiss) {
      this.hide();
    }
  }
  handleBackdrop() {
    if (this.backdrop == true) {
      this.hide();
    }
  }
  async hide(obj = { force: false }) {
    if (obj === null || obj === void 0 ? void 0 : obj.force) {
      this.isShow = false;
      this.close.emit(); // Deprecated
      this.modalClose.emit();
      return;
    }
    this.modalBeforeClose.emit(this.el);
  }
  async show(obj = { force: false }) {
    if (obj === null || obj === void 0 ? void 0 : obj.force) {
      this.isShow = true;
      return;
    }
    this.modalBeforeOpen.emit(this.el);
  }
  keyboardNavigation(e) {
    if (this.backdrop == true) {
      const keyCode = e.keyCode || 0;
      if (keyCode == Bcm.KeyCode.escape) {
        e.preventDefault();
        this.hide();
      }
    }
  }
  async showModal(e) {
    if (e.defaultPrevented) {
      return;
    }
    if (e.target === this.el) {
      this.isShow = true;
      // document.body.appendChild(this.el); A solution must be found for this.
    }
  }
  async hideModal(e) {
    if (e.defaultPrevented) {
      return;
    }
    if (e.target === this.el) {
      this.isShow = false;
      this.close.emit(); // Deprecated
      this.modalClose.emit();
    }
  }
  _openHandler() {
    const disableScrollClass = `bcm-modal--disable-scroll-${this._id}`;
    if (this.isShow) {
      document.body.classList.add(disableScrollClass);
    }
    else {
      document.body.classList.remove(disableScrollClass);
    }
  }
  disconnectedCallback() {
    const disableScrollClass = `bcm-modal--disable-scroll-${this._id}`;
    document.body.classList.remove(disableScrollClass);
  }
  render() {
    const { isShow, size, fullWidth, hidden, width, height } = this;
    const bcmModalContainer = classnames('bcm-modal__container', size, {
      'custom-size': width || height,
      'full-width': fullWidth,
      'bcm-modal__show': isShow,
    });
    const bcmModalHostClasses = classnames('bcm-modal', {
      hidden,
      'bcm-modal__show': isShow,
    });
    const mainClasses = classnames('bcm-modal__container-main', 'size-2');
    const FooterTemplate = () => {
      return (this.modalSlots['footer'] && (h("footer", { class: "bcm-modal__container-footer" }, h("slot", { name: "footer" }))));
    };
    const HeaderTemplate = () => {
      return (this.modalSlots['header'] && (h("header", { class: "bcm-modal__container-header" }, h(SlotTemplate, { name: "header", className: 'full-width' }), h("div", { class: "bcm-modal__container-header-close", onClick: () => this.hide() }, h("bcm-icon", { icon: "far fa-times" })))));
    };
    const customStyle = Object.assign(Object.assign({}, (width && { width: width })), (height && { height: height }));
    return (h(Host, { class: `tw-overscroll-contain  ${bcmModalHostClasses}` }, h("div", { class: "overlay", onClick: () => this.handleBackdrop() }), h("div", { class: bcmModalContainer, style: customStyle }, h(HeaderTemplate, null), h("main", { class: mainClasses }, h("article", null, h(SlotTemplate, null))), h(FooterTemplate, null))));
  }
  get el() { return this; }
  static get watchers() { return {
    "isShow": ["_openHandler"]
  }; }
  static get style() { return modalCss; }
}, [4, "bcm-modal", {
    "_id": [1537, "id"],
    "isShow": [1028, "is-show"],
    "hidden": [1028],
    "size": [1032],
    "backdrop": [1032],
    "width": [1025],
    "height": [1025],
    "fullWidth": [1028, "full-width"],
    "hide": [64],
    "show": [64]
  }, [[8, "click", "handleSubmit"], [4, "keydown", "keyboardNavigation"], [0, "bcm-modal-before-open", "showModal"], [0, "bcm-modal-before-close", "hideModal"]]]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-modal", "bcm-icon"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-modal":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmModal$1);
      }
      break;
    case "bcm-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const BcmModal = BcmModal$1;
const defineCustomElement = defineCustomElement$1;

export { BcmModal, defineCustomElement };
