/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { c as classnames } from './index2.js';

const optionCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}:host{display:block;width:100%;box-sizing:border-box;min-width:256px}:host(.hidden){display:none}:host-context(bcm-select-group) .option{padding-left:16px}.option{display:none;padding:4px 8px;cursor:pointer;color:var(--bcm-color-grey-8);box-sizing:border-box;width:100%}.option:hover:not(.disabled){background-color:var(--bcm-color-prime-blue-1)}.option.selected:not(.disabled){background-color:var(--bcm-color-grey-3)}.option.disabled{background-color:var(--bcm-color-grey-5);color:var(--bcm-color-grey-6);cursor:not-allowed}.option.disabled:not(.selected){background-color:var(--bcm-color-prime-blue-1)}.option.visible{display:inline-flex}";

const BcmSelectOption$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.value = undefined;
    this.selected = undefined;
    this.disabled = undefined;
    this.visible = true;
    this.hidden = false;
  }
  async getLabel() {
    return this.host.innerHTML;
  }
  render() {
    const classes = classnames('option', 'size-2', {
      'selected weight-semibold': this.selected,
      'disabled': this.disabled,
      'visible': this.visible
    });
    const hostClasses = classnames(this.hidden ? 'hidden' : null);
    return (h(Host, { class: hostClasses }, h("span", { class: classes }, h("slot", null))));
  }
  get host() { return this; }
  static get style() { return optionCss; }
}, [1, "bcm-select-option", {
    "value": [1025],
    "selected": [1540],
    "disabled": [1028],
    "visible": [1028],
    "hidden": [1028],
    "getLabel": [64]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-select-option"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-select-option":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmSelectOption$1);
      }
      break;
  } });
}

const BcmSelectOption = BcmSelectOption$1;
const defineCustomElement = defineCustomElement$1;

export { BcmSelectOption, defineCustomElement };
