/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { c as classnames } from './index2.js';
import { d as defineCustomElement$2 } from './icon.js';

const timelineItemCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}:host{display:block}:host(.hidden){display:none}.timeline-item{position:relative;font-size:14px;line-height:22px;padding:8px 8px 8px 30px}.timeline-item:after{content:\"\";position:absolute;left:0;top:14px;width:9px;height:9px;border-radius:100px;background-color:#ffffff;border:2px solid #4293CF;box-sizing:border-box}.timeline-item:before{content:\"\";position:absolute;top:30px;left:3px;width:2px;height:calc(100% - 23px);background-color:#e8e8e8}.timeline-item.last:before{display:none}.timeline-item.icon:after{display:none}bcm-icon{position:absolute;top:10px;left:-4px}.timeline-item.right{text-align:right;padding-left:8px;padding-right:30px}.timeline-item.right:after{left:inherit;right:0}.timeline-item.right:before{left:inherit;right:3px}.timeline-item.right bcm-icon{left:inherit;right:-4px}:host-context(.timeline.alternate){flex:0 0 50% !important;max-width:50% !important}:host-context(.timeline.alternate) .timeline-item.even{text-align:right;padding-left:8px;padding-right:30px}:host-context(.timeline.alternate) .timeline-item.even:after{left:inherit;right:-5px}:host-context(.timeline.alternate) .timeline-item.even:before{left:inherit;right:-1px}:host-context(.timeline.alternate) .timeline-item.even bcm-icon{left:inherit;right:-8px}:host-context(.timeline.alternate) .timeline-item:not(.even):after{left:-3px}:host-context(.timeline.alternate) .timeline-item:not(.even):before{left:0px}:host-context(.timeline.alternate) .timeline-item:not(.even) bcm-icon{left:-7px}@media screen and (min-width: 576px){:host-context(.timeline.alternate){flex:1 1 100% !important;max-width:100% !important;margin-left:inherit !important}:host-context(.timeline.alternate) .timeline-item.even{text-align:left;padding-left:30px;padding-right:8px}:host-context(.timeline.alternate) .timeline-item.even:after{left:-5px;right:inherit}:host-context(.timeline.alternate) .timeline-item.even:before{left:-1px;right:inherit}:host-context(.timeline.alternate) .timeline-item.even bcm-icon{left:-8px;right:inherit}}";

const BcmTimelineItem$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.even = false;
    this.first = false;
    this.last = false;
    this.icon = undefined;
    this.timelineType = 'left';
    this.hidden = false;
  }
  render() {
    const classes = classnames('timeline-item', [this.timelineType], {
      even: this.even,
      first: this.first,
      last: this.last,
      icon: this.icon
    });
    const hostClasses = classnames(this.hidden ? 'hidden' : null);
    return (h(Host, { class: hostClasses }, h("div", { class: classes }, this.icon && (h("bcm-icon", { icon: this.icon })), h("slot", null))));
  }
  get el() { return this; }
  static get style() { return timelineItemCss; }
}, [1, "bcm-timeline-item", {
    "even": [1028],
    "first": [1028],
    "last": [1028],
    "icon": [1025],
    "timelineType": [1025, "timeline-type"],
    "hidden": [1028]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-timeline-item", "bcm-icon"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-timeline-item":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmTimelineItem$1);
      }
      break;
    case "bcm-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const BcmTimelineItem = BcmTimelineItem$1;
const defineCustomElement = defineCustomElement$1;

export { BcmTimelineItem, defineCustomElement };
