/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { c as classnames } from './index2.js';

const timelineCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}:host{display:block}:host(.hidden){display:none}.timeline{position:relative;display:flex;flex-direction:column}.timeline ::slotted(bcm-timeline-item){flex:0 0 100%;max-width:100%}.timeline.alternate ::slotted(bcm-timeline-item:nth-child(even)){margin-left:auto;min-width:50%}";

const BcmTimeline$1 = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.icon = undefined;
    this.type = 'left';
    this.hidden = false;
    this.items = [];
  }
  /**
   * @StencilMethod
   */
  componentDidRender() {
    let slotElements;
    slotElements = this.el.shadowRoot.querySelector('slot').assignedElements();
    // Get only bcm-timeline-item elements from 
    // slot childs
    slotElements.map((element, idx) => {
      if (String(element.tagName).toLowerCase() == 'bcm-timeline-item') {
        element.timelineType = this.type;
        element.even = idx % 2 === 0;
        element.first = idx === 0;
        element.last = idx === slotElements.length - 1;
        element.icon = element.icon ? element.icon : this.icon;
        this.items.push(element);
      }
    });
  }
  /**
  * @StencilMethod
  */
  componentWillRender() {
    console.log(this.el.shadowRoot);
  }
  render() {
    const classes = classnames('timeline', [this.type]);
    const hostClasses = classnames(this.hidden ? 'hidden' : null);
    return (h(Host, { class: hostClasses }, h("div", { class: classes }, h("slot", null))));
  }
  get el() { return this; }
  static get style() { return timelineCss; }
}, [1, "bcm-timeline", {
    "icon": [1025],
    "type": [1025],
    "hidden": [1028],
    "items": [32]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-timeline"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-timeline":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmTimeline$1);
      }
      break;
  } });
}

const BcmTimeline = BcmTimeline$1;
const defineCustomElement = defineCustomElement$1;

export { BcmTimeline, defineCustomElement };
