/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h } from '@stencil/core/internal/client';
import { c as classnames } from './index2.js';

const CaptionTemplate = ({ noCaption, captionType, caption, captionError, customErrorMessage, size, 
//textarea props
maxLength, value, }) => {
  size = size || "medium";
  return ((noCaption == false || maxLength) && (h("div", { class: classnames("bcm-ui-element bcm-ui-feedback bcm-caption-area tw-mt-1 tw-min-h-[20px] tw-flex tw-flex-row tw-items-start tw-justify-between tw-font-normal", {
      "tw-text-slate-500": !captionType || captionType == "default",
      "tw-text-blue-600": captionType == "info",
      "tw-text-emerald-700": captionType == "success",
      "tw-text-amber-700": captionType == "warning",
      "tw-text-red-600": captionType == "error",
    }, {
      "tw-text-1": size == "small",
      "tw-text-2": size == "medium",
      "tw-text-3": size == "large",
    }, captionType && captionType != "default" && `bcm-caption-area__type-${captionType}`) },
    h("div", { class: "bcm-caption-area__text" }, captionType == "error" ? customErrorMessage || captionError : caption),
    maxLength && h("div", { class: "bcm-caption-area__text tw-text-slate-500" },
      " ",
      `${(value === null || value === void 0 ? void 0 : value.length) || 0}/${maxLength}`,
      " "))));
};

export { CaptionTemplate as C };
