/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { c as classnames } from './index2.js';
import { C as ColorHelper } from './color-helper.js';
import { G as Generate } from './generate.js';
import { d as defineCustomElement$8 } from './avatar.js';
import { d as defineCustomElement$7 } from './badge.js';
import { d as defineCustomElement$6 } from './icon.js';
import { d as defineCustomElement$5 } from './label.js';
import { d as defineCustomElement$4 } from './list.js';
import { d as defineCustomElement$3 } from './rc-overflow.js';
import { d as defineCustomElement$2 } from './search.js';
import { d as defineCustomElement$1 } from './tooltip.js';

const chipCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");@import url(\"https://fonts.googleapis.com/css2?family=Inter:wght@200;400;500;600&display=swap\"); .size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}*{box-sizing:border-box}.bcm-chip{--bcm-chip-color:var(--bcm-new-ds-color-slate-700);--bcm-chip-color-hover:var(--bcm-new-ds-color-slate-700);--bcm-chip-color-focus:var(--bcm-new-ds-color-slate-700);--bcm-chip-color-active:var(--bcm-new-ds-color-slate-700);--bcm-chip-color-disabled:var(--bcm-new-ds-color-slate-300);--bcm-chip-background-color:var(--bcm-new-ds-color-slate-100);--bcm-chip-background-color-hover:var(--bcm-new-ds-color-slate-200);--bcm-chip-background-color-focus:var(--bcm-new-ds-color-slate-300);--bcm-chip-background-color-active:var(--bcm-new-ds-color-slate-400);--bcm-chip-background-color-disabled:var(--bcm-new-ds-color-slate-100);display:inline-flex;justify-content:center;align-items:center;width:fit-content;height:fit-content;font-family:\"Inter\", sans-serif;font-size:14px;line-height:calc(14px + 8px);font-weight:400;padding:0 8px;gap:4px;color:var(--bcm-chip-color);background-color:var(--bcm-chip-background-color);border-radius:100px;transition:background-color 0.1s ease-in-out;outline:none}.bcm-chip:not(.bcm-chip--disabled):hover{background-color:var(--bcm-chip-background-color-hover)}.bcm-chip:not(.bcm-chip--disabled):focus{background-color:var(--bcm-chip-background-color-focus);color:var(--bcm-chip-color-focus)}.bcm-chip:not(.bcm-chip--disabled):active{background-color:var(--bcm-chip-background-color-active);color:var(--bcm-chip-color-active)}.bcm-chip--disabled{color:var(--bcm-chip-color-disabled);background-color:var(--bcm-chip-background-color-disabled)}.bcm-chip--avatar{padding-left:2px}.bcm-chip__type-dismissable-icon:hover{cursor:pointer;color:var(--bcm-chip-color-active)}.bcm-chip__size-small{font-size:10px;line-height:calc(10px + 8px)}.bcm-chip__size-small .bcm-avatar{width:14px;height:14px}.bcm-chip__size-small .bcm-chip--selected-icon{width:8px}.bcm-chip__size-medium{font-size:12px;line-height:calc(12px + 8px)}.bcm-chip__size-medium .bcm-avatar{width:16px;height:16px}.bcm-chip__size-medium .bcm-chip--selected-icon{width:10px}.bcm-chip__size-large{font-size:14px;line-height:calc(14px + 8px)}.bcm-chip__size-large .bcm-avatar{width:18px;height:18px}.bcm-chip__size-large .bcm-chip--selected-icon{width:12px}";

const BcmChip = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.bcmChipDismiss = createEvent(this, "bcm-chip-dismiss", 7);
    this.bcmChipSelect = createEvent(this, "bcm-chip-select", 7);
    this.bcmChipAddable = createEvent(this, "bcm-chip-addable", 7);
    this.bcmChipSelectItem = createEvent(this, "bcm-chip-select-item", 7);
    this._id = Generate.UID();
    this.type = "default";
    this.size = "medium";
    this.avatar = undefined;
    this.icon = undefined;
    this.disabled = undefined;
    this.color = undefined;
    this.selected = false;
    this.value = undefined;
    this.data = [];
  }
  // @ts-ignore
  setColor() {
    if (!this.color && !this.selected)
      return;
    const color = this.selected ? "indigo" : this.color; // Important: Find a solution for this in V3! ( selected ? this.color : "indigo" )
    return {
      "--bcm-chip-color": ColorHelper.dsColor(color + "-700"),
      "--bcm-chip-color-hover": ColorHelper.dsColor(color + "-700"),
      "--bcm-chip-color-focus": ColorHelper.dsColor(color + "-700"),
      "--bcm-chip-color-active": ColorHelper.dsColor(color + "-700"),
      "--bcm-chip-color-disabled": ColorHelper.dsColor("slate" + "-300"),
      "--bcm-chip-background-color": ColorHelper.dsColor(color + "-100"),
      "--bcm-chip-background-color-hover": ColorHelper.dsColor(color + "-200"),
      "--bcm-chip-background-color-focus": ColorHelper.dsColor(color + "-300"),
      "--bcm-chip-background-color-active": ColorHelper.dsColor(color + "-200"),
      "--bcm-chip-background-color-disabled": ColorHelper.dsColor("slate" + "-100"),
    };
  }
  handleDismiss(e) {
    e.stopPropagation();
    e.preventDefault();
    this.bcmChipDismiss.emit(this.el);
  }
  handleAddable(e) {
    e.stopPropagation();
    e.preventDefault();
    this.bcmChipAddable.emit(this.el);
  }
  listSelectedItems(e) {
    // To be added to v3
    e.stopPropagation();
    e.preventDefault();
    if (e.detail) {
      this.bcmChipSelectItem.emit(e.detail);
      e.target.setClear();
      this.data = this.data.filter(item => item.id !== e.detail.id);
    }
  }
  render() {
    const { type, size, avatar, disabled, color } = this;
    const hostClasses = classnames("bcm-chip", `bcm-chip__type-${type}`, `bcm-chip__size-${size}`, {
      "bcm-chip--disabled": disabled,
      "bcm-chip--avatar": avatar,
    });
    return (h(Host, { class: hostClasses, tabindex: "0", disabled: disabled, style: this.setColor(), onClick: e => this.bcmChipSelect.emit(e) }, h("div", { class: classnames(this.selected ? "bcm-chip--selected-icon" : "tw-hidden tw-w-0") }, h("bcm-icon", { icon: "fal fa-check" })), avatar && h("bcm-avatar", Object.assign({ size: size }, (color && { color }), (avatar && { image: avatar }))), type === "addable" && (h("span", { class: "bcm-chip__left" }, h("bcm-icon", { onClick: e => this.handleAddable(e), icon: "far fa-plus" }))), h("slot", null), type === "dismissable" && (h("span", { class: "bcm-chip__type-dismissable-icon" }, h("bcm-icon", { onClick: e => this.handleDismiss(e), icon: "fal fa-times" }))), this.data &&
      this.data.length > 0 && ( // To be added to v3
    h("bcm-list", { "onBcm-change": e => this.listSelectedItems(e), id: this._id + "-list", data: this.data, linkedComponent: this._id, searchable: true, highlight: true }))));
  }
  get el() { return this; }
  static get style() { return chipCss; }
}, [4, "bcm-chip", {
    "_id": [1537, "id"],
    "type": [1025],
    "size": [1025],
    "avatar": [1032],
    "icon": [1032],
    "disabled": [1028],
    "color": [1032],
    "selected": [1028],
    "value": [1025],
    "data": [1032]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-chip", "bcm-avatar", "bcm-badge", "bcm-icon", "bcm-label", "bcm-list", "bcm-rc-overflow", "bcm-search", "bcm-tooltip"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-chip":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmChip);
      }
      break;
    case "bcm-avatar":
      if (!customElements.get(tagName)) {
        defineCustomElement$8();
      }
      break;
    case "bcm-badge":
      if (!customElements.get(tagName)) {
        defineCustomElement$7();
      }
      break;
    case "bcm-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$6();
      }
      break;
    case "bcm-label":
      if (!customElements.get(tagName)) {
        defineCustomElement$5();
      }
      break;
    case "bcm-list":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "bcm-rc-overflow":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "bcm-search":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
    case "bcm-tooltip":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { BcmChip as B, defineCustomElement as d };
