/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h } from '@stencil/core/internal/client';
import { d as defaultIcons } from './types.js';
import { a as Bcm } from './bcm.js';
import { c as classnames } from './index2.js';
import { s as snq } from './generate.js';

const InputTemplate = ({ elementType, 
//textarea
rows, 
//props
id, internalId, type, placeholder, value, size, pattern, 
//,
unit, unitPrefix, maxLength, 
//boolean
disabled, clearable, focused, readonly, isPasswordVisible, passwordToggle, noDefaultIcon, inValid, captionType, resize, autocomplete, _suffix, _prefix, 
// custom functions
changePasswordVisibility, handleClear, steps, 
//event functions
ref, handleBlur, handleFocus, handleInput, handleChange, isEyeDropperSupported, eyeDropper, }) => {
  const ElementTagType = Bcm.HtmlElementType[elementType] || Bcm.HtmlElementType.input;
  type = type === "password" && isPasswordVisible ? "text" : type;
  value = snq(() => value, "");
  type = (unit === null || unit === void 0 ? void 0 : unit.length) > 0 && !focused ? "text" : type;
  value = !focused ? value + (value && (unit === null || unit === void 0 ? void 0 : unit.length) > 0 ? " " + unit : "") : value;
  const typeColor = type === "color";
  type = type === "color" ? "text" : type;
  const templateHandleFocus = e => {
    e.target.parentElement.classList.add("focused");
    handleFocus(e);
  };
  const templateHandleBlur = e => {
    e.target.parentElement.classList.remove("focused");
    handleBlur(e);
  };
  var containerClass = classnames("bcm-input__container", ElementTagType === Bcm.HtmlElementType.textarea && classnames("bcm-input__textarea", "textarea-size-" + Bcm.Size[size], "resize-" + resize, "textarea-" + size), ElementTagType === Bcm.HtmlElementType.input && classnames("input-size-" + Bcm.Size[size]), {
    focused: focused,
    clearable: clearable,
    disabled,
    readonly,
    invalid: inValid,
    unit: (unit === null || unit === void 0 ? void 0 : unit.length) > 0,
    // 'empty': value?.length < 1,
    error: captionType === "error",
  });
  const caretContainer = classnames("caret-container", {
    unit: (unit === null || unit === void 0 ? void 0 : unit.length) > 0,
    disabled: disabled || readonly || inValid,
  });
  const inputClass = "bcm-input__container--" + size;
  const unitClass = classnames(inputClass, "unit-prefix");
  return (h("div", { class: containerClass, id: id + "-container" },
    h("span", { hidden: true },
      h("slot", null)),
    h("span", { class: "input-prefix" },
      h("slot", { name: "prefix" }),
      _prefix && _prefix.length > 0 && h("span", { innerHTML: _prefix }),
      unitPrefix && h("span", { class: unitClass }, unitPrefix),
      typeColor && (h("i", { class: "tw-flex tw-h-4 tw-w-4 tw-items-center tw-justify-center tw-rounded-full tw-border tw-border-slate-300", style: {
          backgroundColor: value,
        } }))),
    h(ElementTagType, Object.assign({ tabindex: "0", id: id + "-input", "bcm-internal-id": internalId, class: "bcm-input-element " + inputClass }, (ElementTagType === Bcm.HtmlElementType.input && {
      type,
      autocomplete: autocomplete ? "on" : "off",
      pattern,
    }), (ElementTagType === Bcm.HtmlElementType.textarea && { rows: rows, resize: resize }), { value: value, maxLength: maxLength, "aria-label": placeholder || "Enter text", "aria-labelledby": id + "-label", title: "", placeholder: placeholder, disabled: disabled, readOnly: readonly, ref: el => ref(el), onBlur: e => templateHandleBlur(e), onFocus: e => templateHandleFocus(e), onInput: e => handleInput(e), onChange: e => handleChange(e) })),
    h("span", { class: "input-suffix-content" }, clearable && !disabled && !readonly && (h("span", { class: "input-suffix input-suffix-button input-clear-button", onClick: e => handleClear(e) },
      h("bcm-icon", { icon: "far fa-times" })))),
    h("span", { class: "input-suffix-content" }, (type === "password" || type === "text") && passwordToggle && (h("span", { class: "input-suffix input-suffix-button", onClick: () => changePasswordVisibility() },
      h("bcm-icon", { icon: isPasswordVisible ? "far fa-eye-slash" : "far fa-eye" })))),
    h("span", { class: "input-suffix-content" }, Object.keys(defaultIcons).includes(type) && !noDefaultIcon && (h("span", { class: "input-suffix" },
      h("bcm-icon", { icon: defaultIcons[type] })))),
    h("span", { class: "input-suffix-content" }, type === "number" && (h("div", { class: caretContainer },
      h("span", { class: "bcm-input-caret", onClick: () => steps("up") },
        h("bcm-icon", { icon: "fas fa-caret-up" })),
      h("span", { class: "bcm-input-caret", onClick: () => steps("down") },
        h("bcm-icon", { icon: "fas fa-caret-down" }))))),
    h("span", { class: "input-suffix-content" },
      type !== "number" && (h("span", { class: "input-suffix" },
        h("slot", { name: "suffix" }),
        _suffix && _suffix.length > 0 && h("span", { innerHTML: _suffix }))),
      typeColor && isEyeDropperSupported() && (h("span", { class: "input-suffix" },
        h("span", null,
          h("i", { class: "far fa-eye-dropper", onClick: () => eyeDropper() })))))));
};

export { InputTemplate as I };
