/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h, proxyCustomElement, HTMLElement, Host } from '@stencil/core/internal/client';
import { I as IsLoad } from './is-load-decorator.js';
import { G as Generate } from './generate.js';
import { a as Bcm } from './bcm.js';
import { c as classnames } from './index2.js';
import { d as defineCustomElement$2 } from './icon.js';
import { d as defineCustomElement$1 } from './tooltip.js';

const LabelTemplate = ({ required, value, size, form, htmlFor, type, tooltip }) => {
  size = size || "medium";
  type = type || Bcm.Status.default;
  return (h("label", { form: form, htmlFor: htmlFor, "aria-hidden": "true", class: classnames("bcm-ui-element bcm-ui-feedback bcm-label bcm-label__text tw-mb-1 tw-font-medium tw-text-slate-600 ", {
      "tw-text-1": size == "small",
      "tw-text-2": size == "medium",
      "tw-text-3": size == "large",
    }) },
    value,
    " ",
    required && "*",
    tooltip && (h("span", { class: "tw-ml-1" },
      h("bcm-tooltip", { message: tooltip, placement: "top", trigger: "hover" },
        h("bcm-icon", { icon: "fas fa-info-circle" }))))));
};

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
    r = Reflect.decorate(decorators, target, key, desc);
  else
    for (var i = decorators.length - 1; i >= 0; i--)
      if (d = decorators[i])
        r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const BcmLabel = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this._id = Generate.UID();
    this.required = false;
    this.value = undefined;
    this.label = undefined;
    this.size = "medium";
    this.form = undefined;
    this.htmlFor = undefined;
    this.hidden = false;
    this.type = Bcm.Status.default;
    this.tooltip = undefined;
  }
  render() {
    const { required, value, label, size, form, htmlFor, type, tooltip } = this;
    return (h(Host, { class: "tw-inline-block tw-leading-none" }, h(LabelTemplate, { form: form, htmlFor: htmlFor, value: value || label, size: size, type: type, required: required, tooltip: tooltip })));
  }
  get el() { return this; }
}, [0, "bcm-label", {
    "_id": [513, "id"],
    "required": [4],
    "value": [1],
    "label": [1],
    "size": [1],
    "form": [8],
    "htmlFor": [8, "html-for"],
    "hidden": [4],
    "type": [8],
    "tooltip": [1]
  }]);
__decorate([
  IsLoad()
], BcmLabel.prototype, "el", void 0);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-label", "bcm-icon", "bcm-tooltip"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-label":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmLabel);
      }
      break;
    case "bcm-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
    case "bcm-tooltip":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { BcmLabel as B, LabelTemplate as L, defineCustomElement as d };
