/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import './element-dragger.js';
import { g as getPlacement, s as setPosition } from './popover-placement.js';
import { F as FloatingUI } from './floating-ui.js';
import { c as classnames } from './index2.js';
import { G as Generate } from './generate.js';
import { N as NumberHelper } from './number-helper.js';
import { S as StringHelper } from './string-helper.js';

const oldPopoverBoxCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");@import url(\"https://fonts.googleapis.com/css2?family=Inter:wght@200;400;500;600&display=swap\"); .size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}*{box-sizing:border-box}.bcm-popover-box{display:none;position:absolute;transition:transform 0.2s ease-in-out;}.bcm-popover-box .bcm-pop-box{font-family:\"Inter\", sans-serif;font-size:14px;line-height:calc(14px + 8px);font-weight:400;font-size:10px;line-height:calc(10px + 8px);box-shadow:0 4px 12px 2px rgba(17, 24, 38, 0.1);border-radius:4px;position:absolute;box-sizing:border-box;background-color:#FFFFFF;border:1px solid #FFFFFF;z-index:-99999;overflow:hidden;visibility:hidden;width:fit-content;position:absolute;display:block;overflow:hidden;visibility:hidden;z-index:-99999;filter:drop-shadow(0px 1px 6px rgba(0, 0, 0, 0.25))}.bcm-popover-box .bcm-pop-box.bcm-pop-open{overflow:unset;visibility:visible;height:unset}.bcm-popover-box .bcm-pop-box .bcm-pop-heading,.bcm-popover-box .bcm-pop-box .bcm-pop-content{display:block}.bcm-popover-box .bcm-pop-box .bcm-pop-heading:not(:empty){padding:4px 16px;border-bottom:1px solid #D9D9D9;color:var(--bcm-color-grey-9)}.bcm-popover-box .bcm-pop-box .bcm-pop-content:not(:empty){padding:8px 16px;color:var(--bcm-color-grey-8)}.bcm-popover-box::after{content:\"\";position:absolute;display:none;border:6px solid;z-index:10900;pointer-events:none}.bcm-popover-box.bcm-pop-open{display:block;z-index:10900}.bcm-popover-box.bcm-pop-open .bcm-pop-box{z-index:10900;overflow:unset;visibility:unset}.bcm-popover-box.bcm-pop-open::after{display:block}.bcm-popover-box.top .bcm-pop-box{bottom:100%;margin-bottom:16px}.bcm-popover-box.top::after{bottom:100%;margin-bottom:4px;border-color:#FFFFFF transparent transparent transparent}.bcm-popover-box.bottom .bcm-pop-box{top:100%;margin-top:16px}.bcm-popover-box.bottom::after{top:100%;margin-top:4px;border-color:transparent transparent #FFFFFF transparent}.bcm-popover-box.left .bcm-pop-box{right:100%;margin-right:16px}.bcm-popover-box.left::after{right:100%;margin-right:4px;border-color:transparent transparent transparent #FFFFFF}.bcm-popover-box.right .bcm-pop-box{left:100%;margin-left:16px}.bcm-popover-box.right::after{left:100%;margin-left:4px;border-color:transparent #FFFFFF transparent transparent}.bcm-popover-box.top.center .bcm-pop-box,.bcm-popover-box.bottom.center .bcm-pop-box{left:50%;transform:translateX(-50%)}.bcm-popover-box.top.center::after,.bcm-popover-box.bottom.center::after{left:50%;transform:translateX(-50%)}.bcm-popover-box.top.start .bcm-pop-box,.bcm-popover-box.bottom.start .bcm-pop-box{left:0}.bcm-popover-box.top.start::after,.bcm-popover-box.bottom.start::after{left:16px}.bcm-popover-box.top.end .bcm-pop-box,.bcm-popover-box.bottom.end .bcm-pop-box{right:0}.bcm-popover-box.top.end::after,.bcm-popover-box.bottom.end::after{right:16px}.bcm-popover-box.left.center .bcm-pop-box,.bcm-popover-box.right.center .bcm-pop-box{top:50%;transform:translateY(-50%)}.bcm-popover-box.left.center::after,.bcm-popover-box.right.center::after{top:50%;transform:translateY(-50%)}.bcm-popover-box.left.start .bcm-pop-box,.bcm-popover-box.right.start .bcm-pop-box{top:0}.bcm-popover-box.left.start::after,.bcm-popover-box.right.start::after{top:12px}.bcm-popover-box.left.end .bcm-pop-box,.bcm-popover-box.right.end .bcm-pop-box{bottom:0}.bcm-popover-box.left.end::after,.bcm-popover-box.right.end::after{bottom:12px}.bcm-popover-box.top{transform:translateY(1px)}.bcm-popover-box.bottom{transform:translateY(-1px)}.bcm-popover-box.left{transform:translateX(1px)}.bcm-popover-box.right{transform:translateX(-1px)}.bcm-popover-box.top.bcm-pop-open,.bcm-popover-box.bottom.bcm-pop-open{transform:translateY(0)}.bcm-popover-box.left.bcm-pop-open,.bcm-popover-box.right.bcm-pop-open{transform:translateX(0)}.bcm-popover-box.bcm-pop-linked.top .bcm-pop-box{margin:0 0 2px 0}.bcm-popover-box.bcm-pop-linked.bottom .bcm-pop-box{margin:2px 0 0 0}.bcm-popover-box.bcm-pop-linked.left .bcm-pop-box{margin:0 2px 0 0}.bcm-popover-box.bcm-pop-linked.right .bcm-pop-box{margin:0 0 0 2px}.bcm-popover-box.bcm-pop-linked .bcm-pop-box{filter:unset;border-radius:8px;box-shadow:0 2px 6px 1px rgba(17, 24, 38, 0.1)}.bcm-popover-box.bcm-pop-linked::after{display:none}";

const OldBcmPopoverBox = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this._id = Generate.UID();
    this._target_id = undefined;
    this.message = undefined;
    this._title = undefined;
    this.placement = 'bottom';
    this.open = false;
    this.hidden = false;
    this.htmlContent = undefined;
    this.linkedComponent = undefined;
    this.height = '256px';
    this.maxHeight = '500px';
    this.minHeight = '150px';
    this.placement_string = undefined;
  }
  async show() {
    this.open = true;
    this.calculateLocation();
  }
  async hide() {
    this.open = false;
  }
  // @Listen('click', { target: 'window' })
  // handleOnClick(event) {
  //   if (!this.linkedComponent) return;
  //   const linkedId = document.getElementById(this.linkedComponent);
  //   const isClickTarget = linkedId && Generate.findEventPath(event, linkedId);
  //   if (isClickTarget) {
  //     this.open = !this.open;
  //   } else {
  //     !Generate.findEventPath(event, this.el) && this.hide();
  //   }
  // }
  getParentPopoverBox(parent) {
    if (parent) {
      const parentPopoverBox = parent.closest('old-bcm-popover-box');
      if (parentPopoverBox) {
        return parentPopoverBox;
      }
    }
    return null;
  }
  componentDidRender() {
    this.calculateLocation();
  }
  handleWheel() {
    this.calculateLocation();
  }
  handleScroll() {
    this.calculateLocation();
  }
  calculateLocation() {
    if (this.open) {
      var placement = this.placement;
      const box = this.el.querySelector('.bcm-pop-box');
      const linked = document.getElementById(this.linkedComponent);
      const targetElement = linked ? linked : document.getElementById(this._target_id);
      if (box && targetElement) {
        FloatingUI({
          ref: targetElement,
          floating: box,
          placement: this.placement,
          offset: 2,
          arrow: false,
          arrowColor: ``,
        });
        getPlacement(box, targetElement, placement, (place) => (placement = place));
        let rect = targetElement.getBoundingClientRect();
        let rectTop = rect.top;
        let pos = setPosition(placement, targetElement, { rectTop });
        if (this.height.indexOf('%') > -1) {
          box.style.height = NumberHelper.toNumber(this.height) * 0.01 * window.innerHeight - pos[0] - 50 + 'px';
        }
        else {
          box.style.height = this.height;
        }
        box.style.minHeight = this.minHeight;
        // const calculatedMaxHeight = window.innerHeight - pos[0] - 50;
        const calculatedMaxHeight = placement.split('-')[0] == 'top' ? window.innerHeight - (window.innerHeight - rectTop) - 50 : window.innerHeight - rectTop - 50;
        if (this.maxHeight.indexOf('%') > -1) {
          box.style.maxHeight = NumberHelper.toNumber(this.maxHeight) * 0.01 * calculatedMaxHeight + 'px';
        }
        else {
          box.style.maxHeight = this.maxHeight != 'auto' && NumberHelper.toNumber(this.maxHeight) < calculatedMaxHeight ? this.maxHeight : calculatedMaxHeight + 'px';
        }
        box.style.overflowY = 'auto';
        // getPlacement(box, targetElement, placement, (place: PlacementTypes) => placement = place)
        // rect = targetElement.getBoundingClientRect()
        // rectTop = rect.top;
        // pos = setPosition(placement, targetElement, { rectTop })
        // this.setPlacementString(placement)
        // this.el.style.top = pos[0] + "px"
        // this.el.style.left = pos[1] + "px"
        // this.el.style.zIndex = "10700";
        box.style.minWidth = targetElement.offsetWidth + 'px';
        const parentPopoverBox = this.getParentPopoverBox(targetElement);
        if (parentPopoverBox) {
          const zindex = parentPopoverBox.style.zIndex ? NumberHelper.toNumber(parentPopoverBox.style.zIndex) : 10900;
          this.el.style.zIndex = (+zindex + 1).toString();
        }
        if (this.message || this._title) {
          box.style.minHeight = '0px';
          box.style.height = 'auto';
          box.style.minWidth = '230px';
        }
      }
    }
  }
  setPlacementString(placement) {
    const placements = StringHelper.textContains(placement, '-') ? placement.split('-') : placement.split(' ');
    if (placements.length === 1) {
      placements.push('center');
    }
    this.placement_string = placements.join(' ');
  }
  render() {
    const { message, _title, open, placement_string } = this;
    const classes = classnames('bcm-popover-box', placement_string, {
      'bcm-pop-open': open,
      'bcm-pop-linked': this.linkedComponent,
    });
    const boxClasses = classnames('bcm-pop-box');
    return (h(Host, { class: classes }, h("div", { class: boxClasses }, _title && h("span", { class: "bcm-pop-heading size-2 weight-medium", innerHTML: _title }), h("span", { class: "bcm-pop-content size-2", innerHTML: message }), h("slot", null))));
  }
  get el() { return this; }
  static get style() { return oldPopoverBoxCss; }
}, [4, "old-bcm-popover-box", {
    "_id": [1537, "id"],
    "_target_id": [1025, "target-id"],
    "message": [1025],
    "_title": [1025],
    "placement": [1025],
    "open": [1028],
    "hidden": [1028],
    "htmlContent": [1032, "html-content"],
    "linkedComponent": [1025, "linked-component"],
    "height": [1025],
    "maxHeight": [1025, "max-height"],
    "minHeight": [1025, "min-height"],
    "placement_string": [32],
    "show": [64],
    "hide": [64]
  }, [[4, "wheel", "handleWheel"], [8, "scroll", "handleScroll"], [9, "resize", "calculateLocation"]]]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["old-bcm-popover-box"];
  components.forEach(tagName => { switch (tagName) {
    case "old-bcm-popover-box":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, OldBcmPopoverBox);
      }
      break;
  } });
}

export { OldBcmPopoverBox as O, defineCustomElement as d };
