/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { c as classnames } from './index2.js';
import { d as defineCustomElement$4 } from './icon.js';
import { d as defineCustomElement$3 } from './label.js';
import { d as defineCustomElement$2 } from './old-input.js';
import { d as defineCustomElement$1 } from './tooltip.js';

const oldSearchCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}:host{display:block}:host(.hidden){display:none}";

const lowercase = (str) => str.toLowerCase();
const BcmOldSearch = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.bcmOnSearch = createEvent(this, "bcm-on-search", 7);
    this.bcmOnSearchValue = createEvent(this, "bcm-on-search-value", 7);
    this.data = [];
    this.searchFields = ['text', 'value' /*, ...*/];
    this.returnField = 'idx';
    this.searchSub = null;
    this.hidden = false;
    this.onlyChild = false;
    this.clearable = false;
    this.searchValue = '';
    this.searchPlaceholder = 'Search';
    this.disabled = false;
    this._internal_id = (Math.random() * 4).toString(16).replace('.', '');
    this.results = [];
  }
  getInput() {
    return this.el.shadowRoot.querySelector('bcm-old-input');
  }
  componentDidLoad() {
    this.getInput().clearable = this.clearable;
  }
  listenBcmChange(e) {
    e.stopPropagation();
  }
  async setValue(value) {
    await this.getInput().setValue(value);
    return value;
  }
  async select() {
    await this.getInput().select();
    this.bcmOnSearch.emit(true);
    return true;
  }
  async setClear() {
    await this.getInput().setClear();
    this.bcmOnSearch.emit(true);
    return true;
  }
  async searchArray(value, idFields = null) {
    // console.log(this.data)
    let cacheSearchFields = this.searchFields;
    let arrayResult = [];
    if (idFields) {
      this.searchFields = [idFields];
    }
    value.forEach(item => {
      // item = {[idFields]:item}
      this.results = [];
      // console.log(this.data)
      this.nestedSearch(this.data, item, true);
      arrayResult.push(...this.results);
    });
    this.searchFields = cacheSearchFields;
    return arrayResult;
    // await this.getInput().setValue( value )
    // return value
  }
  nestedSearch(items, value, equal = false) {
    var result;
    items && (items.map((item) => {
      this.searchFields.map(searchField => {
        if (searchField in item) {
          // debugger;
          item[searchField] = lowercase(String(item[searchField]));
          if (this.onlyChild) {
            if (item[this.searchSub]) {
              var temp = this.nestedSearch(item[this.searchSub], value, equal);
              if (temp) {
                this.results.push((result = String(item[this.returnField])));
                this.results.push(temp);
              }
            }
            else {
              if (equal) {
                // console.log(value)
                if (item[searchField] == lowercase(String(value))) {
                  // if (item == lowercase(value)) {
                  this.results.push((result = String(item[this.returnField])));
                  // this.results.push (result = String(item))
                }
              }
              else {
                if (item[searchField].indexOf(lowercase(value)) !== -1) {
                  this.results.push((result = String(item[this.returnField])));
                }
              }
            }
          }
          else {
            if (item[this.searchSub]) {
              var temp = this.nestedSearch(item[this.searchSub], value, equal);
              if (temp) {
                this.results.push((result = String(item[this.returnField])));
                this.results.push(temp);
              }
            }
            if (equal) {
              // console.log(value)
              if (item[searchField] == lowercase(String(value))) {
                // if (item == lowercase(value)) {
                this.results.push((result = String(item[this.returnField])));
                // this.results.push (result = String(item))
              }
            }
            else {
              if (item[searchField].indexOf(lowercase(value)) !== -1) {
                this.results.push((result = String(item[this.returnField])));
              }
            }
          }
        }
      });
    }));
    return result;
  }
  /**
   * @desc
   * @param value
   */
  inputChange(value) {
    this.results = [];
    // data prop'unda arama yapılacak (searchFields prop'u içerisindeki alanlar ile)
    // arama sonucunda eşleyen itemların 'idx', index
    // değerleri, array şeklinde root component'e
    // event ile gönderilecek
    // Örneğin value == 'to' olduğunda aşağıdaki
    // sonuçlar filtrelenmeli
    // -->
    //{ text: 'Mateusz Eaton', idx: 2 },
    //{ text: 'Tony Vickers', idx: 3 },
    // result array'i eşleşen itemların
    // index numaralarını tutacak
    // results = [2, 3]
    // Örnek arama
    // #
    this.nestedSearch(this.data, value);
    this.results = Array.from(new Set(this.results));
    (value && ((this.results.length > 0 && this.bcmOnSearch.emit(this.results)) || this.bcmOnSearch.emit([-1]))) || this.bcmOnSearch.emit(true);
    this.bcmOnSearchValue.emit(value);
  }
  render() {
    const hostClasses = classnames(this.hidden ? 'hidden' : null);
    return (h(Host, { class: hostClasses }, h("bcm-old-input", { placeholder: this.searchPlaceholder, "no-caption": true, "no-margin": true, "full-width": true, disabled: this.disabled, type: "search", "on-bcm-change": e => this.inputChange(e.detail), value: this.searchValue })));
  }
  get el() { return this; }
  static get watchers() { return {
    "searchValue": ["inputChange"]
  }; }
  static get style() { return oldSearchCss; }
}, [1, "bcm-old-search", {
    "data": [1040],
    "searchFields": [1040],
    "returnField": [1025, "return-field"],
    "searchSub": [1025, "searchsub"],
    "hidden": [1028],
    "onlyChild": [1028, "only-child"],
    "clearable": [1028],
    "searchValue": [1025, "search-value"],
    "searchPlaceholder": [1025, "searchplaceholder"],
    "disabled": [1028],
    "_internal_id": [1537],
    "results": [32],
    "setValue": [64],
    "select": [64],
    "setClear": [64],
    "searchArray": [64]
  }, [[0, "bcm-change", "listenBcmChange"]]]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-old-search", "bcm-icon", "bcm-label", "bcm-old-input", "bcm-tooltip"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-old-search":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmOldSearch);
      }
      break;
    case "bcm-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "bcm-label":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "bcm-old-input":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
    case "bcm-tooltip":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { BcmOldSearch as B, defineCustomElement as d };
