/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';
import { c as classnames } from './index2.js';
import { C as ColorPalette } from './colors.js';
import { e as extractColor } from './utils.js';
import { d as defineCustomElement$1 } from './icon.js';

/**
 * 'color' prop predefined values
 */
var ColorProps;
(function (ColorProps) {
  ColorProps["black"] = "black";
  ColorProps["white"] = "white";
  ColorProps["prime-blue"] = "prime-blue";
  ColorProps["grey"] = "grey";
  ColorProps["blue"] = "blue";
  ColorProps["warmyellow"] = "warmyellow";
  ColorProps["yellow"] = "yellow";
  ColorProps["limegreen"] = "limegreen";
  ColorProps["red"] = "red";
  ColorProps["darkorange"] = "darkorange";
  ColorProps["orange"] = "orange";
  ColorProps["green"] = "green";
  ColorProps["turquosie"] = "turquosie";
  ColorProps["cobaltblue"] = "cobaltblue";
  ColorProps["magenta"] = "magenta";
  ColorProps["purple"] = "purple";
  ColorProps["bc-red"] = "bc-red";
  ColorProps["bc-blue"] = "bc-blue";
  ColorProps["bc-green"] = "bc-green";
  ColorProps["bc-orange"] = "bc-orange";
})(ColorProps || (ColorProps = {}));

const oldTagCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}:host{display:inline-block;width:fit-content}:host(.hidden){display:none}:host(.maxwidth){max-width:100px}.tag{display:flex;align-items:center;justify-content:center;padding:0 8px;cursor:default;border-radius:48px;border:1px solid var(--bcm-color-grey-5);user-select:none;min-width:10px;min-height:20px}.tag.size-1{padding:calc(8px - 8px) 8px}.tag.size-2{padding:calc(9px - 8px) 9px}.tag.size-3{padding:calc(10px - 8px) 10px}.tag.size-4{padding:calc(11px - 8px) 11px}.tag.size-5{padding:calc(12px - 8px) 12px}.tag.size-6{padding:calc(13px - 8px) 13px}.tag.size-7{padding:calc(14px - 8px) 14px}.tag.size-8{padding:calc(15px - 8px) 15px}.tag.size-9{padding:calc(16px - 8px) 16px}.tag.basic,.tag.closeable,.tag.add,.tag.dissmisable{background-color:var(--bcm-color-grey-3);color:var(--bcm-color-grey-8)}.tag.basic:hover,.tag.closeable:hover,.tag.add:hover,.tag.dissmisable:hover{opacity:0.85}.tag.dissmisable{color:var(--bcm-color-grey-10)}.tag.dissmisable .close-button{width:14px;cursor:pointer}.tag.dissmisable .close-button bcm-icon{color:var(--bcm-color-grey-7)}.tag.dissmisable .close-button:hover bcm-icon{color:var(--bcm-color-grey-10)}.tag.add{border-style:dashed;background-color:var(--bcm-color-grey-1)}.tag.checkable{background-color:var(--bcm-color-grey-1);color:var(--bcm-color-grey-8);border-color:var(--bcm-color-grey-1)}.tag.checkable:hover{color:var(--bcm-color-prime-blue-5);cursor:pointer}.tag span{display:inline-flex}.tag span.left{margin-right:4px}.tag span.right{margin-left:4px}.tag:before,.tag:after{content:\"\"}button{border:none;outline:0;cursor:pointer !important;margin:0}input[type=checkbox]{margin:0;width:0;height:0;visibility:hidden;position:absolute}input[type=checkbox]:checked+label{background-color:var(--bcm-color-prime-blue-6);color:var(--bcm-color-grey-1);border-color:var(--bcm-color-prime-blue-6)}input[type=checkbox]:checked+label:hover{background-color:var(--bcm-color-prime-blue-5);border-color:var(--bcm-color-prime-blue-5)}input[type=checkbox]:checked+label.checkable:hover{color:var(--bcm-color-grey-1)}input[type=checkbox]:checked+label:active{background-color:var(--bcm-color-prime-blue-7);border-color:var(--bcm-color-prime-blue-7)}";

const BcmOldTag = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.checkedChange = createEvent(this, "bcm-old-tag-checked-change", 7);
    this.tagDissmisable = createEvent(this, "bcm-old-tag-dissmisable", 7);
    this.type = 'basic';
    this.size = 'size-1';
    this.checked = false;
    this.color = undefined;
    this.value = '';
    this.hidden = false;
    this._id = (Math.random() * 4).toString(16).replace('.', '');
    this.maxWidth = false;
    this.customStyle = undefined;
    this._internal_id = (Math.random() * 4).toString(16).replace('.', '');
  }
  handleClick() {
    if (this.type === 'checkable') {
      this.checked = !this.checked;
    }
  }
  onCheckedChange(newValue, oldValue) {
    this.checkedChange.emit({ newValue, oldValue });
  }
  getColor(color) {
    if ((this.type == 'basic' || this.type == 'dissmisable') && ColorProps[color])
      return {
        color: extractColor(ColorPalette, ColorProps[color] + '-6'),
        borderColor: extractColor(ColorPalette, ColorProps[color] + '-3'),
        backgroundColor: extractColor(ColorPalette, ColorProps[color] + '-1')
      };
  }
  getSize(size, returnNumber = false) {
    if (Number(size) == size) {
      size = "size-" + size;
    }
    if (returnNumber) {
      size = size.split("-");
      size = size[size.length - 1];
      var sizeList = { "1": "12", "2": "14", "3": "16", "4": "20", "5": "24", "6": "30", "7": "38", "8": "46", "9": "56" };
      size = sizeList[size];
    }
    return size;
  }
  handleClose() {
    this.tagDissmisable.emit(this.el);
    // this.el.remove()
  }
  render() {
    const { type, color, value, customStyle, size } = this;
    const classes = classnames('tag', this.getSize(size), type);
    const hostClasses = classnames(this.hidden ? 'hidden' : null, this.maxWidth ? 'maxwidth' : null);
    if (type === 'add') {
      return (h(Host, { class: hostClasses }, h("button", { class: classes }, h("span", { class: "left" }, h("bcm-icon", { icon: "far fa-plus" })), value)));
    }
    else if (type === 'dissmisable') {
      return (h(Host, { class: hostClasses }, h("span", { class: classes, style: this.getColor(color) }, h("span", { class: "value", style: customStyle }, value), h("span", { class: "right close-button", onClick: () => this.handleClose(), style: { 'width': (Number(this.getSize(size, true)) + 2) + "px" } }, h("svg", { id: "close", style: { "fill": "#595959", "width": "14px", "height": "14px" }, xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 320 512" }, h("path", { d: "M207.6 256l107.72-107.72c6.23-6.23 6.23-16.34 0-22.58l-25.03-25.03c-6.23-6.23-16.34-6.23-22.58 0L160 208.4 52.28 100.68c-6.23-6.23-16.34-6.23-22.58 0L4.68 125.7c-6.23 6.23-6.23 16.34 0 22.58L112.4 256 4.68 363.72c-6.23 6.23-6.23 16.34 0 22.58l25.03 25.03c6.23 6.23 16.34 6.23 22.58 0L160 303.6l107.72 107.72c6.23 6.23 16.34 6.23 22.58 0l25.03-25.03c6.23-6.23 6.23-16.34 0-22.58L207.6 256z" }))))));
    }
    else if (type === 'checkable') {
      return (h(Host, { class: hostClasses }, h("input", { type: "checkbox", checked: this.checked }), h("label", { class: classes }, value)));
    }
    return (h(Host, { class: hostClasses }, h("span", { class: classes, style: this.getColor(color) }, value)));
  }
  get el() { return this; }
  static get watchers() { return {
    "checked": ["onCheckedChange"]
  }; }
  static get style() { return oldTagCss; }
}, [1, "bcm-old-tag", {
    "type": [1025],
    "size": [1032],
    "checked": [1028],
    "color": [1537],
    "value": [1025],
    "hidden": [1540],
    "_id": [1537, "id"],
    "maxWidth": [1028, "max-width"],
    "customStyle": [1032, "custom-style"],
    "_internal_id": [1537]
  }, [[2, "click", "handleClick"]]]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-old-tag", "bcm-icon"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-old-tag":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmOldTag);
      }
      break;
    case "bcm-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { BcmOldTag as B, defineCustomElement as d };
