/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { c as classnames } from './index2.js';
import { c as colors } from './colors2.js';

const BcmOverlay = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.center = false;
    this.color = colors.black;
    this.opacity = "0.5";
    this.zIndex = "10400";
  }
  render() {
    return (h(Host, { class: classnames("tw-fixed tw-inset-0 tw-transition", {
        "tw-flex tw-items-center tw-justify-center": this.center,
      }), style: {
        backgroundColor: `${this.color}`,
        opacity: this.opacity,
        zIndex: this.zIndex,
      } }, h("slot", null)));
  }
}, [4, "bcm-overlay", {
    "center": [4],
    "color": [1],
    "opacity": [1],
    "zIndex": [1, "z-index"]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-overlay"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-overlay":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmOverlay);
      }
      break;
  } });
}

export { BcmOverlay as B, defineCustomElement as d };
