/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { c as classnames } from './index2.js';

const BcmScrollArea = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.width = "inherit";
    this.height = "inherit";
    this.isDisabled = false;
  }
  render() {
    return (h(Host, { class: classnames("tw-block", {
        "tw-overflow-y-scroll tw-overscroll-contain": !this.isDisabled,
      }), style: { width: this.width, height: this.height } }, h("slot", null)));
  }
}, [4, "bcm-scroll-area", {
    "width": [1],
    "height": [1],
    "isDisabled": [4, "is-disabled"]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-scroll-area"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-scroll-area":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmScrollArea);
      }
      break;
  } });
}

export { BcmScrollArea as B, defineCustomElement as d };
