/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { c as classnames } from './index2.js';
import { d as defineCustomElement$i } from './avatar.js';
import { d as defineCustomElement$h } from './badge.js';
import { d as defineCustomElement$g } from './checkbox.js';
import { d as defineCustomElement$f } from './checkbox-lite.js';
import { d as defineCustomElement$e } from './divider.js';
import { d as defineCustomElement$d } from './empty.js';
import { d as defineCustomElement$c } from './icon.js';
import { d as defineCustomElement$b } from './label.js';
import { d as defineCustomElement$a } from './listbox.js';
import { d as defineCustomElement$9 } from './listbox-group.js';
import { d as defineCustomElement$8 } from './listbox-item.js';
import { d as defineCustomElement$7 } from './old-input.js';
import { d as defineCustomElement$6 } from './old-search.js';
import { d as defineCustomElement$5 } from './text.js';
import { d as defineCustomElement$4 } from './tooltip.js';
import { d as defineCustomElement$3 } from './treeview.js';
import { d as defineCustomElement$2 } from './treeview-item.js';
import { d as defineCustomElement$1 } from './typography.js';

const selectBoxCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}.select-box{flex:1}:host{z-index:-999;position:absolute;opacity:0;top:-10000;left:-10000;visibility:hidden !important;box-shadow:0px 2px 8px rgba(0, 0, 0, 0.15)}:host(.show){opacity:1;z-index:100000;visibility:visible !important}";

const BcmSelectBox = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this._internal_id = (Math.random() * 4).toString(16).replace('.', '');
    this.hidden = false;
    this.isShow = false;
  }
  disconnectedCallback() { }
  componentWillLoad() { }
  componentDidLoad() { }
  componentWillRender() { }
  componentDidRender() { }
  componentWillUpdate() { }
  componentDidUpdate() { }
  handleChangeEvent(event) {
    event.stopPropagation();
  }
  render() {
    const classes = classnames('select-box');
    const hostClasses = classnames(this.hidden ? 'hidden' : null, {
      'show': this.isShow,
    });
    return (h(Host, { class: hostClasses }, h("div", { class: classes }, h("bcm-listbox", { id: "listbox-box" + this._internal_id, class: "listbox-box", _internal_id: this._internal_id, "inner-component": true, "no-caption": true, fullWidth: true, _flex: "true" }))));
  }
  get el() { return this; }
  static get style() { return selectBoxCss; }
}, [1, "bcm-select-box", {
    "_internal_id": [1537],
    "hidden": [1028],
    "isShow": [1028, "open"]
  }, [[0, "bcm-change", "handleChangeEvent"]]]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["bcm-select-box", "bcm-avatar", "bcm-badge", "bcm-checkbox", "bcm-checkbox-lite", "bcm-divider", "bcm-empty", "bcm-icon", "bcm-label", "bcm-listbox", "bcm-listbox-group", "bcm-listbox-item", "bcm-old-input", "bcm-old-search", "bcm-text", "bcm-tooltip", "bcm-treeview", "bcm-treeview-item", "bcm-typography"];
  components.forEach(tagName => { switch (tagName) {
    case "bcm-select-box":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, BcmSelectBox);
      }
      break;
    case "bcm-avatar":
      if (!customElements.get(tagName)) {
        defineCustomElement$i();
      }
      break;
    case "bcm-badge":
      if (!customElements.get(tagName)) {
        defineCustomElement$h();
      }
      break;
    case "bcm-checkbox":
      if (!customElements.get(tagName)) {
        defineCustomElement$g();
      }
      break;
    case "bcm-checkbox-lite":
      if (!customElements.get(tagName)) {
        defineCustomElement$f();
      }
      break;
    case "bcm-divider":
      if (!customElements.get(tagName)) {
        defineCustomElement$e();
      }
      break;
    case "bcm-empty":
      if (!customElements.get(tagName)) {
        defineCustomElement$d();
      }
      break;
    case "bcm-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$c();
      }
      break;
    case "bcm-label":
      if (!customElements.get(tagName)) {
        defineCustomElement$b();
      }
      break;
    case "bcm-listbox":
      if (!customElements.get(tagName)) {
        defineCustomElement$a();
      }
      break;
    case "bcm-listbox-group":
      if (!customElements.get(tagName)) {
        defineCustomElement$9();
      }
      break;
    case "bcm-listbox-item":
      if (!customElements.get(tagName)) {
        defineCustomElement$8();
      }
      break;
    case "bcm-old-input":
      if (!customElements.get(tagName)) {
        defineCustomElement$7();
      }
      break;
    case "bcm-old-search":
      if (!customElements.get(tagName)) {
        defineCustomElement$6();
      }
      break;
    case "bcm-text":
      if (!customElements.get(tagName)) {
        defineCustomElement$5();
      }
      break;
    case "bcm-tooltip":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "bcm-treeview":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "bcm-treeview-item":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
    case "bcm-typography":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { BcmSelectBox as B, defineCustomElement as d };
