/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, c as createEvent, h, H as Host, g as getElement } from './index-0615c2b8.js';
import './color-helper-74614f24.js';
import './datetime-helper-df25808a.js';
import { G as Generate } from './generate-d009624a.js';
import './number-helper-b7a7a318.js';
import './string-helper-3592bdc2.js';
import './validators-5519219e.js';
import './element-dragger-89bb52fd.js';
import { F as FloatingUI } from './floating-ui-3f4394da.js';
import { B as Bcm } from './bcm-a50d55ba.js';
import { c as classnames } from './index-f549811f.js';
import { c as ce } from './index-3bc8c6e3.js';
import './colors-1d7854ea.js';
import './utils-57652744.js';
import './colors-dd598eea.js';
import './_commonjsHelpers-82aa9212.js';
import './package-7549581c.js';

const attendanceActionDropdownStyle = ce({
  slots: {
    host: [
      "tw-w-fit",
      "tw-absolute tw-left-0 tw-right-0 tw-z-tooltip tw-opacity-100 tw-transition-opacity tw-duration-300",
      "tw-overscroll-contain  tw-scroll-smooth tw-rounded tw-bg-white tw-shadow tw-max-h-64 tw-overflow-y-auto",
      "bcm-ui-element bcm-attendance-actions tw-flex tw-flex-col tw-items-start tw-justify-start tw-p-2 tw-font-medium tw-text-slate-700"
    ],
    dataItem: ["tw-flex tw-w-full tw-cursor-pointer tw-flex-row tw-items-start tw-justify-start tw-gap-2 tw-rounded  hover:tw-bg-blue-100"],
    key: ["tw-font-mono tw-text-slate-600"],
    selectedItem: ["tw-bg-blue-100"],
  },
  variants: {
    size: {
      small: {
        dataItem: ["tw-text-2.5 tw-px-2.5 tw-py-2"],
      },
      medium: {
        dataItem: ["tw-text-3 tw-px-3 tw-py-2"],
      },
      large: {
        dataItem: ["tw-text-4 tw-px-4 tw-py-2"],
      },
    }
  },
  defaultVariants: {
    size: "medium"
  },
});

const BcmAttendanceActionsDropdown = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.change = createEvent(this, "bcm-attendance-actions-dropdown-change", 3);
    this._id = Generate.UID();
    this.size = Bcm.Size.medium;
    this.disabled = false;
    this.selectedKey = null;
    this.targetId = null;
    this.isShow = false;
    this.data = [];
  }
  handleSelectItem(item) {
    this.selectedKey = item.key;
    this.change.emit(item);
  }
  async show() {
    const targetElement = document.getElementById(this.targetId);
    FloatingUI({
      ref: targetElement,
      floating: this.el,
      placement: "bottom-end",
      offset: 4,
    });
    this.isShow = true;
  }
  async hide() {
    if (this.isShow) {
      this.el.remove();
    }
  }
  handleClickOutside() {
    this.hide();
  }
  render() {
    const { size } = this;
    const { host, dataItem, selectedItem, key } = attendanceActionDropdownStyle({
      size,
    });
    return (h(Host, { class: host() }, this.data.map((item) => (h("div", { class: classnames(dataItem(), this.selectedKey === item.key && selectedItem()), onClick: () => this.handleSelectItem(item) }, h("span", { class: key() }, item.key, " - "), h("span", null, item.value))))));
  }
  get el() { return getElement(this); }
};

export { BcmAttendanceActionsDropdown as bcm_attendance_actions_dropdown };
