/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, c as createEvent, h, H as Host, g as getElement } from './index-0615c2b8.js';
import './color-helper-74614f24.js';
import './datetime-helper-df25808a.js';
import { G as Generate } from './generate-d009624a.js';
import './number-helper-b7a7a318.js';
import './string-helper-3592bdc2.js';
import './validators-5519219e.js';
import './element-dragger-89bb52fd.js';
import { B as Bcm } from './bcm-a50d55ba.js';
import { c as classnames } from './index-f549811f.js';
import { c as ce } from './index-3bc8c6e3.js';
import './colors-1d7854ea.js';
import './utils-57652744.js';
import './colors-dd598eea.js';
import './_commonjsHelpers-82aa9212.js';
import './package-7549581c.js';

// --bcm-attendance-actions-button-bg: #F1F5F9; /* slate-100 */
// --bcm-attendance-actions-button-text: #334155; /* slate-700 */
// --bcm-attendance-actions-button-border: #CBD5E1; /* slate-300 */
// --bcm-attendance-actions-button-hover-bg: #E2E8F0; /* slate-200 */
// --bcm-attendance-actions-button-active-bg: #CBD5E1; /* slate-300 */
// --bcm-attendance-actions-button-disabled-bg: #CBD5E1; /* slate-300 */
// --bcm-attendance-actions-button-disabled-text: #64748B; /* slate-500 */
const attendanceActionStyle = ce({
  slots: {
    host: ["tw-flex tw-flex-row tw-items-center tw-justify-center tw-w-full tw-max-w-48 tw-gap-2", "bcm-ui-element bcm-attendance-actions"],
    base: "",
    buttonContainer: "tw-flex tw-flex-row tw-items-center tw-justify-center tw-w-full tw-max-w-[168px]",
    button: [
      "",
      "tw-button-reset",
      "tw-flex-1 last:tw-flex-none",
      "tw-bg-[--bcm-attendance-actions-button-bg]",
      "tw-text-[--bcm-attendance-actions-button-text]",
      "tw-border tw-border-solid tw-border-[--bcm-attendance-actions-button-border]",
      "hover:tw-bg-[--bcm-attendance-actions-button-hover-bg]",
      "active:tw-bg-[--bcm-attendance-actions-button-active-bg]",
      "focus-visible:tw-ring-2 focus-visible:tw-ring-offset-2 focus-visible:tw-z-10",
      "tw-flex tw-flex-row tw-items-center tw-justify-center",
      "first:tw-rounded-l last:tw-rounded-r",
      "tw-font-medium",
      "-tw-ml-[1px] first:tw-ml-0",
    ],
    dropdownButton: "",
    mainButton: "",
    commentIcon: "",
  },
  variants: {
    selected: {
      true: {
        button: [
          "tw-text-white tw-border-transparent last:tw-ml-[1px]",
          "first:tw-justify-start",
        ],
        mainButton: [
          "tw-min-w-[calc(theme(spacing.12)-1px)]"
        ],
      },
      false: {
        button: [
          ""
        ],
      },
    },
    size: {
      small: {
        button: [
          "tw-text-2",
          "tw-min-h-6",
          "tw-gap-2",
        ],
        mainButton: [
          "tw-px-3",
        ],
        dropdownButton: [
          "tw-px-2.5"
        ],
      },
      medium: {
        button: [
          "tw-text-3",
          "tw-min-h-8",
          "tw-gap-2",
        ],
        mainButton: [
          "tw-px-3",
        ],
        dropdownButton: [
          "tw-px-2.5"
        ],
      },
      large: {
        button: [
          "tw-text-4",
          "tw-min-h-10",
          "tw-gap-2.5",
        ],
        mainButton: [
          "tw-px-3",
        ],
        dropdownButton: [
          "tw-px-3"
        ],
      },
    },
    disabled: {
      true: {},
      false: {}
    }
  },
  compoundVariants: [
    {
      disabled: true,
      class: {
        buttonContainer: [
          "tw-cursor-not-allowed tw-pointer-events-none",
        ],
        button: [
          "tw-cursor-not-allowed",
          "tw-bg-[--bcm-attendance-actions-button-disabled-bg]",
          "tw-text-[--bcm-attendance-actions-button-disabled-text]",
          "tw-border-transparent",
          "hover:tw-bg-[--bcm-attendance-actions-button-disabled-bg]",
        ],
        mainButton: [
          "tw-bg-[--bcm-attendance-actions-button-disabled-bg]",
          "tw-text-[--bcm-attendance-actions-button-disabled-text]",
          "tw-border-transparent",
          "hover:tw-bg-[--bcm-attendance-actions-button-disabled-bg]",
          "tw-cursor-not-allowed",
        ],
        host: [
          "tw-cursor-not-allowed",
        ],
        commentIcon: [
          "tw-cursor-not-allowed tw-pointer-events-none",
        ],
      }
    },
    {
      disabled: false,
      class: {
        button: [
          "tw-cursor-pointer",
        ],
      }
    }
  ],
  defaultVariants: {
    selected: false,
    size: "medium",
    disabled: false,
  },
});

const attendanceActionsCss = "";

const BcmAttendanceActions = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.change = createEvent(this, "bcm-attendance-change", 3);
    this._id = Generate.UID();
    this.size = Bcm.Size.medium;
    this.disabled = false;
    this.data = [
      { key: "P", value: "Present", color: "emerald", icon: "fa-solid fa-check", priority: 0 },
      { key: "A", value: "Absent", color: "red", icon: "fa-solid fa-times", priority: 1 },
      { key: "L", value: "Late", color: "amber", icon: "fa-solid fa-clock", priority: 2 },
      { key: "C", value: "Other Authorised Circumstance", color: "blue", icon: "fa-solid fa-question" },
      { key: "E", value: "Exlude", color: "blue", icon: "fa-solid fa-minus" },
      { key: "G", value: "Family Holiday", color: "blue", icon: "fa-solid fa-minus" },
      { key: "H", value: "Family Holiday (Agreed)", color: "blue", icon: "fa-solid fa-minus" },
      { key: "I", value: "Illness", color: "blue", icon: "fa-solid fa-minus" },
      { key: "J", value: "Intervier", color: "blue", icon: "fa-solid fa-minus" },
      { key: "M", value: "Medical / Dental", color: "blue", icon: "fa-solid fa-minus" },
      { key: "N", value: "No Reason yet PRovided", color: "blue", icon: "fa-solid fa-minus" },
      { key: "O", value: "Unauthrised Absence", color: "blue", icon: "fa-solid fa-minus" },
      { key: "U", value: "Late after Reg. Closed", color: "blue", icon: "fa-solid fa-minus" },
      { key: "X", value: "Non-comp School Age Absence", color: "blue", icon: "fa-solid fa-minus" },
    ];
    this.lateKeys = "L";
    this.hideComment = false;
  }
  get selectedItem() {
    return this.data.find(item => item.selected);
  }
  get priorityButtons() {
    return this.data.filter(item => item.priority !== undefined).sort((a, b) => a.priority - b.priority);
  }
  get renderButtons() {
    const { selectedItem, priorityButtons } = this;
    return [...(selectedItem ? [selectedItem] : priorityButtons.length ? priorityButtons : this.data.slice(0, 3))];
  }
  get lateKeysMap() {
    return this.lateKeys.toLocaleLowerCase().split(",");
  }
  get isLate() {
    var _a, _b;
    return this.lateKeysMap.includes((_b = (_a = this.selectedItem) === null || _a === void 0 ? void 0 : _a.key) === null || _b === void 0 ? void 0 : _b.toLocaleLowerCase());
  }
  get dropdownMenuElement() {
    return document.getElementById("attendance-dropdown-" + this._id);
  }
  get commentAreaElement() {
    return document.getElementById("comment-" + this._id);
  }
  handleSelectItem(item, triggerChange = true, showComment = true) {
    var _a, _b;
    this.data = [...this.data.map(data => { var _a, _b; return (Object.assign(Object.assign({}, data), { selected: ((_a = item.key) === null || _a === void 0 ? void 0 : _a.toLocaleLowerCase()) === ((_b = data.key) === null || _b === void 0 ? void 0 : _b.toLocaleLowerCase()) })); })];
    (_a = this.dropdownMenuElement) === null || _a === void 0 ? void 0 : _a.hide();
    (_b = this.commentAreaElement) === null || _b === void 0 ? void 0 : _b.hide();
    if (!this.isLate)
      return triggerChange && this.changed();
    !this.hideComment && showComment && this.commentArea();
  }
  changed() {
    this.change.emit(this.selectedItem);
  }
  hasDataForKey(key) {
    return !!this.data.find(item => item.key.toLocaleLowerCase() === key.toLocaleLowerCase());
  }
  handleKeyPress({ key }) {
    if (!this.hasDataForKey(key))
      return;
    const item = this.data.find(item => { var _a; return ((_a = item.key) === null || _a === void 0 ? void 0 : _a.toLocaleLowerCase()) === (key === null || key === void 0 ? void 0 : key.toLocaleLowerCase()); });
    this.handleSelectItem(item);
  }
  handleSave(lateMinutes, comment) {
    this.data = [...this.data].map(item => {
      var _a, _b, _c;
      if (((_a = item.key) === null || _a === void 0 ? void 0 : _a.toLocaleLowerCase()) === ((_c = (_b = this.selectedItem) === null || _b === void 0 ? void 0 : _b.key) === null || _c === void 0 ? void 0 : _c.toLocaleLowerCase())) {
        return Object.assign(Object.assign({}, item), { lateMin: lateMinutes, comment });
      }
      return item;
    });
    this.changed();
  }
  dropdownMenu() {
    var _a;
    const dropdownMenu = Generate.createComponent("bcm-attendance-actions-dropdown", {
      id: "attendance-dropdown-" + this._id,
      size: this.size,
      data: this.data,
      selectedKey: (_a = this.selectedItem) === null || _a === void 0 ? void 0 : _a.key,
      targetId: "attendance-dropdown-button-" + this._id,
    });
    dropdownMenu.addEventListener("bcm-attendance-actions-dropdown-change", ({ detail }) => {
      this.handleSelectItem(detail);
    });
    dropdownMenu.show();
  }
  commentArea() {
    var _a, _b;
    const commentArea = Generate.createComponent("bcm-attendance-actions-comment", {
      id: "comment-" + this._id,
      size: this.size,
      isLate: this.isLate,
      targetId: "comment-area-" + this._id,
      selectedItem: this.selectedItem,
      lateMinutes: (_a = this.selectedItem) === null || _a === void 0 ? void 0 : _a.lateMin,
      comment: (_b = this.selectedItem) === null || _b === void 0 ? void 0 : _b.comment,
    });
    commentArea.addEventListener("bcm-attendance-actions-comment-change", ({ detail }) => {
      this.handleSave(detail.lateMinutes, detail.comment);
    });
    commentArea.show();
  }
  async set(key, triggerChange = true) {
    if (!this.hasDataForKey(key))
      return;
    const item = this.data.find(item => { var _a; return ((_a = item.key) === null || _a === void 0 ? void 0 : _a.toLocaleLowerCase()) === (key === null || key === void 0 ? void 0 : key.toLocaleLowerCase()); });
    this.handleSelectItem(item, triggerChange, false);
  }
  async get() {
    return this.selectedItem;
  }
  render() {
    var _a, _b, _c;
    const { selectedItem, renderButtons, disabled, hideComment, size } = this;
    const { host, buttonContainer, button, dropdownButton, commentIcon, mainButton } = attendanceActionStyle({
      selected: !!selectedItem,
      size,
      disabled,
    });
    const buttonStyle = !!selectedItem
      ? Generate.getTwColor({
        color: (_a = selectedItem.color) !== null && _a !== void 0 ? _a : "blue",
        tones: {
          600: ["bg"],
          700: ["hover-bg"],
          800: ["active-bg"],
        },
        variable: "--bcm-attendance-actions-button",
      })
      : {};
    const buttonAttributes = {
      class: classnames(button(), mainButton()),
      style: Object.assign({}, buttonStyle),
      disabled,
      type: "button",
    };
    const iconButtonAttributes = Object.assign(Object.assign({}, buttonAttributes), { class: classnames(button(), dropdownButton()) });
    const isShowCommentIcon = !hideComment && !!selectedItem;
    const commentTooltip = (selectedItem === null || selectedItem === void 0 ? void 0 : selectedItem.comment) || (selectedItem === null || selectedItem === void 0 ? void 0 : selectedItem.lateMin) ? `${(selectedItem === null || selectedItem === void 0 ? void 0 : selectedItem.comment) || ""}${(selectedItem === null || selectedItem === void 0 ? void 0 : selectedItem.lateMin) ? ` (${selectedItem === null || selectedItem === void 0 ? void 0 : selectedItem.lateMin} min) ` : ""}` : "";
    return (h(Host, { class: host(), onKeyPress: this.handleKeyPress.bind(this) }, h("div", { class: buttonContainer() }, renderButtons === null || renderButtons === void 0 ? void 0 :
      renderButtons.map(item => {
        return (h("button", Object.assign({}, buttonAttributes, { onClick: () => this.handleSelectItem(item), title: item.value }), h("i", { class: classnames(item.icon || "fa-solid fa-minus", "!tw-leading-[inherit]") }), item.selected && h("span", { class: "tw-truncate" }, item.value)));
      }), h("button", Object.assign({ id: "attendance-dropdown-button-" + this._id }, iconButtonAttributes, { onClick: () => this.dropdownMenu(), title: "More" }), h("i", { class: classnames("fa-solid fa-angle-down !tw-leading-[inherit]") }))), h("div", { id: "comment-area-" + this._id, class: classnames(commentIcon(), {
        "tw-cursor-default": !isShowCommentIcon,
        "tw-cursor-pointer": isShowCommentIcon,
      }), onClick: () => isShowCommentIcon && this.commentArea() }, h("i", { title: isShowCommentIcon ? commentTooltip : "", class: classnames("fa-solid fa-comment", {
        "tw-text-gray-400": !(((_b = this.selectedItem) === null || _b === void 0 ? void 0 : _b.comment) || ((_c = this.selectedItem) === null || _c === void 0 ? void 0 : _c.lateMin)),
        "tw-visible": isShowCommentIcon,
        "tw-invisible": !isShowCommentIcon,
      }) }))));
  }
  get el() { return getElement(this); }
};
BcmAttendanceActions.style = attendanceActionsCss;

export { BcmAttendanceActions as bcm_attendance_actions };
