/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, c as createEvent, h, H as Host, g as getElement } from './index-0615c2b8.js';
import { c as classnames } from './index-f549811f.js';
import { G as Generate } from './generate-d009624a.js';
import './_commonjsHelpers-82aa9212.js';
import './package-7549581c.js';
import './colors-dd598eea.js';

const breadcrumbCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}.bcm-breadcrumb{display:flex;flex-direction:row;align-items:center;justify-content:flex-start;flex-wrap:wrap;color:var(--bcm-color-grey-7)}.bcm-breadcrumb__item{display:flex;align-items:center}.bcm-breadcrumb .seperator{cursor:default;display:inline-flex;align-items:center;justify-content:center;margin-left:8px;margin-right:8px;color:var(--bcm-color-grey-7)}.bcm-breadcrumb bcm-link:hover{color:var(--bcm-color-grey-7)}.bcm-breadcrumb .active{color:var(--bcm-color-grey-8)}.bcm-breadcrumb .active:hover{color:var(--bcm-color-grey-8)}.bcm-breadcrumb .is-link:hover{color:var(--bcm-color-prime-blue-6)}.bcm-breadcrumb .is-link:hover bcm-link,.bcm-breadcrumb .is-link:hover bcm-icon{color:var(--bcm-color-prime-blue-6)}.bcm-breadcrumb__dropdown-item{position:relative;display:inline-flex}.bcm-breadcrumb__dropdown-item summary{display:inline-flex;align-items:center;cursor:pointer}.bcm-breadcrumb__dropdown-item summary>span{display:inline-flex;align-items:center}.bcm-breadcrumb__dropdown-item summary::-webkit-details-marker{display:none}.bcm-breadcrumb__dropdown-item summary:focus{outline:none}.bcm-breadcrumb__dropdown-item summary.open bcm-link,.bcm-breadcrumb__dropdown-item summary.open bcm-icon{color:var(--bcm-color-prime-blue-6)}.bcm-breadcrumb__dropdown-item summary .down-icon{margin-left:4px}.bcm-breadcrumb__dropdown-submenu{position:absolute;min-width:140px;background-color:var(--bcm-color-grey-1);box-shadow:0px 4px 4px rgba(0, 0, 0, 0.25);margin-top:4px}.bcm-breadcrumb__dropdown-submenu .dropdown-item{display:flex;padding:4px 8px}.bcm-breadcrumb__dropdown-submenu .dropdown-item bcm-link{width:100%}";

const BcmBreadcrumb = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.bcmBreadcrumb = createEvent(this, "bcm-breadcrumb-click", 7);
    this.items = undefined;
    this.seperator = '/';
    this.hidden = false;
    this.isOpen = false;
  }
  handleClickOutside(e) {
    if (!this.el.contains(e.target)) {
      this.isOpen && (this.isOpen = false);
    }
  }
  handleOpen(id) {
    this.isOpen = this.isOpen == id ? false : id;
  }
  parseItem(item, index) {
    item.index = index;
    item.id = item.id || Generate.UID();
    return item;
  }
  render() {
    const { items, seperator, hidden } = this;
    const hostClasses = classnames('bcm-breadcrumb', 'size-2', { hidden });
    const LinkTemplate = (item) => (h("bcm-link", Object.assign({ id: item.id || Generate.UID(), onClick: () => this.bcmBreadcrumb.emit(item), target: item.target && item.index < items.length - 1 ? item.target : '_self' }, ((item.child == true || item.index < items.length - 1) && item.href && {
      href: item.href
    }), { icon: item.icon ? item.icon : null, class: classnames({
        'active': item.index === items.length - 1,
        'is-link': (item.child == true || item.index < items.length - 1) && item.href
      }) }), item.label ? item.label : null));
    const DropdownTemplate = (item) => (h("details", { class: classnames('bcm-breadcrumb__dropdown-item', { 'active': item.index === items.length - 1, 'open': this.isOpen === item.id }), id: item.id, open: this.isOpen === item.id }, h("summary", { onClick: () => this.handleOpen(item.id), class: this.isOpen === item.id && 'open' }, h("span", { class: "is-link" }, h(LinkTemplate, Object.assign({}, { 'icon': item.icon, 'label': item.label, 'href': 'javascript:void(0)', 'index': item.index })), h("bcm-icon", { icon: "fas fa-caret-down" }))), h("div", { class: "bcm-breadcrumb__dropdown-submenu" }, item.dropdown.map(link => (h("span", { class: "size-2 dropdown-item" }, h(LinkTemplate, Object.assign({}, link, { child: true }))))))));
    return (h(Host, { class: hostClasses }, h("span", { hidden: true }, h("slot", null)), items.map((item, index) => (h("span", { class: "bcm-breadcrumb__item" }, item.dropdown && item.dropdown.length > 0 ? DropdownTemplate(this.parseItem(item, index)) : LinkTemplate(this.parseItem(item, index)), index < items.length - 1 ? h("span", { class: "seperator" }, seperator) : null)))));
  }
  get el() { return getElement(this); }
};
BcmBreadcrumb.style = breadcrumbCss;

export { BcmBreadcrumb as bcm_breadcrumb };
