/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, h, H as Host } from './index-0615c2b8.js';
import { a as Bcm } from './bcm-a50d55ba.js';
import './string-helper-3592bdc2.js';
import { C as CaptionTemplate } from './caption-template-d7953d13.js';
import './index-f549811f.js';
import './types-6f06fa1a.js';
import './color-helper-74614f24.js';
import './datetime-helper-df25808a.js';
import './generate-d009624a.js';
import './number-helper-b7a7a318.js';
import './validators-5519219e.js';
import './element-dragger-89bb52fd.js';
import './types-9493a7ed.js';
import './_commonjsHelpers-82aa9212.js';
import './colors-1d7854ea.js';
import './utils-57652744.js';
import './colors-dd598eea.js';
import './package-7549581c.js';

const BcmCaption = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.noCaption = false;
    this.captionType = Bcm.Status.default;
    this.captionClasses = undefined;
    this.caption = undefined;
    this.captionError = undefined;
    this.customErrorMessage = undefined;
    this.size = Bcm.Size.medium;
    this.maxLength = undefined;
    this.value = undefined;
  }
  render() {
    const { noCaption, captionType, captionClasses, caption, captionError, customErrorMessage, size, maxLength, value } = this;
    return (h(Host, { class: "tw-block" }, h(CaptionTemplate, { noCaption: noCaption, captionType: captionType, captionClasses: captionClasses, caption: caption, captionError: captionError, customErrorMessage: customErrorMessage, size: size, maxLength: maxLength, value: value })));
  }
};

export { BcmCaption as bcm_caption };
