/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, h, H as Host, g as getElement } from './index-0615c2b8.js';
import { g as getChildElements } from './utils-57652744.js';

const BcmCollapseGroup = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.borderless = false;
    this.open = false;
    this.multiple = false;
    this.hidden = false;
  }
  handleOpen({ target, detail }) {
    if (!this.multiple && this.el === target.parentElement) {
      this.qs().forEach(child => {
        child.open = child.id === detail;
      });
    }
  }
  componentDidLoad() {
    this.qs().forEach((child, index) => {
      !child.borderless && (child.borderless = this.borderless);
      this.qs().length == index + 1 && (child.noBorder = true);
    });
  }
  qs() {
    return getChildElements(this.el, 'bcm-collapse');
  }
  render() {
    const { hidden } = this;
    return (h(Host, { class: { hidden } }, h("slot", null)));
  }
  get el() { return getElement(this); }
};

export { BcmCollapseGroup as bcm_collapse_group };
