/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, c as createEvent, h, H as Host, g as getElement } from './index-0615c2b8.js';
import { c as classnames } from './index-f549811f.js';
import { l as lodash } from './lodash-4197be99.js';
import { G as Generate } from './generate-d009624a.js';
import './_commonjsHelpers-82aa9212.js';
import './package-7549581c.js';
import './colors-dd598eea.js';

const collapseCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}.bcm-collapse{display:block;border:1px solid var(--bcm-color-grey-5)}.bcm-collapse ::-webkit-details-marker{display:none}.bcm-collapse__header{display:flex;align-items:center;color:var(--bcm-color-grey-9);padding:16px;background-color:var(--bcm-color-grey-2);border-bottom:1px solid var(--bcm-color-grey-5);cursor:default;user-select:none}.bcm-collapse__header:focus{outline:none}.bcm-collapse__header .collapse-icon{margin-right:8px;display:flex;align-items:center;justify-content:center}.bcm-collapse__body{padding:16px;background-color:var(--bcm-color-grey-1);color:var(--bcm-color-grey-8);margin-top:-1px}.bcm-collapse--borderless{border:none}.bcm-collapse--borderless:not(.bcm-collapse--no-border){border-bottom:1px solid var(--bcm-color-grey-5)}.bcm-collapse--borderless .bcm-collapse__header{border-bottom:none}.bcm-collapse--borderless .bcm-collapse__body{background-color:var(--bcm-color-grey-2);padding:0 40px 16px}.bcm-collapse:not(.bcm-collapse--open) .bcm-collapse__header{border-bottom:none}.bcm-collapse:not(:first-child) .collapse{border-top:none}.bcm-collapse.hidden{display:none}.bcm-collapse--no-padding .bcm-collapse__body{padding:0}";

const BcmCollapse = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.bcmCollapseOpen = createEvent(this, "bcm-collapse-open", 7);
    this._id = Generate.UID();
    this.borderless = false;
    this.open = false;
    this.noBorder = false;
    this.noPadding = false;
    this.hidden = false;
  }
  componentDidRender() {
    this.open && this.bcmCollapseOpen.emit(this._id);
  }
  componentDidLoad() {
    this.checkSlotEmpty();
  }
  checkSlotEmpty() {
    var _a;
    const textContent = (_a = this.el.querySelector('[slot="body"]')) === null || _a === void 0 ? void 0 : _a.textContent;
    if (lodash.trim(textContent) !== "") {
      this.el.removeAttribute("data-slot-empty");
    }
    else {
      this.el.setAttribute("data-slot-empty", "true");
    }
  }
  render() {
    const { hidden, borderless, open, noBorder, _id, noPadding } = this;
    const classes = classnames("bcm-collapse", {
      "bcm-collapse--borderless": borderless,
      "bcm-collapse--open": open,
      "bcm-collapse--no-border": noBorder,
      "bcm-collapse--no-padding": noPadding,
    });
    const caretDown = '<svg style="fill: #595959; width: 14px; height: 14px" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 320 512"><path d="M31.3 192h257.3c17.8 0 26.7 21.5 14.1 34.1L174.1 354.8c-7.8 7.8-20.5 7.8-28.3 0L17.2 226.1C4.6 213.5 13.5 192 31.3 192z"/></svg>';
    const caretRight = '<svg style="fill: #595959; width: 14px; height: 14px" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 192 512"><path d="M0 384.662V127.338c0-17.818 21.543-26.741 34.142-14.142l128.662 128.662c7.81 7.81 7.81 20.474 0 28.284L34.142 398.804C21.543 411.404 0 402.48 0 384.662z"/></svg>';
    return (h(Host, { class: { hidden }, id: _id }, h("details", { class: classes, open: open }, h("summary", { class: "bcm-collapse__header size-2", onClick: () => (this.open = !open) }, h("span", { class: "collapse-icon", innerHTML: open ? caretDown : caretRight }), h("slot", { name: "title" })), h("div", { class: "bcm-collapse__body" }, h("slot", { name: "body", onSlotchange: () => this.checkSlotEmpty() })))));
  }
  get el() { return getElement(this); }
};
BcmCollapse.style = collapseCss;

export { BcmCollapse as bcm_collapse };
