/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, f as forceUpdate, h, H as Host, g as getElement } from './index-0615c2b8.js';
import './color-helper-74614f24.js';
import './datetime-helper-df25808a.js';
import { G as Generate } from './generate-d009624a.js';
import './number-helper-b7a7a318.js';
import './string-helper-3592bdc2.js';
import './validators-5519219e.js';
import './element-dragger-89bb52fd.js';
import './bcm-a50d55ba.js';
import './colors-1d7854ea.js';
import './utils-57652744.js';
import './colors-dd598eea.js';
import './_commonjsHelpers-82aa9212.js';
import './package-7549581c.js';

const BcmColorInput = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this._id = Generate.UID();
    this.label = "";
    this.placeholder = "";
    this.value = "";
    this.required = false;
    this.disabled = false;
    this.readonly = false;
    this.fullWidth = false;
  }
  handleChange(color) {
    this.value = color;
    this.getInputElement().setValue(color);
    forceUpdate(this.el);
  }
  getInputElement() {
    return this.el.querySelector(`bcm-input`);
  }
  getPickerElement() {
    return document.querySelector("#" + this._id + "-picker");
  }
  handleInputChanged(e) {
    this.getPickerElement().color = e.detail;
  }
  eyeDropper() {
    const eyeDropper = new window.EyeDropper();
    eyeDropper
      .open()
      .then((color) => {
      this.handleChange(color.sRGBHex);
    })
      .catch((error) => {
      if (error.name === "NotAllowedError") {
        console.log("Permission to access sensor was denied.");
      }
      else if (error.name === "NotSupportedError") {
        console.log("Sensor not supported.");
      }
    });
  }
  isEyeDropperSupported() {
    return typeof window !== "undefined" && "EyeDropper" in window;
  }
  render() {
    return (h(Host, { class: "tw-block" }, h("bcm-input", { id: this._id + "-color", fullWidth: this.fullWidth, label: this.label, placeholder: this.placeholder, type: "text", "onBcm-change": e => this.handleInputChanged(e), value: this.value }, h("i", { slot: "prefix", class: "tw-flex tw-h-4 tw-w-4 tw-items-center tw-justify-center tw-rounded-full tw-border tw-border-gray-100", style: {
        backgroundColor: this.value,
      } }), this.isEyeDropperSupported() && h("i", { slot: "suffix", class: "far fa-eye-dropper", onClick: () => this.eyeDropper() })), h("bcm-linked", { targetId: this._id + "-color-container" }, h("bcm-colorful", { id: this._id + "-picker", color: this.value, onBcmChange: e => this.handleChange(e.detail) }))));
  }
  get el() { return getElement(this); }
};

export { BcmColorInput as bcm_color_input };
