/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, c as createEvent, h, H as Host, g as getElement } from './index-0615c2b8.js';
import './color-helper-74614f24.js';
import './datetime-helper-df25808a.js';
import { G as Generate } from './generate-d009624a.js';
import './number-helper-b7a7a318.js';
import './string-helper-3592bdc2.js';
import './validators-5519219e.js';
import './element-dragger-89bb52fd.js';
import { B as Bcm } from './bcm-a50d55ba.js';
import { c as classnames } from './index-f549811f.js';
import './colors-1d7854ea.js';
import './utils-57652744.js';
import './colors-dd598eea.js';
import './_commonjsHelpers-82aa9212.js';
import './package-7549581c.js';

const drawerCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");@import url(\"https://fonts.googleapis.com/css2?family=Inter:wght@200;400;500;600&display=swap\"); .size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}*{box-sizing:border-box}.bcm-drawer{user-select:none;position:absolute;width:100vw;height:100vh;top:-100%;left:-100%;overflow:hidden;visibility:hidden}.bcm-drawer--open{visibility:visible;top:0;left:0}.bcm-drawer__content{font-family:\"Inter\", sans-serif;font-size:14px;line-height:calc(14px + 8px);font-weight:400;user-select:text;position:fixed;width:100%;height:100%;background-color:#f1f5f9;z-index:10350;transition:transform 0.2s ease-in-out;transform:translateX(-100%);visibility:hidden;overflow:hidden;display:flex;flex-direction:column;align-items:stretch;justify-content:flex-start}.bcm-drawer__content-body{padding:0 24px 24px 24px}.bcm-drawer__content.full-width{max-width:100%}.bcm-drawer__content-header{padding:24px 24px 0 24px;display:flex;justify-content:space-between;align-items:flex-start;color:var(--bcm-color-grey-8);margin-bottom:8px}.bcm-drawer__content-header-close{padding:4px 8px;margin-right:-4px;margin-top:-4px;color:var(--bcm-color-grey-7)}.bcm-drawer__content-header-close:hover{cursor:pointer;color:var(--bcm-color-grey-8)}.bcm-drawer__content-footer{padding:12px 24px}.bcm-drawer__content--position-left,.bcm-drawer__content--position-right{max-width:500px}.bcm-drawer__content--position-left.full-width,.bcm-drawer__content--position-right.full-width{max-width:100%}.bcm-drawer__content--position-top,.bcm-drawer__content--position-bottom{max-height:500px}.bcm-drawer__content--position-top.full-width,.bcm-drawer__content--position-bottom.full-width{max-height:100%}.bcm-drawer__content--position-left{transform:translateX(-100%);top:0;left:0}.bcm-drawer__content--position-top{transform:translateY(-100%);top:0;left:0}.bcm-drawer__content--position-right{transform:translateX(100%);top:0;right:0}.bcm-drawer__content--position-bottom{transform:translateY(100%);bottom:0;left:0}.bcm-drawer__content--open{transform:translateX(0);visibility:visible}.bcm-drawer__content--close{visibility:visible}.bcm-drawer__overlay{position:fixed;top:0;left:0;width:100%;height:100%;background-color:rgba(0, 0, 0, 0.5);z-index:10349;visibility:hidden;opacity:0;transition:opacity 0.3s ease-in-out}.bcm-drawer__overlay--close{opacity:0;visibility:visible;transform:translateX(-100%)}.bcm-drawer__overlay--open{opacity:1;visibility:visible;transform:translateX(0)}";

const BcmDrawer = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.bcmBeforeOpen = createEvent(this, "bcm-before-open", 7);
    this.bcmBeforeClose = createEvent(this, "bcm-before-close", 7);
    this._id = Generate.UID();
    this._title = undefined;
    this.position = Bcm.Position.right;
    this.fullWidth = false;
    this._open = false;
    this._close = false;
  }
  async show() {
    this.bcmBeforeOpen.emit(true);
  }
  async hide() {
    this.bcmBeforeClose.emit(true);
    this._close = true;
  }
  _beforeOpen(event) {
    var _a;
    event && ((_a = event.target) === null || _a === void 0 ? void 0 : _a.id) == this._id && (this._open = true);
  }
  _beforeClose(event) {
    var _a;
    event && ((_a = event.target) === null || _a === void 0 ? void 0 : _a.id) == this._id && (this._open = false);
  }
  _openHandler() {
    if (this._open) {
      document.body.classList.add('bcm-disable-scroll');
    }
    else {
      document.body.classList.remove('bcm-disable-scroll');
    }
  }
  keyboardNavigation(e) {
    const keyCode = e.keyCode || 0;
    if (keyCode == Bcm.KeyCode.escape) {
      e.preventDefault();
      this.hide();
    }
  }
  disconnectedCallback() {
    this._open = false;
    document.body.classList.remove('bcm-disable-scroll');
    this.el.remove();
  }
  render() {
    const hostClasses = classnames('bcm-drawer', {
      'bcm-drawer--open': this._open,
    });
    const contentClasses = classnames('bcm-drawer__content', `bcm-drawer__content--position-${this.position}`, {
      'bcm-drawer__content--open': this._open,
      'bcm-drawer__content--close': this._close,
      'full-width': this.fullWidth,
    });
    const overlay = classnames('bcm-drawer__overlay', {
      'bcm-drawer__overlay--open': this._open,
      'bcm-drawer__overlay--close': this._close,
    });
    return (h(Host, { class: hostClasses }, h("div", { class: overlay, onClick: () => this.hide() }), h("div", { class: contentClasses }, h("div", { class: "bcm-drawer__content-header" }, h("bcm-text", { class: "bcm-drawer__content-header-title", "font-size": "6", weight: "600", color: "slate-800" }, this._title, " ", h("slot", { name: "header" })), h("div", { class: "bcm-drawer__content-header-close size-4", onClick: () => this.hide() }, h("bcm-icon", { icon: "fal fa-times" }))), h("div", { style: { 'overflow': 'auto', 'flex': '1' } }, h("div", { class: "bcm-drawer__content-body" }, h("slot", null))), h("div", { class: "bcm-drawer__content-footer" }, h("slot", { name: "footer" })))));
  }
  get el() { return getElement(this); }
  static get watchers() { return {
    "_open": ["_openHandler"]
  }; }
};
BcmDrawer.style = drawerCss;

export { BcmDrawer as bcm_drawer };
