/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, c as createEvent, h, H as Host, g as getElement } from './index-0615c2b8.js';
import { c as classnames } from './index-f549811f.js';
import { I as IsLoad } from './is-load-decorator-8277e3b8.js';
import { J as JsonParse } from './json-parse-decarator-56846a0c.js';
import { G as Generate } from './generate-d009624a.js';
import { a as Bcm } from './bcm-a50d55ba.js';
import './_commonjsHelpers-82aa9212.js';
import './package-7549581c.js';
import './colors-dd598eea.js';

const dropdownCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");@import url(\"https://fonts.googleapis.com/css2?family=Inter:wght@200;400;500;600&display=swap\"); .size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}*{box-sizing:border-box}.bcm-dropdown{width:fit-content;display:inline-flex;flex-direction:row}.bcm-dropdown.hidden{display:none}.bcm-dropdown.no-style{cursor:pointer}.bcm-dropdown.full-width{width:100%}.bcm-dropdown.full-width .bcm-button__container-text{flex:1;justify-content:space-between}.bcm-dropdown__type-split .main-button .bcm-button__container{border-top-right-radius:0;border-bottom-right-radius:0}.bcm-dropdown__type-split .split-button .bcm-button__container{border-top-left-radius:0;border-bottom-left-radius:0;margin-left:1px;min-width:auto}.bcm-dropdown__icon{display:flex;flex-direction:row;align-items:center;justify-content:center;flex-wrap:nowrap;transform:rotate(0deg);transition:transform 0.2s ease;padding-top:2px}.bcm-dropdown__icon--open{transform:rotate(180deg)}";

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
    r = Reflect.decorate(decorators, target, key, desc);
  else
    for (var i = decorators.length - 1; i >= 0; i--)
      if (d = decorators[i])
        r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const BcmDropdown = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.bcmClick = createEvent(this, "bcm-click", 7);
    this.bcmDropdownChange = createEvent(this, "bcm-dropdown-change", 7);
    this.isOpen = undefined;
    this._id = Generate.UID();
    this.menuId = Generate.UID();
    this.hidden = false;
    this.type = 'dropdown';
    this.size = Bcm.Size.medium;
    this.disabled = false;
    this.kind = Bcm.Kind.solid;
    this.icon = undefined;
    this.href = undefined;
    this.target = undefined;
    this.value = undefined;
    this.noStyle = false;
    this.dropdownIcon = 'fas fa-angle-down';
    this.linkedComponent = undefined;
    this.loading = false;
    this.variant = undefined;
    this.dataDismiss = false;
    this.fullWidth = false;
    this.iconPosition = Bcm.IconPosition.prefix;
    this.placement = undefined;
    this.height = undefined;
    this.maxHeight = '500px';
    this.minHeight = '50px';
    this.stopDeepClean = false;
    this.selectable = true;
    this.gap = '4px';
    this.color = undefined;
    this.activeItem = null;
    this.data = [];
  }
  async dataChanged(newValue) {
    if (newValue) {
      this.data = newValue;
    }
  }
  async setActive(id = null) {
    var _a, _b;
    (_b = (_a = document
      .getElementById(`${this.menuId}`)) === null || _a === void 0 ? void 0 : _a.querySelectorAll('bcm-menu')) === null || _b === void 0 ? void 0 : _b.forEach(item => {
      item.setActive(id);
    });
  }
  async getActive() {
    return this.activeItem;
  }
  handleSlotItems({ detail }) {
    this.data = detail;
  }
  setActiveAttribute(e) {
    if (e.detail) {
      this.bcmDropdownChange.emit(e.detail);
      this.activeItem = e.detail;
    }
  }
  ;
  render() {
    const { size, kind, disabled, icon, color, href, target, loading, type, variant, fullWidth, isOpen } = this;
    const hostClasses = classnames('bcm-dropdown', 'bcm-dropdown__type-' + type, {
      'full-width': fullWidth,
      'no-style': this.noStyle,
      'hidden': this.hidden || this.linkedComponent,
    });
    const attributes = Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({}, (disabled && { disabled })), (loading && { loading })), (kind && { kind })), (size && { size })), (variant && { variant })), (color && { color })), (this.menuId && { 'menu-id': this.menuId }));
    const iconClasses = classnames('bcm-dropdown__icon', {
      'bcm-dropdown__icon--open': isOpen,
    });
    const dropdownIcon = (h("span", { class: iconClasses }, h("bcm-icon", { icon: this.dropdownIcon })));
    return (h(Host, { class: hostClasses }, h("span", { hidden: true }, h("slot", null)), this.noStyle && h("slot", null), !this.noStyle && (h("bcm-button", Object.assign({ class: "main-button", id: `${this._id}-button` }, attributes, (icon && { icon }), (href && type === 'split' && { href }), (target && type === 'split' && { target }), (fullWidth && { fullWidth })), h("slot", null), type === 'dropdown' && dropdownIcon)), !this.noStyle && type === 'split' && (h("bcm-button", Object.assign({ id: `${this._id}-button-split`, class: "split-button" }, attributes), dropdownIcon)), h("bcm-linked", { id: `${this.menuId}`, "target-id": `${this._id}-button${type === 'split' ? '-split' : ''}`, placement: this.placement || (type === 'dropdown' ? 'bottom-start' : 'bottom-end'), "max-height": this.maxHeight, "min-height": this.minHeight, height: this.height, "on-bcm-open": e => { var _a; return ((_a = e === null || e === void 0 ? void 0 : e.target) === null || _a === void 0 ? void 0 : _a.id) == this.menuId && (this.isOpen = e.detail); } }, this.data && this.data.length > 0 && h("bcm-menu", { data: this.data, selectable: this.selectable, "on-bcm-click": e => this.bcmClick.emit(e.detail), "onBcm-menu-change": e => this.setActiveAttribute(e), gap: this.gap, dropdown: true }), h("slot", { name: "content" }))));
  }
  get el() { return getElement(this); }
  static get watchers() { return {
    "data": ["dataChanged"]
  }; }
};
__decorate([
  IsLoad()
], BcmDropdown.prototype, "el", void 0);
__decorate([
  JsonParse('data', true)
], BcmDropdown.prototype, "dataChanged", null);
BcmDropdown.style = dropdownCss;

export { BcmDropdown as bcm_dropdown };
