/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, c as createEvent, f as forceUpdate, h, H as Host, g as getElement, F as Fragment } from './index-0615c2b8.js';
import './color-helper-74614f24.js';
import './datetime-helper-df25808a.js';
import { G as Generate } from './generate-d009624a.js';
import './number-helper-b7a7a318.js';
import './string-helper-3592bdc2.js';
import './validators-5519219e.js';
import './element-dragger-89bb52fd.js';
import { B as Bcm } from './bcm-a50d55ba.js';
import { C as CaptionTemplate } from './caption-template-d7953d13.js';
import { c as classnames } from './index-f549811f.js';
import './types-6f06fa1a.js';
import './types-9493a7ed.js';
import { c as ce } from './index-3bc8c6e3.js';
import './colors-1d7854ea.js';
import './utils-57652744.js';
import './colors-dd598eea.js';
import './_commonjsHelpers-82aa9212.js';
import './package-7549581c.js';

const inputDropdownStyle = ce({
  slots: {
    base: "tw-font-sans tw-flex tw-flex-col tw-items-start tw-justify-start tw-gap-2",
    content: "tw-flex tw-flex-row tw-items-center tw-justify-start tw-gap-3",
    inputArea: "tw-flex tw-flex-row tw-items-center tw-justify-start tw-gap-1 tw-box-content tw-border tw-border-solid tw-max-w-[100px]  tw-uppercase tw-font-medium tw-text-center tw-border-gray-300 tw-rounded",
    input: "tw-flex-1 tw-text-inherit tw-uppercase tw-font-semibold tw-text-center tw-border-none tw-bg-transparent tw-outline-none tw-w-full",
    button: [
      "input-dropdown-button tw-flex tw-flex-row tw-items-center tw-justify-center tw-gap-1 tw-rounded tw-outline-none tw-bg-slate-100",
      "tw-border tw-border-solid tw-border-slate-300 tw-font-medium tw-text-slate-600",
      "hover:tw-border-slate-400 hover:tw-bg-slate-200",
      "tw-min-w-[32px]",
      "tw-cursor-pointer",
      "disabled:tw-cursor-not-allowed disabled:tw-text-slate-400 disabled:tw-pointer-events-none",
      "readonly:tw-text-slate-700 readonly:tw-cursor-text",
    ],
    menu: "tw-mt-1 tw-flex tw-flex-col tw-items-start tw-justify-center tw-gap-2 tw-overflow-auto tw-bg-white tw-p-3  tw-font-sans tw-text-3 tw-text-slate-700",
    menuItem: "tw-flex tw-w-full tw-cursor-pointer tw-flex-row tw-items-start tw-gap-1 tw-rounded tw-px-3 tw-py-1  tw-text-slate-700 hover:tw-bg-blue-100",
    selectedItem: "tw-flex tw-w-full tw-flex-row tw-items-start tw-gap-1 tw-rounded tw-px-3 tw-py-1  tw-text-slate-700 tw-bg-primary-200",
    disabledItem: "tw-flex tw-w-full tw-flex-row tw-items-start tw-gap-1 tw-rounded tw-px-3 tw-py-1  tw-cursor-not-allowed tw-text-slate-400 tw-bg-slate-100 hover:tw-bg-slate-100 tw-list-none",
    commentArea: "tw-flex tw-h-fit tw-w-full tw-min-w-[288px] tw-flex-col tw-items-start tw-rounded tw-p-4 tw-shadow-2",
  },
  variants: {
    size: {
      small: {
        button: "tw-h-[18px] tw-text-1 tw-leading-none",
      },
      medium: {
        button: "tw-h-[24px] tw-text-2",
        inputArea: "tw-p-0.5",
        input: "tw-text-4",
      },
      large: {
        button: "tw-h-[30px] tw-text-2",
        inputArea: "tw-p-1",
        input: "tw-text-6",
      },
    },
    invalid: {
      true: {
        inputArea: "tw-border-red-600 tw-bg-red-50",
        input: "tw-text-red-500",
      },
    },
    disabled: {
      true: {
        base: "tw-opacity-50 tw-cursor-not-allowed",
        input: "tw-cursor-not-allowed",
      },
    },
    hideComment: {
      true: {
        base: "tw-min-w-[98px]",
      },
      false: {
        base: "tw-min-w-[128px] ",
      },
    },
    label: {
      true: "",
    },
  },
  defaultVariants: {
    size: "medium",
    invalid: false,
    hideComment: false,
    disabled: false,
  },
});

const inputDropdownCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}.bcm-input[no-margin]{margin:0}.bcm-textarea[no-margin]{margin:0}.bcm-switch[no-margin]{margin:0}.bcm-checkbox[no-margin]{margin:0}.bcm-radio-group[no-margin]{margin:0}.bcm-checkbox-group[no-margin]{margin:0}.bcm-range[no-margin]{margin:0}.bcm-form[no-margin]{margin:0}.bcm-form-group[no-margin]{margin:0}.bcm-list[no-margin]{margin:0}.bcm-colorpicker[no-margin]{margin:0}.bcm-date-picker[no-margin]{margin:0}.bcm-time-picker[no-margin]{margin:0}.bcm-datetime-picker[no-margin]{margin:0}.bcm-select[no-margin]{margin:0}.bcm-listbox[no-margin]{margin:0}:host{display:flex;flex-direction:column;width:100%;position:relative}.input-dropdown-button i{transition:transform 0.2s ease-in-out}.input-dropdown-button[linked-is-open]>i{transform:rotate(-180deg);transition:transform 0.2s ease-in-out}";

const BcmInputDropdown = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.change = createEvent(this, "bcm-change", 7);
    this.onChangeDropdown = createEvent(this, "bcm-input-dropdown-change", 7);
    this.handleKeyPress = e => {
      var _a, _b;
      if (((_b = (_a = e === null || e === void 0 ? void 0 : e.target) === null || _a === void 0 ? void 0 : _a.value) === null || _b === void 0 ? void 0 : _b.length) >= +this.maxCharacterLimit) {
        e.preventDefault();
        return;
      }
    };
    this._id = Generate.UID();
    this.value = undefined;
    this.defaultValue = {};
    this.lateKeys = "L";
    this.maxCharacterLimit = 1;
    this.size = Bcm.Size.medium;
    this.label = undefined;
    this.placeholder = undefined;
    this.name = undefined;
    this.fullWidth = false;
    this.hideComment = false;
    this.hideCaption = true;
    this.disabled = false;
    this.required = false;
    this.readonly = false;
    this.data = [
      { key: "/", value: "Present", color: "#00b050" },
      { key: "B", value: "Educated off site (NOT dual registration)", color: "#ffc000" },
      { key: "C", value: "Other authorised circumstance", color: "#ffc000" },
      { key: "D", value: "Dual registration", color: "#0070c0" },
      { key: "E", value: "Excluded", color: "#ff0000" },
      { key: "F", value: "Free Study", color: "#ffc000" },
      { key: "I", value: "Illness", color: "#ff0000" },
      { key: "J", value: "Interview", color: "#ffc000" },
      { key: "L", value: "Late before reg. closed", color: "#ffc000" },
    ];
    this.caption = undefined;
    this.noCaption = false;
    this.captionType = Bcm.Status.default;
    this.captionError = undefined;
    this.customErrorMessage = undefined;
    this.captionCache = undefined;
    this.captionTypeCache = undefined;
    this.isOpenMenu = false;
    this.invalid = false;
  }
  get overlayContainer() {
    return document.getElementById("bcm-overlay-container");
  }
  get menuContent() {
    var _a, _b;
    return (_b = (_a = this.overlayContainer) === null || _a === void 0 ? void 0 : _a.querySelector("#" + `i-dropdown-menu-${this._id}`)) !== null && _b !== void 0 ? _b : this.el.querySelector("#" + `i-dropdown-menu-${this._id}`);
  }
  get keys() {
    return this.lateKeys.toLocaleLowerCase().split(",");
  }
  get isLate() {
    var _a, _b, _c, _d, _e, _f;
    return (this.keys.includes((_b = (_a = this.value) === null || _a === void 0 ? void 0 : _a.key) === null || _b === void 0 ? void 0 : _b.toLocaleLowerCase()) ||
      ((_d = (_c = this.data) === null || _c === void 0 ? void 0 : _c.find(item => { var _a, _b, _c; return ((_a = item === null || item === void 0 ? void 0 : item.key) === null || _a === void 0 ? void 0 : _a.toLowerCase()) === ((_c = (_b = this.value) === null || _b === void 0 ? void 0 : _b.key) === null || _c === void 0 ? void 0 : _c.toLowerCase()); })) === null || _d === void 0 ? void 0 : _d.isLate) ||
      ((_f = (_e = this.data) === null || _e === void 0 ? void 0 : _e.find(item => { var _a, _b, _c; return ((_a = item === null || item === void 0 ? void 0 : item.key) === null || _a === void 0 ? void 0 : _a.toLowerCase()) === ((_c = (_b = this.value) === null || _b === void 0 ? void 0 : _b.key) === null || _c === void 0 ? void 0 : _c.toLowerCase()); })) === null || _f === void 0 ? void 0 : _f.lateMin) > 0);
  }
  componentWillLoad() {
    var _a, _b;
    this.captionCache = this.caption;
    this.captionTypeCache = this.captionType;
    if (((_a = Object.keys(this.defaultValue)) === null || _a === void 0 ? void 0 : _a.length) > 0) {
      this.watchDefaultValueHandler(this.defaultValue);
    }
    else {
      this.value = (_b = this.data) === null || _b === void 0 ? void 0 : _b.find(item => item.selected);
    }
  }
  get commentContent() {
    var _a, _b;
    return (_b = (_a = this.overlayContainer) === null || _a === void 0 ? void 0 : _a.querySelector("#" + `i-dropdown-comment-${this._id}`)) !== null && _b !== void 0 ? _b : this.el.querySelector("#" + `i-dropdown-comment-${this._id}`);
  }
  clickListener(e) {
    var _a, _b;
    const isSelf = Generate.findEventPath(e, this.el);
    const isLinked = Generate.findEventPathWithNodeName(e, "BCM-LINKED");
    if (!isSelf && !isLinked && !this.keys.includes((_a = this.value) === null || _a === void 0 ? void 0 : _a.key)) {
      (_b = this.commentContent) === null || _b === void 0 ? void 0 : _b.hide();
      return;
    }
  }
  watchDefaultValueHandler(newValue) {
    var _a, _b;
    if (newValue) {
      this.value = (_a = this.data) === null || _a === void 0 ? void 0 : _a.find(item => { var _a, _b; return ((_a = item === null || item === void 0 ? void 0 : item.key) === null || _a === void 0 ? void 0 : _a.toLowerCase()) === ((_b = newValue.key) === null || _b === void 0 ? void 0 : _b.toLowerCase()); });
      this.data = this.data.map(data => {
        if (data.key === (newValue === null || newValue === void 0 ? void 0 : newValue.key)) {
          data = newValue;
          data.selected = true;
        }
        else {
          data.selected = false;
        }
        return data;
      });
      this.value = (_b = this.data) === null || _b === void 0 ? void 0 : _b.find(item => item === null || item === void 0 ? void 0 : item.selected);
      forceUpdate(this.el);
    }
  }
  async set(data) {
    this.data = typeof data === "string" ? JSON.parse(data) : data;
  }
  async get() {
    return this.value;
  }
  async setClear() {
    this.value = null;
    return Promise.resolve();
  }
  async resetCaption() {
    this.caption = this.captionCache;
    this.captionType = this.captionTypeCache;
    this.captionError = null;
    this.invalid = false;
    return Promise.resolve();
  }
  onSelectItem(item) {
    var _a;
    this.invalid = false;
    this.data = this.data.map(data => (Object.assign(Object.assign({}, data), { selected: data.key === item.key })));
    this.value = (_a = this.data) === null || _a === void 0 ? void 0 : _a.find(item => item === null || item === void 0 ? void 0 : item.selected);
    this.onChangeDropdown.emit(this.value);
    this.change.emit();
  }
  async handleInput(e) {
    var _a, _b, _c, _d, _e, _f, _g;
    const value = (_a = e === null || e === void 0 ? void 0 : e.target) === null || _a === void 0 ? void 0 : _a.value;
    this.isOpenMenu = true;
    const maxLengthExceeded = (value === null || value === void 0 ? void 0 : value.length) >= +this.maxCharacterLimit;
    if (maxLengthExceeded) {
      const item = (_b = this.data) === null || _b === void 0 ? void 0 : _b.find(item => { var _a; return ((_a = item === null || item === void 0 ? void 0 : item.key) === null || _a === void 0 ? void 0 : _a.toLowerCase()) === value.toLowerCase(); });
      if (item) {
        await ((_c = this.menuContent) === null || _c === void 0 ? void 0 : _c.hide());
        if (!(item === null || item === void 0 ? void 0 : item.hideComment)) {
          (_d = this.commentContent) === null || _d === void 0 ? void 0 : _d.show();
        }
        this.onSelectItem(item);
      }
      else {
        this.invalid = true;
        this.value = e.target.value;
        await ((_e = this.menuContent) === null || _e === void 0 ? void 0 : _e.show());
        this._input.style.color = "#ff0000";
      }
    }
    else {
      (_f = this.commentContent) === null || _f === void 0 ? void 0 : _f.hide();
      (_g = this.menuContent) === null || _g === void 0 ? void 0 : _g.hide();
      this.value = null;
      this._input.style.color = "#000000";
      this.invalid = false;
    }
    this.change.emit();
  }
  onClickSave() {
    var _a;
    (_a = this.commentContent) === null || _a === void 0 ? void 0 : _a.hide();
    this.data = this.data.map(data => (Object.assign(Object.assign({}, data), (data.key === this.value.key && {
      lateMin: this.value.lateMin,
      comment: this.value.comment,
    }))));
    forceUpdate(this.el);
    this.onChangeDropdown.emit(this.value);
    this.change.emit();
  }
  async onClick(item) {
    var _a, _b;
    if (!(item === null || item === void 0 ? void 0 : item.hideComment)) {
      (_a = this.commentContent) === null || _a === void 0 ? void 0 : _a.show();
    }
    await ((_b = this.menuContent) === null || _b === void 0 ? void 0 : _b.hide());
    this.onSelectItem(item);
  }
  render() {
    var _a, _b, _c, _d, _e;
    const { size, label, placeholder, required, disabled, readonly, _id, invalid, hideComment, noCaption, customErrorMessage, caption, captionType, captionError, hideCaption } = this;
    const { base, inputArea, input, button, menu, menuItem, commentArea, disabledItem, content, selectedItem } = inputDropdownStyle({ size, invalid, hideComment, disabled });
    const MenuTemplates = () => {
      var _a;
      return (h(Fragment, null, this.isOpenMenu ? (h("div", { class: menu() }, this.invalid && (h("li", { class: menuItem() + " tw-bg-red-100 hover:tw-bg-red-100" }, h("span", { class: "tw-text-red-900" }, h("i", { class: "far fa-exclamation-circle" })), h("span", null, "There is not mark you entered, please use"))), (_a = this.data) === null || _a === void 0 ? void 0 :
        _a.map((item) => (h(Fragment, null, !(item === null || item === void 0 ? void 0 : item.disabled) ? (h("li", { class: (item === null || item === void 0 ? void 0 : item.selected) ? selectedItem() : menuItem(), onClick: () => this.onClick(item) }, h("span", null, item.key), " - ", h("span", null, item.value))) : (h("li", { class: disabledItem() }, h("span", null, item.key), " - ", h("span", null, item.value)))))))) : null));
    };
    const CommentTemplate = () => {
      var _a, _b, _c;
      return (h(Fragment, null, this.isOpenMenu ? (h("div", { class: commentArea() }, this.isLate ? (h(Fragment, null, h("bcm-input", { label: "Minus Late", required: true, id: this._id + "-input-dropdown-late-content-input", type: "number", "full-width": true, autocomplete: false, min: 0, max: 200, value: (_a = this.value) === null || _a === void 0 ? void 0 : _a.lateMin, placeholder: "Enter Minus Late", customErrorMessage: "Max limit 200 mins", "onBcm-change": ({ detail }) => (this.value.lateMin = +detail) }, h("i", { slot: "prefix", class: "far fa-clock" })))) : null, h("bcm-textarea", { "full-width": true, value: (_c = (_b = this.value) === null || _b === void 0 ? void 0 : _b.comment) !== null && _c !== void 0 ? _c : "", "onBcm-change": ({ detail }) => (this.value.comment = detail), label: "Description", "no-caption": true, rows: 4 }), h("footer", { class: "tw-flex tw-w-full tw-flex-row tw-items-center tw-justify-end tw-gap-2" }, h("bcm-button", { role: "button", "aria-labelledby": "button", "aria-label": "button", icon: "fas fa-times", kind: "ghost", "icon-position": "prefix", onClick: () => { var _a; return (_a = this.commentContent) === null || _a === void 0 ? void 0 : _a.hide(); } }, "Close"), h("bcm-button", { role: "button", "aria-labelledby": "button", "aria-label": "button", icon: "fas fa-save", "icon-position": "prefix", onClick: () => this.onClickSave() }, "Save")))) : null));
    };
    return (h(Host, { class: base() }, label && h("bcm-label", { htmlFor: _id + "-dropdown-input", size: size, value: label, required: required }), h("div", { class: content() }, h("div", { class: inputArea() }, h("input", { id: _id + "-dropdown-input", class: input(), style: { color: (_a = this.value) === null || _a === void 0 ? void 0 : _a.color }, type: "text", tabIndex: -1, placeholder: placeholder, value: (_b = this.value) === null || _b === void 0 ? void 0 : _b.key, disabled: disabled, required: required, autoComplete: "off", readOnly: readonly, onKeyPress: e => this.handleKeyPress(e), onInput: e => this.handleInput(e), ref: el => (this._input = el) }), h("button", { disabled: disabled, id: `i-dropdown-button-${_id}`, class: button(), onClick: () => (this.isOpenMenu = true) }, h("i", { class: "fas fa-chevron-down" })), h("bcm-linked", { "onBcm-open": ({ detail }) => { var _a; return detail && ((_a = this.commentContent) === null || _a === void 0 ? void 0 : _a.hide()); }, class: "tw-mt-1", id: `i-dropdown-menu-${_id}`, "target-id": `i-dropdown-button-${_id}`, placement: "bottom-start" }, h(MenuTemplates, null)), h("bcm-linked", { id: `i-dropdown-comment-${_id}`, "target-id": _id, trigger: "custom", placement: "left" }, h(CommentTemplate, null))), !this.hideComment ? (h("span", { onClick: () => {
        var _a, _b;
        if ((_a = this.value) === null || _a === void 0 ? void 0 : _a.key) {
          this.isOpenMenu = true;
          (_b = this.commentContent) === null || _b === void 0 ? void 0 : _b.show();
        }
      }, class: classnames(((_c = this.value) === null || _c === void 0 ? void 0 : _c.comment) || ((_d = this.value) === null || _d === void 0 ? void 0 : _d.lateMin) > 0 ? "tw-text-slate-600" : "tw-text-slate-400", {
        "tw-cursor-pointer": (_e = this.value) === null || _e === void 0 ? void 0 : _e.key,
      }) }, h("i", { class: "fas fa-comment" }))) : null), !hideCaption && h(CaptionTemplate, { noCaption: noCaption, captionType: captionType, captionError: captionError, caption: caption, customErrorMessage: customErrorMessage })));
  }
  get el() { return getElement(this); }
  static get watchers() { return {
    "defaultValue": ["watchDefaultValueHandler"]
  }; }
};
BcmInputDropdown.style = inputDropdownCss;

export { BcmInputDropdown as bcm_input_dropdown };
