/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, h, H as Host, g as getElement } from './index-0615c2b8.js';
import { G as Generate } from './generate-d009624a.js';
import { a as Bcm } from './bcm-a50d55ba.js';
import { c as classnames } from './index-f549811f.js';
import { C as ColorHelper } from './color-helper-74614f24.js';
import './package-7549581c.js';
import './colors-dd598eea.js';
import './_commonjsHelpers-82aa9212.js';
import './colors-1d7854ea.js';
import './utils-57652744.js';

const itemCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");@import url(\"https://fonts.googleapis.com/css2?family=Inter:wght@200;400;500;600&display=swap\"); .size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}*{box-sizing:border-box}.bcm-item{box-sizing:border-box;display:flex;flex-direction:row;align-items:center;justify-content:flex-start;flex-wrap:nowrap;--bcm-item-color-default:var(--bcm-new-ds-color-white);--bcm-item-background-color-default:var(--bcm-new-ds-color-blue-500);--bcm-item-color-hover:var(--bcm-new-ds-color-white);--bcm-item-background-color-hover:var(--bcm-new-ds-color-blue-600);--bcm-item-color-focus-visible:var(--bcm-new-ds-color-white);--bcm-item-background-color-focus-visible:var(--bcm-new-ds-color-blue-800);--bcm-item-color-active:var(--bcm-new-ds-color-white);--bcm-item-background-color-active:var(--bcm-new-ds-color-blue-700);--bcm-item-color-disabled:var(--bcm-new-ds-color-white);--bcm-item-background-color-disabled:var(--bcm-new-ds-color-slate-400);font-family:\"Inter\", sans-serif;font-size:14px;line-height:calc(14px + 8px);font-weight:400;border-radius:4px;outline:none;color:var(--bcm-item-color-default);background-color:var(--bcm-item-background-color-default)}.bcm-item-size-small{font-size:12px;line-height:calc(12px + 8px);padding:2px 12px;min-height:calc(calc(12px + 8px) + calc(2px) * 2)}.bcm-item-size-medium{font-size:14px;line-height:calc(14px + 8px);padding:5px 12px;min-height:calc(calc(14px + 8px) + calc(5px) * 2)}.bcm-item-size-large{font-size:16px;line-height:calc(16px + 8px);padding:8px 12px;min-height:calc(calc(16px + 8px) + calc(8px) * 2)}.bcm-item:default{color:var(--bcm-item-color-default);background-color:var(--bcm-item-background-color-default)}.bcm-item:hover{color:var(--bcm-item-color-hover);background-color:var(--bcm-item-background-color-hover)}.bcm-item:focus-visible{color:var(--bcm-item-color-focus-visible);background-color:var(--bcm-item-background-color-focus-visible)}.bcm-item:active{color:var(--bcm-item-color-active);background-color:var(--bcm-item-background-color-active)}.bcm-item:disabled{color:var(--bcm-item-color-disabled);background-color:var(--bcm-item-background-color-disabled)}.bcm-item:not(.static):hover{cursor:pointer}";

const BcmItem = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this._id = Generate.UID();
    this.size = Bcm.Size.medium;
    this.color = undefined;
    this.static = false;
  }
  setColor(color = this.color) {
    if (!color)
      return;
    const prefix = `--bcm-item`;
    if (color == "white") {
      return {
        [`${prefix}-color-default`]: ColorHelper.dsColor('slate-600'),
        [`${prefix}-color-hover`]: ColorHelper.dsColor('slate-600'),
        [`${prefix}-color-focus-visible`]: ColorHelper.dsColor('slate-600'),
        [`${prefix}-color-active`]: ColorHelper.dsColor('slate-600'),
        [`${prefix}-color-disabled`]: ColorHelper.dsColor('white'),
        [`${prefix}-background-color-default`]: ColorHelper.dsColor(this.static ? 'white' : 'white'),
        [`${prefix}-background-color-hover`]: ColorHelper.dsColor(this.static ? 'white' : 'slate-100'),
        [`${prefix}-background-color-focus-visible`]: ColorHelper.dsColor(this.static ? 'white' : 'slate-200'),
        [`${prefix}-background-color-active`]: ColorHelper.dsColor(this.static ? 'white' : 'slate-300'),
        [`${prefix}-background-color-disabled`]: ColorHelper.dsColor('slate-400'),
      };
    }
    return {
      [`${prefix}-color-default`]: ColorHelper.dsColor('white'),
      [`${prefix}-color-hover`]: ColorHelper.dsColor('white'),
      [`${prefix}-color-focus-visible`]: ColorHelper.dsColor('white'),
      [`${prefix}-color-active`]: ColorHelper.dsColor('white'),
      [`${prefix}-color-disabled`]: ColorHelper.dsColor('white'),
      [`${prefix}-background-color-default`]: ColorHelper.dsColor(color + '-500'),
      [`${prefix}-background-color-hover`]: ColorHelper.dsColor(color + '-600'),
      [`${prefix}-background-color-focus-visible`]: ColorHelper.dsColor(color + '-700'),
      [`${prefix}-background-color-active`]: ColorHelper.dsColor(color + '-800'),
      [`${prefix}-background-color-disabled`]: ColorHelper.dsColor('slate-400'),
    };
  }
  disconnectedCallback() {
    //   this.el.remove()
  }
  render() {
    const hostClasses = classnames('bcm-item', `bcm-item-size-${this.size}`);
    return (h(Host, { class: hostClasses, style: this.setColor() }, h("slot", null)));
  }
  get el() { return getElement(this); }
};
BcmItem.style = itemCss;

export { BcmItem as bcm_item };
