/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, c as createEvent, h, g as getElement } from './index-0615c2b8.js';
import { G as Generate, s as snq } from './generate-d009624a.js';
import { S as StringHelper } from './string-helper-3592bdc2.js';
import './package-7549581c.js';
import './colors-dd598eea.js';
import './_commonjsHelpers-82aa9212.js';
import './bcm-a50d55ba.js';

const BcmItems = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.bcmItems = createEvent(this, "bcm-items", 7);
    this._id = Generate.UID();
  }
  connectedCallback() {
    if (this.el.children && this.el.children.length > 0) {
      let slots = this.nestedItems(this.el);
      this.bcmItems.emit(slots);
      this.el.remove();
    }
  }
  mapItems(element) {
    var _a;
    const item = element;
    const textContent = (_a = item === null || item === void 0 ? void 0 : item.innerHTML) === null || _a === void 0 ? void 0 : _a.replace(/<bcm-item>.*<\/bcm-item>/g, '').replace(/<bcm-item .*>.*<\/bcm-item>/g, '').replace(/<!--(.|\s)*?-->/g, '').trim();
    const checkAttr = (attr) => StringHelper.elementBooleanCheck(element.getAttribute(attr));
    return Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({ id: element.getAttribute('id') || Generate.UID(), text: element.getAttribute('text') || textContent }, (element.innerHTML.trim() && { isHtmlContent: element.textContent.length > 0 ? (element.innerHTML.trim()) : null })), (checkAttr('disabled') && { disabled: checkAttr('disabled') })), (checkAttr('selected') && { selected: checkAttr('selected') })), (checkAttr('hidden') && { hidden: checkAttr('hidden') })), (checkAttr('checked') && { checked: checkAttr('checked') })), (checkAttr('readonly') && { readonly: checkAttr('readonly') })), (checkAttr('active') && { active: checkAttr('active') })), (checkAttr('icon') && { icon: element.getAttribute('icon') })), (checkAttr('link') && { link: element.getAttribute('link') }));
  }
  nestedItems(element) {
    return snq(() => Array.from(element === null || element === void 0 ? void 0 : element.children).map((child) => {
      var _a;
      return (Object.assign(Object.assign({}, (((_a = child === null || child === void 0 ? void 0 : child.tagName) === null || _a === void 0 ? void 0 : _a.toLowerCase()) === 'bcm-item' && this.mapItems(child))), { items: this.nestedItems(child) }));
    }), []);
  }
  render() {
    return h("slot", null);
  }
  get el() { return getElement(this); }
};

export { BcmItems as bcm_items };
