/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, h, H as Host } from './index-0615c2b8.js';
import { c as classnames } from './index-f549811f.js';
import { c as colors } from './colors-dd598eea.js';
import './_commonjsHelpers-82aa9212.js';

const BcmOverlay = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.center = false;
    this.color = colors.black;
    this.opacity = "0.5";
    this.zIndex = "10400";
  }
  render() {
    return (h(Host, { class: classnames("tw-fixed tw-inset-0 tw-transition", {
        "tw-flex tw-items-center tw-justify-center": this.center,
      }), style: {
        backgroundColor: `${this.color}`,
        opacity: this.opacity,
        zIndex: this.zIndex,
      } }, h("slot", null)));
  }
};

const BcmScrollArea = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.width = "inherit";
    this.height = "inherit";
    this.isDisabled = false;
  }
  render() {
    return (h(Host, { class: classnames("tw-block", {
        "tw-overflow-y-scroll tw-overscroll-contain": !this.isDisabled,
      }), style: { width: this.width, height: this.height } }, h("slot", null)));
  }
};

export { BcmOverlay as bcm_overlay, BcmScrollArea as bcm_scroll_area };
