/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, h, H as Host, g as getElement } from './index-0615c2b8.js';
import { c as classnames } from './index-f549811f.js';
import { C as ColorHelper } from './color-helper-74614f24.js';
import { G as Generate } from './generate-d009624a.js';
import { a as Bcm } from './bcm-a50d55ba.js';
import './_commonjsHelpers-82aa9212.js';
import './colors-1d7854ea.js';
import './utils-57652744.js';
import './colors-dd598eea.js';
import './package-7549581c.js';

// export const lineSizes = {
//   small: {
//     textSize: 'size-1',
//     iconSize: 14,
//   },
//   medium: {
//     textSize: 'size-2',
//     iconSize: 16,
//   }
// }
const circleSizes = {
  small: {
    textSize: 'size-3',
    iconSize: 22,
    circleSize: 80,
    radius: 36
  },
  medium: {
    textSize: 'size-5',
    iconSize: 30,
    circleSize: 120,
    radius: 52
  }
};

const progressCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");@import url(\"https://fonts.googleapis.com/css2?family=Inter:wght@200;400;500;600&display=swap\"); .size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}*{box-sizing:border-box}.bcm-progress{--bcm-progress-color:var(--bcm-new-ds-color-blue-500);display:inline-block;min-width:50px;width:100%;max-width:256px;font-family:\"Inter\", sans-serif;font-size:14px;line-height:calc(14px + 8px);font-weight:400}.bcm-progress.full-width{width:100%;max-width:100%;min-width:auto}.bcm-progress__line{display:flex;flex-direction:row;align-items:center;justify-content:center;flex-wrap:nowrap;min-height:8px}.bcm-progress__line .value{margin-left:8px;color:var(--bcm-new-ds-color-slate-500);min-width:32px;font-size:14px;min-height:calc(14px + 8px);font-weight:500}.bcm-progress__line-progress{width:100%;flex:1;height:8px;border:0 none;background:var(--bcm-new-ds-color-slate-200);appearance:none}.bcm-progress__line-progress.small{height:6px}.bcm-progress__line-progress.line-rounded,.bcm-progress__line-progress.line-rounded::-webkit-progress-value{border-radius:8px}.bcm-progress__line-progress.line-rounded::-moz-progress-bar{border-radius:8px}.bcm-progress__line-progress.completed::-webkit-progress-value{background-color:var(--bcm-progress-color)}.bcm-progress__line-progress.completed::-moz-progress-bar{background-color:var(--bcm-progress-color)}.bcm-progress__line-progress.error::-webkit-progress-value{background-color:var(--bcm-new-ds-color-red-500)}.bcm-progress__line-progress.error::-moz-progress-bar{background-color:var(--bcm-new-ds-color-red-500)}.bcm-progress__line-progress.error .value{color:var(--bcm-new-ds-color-red-500)}.bcm-progress__line-progress::-webkit-progress-bar{background:transparent}.bcm-progress__line-progress::-webkit-progress-value{background-color:var(--bcm-progress-color);transition:0.3s}.bcm-progress__line-progress::-moz-progress-bar{background-color:var(--bcm-progress-color);transition:0.3s}.bcm-progress__circle{position:relative}.bcm-progress__circle bcm-icon{position:absolute;top:50%;left:50%;transform:translate(-50%, -50%)}.bcm-progress__circle text{fill:var(--bcm-new-ds-color-slate-500);font-size:18px;line-height:calc(18px + 8px);font-weight:500}.bcm-progress__circle-circle{transition:0.35s stroke-dashoffset, 0.1s stroke;transform:rotate(-90deg);transform-origin:50% 50%;stroke:#F5F5F5;stroke-width:6px;fill:transparent}.bcm-progress__circle-circle.bar{stroke:var(--bcm-progress-color)}.bcm-progress__circle-circle.completed{stroke:var(--bcm-new-ds-color-emerald-500)}.bcm-progress__circle-circle.error{stroke:var(--bcm-new-ds-color-red-500)}";

const BcmProgress = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this._id = Generate.UID();
    this.value = 0;
    this.max = 100;
    this.size = Bcm.Size.medium;
    this.type = "line-rounded";
    this.info = null;
    this.error = false;
    this.hidden = false;
    this.fullWidth = false;
    this.color = "blue";
    this.isCompleted = false;
  }
  connectedCallback() {
    this.maxPercent(this.value);
  }
  componentDidRender() {
    const circle = this.el.querySelector("#circle");
    if (circle) {
      const radius = circle.r.baseVal.value;
      const circumference = radius * 2 * Math.PI;
      const offset = circumference - (this.value / this.max) * circumference;
      circle.style.strokeDasharray = `${circumference} ${circumference}`;
      circle.style.strokeDashoffset = `${circumference}`;
      circle.style.strokeDashoffset = `${offset}`;
    }
  }
  componentShouldUpdate(newVal, oldVal, propName) {
    if (propName === "value" && newVal !== oldVal) {
      this.handlePercent(newVal);
    }
    if (propName === "max" && newVal !== oldVal) {
      this.value > newVal ? this.value = newVal : this.value;
    }
  }
  maxPercent(newValue) {
    if (newValue >= this.max) {
      this.value = this.max;
      this.isCompleted = true;
    }
    if (newValue < this.max) {
      this.isCompleted = false;
    }
    if (newValue <= 0) {
      this.value = 0;
    }
  }
  async increment(percent) {
    this.handlePercent(+percent, "increment");
  }
  async decrement(percent) {
    this.handlePercent(+percent, "decrement");
  }
  async set(percent) {
    this.handlePercent(+percent, "set");
  }
  handlePercent(percent, process = "set") {
    if ((percent || percent == 0) && typeof percent === "number") {
      switch (process) {
        case "increment":
          this.value += percent;
          break;
        case "decrement":
          this.value -= percent;
          break;
        case "set":
          this.value = percent;
          break;
      }
      this.maxPercent(this.value);
      this.error = false;
    }
    else {
      this.error = true;
    }
  }
  getIcon(type = "line") {
    let icon = "far fa-" + (this.error ? "times" : "check") + (type === "line" ? "-circle" : "");
    if (this.error || (this.info === "icon" && this.isCompleted)) {
      return h("bcm-icon", { icon: icon });
    }
  }
  render() {
    const { type, hidden, error, size, isCompleted, value, fullWidth } = this;
    const isIcon = this.info === "icon";
    const { circleSize, radius, textSize } = circleSizes[this.size];
    const centerOfCircle = +circleSize / 2;
    const completeState = classnames({
      completed: isIcon && isCompleted,
      error,
    });
    const lineClasses = classnames("bcm-progress__line-progress", size, type, completeState);
    const circleClasses = classnames("bcm-progress__circle-circle", "bar", completeState);
    const containerStyle = {
      width: `${circleSize}px`,
      height: `${circleSize}px`,
    };
    const hostClasses = classnames("bcm-progress", {
      hidden,
      "full-width": fullWidth,
    });
    const CircleTemplate = () => (h("div", { class: "bcm-progress__circle", style: containerStyle }, h("svg", { width: circleSize, height: circleSize }, h("circle", { r: radius, cx: centerOfCircle, cy: centerOfCircle, class: "bcm-progress__circle-circle" }), h("circle", { r: radius, cx: centerOfCircle, cy: centerOfCircle, class: circleClasses, id: "circle" }), (this.info && this.info != "icon") && !this.error && (h("text", { x: centerOfCircle, y: centerOfCircle, "text-anchor": "middle", class: textSize, "alignment-baseline": "middle" }, this.info === "value-max" && (value + "/" + this.max), this.info === "value" && { value }, this.info === "percent" &&
      (100 / this.max) * +(value) + "%"))), this.getIcon("circle")));
    const LineTemplate = () => (h("div", { class: "bcm-progress__line" }, h("progress", { class: lineClasses, value: value, max: this.max }), this.info === "value-max" && h("span", { class: "value" }, value, "/", this.max, " "), this.info === "value" && h("span", { class: "value" }, value, " "), this.info === "percent" &&
      h("span", { class: "value" }, (100 / this.max) * +(value), "%"), this.info === "icon" && h("span", { class: "value" }, this.getIcon("line"))));
    return (h(Host, { class: hostClasses, style: {
        [`--bcm-progress-color`]: ColorHelper.dsColor(this.color),
      } }, type === "circle" ? h(CircleTemplate, null) : h(LineTemplate, null)));
  }
  get el() { return getElement(this); }
};
BcmProgress.style = progressCss;

export { BcmProgress as bcm_progress };
