/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, c as createEvent, h, H as Host, g as getElement } from './index-0615c2b8.js';
import './color-helper-74614f24.js';
import './datetime-helper-df25808a.js';
import { G as Generate } from './generate-d009624a.js';
import './number-helper-b7a7a318.js';
import './string-helper-3592bdc2.js';
import './validators-5519219e.js';
import './element-dragger-89bb52fd.js';
import { d as delay } from './utils-57652744.js';
import { B as Bcm } from './bcm-a50d55ba.js';
import { C as CaptionTemplate } from './caption-template-d7953d13.js';
import { c as classnames } from './index-f549811f.js';
import './types-6f06fa1a.js';
import './types-9493a7ed.js';
import { I as IsLoad } from './is-load-decorator-8277e3b8.js';
import './colors-1d7854ea.js';
import './colors-dd598eea.js';
import './_commonjsHelpers-82aa9212.js';
import './package-7549581c.js';

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
    r = Reflect.decorate(decorators, target, key, desc);
  else
    for (var i = decorators.length - 1; i >= 0; i--)
      if (d = decorators[i])
        r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const BcmRadioGroup = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.change = createEvent(this, "bcm-change", 7);
    this._id = Generate.UID();
    this.label = undefined;
    this.name = undefined;
    this.value = null;
    this.defaultValue = undefined;
    this.size = Bcm.Size.medium;
    this.disabled = undefined;
    this.hidden = false;
    this.required = false;
    this.gap = undefined;
    this.direction = Bcm.Direction.horizontal;
    this.fullWidth = false;
    this.items = [];
    this.caption = undefined;
    this.noCaption = false;
    this.captionError = undefined;
    this.captionType = Bcm.Status.default;
    this.captionCache = undefined;
    this.captionTypeCache = undefined;
  }
  get radios() {
    return Array.from(this.el.querySelectorAll("bcm-radio"));
  }
  get Items() {
    return this.items;
  }
  connectedCallback() {
    this.captionCache = this.caption;
    this.captionTypeCache = this.captionType;
  }
  updateValue() {
    var _a, _b, _c;
    this.value = (_c = (_b = (_a = this.radios) === null || _a === void 0 ? void 0 : _a.find(radio => radio.checked)) === null || _b === void 0 ? void 0 : _b.value) !== null && _c !== void 0 ? _c : null;
  }
  setRadioUpdate() {
    var _a;
    (_a = this.radios) === null || _a === void 0 ? void 0 : _a.forEach(radio => {
      radio.disabled = this.disabled || radio.disabled;
      radio.size = this.size;
      if (this.defaultValue) {
        radio.checked = radio.value == this.defaultValue;
      }
    });
  }
  watchDisabled(newVal, _oldVal) {
    var _a;
    (_a = this.radios) === null || _a === void 0 ? void 0 : _a.forEach(radio => radio.disabled = newVal);
  }
  watchDefaultValue(newVal, _oldVal) {
    var _a;
    (_a = this.radios) === null || _a === void 0 ? void 0 : _a.forEach(radio => radio.checked = radio.value == newVal);
    this.updateValue();
    this.change.emit(this.value);
  }
  componentWillLoad() {
    this.setRadioUpdate();
    this.updateValue();
  }
  handleChange(e) {
    var _a, _b;
    e.stopPropagation();
    e.preventDefault();
    const checked = (_a = e.target.checked) !== null && _a !== void 0 ? _a : false;
    (_b = this.radios) === null || _b === void 0 ? void 0 : _b.forEach(radio => {
      radio.checked = radio.id == e.target.id ? !checked : false;
    });
    this.updateValue();
    this.change.emit(this.value);
  }
  ;
  async setClear() {
    var _a;
    this.value = null;
    (_a = this.radios) === null || _a === void 0 ? void 0 : _a.forEach(radio => {
      radio.checked = false;
    });
  }
  async resetCaption() {
    await delay(10);
    this.caption = this.captionCache;
    this.captionType = this.captionTypeCache;
    this.captionError = null;
    await delay(10);
    return Promise.resolve();
  }
  async check(itemId, checked = true) {
    var _a;
    (_a = this.radios) === null || _a === void 0 ? void 0 : _a.forEach(radio => {
      radio.checked = radio.id == itemId || radio.value == itemId ? checked : false;
    });
    this.updateValue();
    this.change.emit(this.value);
  }
  async get() {
    return this.value;
  }
  async set(data) {
    await this.check(data);
  }
  async getValue() {
    return this.value;
  }
  render() {
    var _a, _b;
    const { direction, fullWidth, gap, label, size, required, disabled, caption, captionError, captionType, noCaption } = this;
    return (h(Host, { class: "tw-mb-2 tw-flex tw-flex-col", role: "radiogroup", "aria-labelledby": "radiogroup" }, label && h("bcm-label", { type: captionType, value: label, required: required }), h("div", { class: classnames("tw-flex tw-flex-wrap", direction == Bcm.Direction.horizontal ? "tw-flex-row" : "tw-flex-col", fullWidth && "tw-w-full"), style: { "gap": gap } }, h("slot", null), ((_a = this.Items) === null || _a === void 0 ? void 0 : _a.length) > 0 &&
      ((_b = this.Items) === null || _b === void 0 ? void 0 : _b.map(item => (h("bcm-radio", { id: item.id, value: item.value, disabled: disabled || item.disabled, checked: item.checked, color: item.color, size: size }, item.label))))), h(CaptionTemplate, { noCaption: noCaption, captionType: captionType, captionError: captionError, caption: caption })));
  }
  get el() { return getElement(this); }
  static get watchers() { return {
    "disabled": ["watchDisabled"],
    "defaultValue": ["watchDefaultValue"]
  }; }
};
__decorate([
  IsLoad()
], BcmRadioGroup.prototype, "el", void 0);

export { BcmRadioGroup as bcm_radio_group };
