/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, h, H as Host, g as getElement } from './index-0615c2b8.js';
import { c as classnames } from './index-f549811f.js';
import './_commonjsHelpers-82aa9212.js';

const statuses = {
  success: {
    icon: 'far fa-check-circle',
    color: 'green-6'
  },
  info: {
    icon: 'far fa-info-circle',
    color: 'blue-6'
  },
  warning: {
    icon: 'far fa-warning',
    color: 'warmyellow-6'
  },
  error: {
    icon: 'far fa-times-circle',
    color: 'grey-10'
  }
};

const resultCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}:host{display:block}:host(.hidden){display:none}.result{display:flex;flex-direction:column;align-items:center;padding:32px 24px}.result .content{margin-top:24px}.result .content .heading{margin-bottom:8px}.result .content .heading,.result .content .desc{display:block;text-align:center}.result .content .extra{background-color:#F5F5F5;padding:24px 24px;margin:32px 0}@media screen and (min-width: 576px){.result .content .extra{padding:24px 40px}}.result .content .buttons{display:flex;justify-content:center;grid-gap:8px;flex-wrap:wrap}";

const BcmResult = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.status = null;
    this.heading = undefined;
    this.description = undefined;
    this.hidden = false;
    this.footerArea = undefined;
    this.footerHtml = undefined;
  }
  getIcon() {
    if (this.status != null) {
      const icon = statuses[this.status].icon;
      return (h("div", { class: "icon" }, h("bcm-icon", { icon: icon })));
    }
  }
  componentDidRender() {
    const slot = this.el.shadowRoot.querySelector('slot').assignedElements();
    slot.map(el => {
      if (String(el.tagName).toLowerCase() === 'bcm-result-footer') {
        el.slot = 'footer';
        this.footerArea = true;
        this.footerHtml = el.innerHTML;
        el.innerHTML = "";
      }
    });
  }
  render() {
    const hostClasses = classnames(this.hidden ? 'hidden' : null);
    return (h(Host, { class: hostClasses }, h("div", { class: "result" }, this.getIcon(), h("div", { class: "content" }, h("span", { class: "heading size-5 weight-semibold" }, this.heading), h("span", { class: "desc size-2" }, this.description), h("div", { class: "extra" }, h("slot", null)), (this.footerArea && (h("div", { class: "buttons", innerHTML: this.footerHtml })))))));
  }
  get el() { return getElement(this); }
};
BcmResult.style = resultCss;

export { BcmResult as bcm_result };
