/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, h, H as Host } from './index-0615c2b8.js';
import './color-helper-74614f24.js';
import './datetime-helper-df25808a.js';
import { G as Generate } from './generate-d009624a.js';
import './number-helper-b7a7a318.js';
import './string-helper-3592bdc2.js';
import './validators-5519219e.js';
import './element-dragger-89bb52fd.js';
import { B as Bcm } from './bcm-a50d55ba.js';
import { c as classnames } from './index-f549811f.js';
import './colors-1d7854ea.js';
import './utils-57652744.js';
import './colors-dd598eea.js';
import './_commonjsHelpers-82aa9212.js';
import './package-7549581c.js';

const osKeys = {
  ctrl: "⌘",
  alt: "⌥",
  shift: "⇧",
  del: "⌫",
  delete: "⌫",
  backspace: "⌦",
  enter: "⏎",
  return: "⏎",
};
const BcmShortcut = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.isMac = /Mac/.test(window.navigator.userAgent);
    this.hotkey = undefined;
    this.color = "slate";
    this.size = Bcm.Size.small;
  }
  getHotkey(key) {
    if (!key) {
      return "";
    }
    if (this.isMac && (key.includes(" ") || key.includes("+"))) {
      const keys = key.split(/[\s+]+/);
      return keys.map(k => osKeys[k] || k).join("");
    }
    else {
      return key;
    }
  }
  render() {
    const { size, color, hotkey } = this;
    return (h(Host, { class: classnames("bcm-ui-element bcm-ui-content-display", "tw-block tw-h-fit tw-w-fit tw-rounded tw-border tw-border-solid tw-px-1", "tw-border-default-300 tw-bg-default-100 tw-text-default-700", "tw-text-center tw-font-medium tw-capitalize", {
        "tw-text-2": size === Bcm.Size.small,
        "tw-text-3": size === Bcm.Size.medium,
        "tw-text-4": size === Bcm.Size.large,
      }), style: Object.assign({}, Generate.getTwColor({ color })) }, this.getHotkey(hotkey)));
  }
};

export { BcmShortcut as bcm_shortcut };
