/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, h, H as Host, g as getElement } from './index-0615c2b8.js';
import './color-helper-74614f24.js';
import './datetime-helper-df25808a.js';
import { G as Generate } from './generate-d009624a.js';
import './number-helper-b7a7a318.js';
import './string-helper-3592bdc2.js';
import './validators-5519219e.js';
import './element-dragger-89bb52fd.js';
import { B as Bcm } from './bcm-a50d55ba.js';
import { c as classnames } from './index-f549811f.js';
import './colors-1d7854ea.js';
import './utils-57652744.js';
import './colors-dd598eea.js';
import './_commonjsHelpers-82aa9212.js';
import './package-7549581c.js';

const BcmTabItemHeader = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this._id = Generate.UID();
    this.active = false;
    this.disabled = false;
    this.index = undefined;
    this.color = "blue";
    this.size = Bcm.Size.medium;
  }
  handleClick() {
    var _a;
    if (!this.disabled) {
      (_a = Generate.findParentElement(this.el, "bcm-tab-group")) === null || _a === void 0 ? void 0 : _a.setActive(this.index);
    }
  }
  render() {
    const { color, size, active, disabled } = this;
    const tabId = this.el.getAttribute("tab-id");
    const disabledClass = "tw-cursor-not-allowed tw-text-gray-500 tw-opacity-50";
    const dc = Generate.getTwColor({
      color: color,
      tones: [700, 800, 900]
    });
    return (h(Host, { role: "tab", id: `tab-${tabId}`, "aria-selected": active ? "true" : "false", "aria-controls": tabId, onClick: () => this.handleClick(), class: classnames(`tw-font-medium tw-flex tw-flex-1 tw-items-center tw-justify-center tw-border-0 tw-border-solid tw-border-b-[2px] tw-border-b-gray-300  tw-transition-font tw-focus:outline-none`, {
        "tw-text-2 tw-pt-1 tw-pb-1 tw-gap-2": size === Bcm.Size.small,
        "tw-text-3 tw-pt-2 tw-pb-2.5 tw-gap-2.5": size === Bcm.Size.medium,
        "tw-text-4 tw-pt-3 tw-pb-3 tw-gap-3": size === Bcm.Size.large,
      }, disabled ? disabledClass : "tw-cursor-pointer", active
        ? `tw-text-default-700 enabled:hover:tw-text-default-800 enabled:active:tw-text-default-900 enabled:focus-visible:tw-text-default-900`
        : "tw-text-gray-700"), style: dc }));
  }
  get el() { return getElement(this); }
};

export { BcmTabItemHeader as bcm_tab_item_header };
