/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, h, H as Host, g as getElement } from './index-0615c2b8.js';
import './color-helper-74614f24.js';
import './datetime-helper-df25808a.js';
import { G as Generate } from './generate-d009624a.js';
import './number-helper-b7a7a318.js';
import './string-helper-3592bdc2.js';
import './validators-5519219e.js';
import './element-dragger-89bb52fd.js';
import './bcm-a50d55ba.js';
import './colors-1d7854ea.js';
import './utils-57652744.js';
import './colors-dd598eea.js';
import './_commonjsHelpers-82aa9212.js';
import './package-7549581c.js';

const BcmTabItem = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this._id = Generate.UID();
    this.active = false;
    this.disabled = false;
    this.index = undefined;
  }
  componentWillLoad() {
    this.indexControl();
  }
  componentDidRender() {
    this.headerMove();
  }
  getHeaderItem() {
    const headerItem = this.el.querySelector("bcm-tab-item-header");
    if (headerItem) {
      headerItem.setAttribute("index", `${this.index}`);
      headerItem.setAttribute("active", `${this.active}`);
      headerItem.setAttribute("disabled", `${this.disabled}`);
      headerItem.setAttribute("tab-id", `${this._id}`);
      headerItem.style.order = `${this.index}`;
    }
    return headerItem;
  }
  getParentTabGroup() {
    return Generate.findParentElement(this.el, "bcm-tab-group");
  }
  getFindHeaderItem() {
    var _a, _b;
    return (_b = (_a = this.getParentTabGroup()) === null || _a === void 0 ? void 0 : _a.querySelector("#tab-header")) === null || _b === void 0 ? void 0 : _b.querySelector(`bcm-tab-item-header[tab-id="${this._id}"]`);
  }
  headerMove() {
    var _a, _b, _c, _d;
    if (this.getHeaderItem()) {
      (_a = this.getFindHeaderItem()) === null || _a === void 0 ? void 0 : _a.remove();
      (_c = (_b = this.getParentTabGroup()) === null || _b === void 0 ? void 0 : _b.querySelector("#tab-header")) === null || _c === void 0 ? void 0 : _c.appendChild(this.getHeaderItem());
      (_d = this.el.parentElement) === null || _d === void 0 ? void 0 : _d.refresh();
    }
  }
  indexControl() {
    var _a;
    if (!this.index) {
      (_a = Generate.findParentElement(this.el, "bcm-tab-group")) === null || _a === void 0 ? void 0 : _a.querySelectorAll("bcm-tab-item").forEach((item, index) => {
        if (item === this.el) {
          item.setAttribute("index", `${index + 1}`);
        }
      });
    }
  }
  componentDidLoad() {
    const observer = new MutationObserver(() => {
      this.headerMove();
    });
    observer.observe(this.el, { childList: true, subtree: true });
  }
  render() {
    return (h(Host, { id: this._id, role: "tabpanel", "aria-labelledby": `tab-${this._id}`, "aria-hidden": !this.active ? "true" : "false", class: {
        "tw-block": this.active,
        "tw-hidden": !this.active,
        "tw-opacity-50": this.disabled,
        "tw-w-full": true,
      } }, h("slot", null)));
  }
  get el() { return getElement(this); }
};

export { BcmTabItem as bcm_tab_item };
