/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, h, H as Host, g as getElement } from './index-0615c2b8.js';
import { c as classnames } from './index-f549811f.js';
import './_commonjsHelpers-82aa9212.js';

const tabPaneCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}:host{width:100%;display:block}:host(.hidden){display:none}:host(:not(.active)){height:0 !important;overflow:hidden;padding:0 !important}:host(.active){display:block}";

/**
 * @desc
 * @param str
 */
const lowercase = (str) => str.toLowerCase();
const BcmTabPane = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.size = 'medium';
    this.hidden = false;
    this.fullWidth = false;
    this.tab = (Math.random() * 4).toString(16).replace('.', '');
    this.active = false;
  }
  connectedCallback() { }
  disconnectedCallback() { }
  componentWillLoad() { }
  componentDidLoad() { }
  componentWillRender() { }
  componentDidRender() { }
  componentWillUpdate() { }
  componentDidUpdate() { }
  handleActiveTabPane(e) {
    if (lowercase(e.target.nodeName) === 'bcm-tab') {
      if (e.target.tabId === this.tab) {
        this.active = true;
      }
      else {
        this.active = false;
      }
    }
  }
  render() {
    const classes = classnames('tab-pane', this.size);
    const hostClasses = classnames(this.hidden ? 'hidden' : null, this.active ? 'active' : null);
    return (h(Host, { class: hostClasses }, h("div", { class: classes }, h("slot", null))));
  }
  get el() { return getElement(this); }
};
BcmTabPane.style = tabPaneCss;

export { BcmTabPane as bcm_tab_pane };
