/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { r as registerInstance, h, H as Host, g as getElement } from './index-0615c2b8.js';
import { c as classnames } from './index-f549811f.js';
import { I as IsLoad } from './is-load-decorator-8277e3b8.js';
import { G as Generate } from './generate-d009624a.js';
import { a as Bcm } from './bcm-a50d55ba.js';
import { d as delay } from './utils-57652744.js';
import './_commonjsHelpers-82aa9212.js';
import './package-7549581c.js';
import './colors-dd598eea.js';

const timePickerCss = "@import url(\"https://fonts.googleapis.com/css?family=Roboto:400,500\");.size-1{font-size:12px;line-height:20px}.size-2{font-size:14px;line-height:22px}.size-3{font-size:16px;line-height:24px}.size-4{font-size:20px;line-height:28px}.size-5{font-size:24px;line-height:32px}.size-6{font-size:30px;line-height:38px}.size-7{font-size:38px;line-height:46px}.size-8{font-size:46px;line-height:54px}.size-9{font-size:56px;line-height:64px}.weight-regular{font-weight:400}.weight-semibold{font-weight:500}.input-size-large{height:40px}.input-size-medium{height:32px}.input-size-small{height:24px}.resize-none textarea{resize:none}.resize-vertical textarea{resize:vertical}.resize-auto textarea{height:auto;resize:none}.textarea-size-large{padding:4px 0 0 4px;min-height:40px}.textarea-size-large .bcm-input-element{min-height:calc((40px - 8px) + 2px)}.textarea-size-large .input-clear-button{height:calc( 40px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-medium{padding:4px 0 0 4px;min-height:32px}.textarea-size-medium .bcm-input-element{min-height:calc((32px - 8px) + 2px)}.textarea-size-medium .input-clear-button{height:calc( 32px - 16px );top:8px;padding:0;margin-right:8px}.textarea-size-small{padding:0px 0 0 4px;min-height:24px}.textarea-size-small .bcm-input-element{min-height:calc((24px - 8px) + 2px)}.textarea-size-small .input-clear-button{height:calc( 24px - 16px );top:8px;padding:0;margin-right:8px}:host{display:inline-flex;width:100%;max-width:256px}:host(.full-width){max-width:100%}:host(.hidden){display:none}:host(.linked-component){display:none}";

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
    r = Reflect.decorate(decorators, target, key, desc);
  else
    for (var i = decorators.length - 1; i >= 0; i--)
      if (d = decorators[i])
        r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
const BcmTimePicker = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this._id = Generate.UID();
    this.time = new Date();
    this.value = undefined;
    this.hidden = false;
    this.name = undefined;
    this.fullWidth = false;
    this.required = false;
    this.label = undefined;
    this.placeholder = undefined;
    this.disabled = false;
    this.noMargin = false;
    this.noCaption = false;
    this.caption = '';
    this.captionError = undefined;
    this.captionType = 'default';
    this.alignment = undefined;
    this.placement = Bcm.Placement['bottom-start'];
    this.linkedComponent = undefined;
    this.clearable = false;
  }
  /**
   * @ComponentMethod
   */
  componentWillLoad() {
    if (typeof this.time === 'string') {
      const regTime = /\b([01][0-9]|2[0-3]):([0-5][0-9])\b/;
      const regTimeCheck = regTime.test(this.time);
      const timeSections = regTimeCheck ? this.time.split(':') : false;
      if (timeSections) {
        this.time = new Date(new Date().setHours(Number(timeSections[0]), Number(timeSections[1])));
      }
      else
        this.time = new Date();
    }
  }
  /**
   * @desc
   */
  handlePickerLoad() {
    this.value = this.picker.value;
  }
  /**
   * @desc
   * @param event
   */
  handlePickerChange(event) {
    this.value = event.detail;
  }
  /**
   * @desc
   * @param value
   */
  async set(value) {
    return this.picker.set(value);
  }
  async get() {
    var _a;
    return ((_a = this.value) === null || _a === void 0 ? void 0 : _a.timestamp) || null;
  }
  /**
   * @desc
   * @param disabled
   */
  async setDisabled(disabled) {
    this.disabled = disabled;
  }
  /**
   * @desc
   */
  async getInput() {
    return await this.picker.getInput();
  }
  /**
   * @desc
   */
  async getValue() {
    return this.value;
  }
  /**
   * @desc
   */
  async isValid() {
    return await this.picker.isValid();
  }
  async setClear() {
    await this.picker.setClear();
    await delay(10);
    return Promise.resolve();
  }
  async resetCaption() {
    await delay(10);
    await this.picker.resetCaption();
    this.captionType = 'default';
    this.captionError = null;
    await delay(10);
    return Promise.resolve();
  }
  /**
   * @desc
   */
  async open() {
    return await this.picker.open();
  }
  render() {
    const hostClasses = classnames(this.hidden ? 'hidden' : null, {
      'full-width': this.fullWidth
    });
    return (h(Host, { class: hostClasses }, h("bcm-datetime-picker", { "linked-component": this.linkedComponent, id: this._id, fullWidth: this.fullWidth, required: this.required, label: this.label, name: this.name, placeholder: this.placeholder, type: "time", clearable: this.clearable, date: this.time, ref: el => (this.picker = el), disabled: this.disabled, "on-bcm-load": () => this.handlePickerLoad(), "on-bcm-change": (e) => this.handlePickerChange(e), noCaption: this.noCaption, captionError: this.captionError, caption: this.caption, captionType: this.captionType, alignment: this.alignment, placement: this.placement, noMargin: this.noMargin })));
  }
  get el() { return getElement(this); }
};
__decorate([
  IsLoad()
], BcmTimePicker.prototype, "el", void 0);
BcmTimePicker.style = timePickerCss;

export { BcmTimePicker as bcm_time_picker };
