/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { g as getElement } from './index-0615c2b8.js';
import { s as snq } from './generate-d009624a.js';

function JsonParse(attribute, isMethod = false) {
  return (proto, propName) => {
    const { connectedCallback, componentWillRender } = proto;
    proto.connectedCallback = function () {
      const host = getElement(this);
      if (host[propName]) {
        const value = snq(() => host.hasAttribute(attribute) ? host.getAttribute(attribute).valueOf() : host[attribute].valueOf(), null);
        if (value) {
          this[propName] = snq(() => typeof value === 'string' ? JSON.parse(value) : value, []);
          host.removeAttribute(attribute);
        }
      }
      return connectedCallback && connectedCallback.call(this);
    };
    proto.componentWillRender = async function () {
      if (isMethod) {
        const host = getElement(this);
        if (isMethod) {
          const value = snq(() => host.hasAttribute(attribute) ? host.getAttribute(attribute).valueOf() : host[attribute].valueOf(), null);
          if (value && value.length > 0 && typeof value === 'string') {
            this[attribute] = snq(() => JSON.parse(value), []);
          }
          host.removeAttribute(attribute);
        }
        return componentWillRender && componentWillRender.call(this);
      }
    };
  };
}

export { JsonParse as J };
