/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { h } from './index-0615c2b8.js';
import { c as classnames } from './index-f549811f.js';
import { a as Bcm } from './bcm-a50d55ba.js';

const LabelTemplate = ({ required, value, size, form, htmlFor, type, tooltip }) => {
  size = size || "medium";
  type = type || Bcm.Status.default;
  return (h("label", { form: form, htmlFor: htmlFor, "aria-hidden": "true", class: classnames("bcm-ui-element bcm-ui-feedback bcm-label bcm-label__text tw-mb-1 tw-font-medium tw-text-slate-600 ", {
      "tw-text-1": size == "small",
      "tw-text-2": size == "medium",
      "tw-text-3": size == "large",
    }) },
    value,
    " ",
    required && "*",
    tooltip && (h("span", { class: "tw-ml-1" },
      h("bcm-tooltip", { message: tooltip, placement: "top", trigger: "hover" },
        h("bcm-icon", { icon: "fas fa-info-circle" }))))));
};

export { LabelTemplate as L };
