/*!
 * Built with Stencil
 * Copyright (c) Bromcom.
 */
import { s as snq } from './generate-d009624a.js';

class Validators {
}
Validators.compareTwoArrayIsSame = (arr1, arr2) => snq(() => arr1.length === arr2.length && arr1.every((v, i) => v === arr2[i]));
Validators.isEmailValid = (str) => /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(str);
Validators.isUrlValid = (str) => /^(?:(?:https?|ftp):\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})))(?::\d{2,5})?(?:\/\S*)?$/i.test(str);
Validators.isNumberValid = (str) => /^[+-]?\d+$/.test(str);
Validators.isNumberFloatValid = (str) => /^\d+(\.\d+)?$/.test(str);
Validators.isPhoneValid = (str) => /^(?=.*[0-9])[- +()0-9]+$/.test(str);
Validators.pattern = (str, pattern) => new RegExp(pattern).test(str);
Validators.isValidate = (str, type) => {
  switch (type) {
    case 'email':
      return Validators.isEmailValid(str);
    case 'url':
      return Validators.isUrlValid(str);
    case 'number':
      return Validators.isNumberValid(str) || Validators.isNumberFloatValid(str);
    case 'phone':
      return Validators.isPhoneValid(str);
    default:
      return true;
  }
};

export { Validators as V };
