import { EventEmitter, ComponentInterface } from '../../../stencil-public-runtime';
import { IndeterminateTypes, SizeTypes, StatusTypes } from "../../../models/bcm-types";
export declare class BcmCheckbox implements ComponentInterface {
  /**
   * Private variables
   */
  private inputElement;
  /**
   * Component Element
   */
  el: HTMLElement;
  /** Props **/
  _id: string;
  /**
   * Component Properties
   */
  inGroup: boolean;
  value: boolean;
  checked: boolean;
  name: string;
  disabled: boolean;
  hidden: boolean;
  required: boolean;
  label: string;
  readonly: boolean;
  size: SizeTypes;
  indeterminate: IndeterminateTypes;
  color: string;
  caption: string;
  noCaption: boolean;
  captionError: string;
  captionType: StatusTypes;
  captionCache: string;
  captionTypeCache: any;
  blur: EventEmitter;
  focus: EventEmitter;
  change: EventEmitter;
  changeCheckbox: EventEmitter;
  connectedCallback(): void;
  componentDidRender(): void | Promise<void>;
  onBcmFocus(): Promise<void>;
  onBcmBlur(): Promise<void>;
  setClear(): Promise<void>;
  resetCaption(): Promise<void>;
  handleChange(): void;
  watchIndeterminate(newValue: IndeterminateTypes, oldValue: IndeterminateTypes): void;
  set(data: any): Promise<void>;
  get(): Promise<boolean>;
  check(uncheck?: boolean): Promise<void>;
  handleKeyUp(ev: any): boolean;
  watchChecked(): void;
  setColor(color?: string): {
    [x: string]: string;
  };
  render(): any;
}
