import { EventEmitter, ComponentInterface } from '../../../stencil-public-runtime';
import { DirectionTypes, SizeTypes, StatusTypes } from '../../../models/bcm-types';
export declare class BcmCheckboxGroup implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  direction: DirectionTypes;
  items: Array<object> | string;
  indeterminate: boolean;
  name: string;
  value: any;
  disabled: boolean;
  readonly: boolean;
  hidden: boolean;
  required: boolean;
  label: string;
  gap: string;
  defaultValue: string;
  fullWidth: boolean | "flex";
  optionType: 'default' | 'button';
  buttonStyle: 'solid' | 'outline';
  size: SizeTypes;
  caption: string;
  noCaption: boolean;
  captionType: StatusTypes;
  tick: {};
  change: EventEmitter;
  groupCheckedList: EventEmitter;
  componentDidLoad(): void;
  disconnectedCallback(): void;
  componentShouldUpdate(newVal: any, oldVal: any, propName: string): boolean | void;
  private getOptions;
  private initState;
  markForCheck(): Promise<void>;
  onBcmFocus(): Promise<void>;
  onBcmBlur(): Promise<void>;
  setClear(): Promise<void>;
  resetCaption(): Promise<void>;
  set(data: any): Promise<void>;
  get(): Promise<string[]>;
  check(items: Array<object> | string, checked?: boolean, reset?: boolean): Promise<void>;
  getValue(name?: string): Promise<any>;
  getCheckedList(): Promise<any>;
  handleItemsChange(): void;
  getCheckboxes(): any[];
  getCheckbox(id: any): Promise<{
    element: Element;
    event: any;
  } | {
    element?: undefined;
    event?: undefined;
  }>;
  indeterminateClick(): Promise<void>;
  changeCheckBox(id: any): Promise<void>;
  getItems(): any;
  render(): any;
}
