import { ComponentInterface, EventEmitter } from '../../../stencil-public-runtime';
import { IconPositionTypes, KindTypes, PlacementTypes, SizeTypes } from '../../../models/bcm-types';
import { VariantProp } from '../../atoms/button/types';
export declare class BcmDropdown implements ComponentInterface {
  el: HTMLElement;
  isOpen: boolean;
  _id: string;
  menuId: string;
  hidden: boolean;
  type: 'dropdown' | 'split';
  size: SizeTypes;
  disabled: boolean;
  kind: KindTypes;
  icon: string;
  href: string;
  target: string;
  value: string;
  noStyle: boolean;
  dropdownIcon: string;
  linkedComponent: string;
  loading: boolean;
  variant: VariantProp;
  dataDismiss: boolean;
  fullWidth: boolean;
  iconPosition: IconPositionTypes;
  placement: PlacementTypes;
  height: any;
  maxHeight: string;
  minHeight: string;
  stopDeepClean: boolean;
  selectable: boolean;
  gap: string;
  color: any;
  activeItem: any;
  bcmClick: EventEmitter;
  bcmDropdownChange: EventEmitter;
  data: any;
  dataChanged(newValue: any): Promise<void>;
  setActive(id?: any): Promise<void>;
  getActive(): Promise<any>;
  handleSlotItems({ detail }: {
    detail: any;
  }): void;
  setActiveAttribute(e: any): void;
  render(): any;
}
