import { Bcm, SizeTypes, StatusTypes } from "../../../models";
import { ComponentInterface, EventEmitter } from "../../../stencil-public-runtime";
export declare class BcmInputDropdown implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  value: Bcm.InputDropdownData;
  defaultValue: Object;
  lateKeys: string;
  maxCharacterLimit: number;
  size: SizeTypes;
  label: string;
  placeholder: string;
  name: string;
  fullWidth: boolean;
  hideComment: boolean;
  hideCaption: boolean;
  disabled: boolean;
  required: boolean;
  readonly: boolean;
  data: Bcm.InputDropdownData[];
  caption: string;
  noCaption: boolean;
  captionType: StatusTypes;
  captionError: string;
  customErrorMessage: string;
  change: EventEmitter;
  onChangeDropdown: EventEmitter;
  captionCache: string;
  captionTypeCache: any;
  isOpenMenu: boolean;
  invalid: boolean;
  private _input;
  private get overlayContainer();
  private get menuContent();
  private get keys();
  private get isLate();
  componentWillLoad(): void;
  private get commentContent();
  clickListener(e: any): void;
  watchDefaultValueHandler(newValue: any): void;
  set(data: Bcm.InputDropdownData[]): Promise<void>;
  get(): Promise<Bcm.InputDropdownData>;
  setClear(): Promise<void>;
  resetCaption(): Promise<void>;
  private handleKeyPress;
  private onSelectItem;
  private handleInput;
  private onClickSave;
  private onClick;
  render(): any;
}
