import { EventEmitter, ComponentInterface } from '../../../stencil-public-runtime';
import { InputTypes, SizeTypes, StatusTypes } from '../../../models/bcm-types';
export declare class BcmInput implements ComponentInterface {
  inputElement: HTMLInputElement;
  /** Props **/
  _id: string;
  _internal_id: string;
  value: any;
  size: SizeTypes;
  label: string;
  pattern: string;
  tooltip: string;
  placeholder: string;
  disabled: boolean;
  readonly: boolean;
  clearable: boolean;
  autocomplete: boolean;
  name: string;
  type: InputTypes;
  hidden: boolean;
  required: boolean;
  fullWidth: boolean;
  noDefaultIcon: boolean;
  disableWatchValue: boolean;
  passwordToggle: boolean;
  maxLength: number;
  minLength: number;
  unitPrefix: string;
  unit: string;
  decimal: boolean;
  min: number;
  max: number;
  step: any;
  caption: string;
  noCaption: boolean;
  captionType: StatusTypes;
  captionError: string;
  customErrorMessage: string;
  _prefix: string;
  _suffix: string;
  captionCache: string;
  captionTypeCache: any;
  /** initial States **/
  inValid: boolean;
  valueCache: any;
  focused: boolean;
  isPasswordVisible: boolean;
  /** Events **/
  focus: EventEmitter;
  blur: EventEmitter;
  clear: EventEmitter;
  change: EventEmitter;
  input: EventEmitter;
  isBlur: boolean;
  connectedCallback(): void;
  componentWillRender(): void;
  onBcmFocus(): Promise<void>;
  onBcmBlur(): Promise<void>;
  onBcmSelect(): Promise<void>;
  set(data: any): Promise<void>;
  get(): Promise<any>;
  setValue(value: any): Promise<any>;
  setClear(): Promise<void>;
  resetCaption(): Promise<void>;
  getValue(): Promise<any>;
  watchValue(newValue: any): void;
  listenKeyDown(e: any): void;
  handleFocus(): void;
  handleBlur(): void;
  handleChange(): void;
  handleInput(): void;
  valueSync(): boolean;
  handleClear(e: MouseEvent): void;
  changePasswordVisibility(): void;
  setCaption(caption?: any, captionType?: any): void;
  stepUpOrDown(type: 'up' | 'down'): void;
  validationRange(): boolean;
  checkLength(): void;
  checkPattern(): void;
  checkValid(type: any): boolean;
  whatchHasFocus(): void;
  fixToNumber(val: any): any;
  eyeDropper(): void;
  isEyeDropperSupported(): boolean;
  toggleLinked(): void;
  render(): any;
}
