import { ComponentInterface, EventEmitter } from "../../../stencil-public-runtime";
import { InputTypes, SizeTypes, StatusTypes } from "../../../models/bcm-types";
export declare class BcmInput2 implements ComponentInterface {
  inputElement: HTMLInputElement;
  /** Props **/
  _id: string;
  _internal_id: string;
  value: any;
  size: SizeTypes;
  label: string;
  pattern: string;
  tooltip: string;
  placeholder: string;
  disabled: boolean;
  readonly: boolean;
  clearable: boolean;
  autocomplete: boolean;
  name: string;
  type: InputTypes;
  hidden: boolean;
  required: boolean;
  fullWidth: boolean;
  noDefaultIcon: boolean;
  disableWatchValue: boolean;
  passwordToggle: boolean;
  maxLength: number;
  minLength: number;
  unitPrefix: string;
  unit: string;
  decimal: boolean;
  min: number;
  max: number;
  step: any;
  caption: string;
  noCaption: boolean;
  captionType: StatusTypes;
  captionError: string;
  customErrorMessage: string;
  _prefix: string;
  _suffix: string;
  captionCache: string;
  captionTypeCache: any;
  /** initial States **/
  inValid: boolean;
  valueCache: any;
  focused: boolean;
  isPasswordVisible: boolean;
  /** Events **/
  focus: EventEmitter;
  blur: EventEmitter;
  clear: EventEmitter;
  change: EventEmitter;
  input: EventEmitter;
  onBcmFocus(): Promise<void>;
  onBcmBlur(): Promise<void>;
  onBcmSelect(): Promise<void>;
  handleClear(e: MouseEvent): void;
  handleInput(_e: Event): void;
  handleChange(_e: Event): void;
  handleFocus(e: Event): void;
  handleBlur(e: Event): void;
  handleKeyUp(e: KeyboardEvent): void;
  render(): any;
}
