import { SizeTypes, StatusTypes } from "../../../models";
import { ComponentInterface, EventEmitter } from "../../../stencil-public-runtime";
export declare class NumberInput implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  value?: number | string;
  defaultValue?: number | string;
  _prefix?: string;
  _suffix?: string;
  size?: SizeTypes;
  min?: number | string;
  max?: number | string;
  step?: number;
  label: string;
  name: string;
  fullWidth: boolean;
  clearable: boolean;
  /** Input states */
  readonly?: boolean;
  disabled?: boolean;
  required?: boolean;
  /** Number Input Props */
  mode: "strict" | "none";
  placeholder: string;
  thousandSeparator?: string | boolean;
  decimalSeparator?: string;
  decimalScale?: number;
  fixedDecimalScale?: boolean;
  allowNegative?: boolean;
  allowLeadingZeros?: boolean;
  unitPrefix?: string;
  unitSuffix?: string;
  /** Caption Props */
  caption: string;
  noCaption: boolean;
  captionType: StatusTypes;
  captionError: string;
  customErrorMessage: string;
  /** Events **/
  focus: EventEmitter;
  blur: EventEmitter;
  clear: EventEmitter;
  change: EventEmitter;
  input: EventEmitter;
  beforeClear: EventEmitter;
  _onChange: EventEmitter;
  /** initial States **/
  isFocus: boolean;
  captionCache: string;
  captionTypeCache: any;
  valueCache: any;
  private inputElement;
  private inValid;
  connectedCallback(): void;
  componentDidLoad(): void;
  private onInput;
  private onChange;
  private onFocus;
  private onBlur;
  private onKeydown;
  private listener;
  private up;
  private down;
  private handleClear;
  private checkLength;
  watchValue(): void;
  onBcmFocus(): Promise<void>;
  onBcmBlur(): Promise<void>;
  onBcmSelect(): Promise<void>;
  set(data: any): Promise<void>;
  get(): Promise<string | number>;
  setValue(value: any): Promise<void>;
  setClear(): Promise<void>;
  resetCaption(): Promise<void>;
  setCaption(caption?: any, captionType?: any): Promise<void>;
  disconnectedCallback(): void;
  render(): any;
}
