import { ComponentInterface, EventEmitter } from "../../../stencil-public-runtime";
import { DirectionTypes, SizeTypes, StatusTypes } from "../../../models";
export declare type OptionType = {
  id?: string;
  label: string;
  value: string | number;
  disabled?: boolean;
  checked?: boolean;
  color?: string;
};
export declare class BcmRadioGroup implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  label: string;
  name: string;
  value: string | number;
  defaultValue: string | number;
  size: SizeTypes;
  disabled: boolean;
  hidden: boolean;
  required: boolean;
  gap: string;
  direction: DirectionTypes;
  fullWidth: boolean;
  items: Array<object> | OptionType[] | string;
  caption: string;
  noCaption: boolean;
  captionError: string;
  captionType: StatusTypes;
  captionCache: string;
  captionTypeCache: any;
  change: EventEmitter;
  get radios(): HTMLBcmRadioElement[];
  get Items(): OptionType[];
  connectedCallback(): void;
  updateValue(): void;
  setRadioUpdate(): void;
  watchDisabled(newVal: boolean, _oldVal: boolean): void;
  watchDefaultValue(newVal: any, _oldVal: any): void;
  componentWillLoad(): void;
  handleChange(e: any): void;
  setClear(): Promise<void>;
  resetCaption(): Promise<void>;
  check(itemId: any, checked?: boolean): Promise<void>;
  get(): Promise<string | number>;
  set(data: any): Promise<void>;
  getValue(): Promise<string | number>;
  render(): any;
}
