import { EventEmitter } from '../../../stencil-public-runtime';
import { SizeTypes, StatusTypes } from '../../../models/bcm-types';
export declare class BcmSwitch {
  inputElement: HTMLInputElement;
  el: HTMLElement;
  /** Props **/
  _id: string;
  _internal_id: string;
  checked: boolean;
  hidden: boolean;
  value: boolean;
  name: string;
  disabled: boolean;
  required: boolean;
  size: SizeTypes;
  readonly: boolean;
  activeIcon: string;
  activeText: string;
  inactiveIcon: string;
  inactiveText: string;
  pending: boolean;
  label: string;
  labelPosition: 'top' | 'left' | 'right';
  tooltip: string;
  caption: string;
  noCaption: boolean;
  captionError: string;
  captionType: StatusTypes;
  captionCache: string;
  captionTypeCache: any;
  change: EventEmitter;
  focus: EventEmitter;
  blur: EventEmitter;
  connectedCallback(): void;
  handleChange(): void;
  componentWillRender(): void;
  onBcmFocus(): Promise<void>;
  onBcmBlur(): Promise<void>;
  set(data: any): Promise<void>;
  check(uncheck?: boolean): Promise<void>;
  get(): Promise<boolean>;
  setClear(): Promise<void>;
  resetCaption(): Promise<void>;
  handleKeyUp(ev: any): boolean;
  render(): any;
}
