import { EventEmitter, ComponentInterface } from '../../../stencil-public-runtime';
import { SizeTypes, StatusTypes } from '../../../models/bcm-types';
import { ResizeTypes } from './types';
export declare class BcmTextarea implements ComponentInterface {
  el: HTMLElement;
  /** Props **/
  _id: string;
  _internal_id: string;
  hidden: boolean;
  textarea: HTMLTextAreaElement;
  value: string;
  placeholder: string;
  label: string;
  name: string;
  required: boolean;
  caption: string;
  noCaption: boolean;
  captionError: string;
  captionType: StatusTypes;
  rows: number;
  size: SizeTypes;
  disabled: boolean;
  readonly: boolean;
  clearable: boolean;
  resize: ResizeTypes | any;
  fullWidth: boolean;
  maxLength: number;
  focused: boolean;
  captionCache: string;
  captionTypeCache: any;
  focus: EventEmitter;
  blur: EventEmitter;
  clear: EventEmitter;
  change: EventEmitter;
  input: EventEmitter;
  connectedCallback(): void;
  onBcmFocus(): Promise<void>;
  onBcmBlur(): Promise<void>;
  onBcmSelect(): Promise<void>;
  set(data: any): Promise<void>;
  get(): Promise<string>;
  setValue(value: any): Promise<any>;
  setClear(): Promise<void>;
  resetCaption(): Promise<void>;
  getValue(): Promise<string>;
  watchValue(newValue: any): void;
  handleFocus(): void;
  handleBlur(): void;
  handleChange(): void;
  handleInput(): void;
  handleClear(e: MouseEvent): void;
  render(): any;
}
