import { ComponentInterface } from '../../../stencil-public-runtime';
import { PlacementTypes } from '../../../models/bcm-types';
export declare class BcmDatePicker implements ComponentInterface {
  el: HTMLElement;
  private picker;
  _id: string;
  date: Date | string;
  value: any;
  endDate: Date | string;
  range: boolean;
  hidden: boolean;
  name: string;
  fullWidth: boolean;
  required: boolean;
  label: string;
  placeholder: string;
  disabledDates: any;
  disabled: boolean;
  noMargin: boolean;
  noCaption: boolean;
  caption: string;
  captionError: string;
  captionType: 'primary' | 'success' | 'warning' | 'error' | 'default';
  alignment: any;
  _internal_id: string;
  placement: PlacementTypes;
  linkedComponent: string;
  clearable: boolean;
  stateStartDate: any;
  stateEndDate: any;
  handleStartDateChange(): void;
  handleEndDateChange(): void;
  /**
   * @desc
   */
  handlePickerLoad(): void;
  /**
   * @desc
   * @param event
   */
  handlePickerChange(event: CustomEvent): void;
  /**
   * @desc
   * @param value
   */
  set(value: any): Promise<void>;
  get(): Promise<any>;
  /**
   * @desc
   * @param disabled
   */
  setDisabled(disabled: boolean): Promise<void>;
  setClear(): Promise<void>;
  setStartDate(dateOrTime: any): Promise<void>;
  setEndDate(dateOrTime: any): Promise<void>;
  handleDate(): void;
  /**
   * @desc
   */
  getInput(): Promise<HTMLBcmOldInputElement>;
  /**
   * @desc
   */
  open(): Promise<void>;
  /**
   * @desc
   */
  getValue(): Promise<any>;
  /**
   * @desc
   */
  isValid(): Promise<{
    valid: boolean;
    error: boolean;
    errorText: string;
  }>;
  resetCaption(): Promise<void>;
  render(): any;
}
