import { Bcm, ListTypes, PlacementTypes, SizeTypes, StatusTypes } from "../../../models";
import { ComponentInterface, EventEmitter } from "../../../stencil-public-runtime";
export declare class BcmList implements ComponentInterface {
  private debounce;
  el: HTMLElement;
  _id: string;
  tempId: string;
  type: ListTypes;
  treeview: boolean;
  checkboxes: boolean;
  searchable: boolean;
  value: any;
  inputText: string;
  name: string;
  label: string;
  size: SizeTypes;
  disabled: boolean;
  readonly: boolean;
  highlight: boolean;
  highlightText: any;
  required: boolean;
  hidden: boolean;
  fullWidth: boolean;
  height: string;
  maxHeight: string;
  minHeight: string;
  width: string;
  tooltip: string;
  infoFooter: boolean;
  variableText: string;
  template: string;
  allOpen: boolean;
  keyControl: boolean;
  checkAll: boolean;
  stopDeepClean: boolean;
  openIntersecting: boolean;
  linkedComponent: string;
  isOpen: boolean;
  isOpenAnimation: boolean;
  calculatedViewport: boolean;
  isSelectedOther: boolean;
  isHaveOtherTag: boolean;
  placeholder: string;
  searchPlaceholder: string;
  searchIsOnlyChilds: boolean;
  minSearchLength: number;
  clearable: boolean;
  caption: string;
  noCaption: boolean;
  captionType: StatusTypes;
  captionError: string;
  emptyText: string;
  emptyIcon: string;
  captionCache: string;
  captionTypeCache: any;
  tick: {};
  totalData: any;
  totalRootData: any;
  limit: number;
  searchGetParents: any;
  searchResultLimit: number;
  searchFound: any;
  returnFilterData: {};
  returnOtherData: {};
  options: {
    rootMargin: string;
  };
  tagContainerWidth: number;
  selectAllItem: {
    id: string;
    text: string;
    value: string;
    checked: boolean;
    disabled: boolean;
    icon: string;
    status: Bcm.Status;
    indeterminate: string;
  };
  shouldTriggerChange: any;
  placement: PlacementTypes;
  bcmChecklist: EventEmitter;
  bcmSelected: EventEmitter;
  change: EventEmitter;
  open: EventEmitter;
  close: EventEmitter;
  listClose: EventEmitter;
  listOpen: EventEmitter;
  disableChangeEvent: boolean;
  data: any;
  constructor();
  debounceHandler: () => void;
  connectedCallback(): void;
  componentWillRender(): void | Promise<void>;
  componentShouldUpdate(newVal: any, oldVal: any, propName: string): boolean | void;
  private get containerWidth();
  private get tagCount();
  private get tagData();
  componentDidLoad(): Promise<void>;
  disconnectedCallback(): void;
  watchId(_: any, oldVal: string): void;
  handleValueChange(newVal: any, oldVal: any): void;
  watchReturnFilterData(newVal: any): void;
  handleOpen(): Promise<void>;
  listScrollToTop(): void;
  dataChanged(newValue: any, oldValue: any): Promise<void>;
  isIntersecting(e: CustomEvent): void;
  handleSlotItems(e: CustomEvent): void;
  handleChange(e: any): void;
  handleResize(): void;
  handleWheel(event: WheelEvent): void;
  private clearAutocomplete;
  handleSelectOtherTag(e: CustomEvent): Promise<void>;
  handleDeleteTag(e: CustomEvent): Promise<void>;
  handleSelectTag(_: CustomEvent): Promise<void>;
  handleClick(event: any): void;
  bcmOnSearchClear(event: any): void;
  bcmOnSearch(event: any): void;
  handleKeyDown(ev: any): void;
  handleKeyUp(ev: any): void;
  set(data: any, trigger?: boolean): Promise<void>;
  get(): Promise<any>;
  getCheckedList(): Promise<{
    checkedList: any[];
    nestedResult: any[];
  }>;
  getSelected(): Promise<any>;
  getValue(): Promise<any>;
  triggerChange(action: boolean): Promise<void>;
  addChecked(ids?: any[], save?: boolean, emit?: boolean): Promise<any>;
  selected(id: any): Promise<any>;
  setClear(e?: any): Promise<void>;
  resetCaption(): Promise<void>;
  private detectClone;
  show(): Promise<void>;
  hide(): Promise<void>;
  private updateOptions;
  private handleIndeterminate;
  private listenResize;
  private unSelectOther;
  private onClearSearch;
  private onSelectSearch;
  private filterOtherList;
  private initState;
  private markForCheck;
  private getOptions;
  private getItems;
  private getLimitedItems;
  private openGroup;
  private focusItem;
  private selectedItem;
  private checkedItem;
  private changeVisibleCheckeds;
  private getAutoCompleteInput;
  private dataScrollEvent;
  private calculateLocation;
  handleTransitionEnd(e: any): void;
  render(): any;
}
