import { PlacementTypes } from '../../../models/bcm-types';
export declare class BcmTimePicker {
  el: HTMLElement;
  private picker;
  _id: string;
  time: Date | string;
  value: any;
  hidden: boolean;
  name: string;
  fullWidth: boolean;
  required: boolean;
  label: string;
  placeholder: string;
  disabled: boolean;
  noMargin: boolean;
  noCaption: boolean;
  caption: string;
  captionError: string;
  captionType: 'primary' | 'success' | 'warning' | 'error' | 'default';
  alignment: any;
  placement: PlacementTypes;
  linkedComponent: string;
  clearable: boolean;
  /**
   * @ComponentMethod
   */
  componentWillLoad(): void;
  /**
   * @desc
   */
  handlePickerLoad(): void;
  /**
   * @desc
   * @param event
   */
  handlePickerChange(event: CustomEvent): void;
  /**
   * @desc
   * @param value
   */
  set(value: string): Promise<void>;
  get(): Promise<any>;
  /**
   * @desc
   * @param disabled
   */
  setDisabled(disabled: boolean): Promise<void>;
  /**
   * @desc
   */
  getInput(): Promise<HTMLBcmOldInputElement>;
  /**
   * @desc
   */
  getValue(): Promise<any>;
  /**
   * @desc
   */
  isValid(): Promise<{
    valid: boolean;
    error: boolean;
    errorText: string;
  }>;
  setClear(): Promise<void>;
  resetCaption(): Promise<void>;
  /**
   * @desc
   */
  open(): Promise<void>;
  render(): any;
}
