import { EventEmitter } from '../../../stencil-public-runtime';
export declare class BcmColorPicker {
  private initialized;
  private setColorBeforeInitialized;
  private inputElement;
  private colorDragger;
  private colorElement;
  private colorIndicatorElement;
  private colorsDragger;
  private colorsElement;
  private colorsIndicatorElement;
  el: HTMLElement;
  /**
   * Component Properties
   */
  _color: string;
  open: boolean;
  value: string;
  label: string;
  size: 'small' | 'medium' | 'large';
  noCaption: boolean;
  caption: string;
  captionError: string;
  captionType: 'primary' | 'success' | 'warning' | 'error' | 'default';
  fullWidth: boolean;
  disabled: boolean;
  hidden: boolean;
  required: boolean;
  tooltip: string;
  /**
   * Component States
   */
  h: number;
  s: number;
  v: number;
  a: number;
  selectedH: number;
  selectedS: number;
  selectedV: number;
  selectedA: number;
  color: {
    rgba: string;
    hex: string;
  };
  inputValue: string;
  mouseState: 'up' | 'down';
  /**
   * Component Events
   */
  change: EventEmitter;
  /**
   * @ComponentMethod
   */
  componentWillLoad(): void;
  /**
   * @ComponentMethod
   */
  componentDidRender(): void;
  /**
   * @desc
   */
  initColorDragger(): Promise<void>;
  /**
   * @desc
   */
  initColorsDragger(): Promise<void>;
  /**
   * @desc
   */
  initTransparencyDragger(): void;
  /**
   * @desc
   * @param hsv
   */
  hsvtorgb(hsv: any): {
    hex: string;
    r: number;
    g: number;
    b: number;
  };
  /**
   * @desc
   * @param rgb
   */
  rgbtohsv(rgb: {
    r: number;
    g: number;
    b: number;
  }): {
    h: number;
    s: number;
    v: number;
  };
  /**
   * @desc
   * @param hex
   */
  hextohsv(hex: string): {
    h: number;
    s: number;
    v: number;
  };
  /**
   * @desc
   * @param hex
   */
  hextorgb(hex: string): {
    r: number;
    g: number;
    b: number;
  };
  /**
   * @desc
   * @param pos
   */
  colorDrag(pos: any): void;
  /**
   * @desc
   * @param pos
   */
  colorsDrag(pos: any): void;
  /**
   * @desc
   * @param pos
   */
  /**
   * @desc
   */
  setHsvColor(): {
    rgba: string;
    hex: string;
  };
  /**
   * @desc
   * @param hexColor
   */
  _setColor(color: string, preventInputUpdate?: boolean): void;
  /**
   * @desc
   */
  updateIndicators(): void;
  /**
   * @desc
   * @param preventInputUpdate
   */
  updateValue(preventInputUpdate?: boolean): void;
  /**
   * @desc
   * @param value
   */
  updateInputValue(value: string): void;
  /**
   * @desc
   */
  /**
   * @desc
   */
  handleClick(): void;
  /**
   * @desc
   * @param event
   */
  handleColorInputKeyUp(event: any): void;
  /**
   * @desc
   * @param event
   */
  handleWindowClick(event: any): void;
  /**
   * @desc
   */
  valueChange(): void;
  getValue(): Promise<string>;
  setColor(color: string): Promise<void>;
  render(): any;
}
