import { EventEmitter } from '../../../stencil-public-runtime';
import { SizeProp } from './types';
export declare class BcmListboxItem {
  objectMapping: object;
  el: HTMLElement;
  display: boolean;
  avatar: boolean;
  avatarImage: string;
  avatarName: string;
  secondaryText: string;
  tooltipText: string;
  text: string;
  _id: string;
  size: SizeProp;
  icon: string;
  open: boolean;
  selected: boolean;
  checkboxes: boolean;
  showIcon: boolean;
  checked: boolean;
  focused: boolean;
  hidden: boolean;
  itemObject: string;
  disabled: boolean;
  highlight: boolean | string;
  _internal_id: string;
  template: string;
  /**
   * Component Events
   */
  listboxItemSelected: EventEmitter;
  listboxUnchecked: EventEmitter;
  listboxChecked: EventEmitter;
  componentDidLoad(): void;
  /**
   * @desc
   */
  handleClick(): void;
  handleCheckboxClick(e: any): void;
  isInternal(event: any): boolean;
  /**
   * @descc
   * @param event
   */
  ListenListboxCheck(event: any): void;
  /**
   * @descc
   * @param event
   */
  ListenListboxUncheck(event: any): void;
  /**
   * @descc
   * @param event
   */
  handleListboxClearSelecteds(event: any): void;
  templateParser(template: any): any;
  render(): any;
}
