import { EventEmitter } from '../../../stencil-public-runtime';
import { SizeProp } from './types';
export declare class BcmListbox {
  el: HTMLElement;
  objectMapping: object;
  checkedObjectList: Array<object>;
  cacheCheckedObjectList: Array<object>;
  allChilds: any;
  onlyChilds: any;
  firstRun: boolean;
  firstCheck: boolean;
  onFocus: boolean;
  isSetData: boolean;
  isGroupArray: Array<Number>;
  intersection: Array<Number>;
  /**
   * Component Properties
   */
  innerComponent: boolean;
  checkboxes: boolean;
  label: string;
  required: boolean;
  value: any;
  search: boolean;
  infoFooter: boolean;
  showIcon: boolean;
  size: SizeProp;
  selectedId: string;
  checkedList: Array<any>;
  updateCheckedList: Array<any>;
  _items: Array<object> | string;
  fullWidth: boolean;
  searchFields: Array<string>;
  _flex: string;
  hidden: boolean;
  returnField: string;
  searchSub: string;
  searchText: string;
  treeview: boolean;
  searchPlaceholder: string;
  numberOfColumns: number;
  height: string;
  maxHeight: string;
  template: string;
  highlight: boolean;
  loading: boolean;
  noCaption: boolean;
  caption: string;
  captionError: string;
  captionType: 'primary' | 'success' | 'warning' | 'error' | 'default';
  _internal_id: string;
  tooltip: string;
  /**
   * Component States
   */
  searchResults: any;
  private totalSearch;
  showSearch: boolean;
  empty: boolean;
  runClearAndSelect: boolean;
  total: number;
  items: Array<object>;
  checklist: Array<number>;
  sortedChecklist: Array<number>;
  indeterminateState: 'uncheck' | 'indeterminate' | 'determinate';
  checked: boolean;
  jsonItem: any;
  searchData: any;
  captionCache: string;
  captionTypeCache: any;
  checklistSorted: Array<number>;
  /**
   * Component Events
   */
  listboxItemSelected: EventEmitter;
  listboxClearSelected: EventEmitter;
  listboxSendCheck: EventEmitter;
  listboxSendUncheck: EventEmitter;
  listboxChecklist: EventEmitter;
  listboxChange: EventEmitter;
  listboxChecked: EventEmitter;
  change: EventEmitter;
  setClear(): Promise<void>;
  resetCaption(): Promise<void>;
  connectedCallback(): void;
  getValue(): Promise<any>;
  getChecklist(): Promise<object[]>;
  showSearchMethod(val?: boolean): Promise<void>;
  selected(id: any): Promise<void>;
  clearAndSelectSearch(select?: boolean): Promise<void>;
  addChecked(items: any): Promise<void>;
  updateChecked(items: any): Promise<void>;
  config(_config: Array<object>): Promise<boolean>;
  setData(_data?: Array<object> | string): Promise<void>;
  componentWillRender(): void;
  componentDidRender(): void;
  /**
   * @desc
   * @returns {void}
   */
  setIndeterminateState(): void;
  getAllGroup(element?: HTMLElement, onlyItem?: boolean): any;
  getAllChilds(element?: HTMLElement, type?: string): any;
  /**
   * @desc
   */
  handleCheckList(process: string, checkId: any): void;
  handleIndeterminateClick(): void;
  handleCheckboxClick(e: any): void;
  /**
   * @desc
   * @param item
   */
  itemRenderer(item: any): any;
  /**
   * @desc
   * @param group
   */
  recursiveGroupRenderer(group: any): any;
  searchResultMethod(items?: any[]): Promise<void>;
  handleListboxSelected(event: any): void;
  /**
   * @desc
   */
  isLoading(val: any): void;
  isEmpty(val: any): void;
  isSearchCount(val?: any): void;
  listenSearchResult(event: any): void;
  /**
   * @desc
   * @param newValue
   * @returns {void}
   */
  parseItems(newValue: Array<object> | string): void;
  handleChange(newValue: string): void;
  handleChildProcess(): void;
  /**
   * @desc
   */
  handleListboxClearSelected(event: any): void;
  /**
   * @desc
   */
  handleListboxChecked(event: any, _internal_id?: string): void;
  /**
   * @desc
   */
  handleListboxUnchecked(event: any, _internal_id?: string): void;
  listboxUncheckedMethod(item: any, internal_id?: string): Promise<void>;
  handleFocus(focusEvent?: boolean): void;
  render(): any;
}
