import { EventEmitter } from '../../../stencil-public-runtime';
import { PlacementTypes } from '../../../models/bcm-types';
export declare class BcmSelect {
  el: HTMLElement;
  isRendered: boolean;
  cleaned: boolean;
  objectMapping: object;
  bcmListbox: any;
  firstRun: boolean;
  currentItemWidth: number;
  otherTagsWidth: number;
  areaWidth: number;
  otherTag: any;
  cacheChange: any;
  itemsWidth: any | Array<any>;
  itemsWidthArray: any | Array<any>;
  checklist: Array<any>;
  pastItem: Array<any>;
  _id: string;
  value: string;
  value2: string;
  size: 'small' | 'medium' | 'large';
  scrollable: 'none' | 'vertical' | 'horizontal' | 'both';
  clearable: boolean;
  label: string;
  placeholder: string;
  search: boolean;
  noCaption: boolean;
  caption: string;
  captionError: string;
  captionType: 'primary' | 'success' | 'warning' | 'error' | 'default';
  disabled: boolean;
  flex: boolean;
  name: string;
  searchFields: Array<string>;
  fullWidth: boolean;
  defaultValue: string;
  hidden: boolean;
  checkboxes: boolean;
  searchable: boolean;
  required: boolean;
  treeview: boolean;
  numberOfColumns: number;
  viewportWidth: string;
  viewportMinWidth: string;
  viewportMaxWidth: string;
  template: string;
  maxHeight: string;
  infoFooter: boolean;
  _internal_id: string;
  alignment: 'left' | 'right' | 'default';
  _items: any;
  _data: any;
  placement: PlacementTypes;
  tooltip: string;
  otherTagStatus: boolean;
  _config: any;
  firstSetData: boolean;
  visibleTags: any[];
  hiddenTags: any[];
  onShowVisibleTags: any[];
  onShowHiddenTags: any[];
  hiddenTagsString: string;
  clientWidth: number;
  tagLabel: Array<object>;
  selectText: string;
  isOpen: boolean;
  searchData: any;
  searchResults: any;
  optionViewportStyleAlignment: {};
  captionCache: string;
  captionTypeCache: any;
  change: EventEmitter;
  clear: EventEmitter;
  focus: EventEmitter;
  blur: EventEmitter;
  listboxUnchecked: EventEmitter;
  listboxSendCheck: EventEmitter;
  componentWillLoad(): Promise<void>;
  disconnectedCallback(): void;
  componentWillRender(): void;
  config(_config: Array<object>): Promise<void>;
  renderListbox(): Promise<any>;
  setData(_data?: Array<object> | string): Promise<void>;
  setDataAsync(_data?: Array<object> | string): Promise<void>;
  clearAndSelectSearch(select?: boolean): Promise<void>;
  selected(id: any): Promise<void>;
  addChecked(id?: any[]): Promise<void>;
  updateChecked(id?: any[]): Promise<void>;
  getValue(): Promise<string>;
  getChecklist(): Promise<any[]>;
  get(): Promise<string | any[]>;
  set(data: any): Promise<void>;
  setClear(): Promise<void>;
  resetCaption(): Promise<void>;
  connectedCallback(): void;
  handleChange(newValue: string, oldValue: string): void;
  handleOpenState(): Promise<void>;
  handleOpen(event: any, otherTag?: boolean): Promise<void>;
  onwheelEvent(event: any): void;
  scrollEvent(event: any): Promise<void>;
  viewportCoordinateUpdater(): void;
  createElement(isOpen?: boolean): Promise<void>;
  getPlacement(): string[];
  clickClear(e: MouseEvent): void;
  handleClear(): Promise<void>;
  handleFocus(): void;
  handleBlur(): void;
  handleScreenResize(): void;
  handleClickOutside(event: any): void;
  /**
   * @desc
   */
  handleTreeviewUnchecked(event: any): void;
  handleListboxUnchecked(event: any): void;
  bcmOldTagDissmisable(event: any, internal_id?: any): Promise<void>;
  /**
   * @desc
   */
  handleListboxSelected(event: any): void;
  /**
   * @desc
   */
  handleListboxCheckedList(event: any): void;
  handleTreeviewCheckedList(event: any): void;
  handleTagControl2(value: any): Promise<void>;
  calculateContainer(): Promise<void>;
  handleTagControl(value: any): Promise<void>;
  handleClickTag(): void;
  showHiddenTags(e: any): void;
  watchSearchResults(): Promise<void>;
  render(): any;
}
