import { EventEmitter } from '../../../stencil-public-runtime';
import { buttonStateProp, DirectionProp, SizeProp, TypeProp } from './types';
export declare class BcmTabs {
  /**
   * Component Private variables
   */
  private tabs;
  private firstInit;
  private count;
  /**
   * Component Element
   */
  el: HTMLElement;
  /**
   * Component Properties
   */
  size: SizeProp;
  type: TypeProp;
  direction: DirectionProp;
  hidden: boolean;
  fullWidth: boolean;
  underline: boolean;
  /**
   * Component States
   */
  activeChild: number;
  lineOpts: {
    top: string;
    left: string;
    right: string;
    width: string;
    height: string;
  };
  prevButton: Element;
  nextButton: Element;
  completeButton: Element;
  prevButtonState: buttonStateProp;
  nextButtonState: buttonStateProp;
  completeButtonState: buttonStateProp;
  /**
   * Component Events
   */
  click: EventEmitter;
  change: EventEmitter;
  bcmTabsActiveItem: EventEmitter;
  config(_config: Array<object>): Promise<boolean>;
  next(): Promise<any>;
  prev(): Promise<number>;
  complete(): Promise<{
    isValid: Boolean;
    Forms: any[];
  }>;
  active(id: any): Promise<void>;
  getActiveTab(): Promise<any>;
  getActiveIndex(): Promise<number>;
  error(id: any, blink?: boolean): Promise<void>;
  info(id: any, blink?: boolean): Promise<void>;
  warning(id: any, blink?: boolean): Promise<void>;
  success(id: any, blink?: boolean): Promise<void>;
  statusReset(id: any): Promise<void>;
  buttonControl(): void;
  /**
   * @ComponentMethod
   */
  componentDidRender(): void;
  componentDidLoad(): void;
  getActive(): number;
  /**
   * @desc
   */
  getChildIdx(child: HTMLElement): number;
  /**
   * @desc
   * @param idx
   */
  activateChild(idx: number): void;
  /**
   * @desc
   * @param idx
   */
  transformLine(idx: number): void;
  /**
   * @desc
   */
  getLineTransform(): {
    '--bcm-tabs-line-top': string;
    '--bcm-tabs-line-left': string;
    '--bcm-tabs-line-width': string;
    '--bcm-tabs-line-right': string;
    '--bcm-tabs-line-height': string;
  };
  /**
   * @desc
   * @param event
   */
  handleTabClick(event: MouseEvent): void;
  /**
   * @desc
   * @param event
   */
  handleTabClose(event: MouseEvent): void;
  /**
   * @desc
   * @param newValue
   */
  activeChildChange(newValue: number): void;
  /**
   * @desc
   */
  windowResize(): void;
  render(): any;
}
