import { EventEmitter } from '../../../stencil-public-runtime';
import { SizeProp } from './types';
export declare class BcmtreeviewItem {
  firstRun: boolean;
  el: HTMLElement;
  items: any;
  itemObject: string;
  text: string;
  tooltipText: string;
  _id: string;
  parentId: string;
  hasChild: boolean;
  size: SizeProp;
  icon: string;
  open: boolean;
  selected: boolean;
  checkboxes: boolean;
  showIcon: boolean;
  favicon: boolean;
  favorite: boolean;
  checked: boolean;
  checkTrigger: boolean;
  focused: boolean;
  disabled: boolean;
  contextMenuShow: boolean;
  _contextMenu: Array<object> | string;
  indeterminateState: 'uncheck' | 'indeterminate' | 'determinate';
  _internal_id: string;
  menuPadding: number;
  childLength: number;
  indeterminate: boolean;
  hidden: boolean;
  contextMenu: Array<object>;
  contextOffsetLeft: number;
  contextOffsetTop: number;
  /**
   * Component Events
   */
  treeviewItemSelected: EventEmitter;
  treeviewUnchecked: EventEmitter;
  treeviewChecked: EventEmitter;
  treeviewChange: EventEmitter;
  treeviewIndeterminateUnchecked: EventEmitter;
  treeviewIndeterminateChecked: EventEmitter;
  itemChecked: EventEmitter;
  itemUnchecked: EventEmitter;
  groupCheck: EventEmitter;
  favoriteStatus: EventEmitter;
  /**
   * @ComponentMethod
   */
  componentWillLoad(): void;
  /**
   * @ComponentMethod
   */
  componentDidLoad(): void;
  /**
   * @desc
   * @returns {void}
   */
  /**
   * @descc
   * @param event
   */
  handletreeviewClearSelecteds(event: any): void;
  /**
   * @descc
   * @param event
   */
  ListentreeviewChange(): void;
  /**
   * @descc
   * @param event
   */
  ListentreeviewShowContext(event: any): void;
  /**
   * @desc
   * @param event
   */
  handleWindowClick(event: any): void;
  /**
   * @desc
   */
  handleClick(): void;
  /**
   * @desc
   */
  handleFavClick(e: Event): void;
  /**
   * @desc
   */
  handleOpen(): void;
  getRootChilds(element?: HTMLElement): any[];
  getAllChilds(element?: HTMLElement): any;
  /**
   * @desc
   * -
   */
  checkGroupState(): void;
  /**
   * @Event
   * @desc
   * -
   */
  handleCheckMouseUp(): void;
  checkGroup(e: CustomEvent): void;
  /**
   * @desc
   * @param item
   */
  contextItemRenderer(item: any): any;
  /**
   * @desc
   * @param newValue
   * @returns {void}
   */
  parseItems(newValue: Array<object> | string): void;
  render(): any;
}
