import { EventEmitter } from '../../../stencil-public-runtime';
import { SizeProp } from './types';
export declare class Bcmtreeview {
  el: HTMLElement;
  objectMapping: object;
  checkedObjectList: Array<object>;
  allChilds: any;
  onFocus: boolean;
  minHeight: number;
  minWidth: number;
  allOpenCache: boolean;
  allOpenOnSearch: boolean;
  parentLength: Array<object>;
  isSetData: boolean;
  runClearAndSelect: boolean;
  checkboxes: boolean;
  showIcon: boolean;
  size: SizeProp;
  selectedId: string;
  checkedList: Array<any>;
  updateCheckedList: Array<any>;
  hidden: boolean;
  search: boolean;
  searchOnlyChild: boolean;
  keydown: boolean;
  allOpen: boolean;
  fullWidth: boolean;
  infoFooter: boolean;
  searchFields: Array<string>;
  searchSub: string;
  returnField: string;
  _items: Array<object> | string;
  searchPlaceholder: string;
  maxHeight: string;
  highlight: boolean;
  loading: boolean;
  favIcon: boolean;
  favIconOnlyChilds: boolean;
  _internal_id: string;
  /**
   * Component States
   */
  empty: boolean;
  showSearch: boolean;
  items: Array<object>;
  total: number;
  checkCount: number;
  focusedElement: any;
  keyMapForFocus: {
    18: boolean;
    87: boolean;
  };
  checklist: Array<number>;
  favoriteList: Array<number>;
  checklistSorted: Array<number>;
  searchData: any;
  searchResults: any[];
  /**
   * Component Events
   */
  treeviewChange: EventEmitter;
  treeviewSendCheck: EventEmitter;
  treeviewSendUncheck: EventEmitter;
  treeviewChecklist: EventEmitter;
  treeviewItemSelected: EventEmitter;
  treeviewClearSelecteds: EventEmitter;
  treeviewShowContext: EventEmitter;
  treeviewUnchecked: EventEmitter;
  treeviewChecked: EventEmitter;
  setData(_data?: Array<object> | string): Promise<boolean>;
  getChecklist(): Promise<object[]>;
  getFavorites(): Promise<number[]>;
  selected(id: any): Promise<void>;
  clearAndSelectSearch(select?: boolean): Promise<void>;
  addChecked(items?: any[]): Promise<void>;
  updateChecked(items?: any[]): Promise<void>;
  config(_config: Array<object>): Promise<boolean>;
  calculateMinSizes(): void;
  connectedCallback(): void;
  componentWillLoad(): void;
  componentWillRender(): void;
  componentDidRender(): void;
  componentWillUpdate(): void;
  componentDidUpdate(): void;
  parseItems(newValue: Array<object> | string): void;
  handleChildProcess(): void;
  /**
   * @desc
   * @param group
   */
  recursiveItemRenderer(group: any, parentGroup: any): any;
  /**
   * @desc
   */
  handleCheckList(process: string, checkId: any): void;
  showSearchMethod(val?: boolean): Promise<void>;
  searchResultMethod(items?: any): Promise<void>;
  isLoading(val: any): boolean;
  isEmpty(val: any): void;
  isSearchCount(val?: any): void;
  listenSearchResult(e: any): void;
  getAllChilds(element?: HTMLElement): any;
  /**
   * @desc
   */
  handletreeviewItemSelected(event: any): void;
  /**
   * @desc
   */
  handletreeviewChecked(event: any): void;
  /**
   * @desc
   */
  /**
   * @desc
   */
  handletreeviewUnchecked(event: any): void;
  /**
   * @desc
   */
  handletreeviewIndeterminateChecked(event: any): void;
  /**
   * @desc
   */
  handletreeviewIndeterminateUnchecked(event: any): void;
  treeviewUncheckedMethod(item: any): Promise<boolean>;
  /**
   * @desc
   * Keyboard Navigation
   */
  getIndex(item: any): number;
  /**
   * @desc
   * Keyboard Navigation
   */
  getNext(item: any): any;
  /**
   * @desc
   * Keyboard Navigation
   */
  getPrev(item: any): any;
  /**
   * @desc
   * Keyboard Navigation
   */
  getParent(item: any): any;
  /**
   * @desc
   * Keyboard Navigation
   */
  getNextParent(item: any): any;
  /**
   * @desc
   * Keyboard Navigation
   */
  getFirstItem(el?: HTMLElement): any;
  /**
   * @desc
   * Keyboard Navigation
   */
  getLastItem(el?: HTMLElement): any;
  /**
   * @desc
   * Keyboard Navigation
   */
  getChildItem(element?: HTMLElement): any;
  /**
   * @desc
   */
  handleRightClick(e: any): void;
  /**
   * @desc
   */
  keyboardNavigationUp(e: any): void;
  /**
   * @desc
   */
  keyboardNavigation(e: any): void;
  handleFocus(focusEvent?: boolean): void;
  render(): any;
}
