import { SizeTypes, StatusTypes } from "../../../models";
import { ComponentInterface, EventEmitter } from "../../../stencil-public-runtime";
export declare class BcmDate implements ComponentInterface {
  el: HTMLElement;
  _id: string;
  label: string;
  placeholder: string;
  size: SizeTypes;
  fullWidth: boolean;
  required: boolean;
  clearable: boolean;
  disabled: boolean;
  noMargin: boolean;
  caption: string;
  noCaption: boolean;
  captionType: StatusTypes;
  captionError: string;
  name: string;
  value: any;
  type: "time" | "date" | "week" | "month" | "year" | "datetime";
  format: any;
  range: boolean;
  showTime: boolean;
  showNow: boolean;
  showHour: boolean;
  showMinute: boolean;
  showSecond: boolean;
  use12Hours: boolean;
  hourStep: number;
  minuteStep: number;
  secondStep: number;
  hideDisabledOptions: boolean;
  disabledTime: any;
  showToday: boolean;
  disabledDates: any;
  change: EventEmitter;
  onChange: (e: any) => void;
  getFormat: () => any;
  getValueObject: (value: any) => {
    time: string;
    timeObject: {
      hour: number;
      minute: number;
      second: number;
    };
    isValid: boolean;
    date: Date;
    timestamp: number;
    dateObject: {
      year: number;
      day: number;
      month: number;
      dayOfWeek: number;
      monthFirstDay: number;
    };
    value: string;
  } | {
    time: string;
    isValid: boolean;
    start: {
      time: string;
      timeObject: {
        hour: number;
        minute: number;
        second: number;
      };
      isValid: boolean;
      date: Date;
      timestamp: number;
      dateObject: {
        year: number;
        day: number;
        month: number;
        dayOfWeek: number;
        monthFirstDay: number;
      };
      value: string;
    };
    end: {
      time: string;
      timeObject: {
        hour: number;
        minute: number;
        second: number;
      };
      isValid: boolean;
      date: Date;
      timestamp: number;
      dateObject: {
        year: number;
        day: number;
        month: number;
        dayOfWeek: number;
        monthFirstDay: number;
      };
      value: string;
    };
    date: Date[];
    timestamp: number[];
    value: string;
  };
  getRangeValueObject: (value: any) => {
    time: string;
    isValid: boolean;
    start: {
      time: string;
      timeObject: {
        hour: number;
        minute: number;
        second: number;
      };
      isValid: boolean;
      date: Date;
      timestamp: number;
      dateObject: {
        year: number;
        day: number;
        month: number;
        dayOfWeek: number;
        monthFirstDay: number;
      };
      value: string;
    };
    end: {
      time: string;
      timeObject: {
        hour: number;
        minute: number;
        second: number;
      };
      isValid: boolean;
      date: Date;
      timestamp: number;
      dateObject: {
        year: number;
        day: number;
        month: number;
        dayOfWeek: number;
        monthFirstDay: number;
      };
      value: string;
    };
    date: Date[];
    timestamp: number[];
    value: string;
  };
  createValueObject: (value: any) => {
    time: string;
    timeObject: {
      hour: number;
      minute: number;
      second: number;
    };
    isValid: boolean;
    date: Date;
    timestamp: number;
    dateObject: {
      year: number;
      day: number;
      month: number;
      dayOfWeek: number;
      monthFirstDay: number;
    };
    value: string;
  };
  getValue(): Promise<any>;
  get(): Promise<any>;
  set(value: any): Promise<void>;
  setClear(): Promise<void>;
  resetCaption(): Promise<void>;
  getInput(): Promise<HTMLInputElement>;
  isValid(): Promise<boolean>;
  getPickerElement(): HTMLBcmRcPickerElement;
  render(): any;
}
