export declare class ColorHelper {
  static isHex: (str: string) => boolean;
  static isRgb: (str: string) => boolean;
  static isRgba: (str: string) => boolean;
  static isHsl: (str: string) => boolean;
  static isHsla: (str: string) => boolean;
  static isVariable: (str: string) => boolean;
  static extractVariable: (str: string) => string;
  static convertColorToHex: (color: string) => any;
  static reverseColor: (color: string) => "#334155" | "#fff";
  static dsColor: (color: string) => string;
  static getTwColorToHex: (colorName: string) => any;
  static getTwColor: (colorName: string, checkTw?: boolean) => any;
  static twColor: (colorName: string, tone?: string | number) => string;
  static twColorReverse: (color: string) => "#334155" | "#fff";
  /**
   * @param color - color string in format of `colorName-tone` or `colorName` (default tone is 600)
   * @return `{ tone: number, colorName: string }`
   * @description
   * Parse color string to get color name and tone
   * @example
   * parseColor("red-500") // { tone: 500, colorName: "red" }
   * parseColor("red") // { tone: 600, colorName: "red" }
   * parseColor(null) // { tone: null, colorName: null }
   */
  static parseColor(color: any, defaultTone?: number): {
    tone: number;
    colorName: any;
  };
  /**
   * @param object
   * @return string
   * @description Convert style object to string
   */
  static generateStyleString: (obj: any) => string;
}
