export declare class Tooltip {
  id: string;
  message: string;
  targetId: string;
  placement: any;
  color: string;
  el: HTMLElement;
  trigger: string;
  size: string;
  openDelay: number;
  closeDelay: number;
  autoHide?: boolean;
  emitShow: () => void;
  emitHide: () => void;
  constructor({ message, targetId, placement, color, trigger, size, openDelay, closeDelay, autoHide, emitShow, emitHide, }: {
    message: any;
    targetId: any;
    placement?: string;
    color?: string;
    trigger?: string;
    size?: string;
    openDelay?: number;
    closeDelay?: number;
    autoHide?: boolean;
    emitShow?: () => void;
    emitHide?: () => void;
  });
  destroy: () => void;
  private target;
  private sizeClass;
  private init;
  update: () => void;
  listener: () => void;
  removeListener: () => void;
  private calculatePosition;
  show: () => Promise<void>;
  hide: () => Promise<void>;
  toggle: () => void;
}
