export declare namespace Bcm {
  enum HtmlElementType {
    div = "div",
    span = "span",
    button = "button",
    a = "a",
    input = "input",
    textarea = "textarea",
    select = "select",
    option = "option",
    img = "img",
    table = "table",
    tr = "tr",
    td = "td",
    th = "th",
    tbody = "tbody",
    thead = "thead",
    tfoot = "tfoot",
    ul = "ul",
    li = "li",
    form = "form",
    label = "label",
    main = "main",
    header = "header",
    footer = "footer",
    section = "section",
    article = "article",
    nav = "nav",
    aside = "aside"
  }
  enum Status {
    info = "info",
    error = "error",
    warning = "warning",
    success = "success",
    default = "default"
  }
  enum Shape {
    ellipse = "ellipse",
    square = "square"
  }
  enum Direction {
    horizontal = "horizontal",
    vertical = "vertical"
  }
  enum PreDefinedIconSize {
    large = 48,
    medium = 24,
    default = 16,
    small = 12,
    xsmall = 8
  }
  enum BaseSize {
    small = "small",
    medium = "medium",
    large = "large"
  }
  enum Size {
    small = "small",
    medium = "medium",
    large = "large",
    xsmall = "xsmall",
    xlarge = "xlarge",
    xxlarge = "xxlarge",
    xxxlarge = "xxxlarge"
  }
  enum Kind {
    "solid" = "solid",
    "ghost" = "ghost",
    "link" = "link",
    "ghost-link" = "ghost-link"
  }
  enum ButtonType {
    button = "button",
    reset = "reset",
    submit = "submit"
  }
  enum IconPosition {
    prefix = "prefix",
    suffix = "suffix"
  }
  enum TagType {
    basic = "basic",
    add = "add",
    checkable = "checkable",
    dismissable = "dismissable"
  }
  enum FontSize {
    "size-1" = "size-1",
    "size-2" = "size-2",
    "size-3" = "size-3",
    "size-4" = "size-4",
    "size-5" = "size-5",
    "size-6" = "size-6",
    "size-7" = "size-7",
    "size-8" = "size-8",
    "size-9" = "size-9"
  }
  enum FontSizeValue {
    "size-1" = 12,
    "size-2" = 14,
    "size-3" = 16,
    "size-4" = 20,
    "size-5" = 24,
    "size-6" = 30,
    "size-7" = 38,
    "size-8" = 46,
    "size-9" = 56
  }
  enum FontWeight {
    thin = "thin",
    light = "light",
    regular = "regular",
    medium = "medium",
    bold = "bold",
    black = "black"
  }
  enum ColorPalette {
    "default" = "default",
    "black" = "black",
    "white" = "white",
    "prime-blue" = "prime-blue",
    "prime-blue-1" = "prime-blue-1",
    "prime-blue-2" = "prime-blue-2",
    "prime-blue-3" = "prime-blue-3",
    "prime-blue-4" = "prime-blue-4",
    "prime-blue-5" = "prime-blue-5",
    "prime-blue-6" = "prime-blue-6",
    "prime-blue-7" = "prime-blue-7",
    "prime-blue-8" = "prime-blue-8",
    "prime-blue-9" = "prime-blue-9",
    "prime-blue-10" = "prime-blue-10",
    "grey" = "grey",
    "grey-1" = "grey-1",
    "grey-2" = "grey-2",
    "grey-3" = "grey-3",
    "grey-4" = "grey-4",
    "grey-5" = "grey-5",
    "grey-6" = "grey-6",
    "grey-7" = "grey-7",
    "grey-8" = "grey-8",
    "grey-9" = "grey-9",
    "grey-10" = "grey-10",
    "blue" = "blue",
    "blue-1" = "blue-1",
    "blue-2" = "blue-2",
    "blue-3" = "blue-3",
    "blue-4" = "blue-4",
    "blue-5" = "blue-5",
    "blue-6" = "blue-6",
    "blue-7" = "blue-7",
    "blue-8" = "blue-8",
    "blue-9" = "blue-9",
    "blue-10" = "blue-10",
    "warmyellow" = "warmyellow",
    "warmyellow-1" = "warmyellow-1",
    "warmyellow-2" = "warmyellow-2",
    "warmyellow-3" = "warmyellow-3",
    "warmyellow-4" = "warmyellow-4",
    "warmyellow-5" = "warmyellow-5",
    "warmyellow-6" = "warmyellow-6",
    "warmyellow-7" = "warmyellow-7",
    "warmyellow-8" = "warmyellow-8",
    "warmyellow-9" = "warmyellow-9",
    "warmyellow-10" = "warmyellow-10",
    "yellow" = "yellow",
    "yellow-1" = "yellow-1",
    "yellow-2" = "yellow-2",
    "yellow-3" = "yellow-3",
    "yellow-4" = "yellow-4",
    "yellow-5" = "yellow-5",
    "yellow-6" = "yellow-6",
    "yellow-7" = "yellow-7",
    "yellow-8" = "yellow-8",
    "yellow-9" = "yellow-9",
    "yellow-10" = "yellow-10",
    "limegreen" = "limegreen",
    "limegreen-1" = "limegreen-1",
    "limegreen-2" = "limegreen-2",
    "limegreen-3" = "limegreen-3",
    "limegreen-4" = "limegreen-4",
    "limegreen-5" = "limegreen-5",
    "limegreen-6" = "limegreen-6",
    "limegreen-7" = "limegreen-7",
    "limegreen-8" = "limegreen-8",
    "limegreen-9" = "limegreen-9",
    "limegreen-10" = "limegreen-10",
    "red" = "red",
    "red-1" = "red-1",
    "red-2" = "red-2",
    "red-3" = "red-3",
    "red-4" = "red-4",
    "red-5" = "red-5",
    "red-6" = "red-6",
    "red-7" = "red-7",
    "red-8" = "red-8",
    "red-9" = "red-9",
    "red-10" = "red-10",
    "darkorange" = "darkorange",
    "darkorange-1" = "darkorange-1",
    "darkorange-2" = "darkorange-2",
    "darkorange-3" = "darkorange-3",
    "darkorange-4" = "darkorange-4",
    "darkorange-5" = "darkorange-5",
    "darkorange-6" = "darkorange-6",
    "darkorange-7" = "darkorange-7",
    "darkorange-8" = "darkorange-8",
    "darkorange-9" = "darkorange-9",
    "darkorange-10" = "darkorange-10",
    "orange" = "orange",
    "orange-1" = "orange-1",
    "orange-2" = "orange-2",
    "orange-3" = "orange-3",
    "orange-4" = "orange-4",
    "orange-5" = "orange-5",
    "orange-6" = "orange-6",
    "orange-7" = "orange-7",
    "orange-8" = "orange-8",
    "orange-9" = "orange-9",
    "orange-10" = "orange-10",
    "green" = "green",
    "green-1" = "green-1",
    "green-2" = "green-2",
    "green-3" = "green-3",
    "green-4" = "green-4",
    "green-5" = "green-5",
    "green-6" = "green-6",
    "green-7" = "green-7",
    "green-8" = "green-8",
    "green-9" = "green-9",
    "green-10" = "green-10",
    "turquosie" = "turquosie",
    "turquosie-1" = "turquosie-1",
    "turquosie-2" = "turquosie-2",
    "turquosie-3" = "turquosie-3",
    "turquosie-4" = "turquosie-4",
    "turquosie-5" = "turquosie-5",
    "turquosie-6" = "turquosie-6",
    "turquosie-7" = "turquosie-7",
    "turquosie-8" = "turquosie-8",
    "turquosie-9" = "turquosie-9",
    "turquosie-10" = "turquosie-10",
    "cobaltblue" = "cobaltblue",
    "cobaltblue-1" = "cobaltblue-1",
    "cobaltblue-2" = "cobaltblue-2",
    "cobaltblue-3" = "cobaltblue-3",
    "cobaltblue-4" = "cobaltblue-4",
    "cobaltblue-5" = "cobaltblue-5",
    "cobaltblue-6" = "cobaltblue-6",
    "cobaltblue-7" = "cobaltblue-7",
    "cobaltblue-8" = "cobaltblue-8",
    "cobaltblue-9" = "cobaltblue-9",
    "cobaltblue-10" = "cobaltblue-10",
    "magenta" = "magenta",
    "magenta-1" = "magenta-1",
    "magenta-2" = "magenta-2",
    "magenta-3" = "magenta-3",
    "magenta-4" = "magenta-4",
    "magenta-5" = "magenta-5",
    "magenta-6" = "magenta-6",
    "magenta-7" = "magenta-7",
    "magenta-8" = "magenta-8",
    "magenta-9" = "magenta-9",
    "magenta-10" = "magenta-10",
    "purple" = "purple",
    "purple-1" = "purple-1",
    "purple-2" = "purple-2",
    "purple-3" = "purple-3",
    "purple-4" = "purple-4",
    "purple-5" = "purple-5",
    "purple-6" = "purple-6",
    "purple-7" = "purple-7",
    "purple-8" = "purple-8",
    "purple-9" = "purple-9",
    "purple-10" = "purple-10",
    "bc-red" = "bc-red",
    "bc-red-1" = "bc-red-1",
    "bc-red-2" = "bc-red-2",
    "bc-red-3" = "bc-red-3",
    "bc-red-4" = "bc-red-4",
    "bc-red-5" = "bc-red-5",
    "bc-red-6" = "bc-red-6",
    "bc-red-7" = "bc-red-7",
    "bc-red-8" = "bc-red-8",
    "bc-red-9" = "bc-red-9",
    "bc-blue" = "bc-blue",
    "bc-blue-1" = "bc-blue-1",
    "bc-blue-2" = "bc-blue-2",
    "bc-blue-3" = "bc-blue-3",
    "bc-blue-4" = "bc-blue-4",
    "bc-blue-5" = "bc-blue-5",
    "bc-blue-6" = "bc-blue-6",
    "bc-blue-7" = "bc-blue-7",
    "bc-blue-8" = "bc-blue-8",
    "bc-blue-9" = "bc-blue-9",
    "bc-green" = "bc-green",
    "bc-green-1" = "bc-green-1",
    "bc-green-2" = "bc-green-2",
    "bc-green-3" = "bc-green-3",
    "bc-green-4" = "bc-green-4",
    "bc-green-5" = "bc-green-5",
    "bc-green-6" = "bc-green-6",
    "bc-green-7" = "bc-green-7",
    "bc-green-8" = "bc-green-8",
    "bc-green-9" = "bc-green-9",
    "bc-orange" = "bc-orange",
    "bc-orange-1" = "bc-orange-1",
    "bc-orange-2" = "bc-orange-2",
    "bc-orange-3" = "bc-orange-3",
    "bc-orange-4" = "bc-orange-4",
    "bc-orange-5" = "bc-orange-5",
    "bc-orange-6" = "bc-orange-6",
    "bc-orange-7" = "bc-orange-7",
    "bc-orange-8" = "bc-orange-8",
    "bc-orange-9" = "bc-orange-9"
  }
  enum InputType {
    text = "text",
    number = "number",
    email = "email",
    password = "password",
    url = "url",
    search = "search",
    tel = "tel",
    hidden = "hidden",
    color = "color"
  }
  enum KeyCode {
    backspace = 8,
    tab = 9,
    enter = 13,
    shift = 16,
    ctrl = 17,
    alt = 18,
    pause = 19,
    capslock = 20,
    escape = 27,
    space = 32,
    pageup = 33,
    pagedown = 34,
    end = 35,
    home = 36,
    left = 37,
    up = 38,
    right = 39,
    down = 40,
    insert = 45,
    delete = 46,
    f1 = 112,
    f2 = 113,
    f3 = 114,
    f4 = 115,
    f5 = 116,
    f6 = 117,
    f7 = 118,
    f8 = 119,
    f9 = 120,
    f10 = 121,
    f11 = 122,
    f12 = 123,
    numlock = 144,
    scrolllock = 145,
    semicolon = 186,
    equal = 187,
    comma = 188,
    dash = 189,
    period = 190,
    slash = 191,
    backslash = 220,
    bracketleft = 219,
    bracketright = 221,
    quote = 222,
    backtick = 192,
    a = 65
  }
  const FormErrorMessages: {
    email: string;
    password: string;
    url: string;
    phone: string;
    search: string;
    number: string;
    text: string;
    required: string;
    minlength: string;
    maxlength: string;
    betweenlength: string;
    min: string;
    max: string;
    between: string;
    pattern: string;
    date: string;
    time: string;
    datetime: string;
    "datetime-local": string;
    month: string;
    week: string;
    color: string;
    file: string;
    range: string;
    radio: string;
    checkbox: string;
    select: string;
    multiple: string;
  };
  interface InputClickEvent {
    ref?: (input: any) => void;
    handleBlur?: (event: any) => void;
    handleFocus?: (event: any) => void;
    handleInput?: (event: any) => void;
    handleClick?: (event: any) => void;
    handleChange?: (event: any) => void;
    onClick?: (event: any) => void;
  }
  interface ListItemClickEvent extends InputClickEvent {
    openGroup?: (event: any) => void;
    checkedItem?: (event: any) => void;
    selectedItem?: (event: any) => void;
  }
  interface ListClickEvent extends InputClickEvent, ListItemClickEvent {
    onScrollEvent?: (event: any) => void;
  }
  enum IndeterminateType {
    uncheck = "uncheck",
    indeterminate = "indeterminate",
    determinate = "determinate"
  }
  enum Placement {
    "top" = "top",
    "top-start" = "top-start",
    "top-end" = "top-end",
    "bottom" = "bottom",
    "bottom-start" = "bottom-start",
    "bottom-end" = "bottom-end",
    "left" = "left",
    "left-start" = "left-start",
    "left-end" = "left-end",
    "right" = "right",
    "right-start" = "right-start",
    "right-end" = "right-end"
  }
  enum Position {
    "top" = "top",
    "bottom" = "bottom",
    "left" = "left",
    "right" = "right"
  }
  enum TriggerType {
    hover = "hover",
    click = "click",
    focus = "focus",
    custom = "custom"
  }
  enum ListType {
    listbox = "listbox",
    select = "select",
    autocomplete = "autocomplete"
  }
  interface ToolBarButtonProps {
    showNewButton?: boolean;
    showExportButton?: boolean;
    showColumnButton?: boolean;
    showFilterButton?: boolean;
    showSearchInput?: boolean;
  }
  interface InputDropdownData {
    key?: string;
    value?: string;
    color?: string;
    lateMin?: number;
    isLate?: boolean;
    comment?: string;
    hideComment?: boolean;
    disabled?: boolean;
    selected?: boolean;
    icon?: string;
    priority?: number;
    locked?: boolean;
    id?: string;
  }
  type Prettify<T> = {
    [K in keyof T]: T[K];
  };
}
export default Bcm;
