import { BcmStepper } from '../../../components/molecules/stepper/stepper';
export declare namespace BcmMoleculesState {
  interface BaseMolecules {
    id: string | number;
  }
  interface Icon {
    icon?: any;
    iconType?: any;
    size?: any;
    color?: any;
    loading?: any;
    bigIcon?: any;
  }
  interface FormAttr {
    disabled?: boolean;
    hidden?: boolean;
    required?: boolean;
    readonly?: boolean;
    value?: any;
    name?: any;
    label?: any;
  }
  interface Alert extends Icon, BaseMolecules {
    status?: any;
    dismissable?: any;
  }
  interface Message extends Icon, BaseMolecules {
    message?: any;
    status?: any;
  }
  interface Notification extends Icon, BaseMolecules {
    message?: any;
    description?: any;
    status?: any;
  }
  interface Result extends Icon, BaseMolecules {
    message?: any;
    description?: any;
    status?: any;
  }
  interface Options {
    value?: any;
    size?: any;
    label?: any;
    placeholder?: any;
    noCaption?: any;
    caption?: any;
    captionError?: any;
    captionType?: any;
    disabled?: any;
    required?: any;
    hidden?: any;
    highlight?: any;
    name?: any;
    items?: any;
    infoFooter?: any;
    checkboxes?: any;
    clearable?: any;
    template?: any;
    favIcon?: any;
    favIconOnlyChilds?: any;
    showIcon?: any;
    treeview?: any;
    allOpen?: any;
    fullWidth?: any;
    readonly?: any;
    type?: any;
    linkedComponent?: any;
  }
  interface SearchData extends BaseMolecules {
    parentId?: any;
    text?: any;
    items?: SearchData[];
  }
  interface BcmSearchModel extends BaseMolecules {
    dataSource: SearchData[];
    searchIsOnlyChilds: boolean;
  }
  interface BcmStepperModel extends BaseMolecules {
    headerHidden: any;
    direction: any;
    linear: any;
    size: any;
    active: any;
    icon: any;
    el: BcmStepper;
    steps: any[];
  }
}
export default BcmMoleculesState;
